#region Using Directives

using System;
using System.Collections.Generic;

#endregion

namespace JadEngine.AI.NeuralNets
{
	public class Neuron
	{
		#region Fields

		protected internal NeuronType type;
		protected internal Dictionary<NeuronData, float> data;
		protected internal Dictionary<NeuronData, ActivationFunction> functions;
		protected internal List<Connection> connections;

		#endregion

		#region Constructors
		
		public Neuron(NeuronType type)
		{
			this.type = type;
			
			data = new Dictionary<NeuronData, float>();
			functions = new Dictionary<NeuronData, ActivationFunction>();
			connections = new List<Connection>();
		}
		
		#endregion
		
		#region Properties

		public NeuronType Type
		{
			get { return type; }
			set { type = value; }
		}

		public Dictionary<NeuronData, float> Data
		{
			get { return data; }
		}

		public Dictionary<NeuronData, ActivationFunction> Functions
		{
			get { return functions; }
		}

		public List<Connection> Connections
		{
			get { return connections; }
		}
		
		#endregion
	}
}
