#region Using Directives

using System;

#endregion

namespace JadEngine.AI.NeuralNets
{
	public class SigmoidFunctions
	{
		#region Fields

		protected internal float minimum;
		protected internal float maximum;
		protected internal float slope;
		protected internal float gamma;
		protected internal float nu;

		#endregion

		#region Constructors
		
		public SigmoidFunctions(float minimum, float maximum, float slope)
		{
			this.minimum = minimum;
			this.maximum = maximum;
			this.slope = slope;

			gamma = maximum - minimum;
			nu = -minimum;
		}

		#endregion

		#region Properties

		public float Minimum
		{
			get { return minimum; }
			set
			{
				minimum = value;

				gamma = maximum - minimum;
				nu = -minimum;
			}
		}

		public float Maximum
		{
			get { return maximum; }
			set
			{
				maximum = value;

				gamma = maximum - minimum;
			}
		}

		public float Slope
		{
			get { return slope; }
			set { slope = value; }
		}

		public float Gamma
		{
			get { return gamma; }
		}

		public float Nu
		{
			get { return nu; }
		}
		
		#endregion
		
		#region Methods

		public float Sigmoid(float value)
		{
			return gamma * (1.0f / (1.0f + (float) Math.Exp(-slope * value))) - nu;
		}

		public float FirstDerivativeSigmoid(float value)
		{
			float sigmoidValue;

			sigmoidValue = Sigmoid(value);
			return (slope / gamma) * (nu + sigmoidValue) * (gamma - nu - sigmoidValue);
		}

		#endregion
	}
}
