#define DEBUG

#region Using directives

using System;
using System.Collections.Generic;
using System.IO;

using Microsoft.DirectX.Direct3D;

using JadEngine.Tools;
using JadEngine.Core;
using JadEngine.Video;
using JadEngine.Scene;

#endregion

namespace JadEngine.Core
{
	/// <summary>
	/// TODO
	/// </summary>
	public enum JUniqueEffectIDGlobal
	{
		/// <summary>
		/// TODO
		/// </summary>
		FogPass = 1 << 0,

		/// <summary>
		/// TODO
		/// </summary>
		AffectDiffuse = 1 << 1,

		/// <summary>
		/// TODO
		/// </summary>
		AffectSpecular = 1 << 2,

		/// <summary>
		/// TODO
		/// </summary>
		ProjectorEnabled = 1 << 3,

		/// <summary>
		/// TODO
		/// </summary>
		ReflectionMapEnabled = 1 << 4,

		/// <summary>
		/// TODO
		/// </summary>
		RefractionMapEnabled = 1 << 5,

		/// <summary>
		/// TODO
		/// </summary>
		WorldSpaceNormals = 1 << 6,

		/// <summary>
		/// TODO
		/// </summary>
		ParallaxMapping = 1 << 7,

		/// <summary>
		/// TODO
		/// </summary>
		EmissiveEnabled = 1 << 8,

		/// <summary>
		/// TODO
		/// </summary>
		DetailMapEnabled = 1 << 10,

		/// <summary>
		/// TODO
		/// </summary>
		DepthOfField = 1 << 11,

		/// <summary>
		/// TODO
		/// </summary>
		SpecularMapEnabled = 1 << 12,

		/// <summary>
		/// TODO
		/// </summary>
		ShadowsOnRender = 1 << 13,

		/// <summary>
		/// TODO
		/// </summary>
		GeneratingShadowMap = 1 << 14,

		/// <summary>
		/// TODO
		/// </summary>
		GeneratingShadowMaskForShadowMap = 1 << 15,

		/// <summary>
		/// TODO
		/// </summary>
		GeneratingShadowMaskForShadowMapPCF = 1 << 16,

		/// <summary>
		/// TODO
		/// </summary>
		UseTexCoordForDetailMap = 1 << 18,

		/// <summary>
		/// TODO
		/// </summary>
		DiffuseMapEnabled = 1 << 19,

		/// <summary>
		/// TODO
		/// </summary>
		VolumetricLight = 1 << 20,

		/// <summary>
		/// TODO
		/// </summary>
		ZPass_WithoutAlphaTest = 1 << 21,

		/// <summary>
		/// TODO
		/// </summary>
		ZPass_WithAlphaTest = 1 << 22,

		/// <summary>
		/// TODO
		/// </summary>
		Ghost = 1 << 23,

		/// <summary>
		/// TODO
		/// </summary>
		PostPass = 1 << 24,

		/// <summary>
		/// TODO
		/// </summary>
		ApplyAmbient = 1 << 25,

		/// <summary>
		/// TODO
		/// </summary>
		AmbientOnly = 1 << 26,

		/// <summary>
		/// TODO
		/// </summary>
		MotionBlurPass = 1 << 27,

		/// <summary>
		/// TODO
		/// </summary>
		ParallaxPass = 1 << 28,

		/// <summary>
		/// TODO
		/// </summary>
		SphericalMapping = 1 << 29,

		/// <summary>
		/// TODO
		/// </summary>
		ParallaxOcclusion = 1 << 30,

		/// <summary>
		/// TODO
		/// </summary>
		ParallaxShadowOnlyPass = 1 << 31
	}

	/// <summary>
	/// TODO
	/// </summary>
	public struct JUniqueEffectID
	{
		#region Fields

		/// <summary>
		/// TODO
		/// </summary>
		public int Global;

		/// <summary>
		/// TODO
		/// </summary>
		public byte NormalType;

		/// <summary>
		/// TODO
		/// </summary>
		public byte LightType;

		/// <summary>
		/// TODO
		/// </summary>
		public byte EmissiveModel;

		/// <summary>
		/// TODO
		/// </summary>
		public byte Attenuation;

		/// <summary>
		/// TODO
		/// </summary>
		public byte Fog;

		/// <summary>
		/// TODO
		/// </summary>
		public Int16 LightingID;

		/// <summary>
		/// TODO
		/// </summary>
		/// <remarks>
		/// Sadly the HashTable DOESNT support arrays, so all the posibilites
		/// must be built as a string
		/// </remarks>
		public string GeometryModifiersID;

		#endregion

		#region Methods

		/// <summary>
		/// TODO
		/// </summary>
		public void Reset()
		{
			Global = 0;
			NormalType = (byte) JNormalType.None;    // Valor 0
			LightType = (byte) JLightType.Unknown;	// valor 3
			EmissiveModel = 0;
			Attenuation = (byte) JLightAttenuationType.None;
			LightingID = 0;
			GeometryModifiersID = null;
			Fog = 0;
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <returns>TODO</returns>
		public override string ToString()
		{
			string t = "/*\n\nScene status:";

			if (Jad.Scene.Status == JSceneStatus.ZPass) t += "ZPass";
			if (Jad.Scene.Status == JSceneStatus.ParallaxPass) t += "ParallaxPass";
			if (Jad.Scene.Status == JSceneStatus.PostPass) t += "PostPass";
			if (Jad.Scene.Status == JSceneStatus.FogPass) t += "FogPass";
			if (Jad.Scene.Status == JSceneStatus.GlowDOFPass) t += "GlowDOFPass";
			if (Jad.Scene.Status == JSceneStatus.MotionBlurPass) t += "MotionBlurPass";
			if (Jad.Scene.Status == JSceneStatus.ParallaxShadowPass) t += "ParallaxShadowPass";

			if (Jad.Scene.Status == JSceneStatus.Rendering)
			{
				if (Jad.Scene.RenderWithShadows)
					t += "RenderWithShadow";
				else
					t += "Rendering";
			}

			if (Jad.Scene.Status == JSceneStatus.RenderShadow) t += "RenderShadow";
			if (Jad.Scene.Status == JSceneStatus.ShadowMapGeneration) t += "ShadowMapGeneration";

			t += "\n\n";

			if ((Global & (int) JUniqueEffectIDGlobal.FogPass) != 0) t = t + "FogPass\n";
			if ((Global & (int) JUniqueEffectIDGlobal.AffectDiffuse) != 0) t = t + "AffectDiffuse\n";
			if ((Global & (int) JUniqueEffectIDGlobal.AffectSpecular) != 0) t = t + "AffectSpecular\n";
			if ((Global & (int) JUniqueEffectIDGlobal.ReflectionMapEnabled) != 0) t = t + "ReflectionMapEnabled\n";
			if ((Global & (int) JUniqueEffectIDGlobal.RefractionMapEnabled) != 0) t = t + "RefractionMapEnabled\n";
			if ((Global & (int) JUniqueEffectIDGlobal.ParallaxMapping) != 0) t = t + "ParallaxMapping\n";
			if ((Global & (int) JUniqueEffectIDGlobal.EmissiveEnabled) != 0) t = t + "EmissiveEnabled\n";
			if ((Global & (int) JUniqueEffectIDGlobal.DepthOfField) != 0) t = t + "DepthOfField\n";
			if ((Global & (int) JUniqueEffectIDGlobal.SpecularMapEnabled) != 0) t = t + "SpecularMapEnabled\n";
			if ((Global & (int) JUniqueEffectIDGlobal.ShadowsOnRender) != 0) t = t + "ShadowsOnRender\n";
			if ((Global & (int) JUniqueEffectIDGlobal.GeneratingShadowMap) != 0) t = t + "GeneratingShadowMap\n";
			if ((Global & (int) JUniqueEffectIDGlobal.GeneratingShadowMaskForShadowMap) != 0) t = t + "GeneratingShadowMaskForShadowMap\n";
			if ((Global & (int) JUniqueEffectIDGlobal.GeneratingShadowMaskForShadowMapPCF) != 0) t = t + "GeneratingShadowMaskForShadowMapPCF\n";
			if ((Global & (int) JUniqueEffectIDGlobal.DiffuseMapEnabled) != 0) t = t + "DiffuseMapEnabled\n";
			if ((Global & (int) JUniqueEffectIDGlobal.VolumetricLight) != 0) t = t + "VolumetricLight\n";
			if ((Global & (int) JUniqueEffectIDGlobal.DetailMapEnabled) != 0) t = t + "DetailMapEnabled\n";
			if ((Global & (int) JUniqueEffectIDGlobal.UseTexCoordForDetailMap) != 0) t = t + "UseTexCoordForDetailMap\n";
			if ((Global & (int) JUniqueEffectIDGlobal.ZPass_WithoutAlphaTest) != 0) t = t + "ZPass_WithoutAlphaTest\n";
			if ((Global & (int) JUniqueEffectIDGlobal.ZPass_WithAlphaTest) != 0) t = t + "ZPass_WithAlphaTest\n";
			if ((Global & (int) JUniqueEffectIDGlobal.Ghost) != 0) t = t + "Ghost\n";
			if ((Global & (int) JUniqueEffectIDGlobal.ApplyAmbient) != 0) t = t + "ApplyAmbient\n";
			if ((Global & (int) JUniqueEffectIDGlobal.AmbientOnly) != 0) t = t + "AmbientOnly\n";
			if ((Global & (int) JUniqueEffectIDGlobal.WorldSpaceNormals) != 0) t = t + "WorldSpaceNormals\n";
			if ((Global & (int) JUniqueEffectIDGlobal.MotionBlurPass) != 0) t = t + "MotionBlurPass\n";
			if ((Global & (int) JUniqueEffectIDGlobal.ParallaxOcclusion) != 0) t = t + "ParallaxOcclusion\n";
			if ((Global & (int) JUniqueEffectIDGlobal.ParallaxPass) != 0) t = t + "ParallaxPass\n";

			string normal = String.Empty, light = String.Empty;

			if (NormalType == (byte) JNormalType.None) normal = "None";
			if (NormalType == (byte) JNormalType.Mapping) normal = "Mapping";
			if (NormalType == (byte) JNormalType.Vertex) normal = "Vertex";

			t += "\n\nNormal Type:" + normal;

			t += "\n\nFog:" + Fog.ToString();

			if (LightType == (byte) JLightType.Unknown) light = "Unknown";
			if (LightType == (byte) JLightType.Directional) light = "Directional";
			if (LightType == (byte) JLightType.Omni) light = "Omni";
			if (LightType == (byte) JLightType.Spot) light = "Spot";

			t += "\nLight Type:" + light;
			t += "\nlightingID:" + LightingID.ToString();

			t += "\nAttenuation Type:" + ((JLightAttenuationType) Attenuation).ToString();
			t += "\ngeometryModifiersID:" + GeometryModifiersID;

			string emissive = String.Empty;

			if (EmissiveModel == (byte) JEmissiveMode.Texture) emissive = "Texture";
			if (EmissiveModel == (byte) JEmissiveMode.Color) emissive = "Color";
			if (EmissiveModel == (byte) JEmissiveMode.Diffuse) emissive = "Diffuse";

			t += "\n\nEmissive Model:" + emissive;

			t += "\n\n************************************************************/\n\n";

			return t;
		}

		#endregion
	}

	/// <summary>
	/// TODO
	/// </summary>
	public class JEffectBuilder
	{
		#region Struct JBuilderParams

		/// <summary>
		/// TODO
		/// </summary>
		struct JBuilderParams
		{
			#region Fields

			/// <summary>
			/// TODO
			/// </summary>
			internal string FogPass;

			/// <summary>
			/// TODO
			/// </summary>
			internal string GlowDOFPass;

			/// <summary>
			/// TODO
			/// </summary>
			internal string lightType;

			/// <summary>
			/// TODO
			/// </summary>
			internal string affectDiffuse;

			/// <summary>
			/// TODO
			/// </summary>
			internal string affectSpecular;

			/// <summary>
			/// TODO
			/// </summary>
			internal string attenType;

			/// <summary>
			/// TODO
			/// </summary>
			internal string projectorEnabled;

			/// <summary>
			/// TODO
			/// </summary>
			internal string reflectionMapEnabled;

			/// <summary>
			/// TODO
			/// </summary>
			internal string refractionMapEnabled;

			/// <summary>
			/// TODO
			/// </summary>
			internal string specularMapEnabled;

			/// <summary>
			/// TODO
			/// </summary>
			internal string diffuseMapEnabled;

			/// <summary>
			/// TODO
			/// </summary>
			internal string additiveEnabled;

			/// <summary>
			/// TODO
			/// </summary>
			internal string emissiveEnabled;

			/// <summary>
			/// TODO
			/// </summary>
			internal string emissiveMapEnabled;

			/// <summary>
			/// TODO
			/// </summary>
			internal string emissiveModel;

			/// <summary>
			/// TODO
			/// </summary>
			internal string normalType;

			/// <summary>
			/// TODO
			/// </summary>
			internal string volumetricLight;

			/// <summary>
			/// TODO
			/// </summary>
			internal string parallaxMapping;

			/// <summary>
			/// TODO
			/// </summary>
			internal string DOF;

			/// <summary>
			/// TODO
			/// </summary>
			internal string shadowsOnRender;

			/// <summary>
			/// TODO
			/// </summary>
			internal string generatingShadowMap;

			/// <summary>
			/// TODO
			/// </summary>
			internal string generatingShadowMaskForShadowMap;

			/// <summary>
			/// TODO
			/// </summary>
			internal string fog;

			/// <summary>
			/// TODO
			/// </summary>
			internal string detailMapEnabled;

			/// <summary>
			/// TODO
			/// </summary>
			internal string useTexCoordForDetailMap;

			/// <summary>
			/// TODO
			/// </summary>
			internal string zPass;

			/// <summary>
			/// TODO
			/// </summary>
			internal string ghost;

			/// <summary>
			/// TODO
			/// </summary>
			internal string applyAmbient;

			/// <summary>
			/// TODO
			/// </summary>
			internal string ambientOnly;

			/// <summary>
			/// TODO
			/// </summary>
			internal string sphericalMapping;

			/// <summary>
			/// TODO
			/// </summary>
			internal string parallaxOcclusion;

			/// <summary>
			/// TODO
			/// </summary>
			internal string parallaxPass;

			/// <summary>
			/// TODO
			/// </summary>
			internal string parallaxShadowOnlyPass;

			#endregion

			#region Methods

			/// <summary>
			/// TODO
			/// </summary>
			internal void Initialize()
			{
				// Here we define the uniforms
				FogPass = "false";
				GlowDOFPass = "false";
				lightType = "LIGHT_UNKNOWN";
				affectDiffuse = "false";
				affectSpecular = "false";
				attenType = "ATTEN_NONE";
				projectorEnabled = "false";
				reflectionMapEnabled = "false";
				refractionMapEnabled = "false";
				specularMapEnabled = "false";
				diffuseMapEnabled = "false";
				additiveEnabled = "false";
				emissiveEnabled = "false";
				emissiveMapEnabled = "false";
				emissiveModel = "EMISSIVEMODEL_DIFFUSE";
				normalType = "NORMAL_NONE";
				volumetricLight = "false";
				parallaxMapping = "false";
				DOF = "false";
				shadowsOnRender = "false";
				generatingShadowMap = "false";
				generatingShadowMaskForShadowMap = "0";
				fog = "0";
				detailMapEnabled = "false";
				useTexCoordForDetailMap = "false";
				zPass = "ZPASS_NONE";
				ghost = "false";
				applyAmbient = "false";
				ambientOnly = "false";
				sphericalMapping = "false";
				parallaxOcclusion = "false";
				parallaxPass = "false";
				parallaxShadowOnlyPass = "false";
			}

			/// <summary>
			/// TODO
			/// </summary>
			/// <returns>TODO</returns>
			public string Process()
			{
				string Uniform = "\n";

				Uniform += "#define Uniform_PixelShaderVersion " + PixelShaderVersionInteger + " \n";

				if (Jad.Video.RenderTargets == null)
					Uniform += "#define Uniform_NORMALRTFLOATINGPOINT false \n";

				else
					Uniform += "#define Uniform_NORMALRTFLOATINGPOINT " + (Jad.Video.RenderTargets.normalMappingFormatInFloatingPoint ? "true" : "false") + "\n";

				Uniform += "#define Uniform_FogPass " + FogPass + "\n";
				Uniform += "#define Uniform_GlowDOFPass " + GlowDOFPass + "\n";
				Uniform += "#define Uniform_lightType " + lightType + "\n";
				Uniform += "#define Uniform_affectDiffuse " + affectDiffuse + "\n";
				Uniform += "#define Uniform_affectSpecular " + affectSpecular + "\n";
				Uniform += "#define Uniform_attenType " + attenType + "\n";
				Uniform += "#define Uniform_projectorEnabled " + projectorEnabled + "\n";
				Uniform += "#define Uniform_reflectionMapEnabled " + reflectionMapEnabled + "\n";
				Uniform += "#define Uniform_refractionMapEnabled " + refractionMapEnabled + "\n";
				Uniform += "#define Uniform_diffuseMapEnabled " + diffuseMapEnabled + "\n";
				Uniform += "#define Uniform_specularMapEnabled " + specularMapEnabled + "\n";
				Uniform += "#define Uniform_additiveEnabled " + additiveEnabled + "\n";
				Uniform += "#define Uniform_emissiveEnabled " + emissiveEnabled + "\n";
				Uniform += "#define Uniform_emissiveMapEnabled " + emissiveMapEnabled + "\n";
				Uniform += "#define Uniform_emissiveModel " + emissiveModel + "\n";
				Uniform += "#define Uniform_normalType " + normalType + "\n";
				Uniform += "#define Uniform_volumetricLight " + volumetricLight + "\n";
				Uniform += "#define Uniform_parallaxMapping " + parallaxMapping + "\n";
				Uniform += "#define Uniform_shadowsOnRender " + shadowsOnRender + "\n";
				Uniform += "#define Uniform_DOF " + DOF + "\n";
				Uniform += "#define Uniform_GeneratingShadowMap " + generatingShadowMap + "\n";
				Uniform += "#define Uniform_GeneratingShadowMaskForShadowMap " + generatingShadowMaskForShadowMap + "\n";
				Uniform += "#define Uniform_Fog " + fog + "\n";
				Uniform += "#define Uniform_DetailMapEnabled " + detailMapEnabled + "\n";
				Uniform += "#define Uniform_useTexCoordForDetailMap " + useTexCoordForDetailMap + "\n";
				Uniform += "#define Uniform_ZPass " + zPass + "\n";
				Uniform += "#define Uniform_Ghost " + ghost + "\n";
				Uniform += "#define Uniform_ApplyAmbient " + applyAmbient + "\n";
				Uniform += "#define Uniform_AmbientOnly " + ambientOnly + "\n";
				Uniform += "#define Uniform_WorldSpaceNormals " + WorldSpaceNormals + "\n";
				Uniform += "#define Uniform_SphericalMapping " + sphericalMapping + "\n";
				Uniform += "#define Uniform_ParallaxOcclusion " + parallaxOcclusion + "\n";
				Uniform += "#define Uniform_ParallaxPass " + parallaxPass + "\n";
				Uniform += "#define Uniform_ParallaxShadowOnlyPass " + parallaxShadowOnlyPass + "\n";

				Uniform += "\n\n";

				return Uniform;
			}

			#endregion
		}

		#endregion

		#region Static Fields

		/// <summary>
		/// Vertex shader version that will be created the effect
		/// </summary>
		public static string VertexShaderVersion = "2_0";

		/// <summary>
		/// Pixel shader version that will be created the effect
		/// </summary>
		public static string PixelShaderVersion = "2_0";

		/// <summary>
		/// Pixel shader version used by the effect builder
		/// </summary>
		public static int PixelShaderVersionInteger = 20;

		/// <summary>
		/// TODO
		/// </summary>
		public static string WorldSpaceNormals = "false";

		/// <summary>
		/// TODO
		/// </summary>
		public static string Test = "false";

		/// <summary>
		/// TODO
		/// </summary>
		public static int NumberOfEffectsBuilt = 0;

		/// <summary>
		/// TODO
		/// </summary>
		static int numPreShader = 0;

		#endregion

		#region Fields

		/// <summary>
		/// TODO
		/// </summary>
		JBuilderParams parameters;

		/// <summary>
		/// TODO
		/// </summary>
		StreamReader stream = null;

		/// <summary>
		/// TODO
		/// </summary>
		string allInOneFX;

		/// <summary>
		/// Used for the engine to build the effects
		/// </summary>
		internal string allInOneFXForEffect;

		/// <summary>
		/// TODO
		/// </summary>
		string lightPassFx;

		/// <summary>
		/// TODO
		/// </summary>
		string zPassFx;

		/// <summary>
		/// TODO
		/// </summary>
		string fogPassFx;

		/// <summary>
		/// TODO
		/// </summary>
		string glowDOFPassFx;

		/// <summary>
		/// TODO
		/// </summary>
		string postPassFx;

		/// <summary>
		/// TODO
		/// </summary>
		string motionBlurPassFx;

		/// <summary>
		/// TODO
		/// </summary>
		string source;

		/// <summary>
		/// TODO
		/// </summary>
		JUniqueEffectID UniqueEffectID;

		/// <summary>
		/// TODO
		/// </summary>
		Dictionary<String, JEffect> effects = new Dictionary<String, JEffect>();

		/// <summary>
		/// TODO
		/// </summary>
		public bool SavePreShaders = false;

		#endregion

		#region Constructors

		/// <summary>
		/// TODO
		/// </summary>
		public JEffectBuilder()
		{
			string shadersDir = JPath.InHouseDirectory + @"shaders\internal\";

			// Read all the effect and save it in the fx var
			stream = new StreamReader(shadersDir + @"AllInOne.fx");
			allInOneFX = stream.ReadToEnd() + "\n";
			stream.Close();

			// The samplers just afte the AllInOne
			stream = new StreamReader(shadersDir + @"Samplers.fx");
			allInOneFX += stream.ReadToEnd() + "\n";
			stream.Close();

			// Delete the Enum region from the AllInOne
			int psEnd = allInOneFX.IndexOf("#end Enum");
			JEffectFragments.ParseEnum(Jad.EffectFragments.EnumValues, allInOneFX.Substring(0, psEnd));
			allInOneFX = allInOneFX.Substring(psEnd + 9);

			// Search the *.h files in the shaders folder to include them in the AllInOne

			DirectoryInfo dir = new DirectoryInfo(JPath.InHouseDirectory + "shaders");
			FileInfo[] files = dir.GetFiles("*.h");

			for (int i = 0; i < files.Length; i++)
			{
				// Read all the effect and save it in the fx var
				stream = new StreamReader(files[i].FullName);
				allInOneFX += stream.ReadToEnd() + "\n";
				stream.Close();
			}

			// Add the enums at the start

			string enums = JEffectFragments.EnumToDefines(Jad.EffectFragments.EnumValues);
			foreach (JEffectFragment f in Jad.EffectFragments.List)
				if (f.EnumValues != null)
					enums += JEffectFragments.EnumToDefines(f.EnumValues);

			allInOneFX = enums + allInOneFX;

			parameters.Initialize();

			// Create the AllInOne that will be used in the InHouse effects

			string uniformDefines = parameters.Process();
			allInOneFXForEffect = uniformDefines + allInOneFX;

			// Take out the samplers, as its more logical that the effect defines them

			string temp;

			temp = allInOneFXForEffect.Substring(0, allInOneFXForEffect.IndexOf("//SamplersStart"));
			temp += allInOneFXForEffect.Substring(allInOneFXForEffect.IndexOf("//SamplersEnd"));
			allInOneFXForEffect = temp;

			// Read the vertex and pixel shaders and save them

			// ------------------------------------------------------------------------
			// ZPass
			// ------------------------------------------------------------------------

			stream = new StreamReader(shadersDir + "ZPass_VertexShader.fx");
			zPassFx = stream.ReadToEnd() + "\n";
			stream.Close();

			stream = new StreamReader(shadersDir + "ZPass_PixelShader.fx");
			zPassFx += stream.ReadToEnd() + "\n";
			stream.Close();

			zPassFx = allInOneFX + zPassFx;

			// ------------------------------------------------------------------------
			// FogPass
			// ------------------------------------------------------------------------

			stream = new StreamReader(shadersDir + "FogPass_VertexShader.fx");
			fogPassFx = stream.ReadToEnd() + "\n";
			stream.Close();

			stream = new StreamReader(shadersDir + "FogPass_PixelShader.fx");
			fogPassFx += stream.ReadToEnd() + "\n";
			stream.Close();

			fogPassFx = allInOneFX + fogPassFx;

			// ------------------------------------------------------------------------
			// GlowDOFPass
			// ------------------------------------------------------------------------

			stream = new StreamReader(shadersDir + "GlowDOFPass_VertexShader.fx");
			glowDOFPassFx = stream.ReadToEnd() + "\n";
			stream.Close();

			stream = new StreamReader(shadersDir + "GlowDOFPass_PixelShader.fx");
			glowDOFPassFx += stream.ReadToEnd() + "\n";
			stream.Close();

			glowDOFPassFx = allInOneFX + glowDOFPassFx;

			// ------------------------------------------------------------------------
			// MotionBlurPass
			// ------------------------------------------------------------------------

			stream = new StreamReader(shadersDir + "MotionBlurPass_VertexShader.fx");
			motionBlurPassFx = stream.ReadToEnd() + "\n";
			stream.Close();

			stream = new StreamReader(shadersDir + "MotionBlurPass_PixelShader.fx");
			motionBlurPassFx += stream.ReadToEnd() + "\n";
			stream.Close();

			motionBlurPassFx = allInOneFX + motionBlurPassFx;

			// ------------------------------------------------------------------------
			// LightPass
			// ------------------------------------------------------------------------

			stream = new StreamReader(shadersDir + "LightPass_VertexShader.fx");
			lightPassFx = stream.ReadToEnd() + "\n";
			stream.Close();

			stream = new StreamReader(shadersDir + "LightPass_PixelShader.fx");
			lightPassFx += stream.ReadToEnd() + "\n";
			stream.Close();

			lightPassFx = allInOneFX + lightPassFx;

			// ------------------------------------------------------------------------
			// PostPass
			// ------------------------------------------------------------------------

			stream = new StreamReader(shadersDir + "PostPass_VertexShader.fx");
			postPassFx = stream.ReadToEnd() + "\n";
			stream.Close();

			stream = new StreamReader(shadersDir + "PostPass_PixelShader.fx");
			postPassFx += stream.ReadToEnd() + "\n";
			stream.Close();

			postPassFx = allInOneFX + postPassFx;
		}

		#endregion

		#region Methods

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="material">TODO</param>
		/// <param name="pass">TODO</param>
		void BuildGeometry(JMaterialLayer material, string pass)
		{
			// Initializa the local vars

			// In the end, "source" has the shader
			source = String.Empty;

			// Initialize the parameters
			parameters.Initialize();

			string geometry = String.Empty, ps = String.Empty;

			source = pass;

			// Assign the geometry fragments

			if (material.GeometryFragments.Count > 0)
			{
				foreach (JEffectFragment f in material.GeometryFragments)
				{
					geometry = geometry + f.VS;

					if (f.PS != null)
						ps += f.PS;

					if (f.Vars != null)
						source = f.Vars + source;
				}
			}

			if (material.Parent.GeometryFragments.Count > 0)
			{
				foreach (JEffectFragment f in material.Parent.GeometryFragments)
				{
					geometry = geometry + f.VS;

					if (f.PS != null)
						ps += f.PS;

					if (f.Vars != null)
						source = f.Vars + source;
				}
			}

			source = source.Replace("// ALLINONE:Geometry", geometry);
			source = source.Replace("// ALLINONE:PS_GEOMETRY", ps);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <returns>TODO</returns>
		JEffect Process()
		{
			source = parameters.Process() + source;

			source += "technique RenderScene\n" +
					  "{\n" +
					  "\tpass p0\n" +
					  "\t{\n" +
					  "\t\tVertexShader = compile vs_" + JEffectBuilder.VertexShaderVersion + " VShader();\n" +
					  "\t\tPixelShader = compile ps_" + JEffectBuilder.PixelShaderVersion + " PShader();\n" +
					  "\t}\n" +
					  "}";

			JEffect j;

			if (Jad.VideoRecorder.Enabled)
			{
				Effect effect = Effect.FromString(Jad.Video.Device, source, null, null, ShaderFlags.None, null);

				j = new JEffect("interno");
				j.DXResource = effect;
				j.GetHandles();
			}

			else
			{
#if DEBUG
				StreamWriter s = new StreamWriter("interno.fx");
				s.Write(source);
				s.Close();

				Save(source);

				j = new JEffect("interno");
				Jad.Video.Effects.Add(j);

				if (!j.Load())
					return null;
#else
				Effect effect = Effect.FromString(Haddd.Video.Device, source, null, null, ShaderFlags.None, null);

				h = new HEffect("interno");
				h.DXResource = effect;
				h.GetHandles();
#endif
			}

			return j;
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="sourceText">TODO</param>
		void Save(string sourceText)
		{
			if (numPreShader == 0)
			{
				// Delete the directory

				string[] files = Directory.GetFiles(JPath.GameDirectory + "Preshaders", "*.fx");
				for (int i = 0; i < files.Length; i++)
					File.Delete(files[i]);
			}

			numPreShader++;

			StreamWriter s = new StreamWriter(JPath.GameDirectory + @"Preshaders\shader" + numPreShader.ToString("D4") + ".fx");

			s.Write(UniqueEffectID.ToString());
			s.Write(sourceText);
			s.Close();
		}

		#endregion

		#region ZPass

		/// <summary>
		/// Creates the effect for the ZPass (and the shadowmap pass)
		/// </summary>
		/// <param name="material">TODO</param>
		/// <param name="shadowMap">TODO</param>
		/// <returns>The correct JEffect according to the parameters</returns>
		public JEffect SetZPass(JMaterialLayer material, bool shadowMap)
		{
			String hash;
			JEffect fx;

			// Create the unique index that identifies this shader
			UniqueEffectID.Reset();

			material.BuildHashCodeZPass(ref UniqueEffectID);

			if (Jad.Scene.Status == JSceneStatus.ParallaxPass)
				UniqueEffectID.Global |= (int) JUniqueEffectIDGlobal.ParallaxPass;

			if (Jad.Scene.Status == JSceneStatus.ParallaxShadowPass)
				UniqueEffectID.Global |= (int) JUniqueEffectIDGlobal.ParallaxShadowOnlyPass;

			if (shadowMap)
			{
				if (Jad.Scene.Status == JSceneStatus.ShadowMapGeneration)
					UniqueEffectID.Global |= (int) JUniqueEffectIDGlobal.GeneratingShadowMap;

				else
				{
					if (Jad.Scene.Shadows.ShadowMap.UsePCF)
						UniqueEffectID.Global |= (int) JUniqueEffectIDGlobal.GeneratingShadowMaskForShadowMapPCF;

					else
						UniqueEffectID.Global |= (int) JUniqueEffectIDGlobal.GeneratingShadowMaskForShadowMap;
				}
			}

			hash = UniqueEffectID.GeometryModifiersID + UniqueEffectID.Global;
			if (!effects.TryGetValue(hash, out fx))
			{
				fx = BuildZPass(material);

				effects.Add(hash, fx);
				NumberOfEffectsBuilt++;
				JLogWriter.Write("Effect Builded #:" + NumberOfEffectsBuilt.ToString(), true);
			}

			return fx;
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="material">TODO</param>
		/// <returns>TODO</returns>
		JEffect BuildZPass(JMaterialLayer material)
		{
			BuildGeometry(material, zPassFx);

			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.ZPass_WithAlphaTest) != 0)
				parameters.zPass = "ZPASS_WITHALPHATEST";

			else
				parameters.zPass = "ZPASS_WITHOUTALPHATEST";

			parameters.diffuseMapEnabled = ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.DiffuseMapEnabled) != 0 ? "true" : "false");
			parameters.parallaxMapping = ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.ParallaxMapping) != 0 ? "true" : "false");

			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.ParallaxOcclusion) != 0)
				parameters.parallaxOcclusion = "true";

			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.ParallaxPass) != 0)
				parameters.parallaxPass = "true";

			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.ParallaxShadowOnlyPass) != 0)
				parameters.parallaxShadowOnlyPass = "true";

			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.DetailMapEnabled) != 0)
				parameters.detailMapEnabled = "true";

			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.UseTexCoordForDetailMap) != 0)
				parameters.useTexCoordForDetailMap = "true";

			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.GeneratingShadowMap) != 0)
				parameters.generatingShadowMap = "true";

			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.GeneratingShadowMaskForShadowMapPCF) != 0)
				parameters.generatingShadowMaskForShadowMap = "2";

			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.GeneratingShadowMaskForShadowMap) != 0)
				parameters.generatingShadowMaskForShadowMap = "1";

			return Process();
		}

		#endregion

		#region FogPass

		/// <summary>
		/// Creates the effect according to the parameters
		/// </summary>
		/// <param name="material">TODO</param>
		/// <returns>The correct JEffect according to the parameters</returns>
		public JEffect SetFogPass(JMaterialLayer material)
		{
			String hash;
			JEffect fx;

			// Create the unique index that identifies this shader
			UniqueEffectID.Reset();

			material.BuildHashCodeGeometry(ref UniqueEffectID);

			UniqueEffectID.Global = (int) JUniqueEffectIDGlobal.FogPass;

			UniqueEffectID.Fog = (byte) Jad.Scene.Fog.Type;

			hash = UniqueEffectID.GeometryModifiersID + UniqueEffectID.Global;
			if (!effects.TryGetValue(hash, out fx))
			{
				fx = BuildFogPass(material);
				effects.Add(hash, fx);
				NumberOfEffectsBuilt++;
				JLogWriter.Write("Effect Builded #:" + NumberOfEffectsBuilt.ToString(), true);
			}

			return fx;
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="material">TODO</param>
		/// <returns>TODO</returns>
		JEffect BuildFogPass(JMaterialLayer material)
		{
			BuildGeometry(material, fogPassFx);

			parameters.FogPass = "true";
			parameters.fog = ((int) Jad.Scene.Fog.Type).ToString();

			return Process();
		}

		#endregion

		#region GlowDOFPass

		/// <summary>
		/// Creates the effect according to the parameters
		/// </summary>
		/// <param name="material">TODO</param>
		/// <returns>The correct JEffect according to the parameters</returns>
		public JEffect SetGlowDOFPass(JMaterialLayer material)
		{
			String hash;
			JEffect fx;

			// Create the unique index that identifies this shader
			UniqueEffectID.Reset();

			material.BuildHashCodeGlowDOFPass(ref UniqueEffectID);

			hash = UniqueEffectID.GeometryModifiersID + UniqueEffectID.Global;
			if (!effects.TryGetValue(hash, out fx))
			{
				fx = BuildGlowDOFPass(material);

				effects.Add(hash, fx);
				NumberOfEffectsBuilt++;
				JLogWriter.Write("Effect Builded #:" + NumberOfEffectsBuilt.ToString(), true);
			}

			return fx;
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="material">TODO</param>
		/// <returns>TODO</returns>
		JEffect BuildGlowDOFPass(JMaterialLayer material)
		{
			BuildGeometry(material, glowDOFPassFx);

			if (Jad.Scene.GlowEffect.Enabled)
			{
				parameters.emissiveEnabled = "true";
				parameters.emissiveModel = UniqueEffectID.EmissiveModel.ToString();
			}

			if (Jad.Scene.DepthOfField.Enabled)
				parameters.DOF = "true";

			return Process();
		}

		#endregion

		#region MotionBlurPass

		/// <summary>
		/// Creates the effect according to the parameters
		/// </summary>
		/// <param name="material">TODO</param>
		/// <returns>The correct JEffect according to the parameters</returns>
		public JEffect SetMotionBlurPass(JMaterialLayer material)
		{
			String hash;
			JEffect fx;

			// Create the unique index that identifies this shader
			UniqueEffectID.Reset();

			material.BuildHashCodeGeometry(ref UniqueEffectID);

			UniqueEffectID.Global |= (int) JUniqueEffectIDGlobal.MotionBlurPass;

			hash = UniqueEffectID.GeometryModifiersID + UniqueEffectID.Global;
			if (!effects.TryGetValue(hash, out fx))
			{
				fx = BuildMotionBlurPass(material);

				effects.Add(hash, fx);
				NumberOfEffectsBuilt++;
				JLogWriter.Write("Effect Builded #:" + NumberOfEffectsBuilt.ToString(), true);
			}

			return fx;
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="material">TODO</param>
		/// <returns>TODO</returns>
		JEffect BuildMotionBlurPass(JMaterialLayer material)
		{
			BuildGeometry(material, motionBlurPassFx);

			return Process();
		}

		#endregion

		#region LightPass

		/// <summary>
		/// Creates the effect according to the parameters
		/// </summary>
		/// <param name="light">TODO</param>
		/// <param name="material">TODO</param>
		/// <param name="applyAmbient">TODO</param>
		/// <returns>The correct JEffect according to the parameters</returns>
		public JEffect SetLightPass(JBaseLight light, JMaterialLayer material, bool applyAmbient)
		{
			String hash;
			JEffect fx;

			// Create the unique index that identifies this shader
			UniqueEffectID.Reset();

			material.BuildHashCodeLightPass(ref UniqueEffectID);

			bool diffuse = true;
			bool specular = material.SpecularMap.Enabled;

			if (light != null)
			{
				diffuse = diffuse && light.AffectDiffuse;
				specular = specular && light.AffectSpecular;

				light.BuildHashCode(ref UniqueEffectID);
			}

			else
				UniqueEffectID.Global |= (int) JUniqueEffectIDGlobal.AmbientOnly;

			// Test if its needed to apply the ambient light and if the color is not 0
			// (if its 0 then no need to apply it)
			if (applyAmbient && !Jad.Scene.Lights.Ambient.IsBlack())
				UniqueEffectID.Global |= (int) JUniqueEffectIDGlobal.ApplyAmbient;

			// If the normal map is disabled, change to per vertex normals
			if (!material.NormalMap.Enabled && material.NormalType == JNormalType.Mapping)
				UniqueEffectID.NormalType = (byte) JNormalType.Vertex;

			else
				UniqueEffectID.NormalType = (byte) material.NormalType;

			// Test if the normals are in WorldSpace or it these maps are enabled...
			if (material.Parent.WorldSpaceNormals || material.ReflectionMap.Enabled || material.RefractionMap.Enabled)
				JEffectBuilder.WorldSpaceNormals = "true";

			else
				JEffectBuilder.WorldSpaceNormals = "false";

			// Test if true was set
			if (JEffectBuilder.WorldSpaceNormals[0] == 't')
				UniqueEffectID.Global |= (int) JUniqueEffectIDGlobal.WorldSpaceNormals;

			// If rendering with shadows...
			if (Jad.Scene.RenderWithShadows)
				UniqueEffectID.Global |= (int) JUniqueEffectIDGlobal.ShadowsOnRender;

			if (diffuse)
				UniqueEffectID.Global |= (int) JUniqueEffectIDGlobal.AffectDiffuse;

			if (specular)
				UniqueEffectID.Global |= (int) JUniqueEffectIDGlobal.AffectSpecular;

			hash = UniqueEffectID.GeometryModifiersID + UniqueEffectID.Global;
			if (!effects.TryGetValue(hash, out fx))
			{
				fx = BuildLightPass(light, material);

				effects.Add(hash, fx);
				NumberOfEffectsBuilt++;
				JLogWriter.Write("Effect Builded #:" + NumberOfEffectsBuilt.ToString(), true);
			}

			return fx;
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="light">TODO</param>
		/// <param name="material">TODO</param>
		/// <returns>TODO</returns>
		JEffect BuildLightPass(JBaseLight light, JMaterialLayer material)
		{
			BuildGeometry(material, lightPassFx);

			// Assign the lighting fragments
			source = source.Replace("// ALLINONE:LIGHTING_PS", material.LightingFragment.PS);
			source = source.Replace("// ALLINONE:LIGHTING", material.LightingFragment.VS);

			// If the lightingfragment has vars, add them
			if (material.LightingFragment.Vars != null)
				source = material.LightingFragment.Vars + source;

			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.AffectDiffuse) != 0) parameters.affectDiffuse = "true";
			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.AffectSpecular) != 0) parameters.affectSpecular = "true";
			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.DiffuseMapEnabled) != 0) parameters.diffuseMapEnabled = "true";
			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.SpecularMapEnabled) != 0) parameters.specularMapEnabled = "true";
			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.DetailMapEnabled) != 0) parameters.detailMapEnabled = "true";
			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.ParallaxMapping) != 0) parameters.parallaxMapping = "true";
			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.ParallaxOcclusion) != 0) parameters.parallaxOcclusion = "true";
			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.ReflectionMapEnabled) != 0) parameters.reflectionMapEnabled = "true";
			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.RefractionMapEnabled) != 0) parameters.refractionMapEnabled = "true";
			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.UseTexCoordForDetailMap) != 0) parameters.useTexCoordForDetailMap = "true";
			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.ApplyAmbient) != 0) parameters.applyAmbient = "true";
			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.AmbientOnly) != 0) parameters.ambientOnly = "true";
			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.SphericalMapping) != 0) parameters.sphericalMapping = "true";

			parameters.normalType = ((int) UniqueEffectID.NormalType).ToString();

			// If light == null then its the ambient pass
			if (light != null)
			{
				parameters.lightType = light.NameInShaders;

				if (light.Projector.Enabled)
					parameters.projectorEnabled = "true";

				switch (light.AttenuationType)
				{
					case JLightAttenuationType.None:
						parameters.attenType = "ATTEN_NONE";
						break;

					case JLightAttenuationType.Inverse:
						parameters.attenType = "ATTEN_INVLINEAR";
						break;

					case JLightAttenuationType.InverseSquare:
						parameters.attenType = "ATTEN_INVSQUARE";
						break;

					case JLightAttenuationType.DualRadius:
						parameters.attenType = "ATTEN_DUALRADIUS";
						break;

					default:
						parameters.attenType = "ATTEN_DUALRADIUS";
						break;
				}

				parameters.volumetricLight = (light.Volumetric.Enabled ? "true" : "false");
				parameters.shadowsOnRender = (Jad.Scene.RenderWithShadows ? "true" : "false");
			}

			return Process();
		}

		#endregion

		#region PostPass

		/// <summary>
		/// Creates the effect according to the parameters
		/// </summary>
		/// <param name="material">TODO</param>
		/// <returns>The correct JEffect according to the parameters</returns>
		public JEffect SetPostPass(JMaterialLayer material)
		{
			String hash;
			JEffect fx;

			// Create the unique index that identifies this shader
			UniqueEffectID.Reset();

			material.BuildHashCodeGeometry(ref UniqueEffectID);

			UniqueEffectID.Global = (int) JUniqueEffectIDGlobal.PostPass;

			if (material.Parent.SphericalMapping)
				UniqueEffectID.Global |= (int) JUniqueEffectIDGlobal.SphericalMapping;

			// In the wireframe mode, use the material color
			if (material.DiffuseMap.TextureEnabled && material.DiffuseMap.Texture != null)
				UniqueEffectID.Global |= (int) JUniqueEffectIDGlobal.DiffuseMapEnabled;

			if (material.Ghost)
				UniqueEffectID.Global |= (int) JUniqueEffectIDGlobal.Ghost;

			hash = UniqueEffectID.GeometryModifiersID + UniqueEffectID.Global;
			if (!effects.TryGetValue(hash, out fx))
			{
				fx = BuildPostPass(material);

				effects.Add(hash, fx);
				NumberOfEffectsBuilt++;
				JLogWriter.Write("Effect Builded #:" + NumberOfEffectsBuilt.ToString(), true);
			}

			return fx;
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="material">TODO</param>
		/// <returns>TODO</returns>
		JEffect BuildPostPass(JMaterialLayer material)
		{
			BuildGeometry(material, postPassFx);

			parameters.diffuseMapEnabled = ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.DiffuseMapEnabled) != 0 ? "true" : "false");

			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.SphericalMapping) != 0)
				parameters.sphericalMapping = "true";

			if ((UniqueEffectID.Global & (int) JUniqueEffectIDGlobal.Ghost) != 0)
				parameters.ghost = "true";

			return Process();
		}

		#endregion
	}
}
