#region Using directives

using System.Collections.Generic;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

using JadEngine.Video;

#endregion

namespace JadEngine.Core
{
	/// <summary>
	/// TODO
	/// </summary>
	public class JShaderParams
	{
		#region Structs

		/// <summary>
		/// TODO
		/// </summary>
		public struct JVector4
		{
			#region Fields
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Name;
			
			/// <summary>
			/// TODO
			/// </summary>
			public Vector4 Vector;

			/// <summary>
			/// TODO
			/// </summary>
			public int Count;

			#endregion

			#region Constructors
			
			/// <summary>
			/// TODO
			/// </summary>
			/// <param name="name">TODO</param>
			/// <param name="value">TODO</param>
			/// <param name="count">TODO</param>
			public JVector4(string name, Vector4 value, int count)
			{
				Name = name;
				Vector = value;
				Count = count;
			}

			#endregion
		}

		/// <summary>
		/// TODO
		/// </summary>
		public struct JFloat
		{
			#region Fields
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Name;

			/// <summary>
			/// TODO
			/// </summary>
			public float Float;

			#endregion

			#region Constructors
			
			/// <summary>
			/// TODO
			/// </summary>
			/// <param name="name">TODO</param>
			/// <param name="value">TODO</param>
			public JFloat(string name, float value)
			{
				Name = name;
				Float = value;
			}

			#endregion
		}

		/// <summary>
		/// TODO
		/// </summary>
		public struct JBool
		{
			#region Fields
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Name;

			/// <summary>
			/// TODO
			/// </summary>
			public bool Bool;

			#endregion

			#region Constructors
			
			/// <summary>
			/// TODO
			/// </summary>
			/// <param name="name">TODO</param>
			/// <param name="value">TODO</param>
			public JBool(string name, bool value)
			{
				Name = name;
				Bool = value;
			}

			#endregion
		}

		/// <summary>
		/// TODO
		/// </summary>
		public struct JSampler
		{
			#region Fields
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Name;

			/// <summary>
			/// TODO
			/// </summary>
			public int Stage;

			/// <summary>
			/// TODO
			/// </summary>
			public JTextureBase Texture;

			#endregion
		}

		#endregion

		#region Fields

		/// <summary>
		/// TODO
		/// </summary>
		public List<JVector4> VectorList;

		/// <summary>
		/// TODO
		/// </summary>
		public List<JFloat> FloatList;

		/// <summary>
		/// TODO
		/// </summary>
		public List<JBool> BoolList;

		/// <summary>
		/// TODO
		/// </summary>
		public List<JSampler> SamplerList;

		#endregion

		#region Constructors

		/// <summary>
		/// Default constructor
		/// </summary>
		public JShaderParams()
		{
			VectorList = new List<JVector4>();
			FloatList = new List<JFloat>();
			BoolList = new List<JBool>();
			SamplerList = new List<JSampler>();
		}

		#endregion

		#region Methods

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="name">TODO</param>
		/// <param name="var">TODO</param>
		/// <param name="count">TODO</param>
		public void AddVector(string name, Vector4 var, int count)
		{
			JVector4 v = new JVector4();
			
			v.Name = name;
			v.Vector = var;
			v.Count = count;
			
			VectorList.Add(v);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="name">TODO</param>
		/// <param name="count">TODO</param>
		/// <returns>TODO</returns>
		public Vector4 GetVector(string name, out int count)
		{
			count = 4;

			foreach (JVector4 v in VectorList)
			{
				if (v.Name == name)
				{
					count = v.Count;
					return v.Vector;
				}
			}

			return Vector4.Empty;
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="name">TODO</param>
		/// <param name="value">TODO</param>
		/// <returns>TODO</returns>
		public bool SetVector(string name, Vector4 value)
		{
			int index = 0;
			bool found = false;

			while (!found && index < VectorList.Count)
			{
				JVector4 theVector = VectorList[index];
				if (theVector.Name == name)
				{
					theVector.Vector = value;
					VectorList[index] = new JVector4(name, value, theVector.Count);
					found = true;
				}

				index++;
			}

			return found;
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="name">TODO</param>
		/// <param name="var">TODO</param>
		public void AddFloat(string name, float var)
		{
			JFloat v = new JFloat();
			
			v.Name = name;
			v.Float = var;
			
			FloatList.Add(v);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="name">TODO</param>
		/// <returns></returns>
		public float GetFloat(string name)
		{
			foreach (JFloat v in FloatList)
				if (v.Name == name)
					return v.Float;

			return 0;
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="name">TODO</param>
		/// <param name="value">TODO</param>
		/// <returns>TODO</returns>
		public bool SetFloat(string name, float value)
		{
			int index = 0;
			bool found = false;

			while (!found && index < FloatList.Count)
			{
				JFloat theFloat = FloatList[index];
				if (theFloat.Name == name)
				{
					theFloat.Float = value;
					FloatList[index] = new JFloat(name, value);
					found = true;
				}

				index++;
			}

			return found;
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="name">TODO</param>
		/// <param name="var">TODO</param>
		public void AddBool(string name, bool var)
		{
			JBool v = new JBool();
			
			v.Name = name;
			v.Bool = var;
			
			BoolList.Add(v);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="name">TODO</param>
		/// <returns>TODO</returns>
		public bool GetBool(string name)
		{
			foreach (JBool v in BoolList)
				if (v.Name == name)
					return v.Bool;

			return false;
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="name">TODO</param>
		/// <param name="value">TODO</param>
		/// <returns>TODO</returns>
		public bool SetBool(string name, bool value)
		{
			int index = 0;
			bool found = false;

			while (!found && index < BoolList.Count)
			{
				JBool theBool = BoolList[index];
				if (theBool.Name == name)
				{
					theBool.Bool = value;
					BoolList[index] = new JBool(name, value);
					found = true;
				}

				index++;
			}

			return found;
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="sample">TODO</param>
		public void AddSampler(JSampler sample)
		{
			SamplerList.Add(sample);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="name">TODO</param>
		/// <param name="sampler">TODO</param>
		/// <returns>TODO</returns>
		public bool GetSampler(string name, out JSampler sampler)
		{
			sampler = new JSampler();

			foreach (JSampler s in SamplerList)
			{
				if (s.Name == name)
				{
					sampler = s;
					return true;
				}
			}

			return false;
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="effect">TODO</param>
        internal void Apply(JEffect effect)
        {
            EffectHandle handle;

            foreach (JBool elem in BoolList)
            {
                handle = effect.DXResource.GetParameter(null, elem.Name);
                if(handle!=null)
                    effect.DXResource.SetValue(handle, elem.Bool);
            }
			
            foreach (JFloat elem in FloatList)
            {
                handle = effect.DXResource.GetParameter(null, elem.Name);
                if (handle != null)
                    effect.DXResource.SetValue(handle, elem.Float);
            }
			
            foreach (JVector4 elem in VectorList)
            {
                handle = effect.DXResource.GetParameter(null, elem.Name);
                if (handle != null)
                    effect.DXResource.SetValue(handle, elem.Vector);
            }
        }
		
		#endregion
	}
}
