#region Using Directives

using System.Collections;

using JadEngine.Tools;

#endregion

namespace JadEngine
{
	/// <summary>
	/// Reads the Configuration.xml file and saves the information on the class
	/// </summary>
	public class JConfiguration
    {
        #region Structs

        /// <summary>
        /// Encapsulates the video properties
        /// </summary>
        public struct JVideoProperties
		{
			#region Structs

			/// <summary>
			/// Encapsulates the resolution properties
			/// </summary>
			public struct JResolutionProperties
			{
				#region Fields

				/// <summary>
				/// TODO
				/// </summary>
				public int Width;

				/// <summary>
				/// TODO
				/// </summary>
				public int Height;

				#endregion
			}

			#endregion
        	
			#region Fields
        	
			/// <summary>
        	/// TODO
        	/// </summary>
            public bool Windowed;
        	
        	/// <summary>
        	/// TODO
        	/// </summary>
			public bool HDR;

			/// <summary>
			/// TODO
			/// </summary>
			public JResolutionProperties Resolution;
        	
			#endregion
		}
        #endregion

        #region Fields

		/// <summary>
		/// TODO
		/// </summary>
        Hashtable attributes = null;

		/// <summary>
		/// Values related to video
		/// </summary>
		public JVideoProperties Video;
		
        #endregion
		
		#region Methods
		
        /// <summary>
        /// Gets a value from the xml file
        /// </summary>
        /// <param name="key">The name of the xml field</param>
        /// <returns>A string with the value for this field</returns>
		public string GetValue(string key)
		{
            return (string) attributes[key];
		}

		/// <summary>
		/// Reads the Configuration.xml file
		/// </summary>
		public void GetConfiguration()
        {
			attributes = new Hashtable();
			JXmlHandler.LoadXMLToHash(attributes, @"Configuration.xml");

			// Read the values from the configuration file
			Video.Resolution.Width = int.Parse(GetValue("Video.Resolution.Width"));
			Video.Resolution.Height = int.Parse(GetValue("Video.Resolution.Height"));
			
			string fullscreen = GetValue("Video.FullScreen");
			Video.Windowed = !bool.Parse(fullscreen);
			
			Video.HDR = bool.Parse(GetValue("Video.HDR"));
		}

		#endregion
	}
}
