#region Using directives

using System;

#endregion

namespace JadEngine.Mathematics
{
    /// <summary>
    /// A class to compute the perlin noise
    /// </summary>
    /// <remarks>
	/// /*
	/// /**********\      .---.         .-"-.      /**************************\
	/// * -------- *     /   ._.       /  ` \     * ------------------------ *
	/// * Author's *     \_  (__\      \_v_/     * emiper-8@student.luth.se *
	/// *   note   *     //   \\       //   \\     * ICQ #47010716            *
	/// * -------- *    ((     ))     ((     ))    * ------------------------ *
	/// *          ****--""---""-------""---""--****                          *
	/// * This file is a part of the work done by Humus. You are free to use  *
	/// * the code in any way you like, modified, unmodified or copy'n'pasted *
	/// * into your own work. However, I expect you to respect these points:  *
	/// *  @ If you use this file and its contents unmodified, or use a major *
	/// *    part of this file, please credit the author and leave this note. *
	/// *  @ For use in anything commercial, please request my approval.      *
	/// *  @ Share your work and ideas too as much as you can.                *
	/// \*********************************************************************/
	///
	/// /*
	///	Credits:
	///
	///	This file is based on the great work done by Ken Perlin.
	///	http://mrl.nyu.edu/~perlin/doc/oscar.html
	///
	/// */
    /// </remarks>
	public sealed class JPerlinNoise
	{
		#region Constants

    	/// <summary>
    	/// TODO
    	/// </summary>
		const int B = 0x1000;

		/// <summary>
		/// TODO
		/// </summary>
		const int BM = 0xff;

		/// <summary>
		/// TODO
		/// </summary>
		const int N = 0x1000;

		/// <summary>
		/// TODO
		/// </summary>
		const int NP = 12;   /* 2^N */

		/// <summary>
		/// TODO
		/// </summary>
		const int NM = 0xfff;

		#endregion

		#region Fields

		/// <summary>
    	/// TODO
    	/// </summary>
		static int[] p;

		/// <summary>
		/// TODO
		/// </summary>
		static float[,] g3;

		/// <summary>
		/// TODO
		/// </summary>
		static float[,] g2;

		/// <summary>
		/// TODO
		/// </summary>
		static float[] g1;

		/// <summary>
		/// TODO
		/// </summary>
		static Random r;

		/// <summary>
		/// TODO
		/// </summary>
		public static float Frecuency = 0.05f;

		/// <summary>
		/// TODO
		/// </summary>
		public static float Persistency = 0.65f;

    	//TODO (VICENTE): CHANGE THIS
		/// <summary>
		/// TODO
		/// </summary>
		public static int numOctavas = 8;

		/// <summary>
		/// TODO
		/// </summary>
		public static float Amplitude = 1;
    	
		/// <summary>
		/// TODO
		/// </summary>
		public static bool Tileable = false;

		/// <summary>
		/// TODO
		/// </summary>
		public static float Width = 200;

		/// <summary>
		/// TODO
		/// </summary>
		public static float Height = 200;

    	#endregion

		#region Constructors

        /// <summary>
        /// Default constructor
        /// </summary>
		private JPerlinNoise()
		{

			p = new int[B + B + 2];
			g3 = new float[B + B + 2, 3];
			g2 = new float[B + B + 2, 2];
			g1 = new float[B + B + 2];

			r = new Random();

			ComputeRandomTable();
		}

		#endregion

		#region Methods

    	/// <summary>
    	/// TODO
    	/// </summary>
		/// <param name="t">TODO</param>
		/// <returns>TODO</returns>
		static float s_curve(float t)
		{
			return (t * t * (3 - 2 * t));
		}
		
    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="t">TODO</param>
		/// <param name="a">TODO</param>
		/// <param name="b">TODO</param>
    	/// <returns></returns>
		static float lerp(float t, float a, float b)
		{
			return (a + t * (b - a));
		}

    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="i">TODO</param>
		/// <param name="b0">TODO</param>
		/// <param name="b1">TODO</param>
		/// <param name="r0">TODO</param>
		/// <param name="r1">TODO</param>
		static void setup(float i, out int b0, out int b1, out float r0, out float r1)
		{
			float t = i + N;
			b0 = ((int) t) & BM;
			b1 = (b0 + 1) & BM;
			r0 = t - (int) t;
			r1 = r0 - 1;
		}

    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="x">TODO</param>
		/// <returns>TODO</returns>
		static float noise1(float x)
		{
			int bx0, bx1;
			float rx0, rx1, sx, u, v;

			setup(x, out bx0,out bx1, out rx0,out rx1);

			sx = s_curve(rx0);

			u = rx0 * g1[p[bx0]];
			v = rx1 * g1[p[bx1]];

			return lerp(sx, u, v);
		}

    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="rx">TODO</param>
		/// <param name="ry">TODO</param>
		/// <param name="i">TODO</param>
    	/// <returns></returns>
		static float at2(float rx, float ry, int i)
		{
			return (rx * g2[i,0] + ry * g2[i,1]);
		}

    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="x">TODO</param>
		/// <param name="y">TODO</param>
		/// <returns>TODO</returns>
		static float noise2(float x, float y)
		{
			int bx0, bx1, by0, by1, b00, b10, b01, b11;
			float rx0, rx1, ry0, ry1, sx, sy, a, b, u, v;
			int i, j;

			setup(x, out bx0,out bx1, out rx0,out rx1);
			setup(y, out by0,out by1, out ry0,out ry1);

			i = p[bx0];
			j = p[bx1];

			b00 = p[i + by0];
			b10 = p[j + by0];
			b01 = p[i + by1];
			b11 = p[j + by1];

			sx = s_curve(rx0);
			sy = s_curve(ry0);


			u = at2(rx0,ry0,b00);
			v = at2(rx1,ry0,b10);
			a = lerp(sx, u, v);

			u = at2(rx0,ry1,b01);
			v = at2(rx1,ry1,b11);
			b = lerp(sx, u, v);

			return lerp(sy, a, b);
		}

    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="rx">TODO</param>
		/// <param name="ry">TODO</param>
		/// <param name="rz">TODO</param>
		/// <param name="i">TODO</param>
		/// <returns>TODO</returns>
		static float at3(float rx, float ry, float rz, int i)
		{
			return (rx * g3[i,0] + ry * g3[i,1] + rz * g3[i,2]);
		}

    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="x">TODO</param>
		/// <param name="y">TODO</param>
		/// <param name="z">TODO</param>
		/// <returns>TODO</returns>
		static float noise3(float x, float y, float z)
		{
			int bx0, bx1, by0, by1, bz0, bz1, b00, b10, b01, b11;
			float rx0, rx1, ry0, ry1, rz0, rz1, sy, sz, a, b, c, d, t, u, v;
			int i, j;

			setup(x, out bx0,out bx1, out rx0,out rx1);
			setup(y, out by0,out by1, out ry0,out ry1);
			setup(z, out bz0,out bz1, out rz0,out rz1);

			i = p[bx0];
			j = p[bx1];

			b00 = p[i + by0];
			b10 = p[j + by0];
			b01 = p[i + by1];
			b11 = p[j + by1];

			t  = s_curve(rx0);
			sy = s_curve(ry0);
			sz = s_curve(rz0);

			u = at3(rx0, ry0, rz0, b00 + bz0);
			v = at3(rx1, ry0, rz0, b10 + bz0);
			a = lerp(t, u, v);

			u = at3(rx0, ry1, rz0, b01 + bz0);
			v = at3(rx1, ry1, rz0, b11 + bz0);
			b = lerp(t, u, v);

			c = lerp(sy, a, b);

			u = at3(rx0, ry0, rz1, b00 + bz1);
			v = at3(rx1, ry0, rz1, b10 + bz1);
			a = lerp(t, u, v);

			u = at3(rx0, ry1, rz1, b01 + bz1);
			v = at3(rx1, ry1, rz1, b11 + bz1);
			b = lerp(t, u, v);

			d = lerp(sy, a, b);

			return lerp(sz, c, d);
		}

		/// <summary>
        /// Returns a value between 0 and 1 computing the noise for this position
		/// </summary>
		/// <param name="x">x</param>
		/// <param name="y">y</param>
		/// <returns>A [0,1] value</returns>
		public static float GetNoise(int x, int y)
		{
			float total = 0;
			float amplitude = Amplitude;
			float freq_factor = Frecuency;

			float i = (float)x, j = (float)y;

			for (int k = 0; k < numOctavas; k++)
			{
				float v;

				if (Tileable)
					v = tileableNoise2(i * freq_factor, j * freq_factor, Width * freq_factor, Height * freq_factor);
				
				else
					v = noise2(i * freq_factor, j * freq_factor);

				total += v * amplitude;
				amplitude *= Persistency;
				freq_factor *= 2;
			}

			total = total * 0.5f + 0.5f;

			if (total < 0) total = 0.0f;
			if (total > 1) total = 1.0f;

			return total;
		}

    	/// <summary>
    	/// TODO
    	/// </summary>
		/// <param name="i">TODO</param>
		static void normalize2(int i)
		{
			float s = 1.0f / (float)Math.Sqrt(g2[i, 0] * g2[i, 0] + g2[i, 1] * g2[i, 1]);
			g2[i, 0] *= s;
			g2[i, 1] *= s;
		}

    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="i">TODO</param>
		static void normalize3(int i)
		{
			float s = 1.0f / (float)Math.Sqrt(g3[i, 0] * g3[i, 0] + g3[i, 1] * g3[i, 1] + g3[i, 2] * g3[i, 2]);
			g3[i, 0] *= s;
			g3[i, 1] *= s;
			g3[i, 2] *= s;
		}

    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="x">TODO</param>
		/// <param name="y">TODO</param>
		/// <param name="freq">TODO</param>
		/// <returns>TODO</returns>
		static float turbulence2(float x, float y, float freq)
		{
			float t = 0.0f;

			do {
				t += noise2(freq * x, freq * y) / freq;
				freq *= 0.5f;
			} while (freq >= 1.0f);
	        
			return t;
		}

    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="x">TODO</param>
		/// <param name="y">TODO</param>
		/// <param name="z">TODO</param>
		/// <param name="freq">TODO</param>
		/// <returns>TODO</returns>
		static float turbulence3(float x, float y, float z, float freq)
		{
			float t = 0.0f;

			do {
				t += noise3(freq * x, freq * y, freq * z) / freq;
				freq *= 0.5f;
			} while (freq >= 1.0f);
	        
			return t;
		}

    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="x">TODO</param>
		/// <param name="w">TODO</param>
		/// <returns>TODO</returns>
		static float tileableNoise1(float x, float w)
		{
			return (noise1(x)     * (w - x) +
					noise1(x - w) *      x) / w;
		}

    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="x">TODO</param>
		/// <param name="y">TODO</param>
		/// <param name="w">TODO</param>
		/// <param name="h">TODO</param>
		/// <returns>TODO</returns>
		static float tileableNoise2(float x, float y, float w, float h)
		{
			return (noise2(x,     y)     * (w - x) * (h - y) +
					noise2(x - w, y)     *      x  * (h - y) +
					noise2(x,     y - h) * (w - x) *      y  +
					noise2(x - w, y - h) *      x  *      y) / (w * h);
		}

    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="x">TODO</param>
		/// <param name="y">TODO</param>
		/// <param name="z">TODO</param>
		/// <param name="w">TODO</param>
		/// <param name="h">TODO</param>
		/// <param name="d">TODO</param>
    	/// <returns></returns>
		static float tileableNoise3(float x, float y, float z, float w, float h, float d)
		{
			return (noise3(x,     y,     z)     * (w - x) * (h - y) * (d - z) +
					noise3(x - w, y,     z)     *      x  * (h - y) * (d - z) +
					noise3(x,     y - h, z)     * (w - x) *      y  * (d - z) +
					noise3(x - w, y - h, z)     *      x  *      y  * (d - z) + 
					noise3(x,     y,     z - d) * (w - x) * (h - y) *      z  +
					noise3(x - w, y,     z - d) *      x  * (h - y) *      z  +
					noise3(x,     y - h, z - d) * (w - x) *      y  *      z  +
					noise3(x - w, y - h, z - d) *      x  *      y  *      z) / (w * h * d);
		}

    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="x">TODO</param>
		/// <param name="y">TODO</param>
		/// <param name="w">TODO</param>
		/// <param name="h">TODO</param>
		/// <param name="freq">TODO</param>
		/// <returns>TODO</returns>
		static float tileableTurbulence2(float x, float y, float w, float h, float freq)
		{
			float t = 0.0f;

			do {
				t += tileableNoise2(freq * x, freq * y, w * freq, h * freq) / freq;
				freq *= 0.5f;
			} while (freq >= 1.0f);
	        
			return t;
		}

    	/// <summary>
    	/// TODO
    	/// </summary>
		/// <param name="x">TODO</param>
		/// <param name="y">TODO</param>
		/// <param name="z">TODO</param>
		/// <param name="w">TODO</param>
		/// <param name="h">TODO</param>
		/// <param name="d">TODO</param>
		/// <param name="freq">TODO</param>
		/// <returns>TODO</returns>
		static float tileableTurbulence3(float x, float y, float z, float w, float h, float d, float freq)
		{
			float t = 0.0f;

			do {
				t += tileableNoise3(freq * x, freq * y, freq * z, w * freq, h * freq, d * freq) / freq;
				freq *= 0.5f;
			} while (freq >= 1.0f);
	        
			return t;
		}

    	/// <summary>
		/// Generates a random number
    	/// </summary>
		/// <returns>An int random value</returns>
		static int rand()
		{
			return r.Next();
		}

		/// <summary>
		/// Computes the random table
		/// </summary>
		public static void ComputeRandomTable()
		{
			int i, j, k;

			for (i = 0; i < B; i++)
			{
				p[i] = i;

				g1[i] = (float)((rand() % (B + B)) - B) / B;

				for (j = 0; j < 2; j++)
					g2[i, j] = (float)((rand() % (B + B)) - B) / B;

				normalize2(i);

				for (j = 0; j < 3; j++)
					g3[i, j] = (float)((rand() % (B + B)) - B) / B;

				normalize3(i);
			}

			while (--i>=0)
			{
				k = p[i];
				p[i] = p[j = rand() % B];
				p[j] = k;
			}

			for (i = 0; i < B + 2; i++)
			{
				p[B + i] = p[i];
				g1[B + i] = g1[i];
				for (j = 0; j < 2; j++)
					g2[B + i,j] = g2[i,j];
				for (j = 0; j < 3; j++)
					g3[B + i,j] = g3[i,j];
			}
		}
    	
		#endregion
	}
}
