namespace JadEngine.Tools
{
	/// <summary>
	/// TODO
	/// </summary>
	public class JArray
	{
		#region Methods
		
		/// <summary>
		/// Copies a 32 bits array to a 16 bit array
		/// </summary>
		/// <param name="source">Source array</param>
		/// <param name="dest">Destination array</param>
		/// <param name="num">Number of elements to copy</param>
		public static unsafe void CopyInt32ToInt16(int[] source, ushort[] dest, int num)
		{
			fixed (int* s = source)
			{
				ushort* ps = (ushort*)s;

				fixed (ushort* d = dest)
				{
					ushort* pd = d;

					for (int i = 0; i < num; i++, ps += 2)
						*pd++ = *ps;
				}
			}
		}

		/// <summary>
		/// Copies a 16 bits array to a 32 bit array
		/// </summary>
		/// <param name="source">Source array</param>
		/// <param name="dest">Destination array</param>
		/// <param name="num">Number of elements to copy</param>
		public static unsafe void CopyInt16ToInt32(ushort[] source, int[] dest, int num)
		{
			fixed (ushort* s = source)
			{
				ushort* ps = s;

				fixed (int* d = dest)
				{
					int* pd = d;

					for (int i = 0; i < num; i++)
						*pd++ = *ps++;
				}
			}
		}

		/// <summary>
		/// Copies a 16 bits array to a 32 bit array
		/// </summary>
		/// <param name="source">Source array</param>
		/// <param name="dest">Destination array</param>
		/// <param name="num">Number of elements to copy</param>
		public static unsafe void CopyInt16ToInt32(short[] source, int[] dest, int num)
		{
			fixed (short* s = source)
			{
				short* ps = s;

				fixed (int* d = dest)
				{
					int* pd = d;

					for (int i = 0; i < num; i++)
						*pd++ = *ps++;
				}
			}
		}

		#endregion
	}
}
