#region Using directives

using System;
using System.IO;
using System.Text;
using System.Diagnostics;

#endregion

namespace JadEngine.Tools
{
    /// <summary>
    /// LogWriter class
    /// </summary>
    public static class JLogWriter
	{
		#region Enums
    	
		/// <summary>
    	/// TODO
    	/// </summary>
		public enum Style
		{
    		/// <summary>
    		/// TODO
    		/// </summary>
			Bold,

			/// <summary>
			/// TODO
			/// </summary>
			Italic,

			/// <summary>
			/// TODO
			/// </summary>
			Underlined,

			/// <summary>
			/// TODO
			/// </summary>
			Emphasis,

			/// <summary>
			/// TODO
			/// </summary>
			Strong,

			/// <summary>
			/// TODO
			/// </summary>
			Code,

			/// <summary>
			/// TODO
			/// </summary>
			Citation,

			/// <summary>
			/// TODO
			/// </summary>
			Keyboard,

			/// <summary>
			/// TODO
			/// </summary>
			Sample,

			/// <summary>
			/// TODO
			/// </summary>
			Teletype,

			/// <summary>
			/// TODO
			/// </summary>
			Big,

			/// <summary>
			/// TODO
			/// </summary>
			Small,

			/// <summary>
			/// TODO
			/// </summary>
			Subindex,

			/// <summary>
			/// TODO
			/// </summary>
			Superindex,

			/// <summary>
			/// TODO
			/// </summary>
			Blink,

			/// <summary>
			/// TODO
			/// </summary>
			Strike
		}

		#endregion

		#region Fields
    	
		/// <summary>
		/// TODO
		/// </summary>
		private static bool Disposed;
    	
    	/// <summary>
    	/// TODO
    	/// </summary>
		private static StreamWriter stream;

    	/// <summary>
    	/// TODO
    	/// </summary>
		static string[] codeStyle = { "B", "I", "U", "EM", "STRONG", "CODE", "CITE", "KBD", "SAMP", "TT", "BIG", "SMALL", "SUB", "SUP", "BLINK", "STRIKE" };

		#endregion

		#region Methods
    	
		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="file">TODO</param>
        public static void Create(string file)
        {
            Disposed = false;
            stream = new StreamWriter(file + ".htm", false, Encoding.Unicode);

            // Write the header
            stream.WriteLine("<html><h1>LOG Jad</h1>");
            stream.Flush();
        }

    	/// <summary>
    	/// TODO
    	/// </summary>
		/// <param name="Disposing">TODO</param>
        public static void Dispose(bool Disposing)
        {
            if (!Disposed)
            {
                if (Disposing)
                {
                }
            	
                stream.Close();
                stream = null;
                Disposed = true;
            }
        }

    	/// <summary>
    	/// TODO
    	/// </summary>
		public static void Close()
        {
            stream.WriteLine("</html>");
            Dispose(true);
        }

    	/// <summary>
    	/// TODO
    	/// </summary>
		/// <param name="style">TODO</param>
		/// <returns>TODO</returns>
		private static string CodeStyle(Style style)
        {
            return "<" + codeStyle[(int)style] + ">";
        }

    	/// <summary>
    	/// TODO
    	/// </summary>
		public static void TestStyle()
        {
            for (int i = 0; i < (int)Style.Strike + 1; i++)
				Write("Style test", true, (Style)i);

            WriteSeparator();
			Write("Another one", true, Style.Bold, Style.Italic);
		}

    	/// <summary>
    	/// TODO
    	/// </summary>
		/// <param name="text">TODO</param>
		/// <param name="breakline">TODO</param>
		/// <param name="styles">TODO</param>
		public static void Write(string text, bool breakline, params Style[] styles)
        {
            string codes = "", closings = "";

            for (int i = 0; i < styles.Length; i++)
            {
                string code = CodeStyle(styles[i]);

                codes += code;
                closings+="</" + code.Substring(1);
            }

			Write(codes + text + closings, breakline);
		}

    	/// <summary>
    	/// TODO
    	/// </summary>
		/// <param name="text">TODO</param>
		public static void WriteMethod(string text)
        {
            StackTrace stack = new StackTrace();
			WriteLine("Class:" + stack.GetFrame(1).GetMethod().ReflectedType.FullName);
			WriteLine("Method:" + stack.GetFrame(1).GetMethod().ToString());
		}

    	/// <summary>
    	/// TODO
    	/// </summary>
		public static void WriteSeparator()
        {
			WriteSeparator(100, 3, System.Drawing.Color.Blue.ToArgb() & 0x00ffffff);
		}

    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="widthPercent">TODO</param>
		/// <param name="height">TODO</param>
		/// <param name="color">TODO</param>
		public static void WriteSeparator(int widthPercent, int height, int color)
		{
            string hex = String.Format("{0:X8}", color);

            stream.WriteLine("<HR WIDTH=" + widthPercent.ToString() + "% SIZE=" + height.ToString() + " COLOR=#" + hex, false);
            stream.WriteLine("<BR>");
        }

    	/// <summary>
    	/// TODO
    	/// </summary>
		/// <param name="text">TODO</param>
		/// <param name="breakline">TODO</param>
		public static void Write(string text, bool breakline)
		{
            stream.WriteLine(text);

            if (breakline)
            	stream.WriteLine("<BR>");

            stream.Flush();
        }

    	/// <summary>
    	/// TODO
    	/// </summary>
		/// <param name="text">TODO</param>
		public static void WriteLine(string text)
		{
			Write(text, true);
		}

    	/// <summary>
    	/// TODO
    	/// </summary>
		/// <param name="breakLine">TODO</param>
		/// <param name="text">TODO</param>
		/// <param name="args">TODO</param>
		public static void Write(bool breakLine, string text, params object[] args)
		{
			for (int i = 0; i < args.Length; i++)
				text = text.Replace("{" + i + "}", args[i].ToString());

			stream.WriteLine(text);

			if (breakLine)
				stream.WriteLine("<BR>");

			stream.Flush();
		}

		#endregion
	}
}
