#region Using directives

using System;
using System.Drawing;
using System.Windows.Forms;

#endregion

namespace JadEngine.Video
{
	/// <summary>
	/// Class that creates the default form associated with the engine
	/// </summary>
	public class JBaseForm : Form
	{
		#region Constructors
		
		/// <summary>
		/// Default constructor
		/// </summary>
		public JBaseForm()
		{
			// Set the initial size of our form
			ClientSize = new Size(Jad.Video.Adapter.Initialization.PresentParams.BackBufferWidth,
													  Jad.Video.Adapter.Initialization.PresentParams.BackBufferHeight);
			// And its caption
			Text = "Jad 3D Engine";

			StartPosition = FormStartPosition.CenterScreen;
            
            // No resize in full screen
			if(Jad.Configuration.Video.Windowed) Resize += new EventHandler(form_Resize);
		}

		#endregion

		#region Methods
		
		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="e">TODO</param>
		protected override void OnActivated(EventArgs e)
		{
			if (Jad.Input != null)
				Jad.Input.Acquire();
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="sender">TODO</param>
		/// <param name="e">TODO</param>
		private void form_Resize(object sender, EventArgs e)
		{
			Form f = (Form)sender;

			Size s = f.Size;

			if (!Jad.Active) return;

			// Modify the parameters to indicate the size change
			Jad.Video.Adapter.Initialization.PresentParams.BackBufferWidth = s.Width;
			Jad.Video.Adapter.Initialization.PresentParams.BackBufferHeight = s.Height;

			// Reset the device. This will call the Lost and Reset events of the device
            Jad.Video.Adapter.Reset();
		}

		#endregion
	}
}
