#region Using Directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using Microsoft.DirectX;

using JadEngine.Particles;

#endregion

namespace Viewer
{
	public partial class ParticleSystemEmitterBoxPanel: UserControl
	{
		#region Events

		public event EventHandler EmitterChanged;

		#endregion

		#region Fields

		public JEmitterBox Emitter;

		#endregion

		#region Constructors

		public ParticleSystemEmitterBoxPanel()
		{
			InitializeComponent();
		}

		#endregion

		#region Methods

		public void UpdateEmitter(JEmitterBox emitter)
		{
			Emitter = emitter;

			numEmitterBoxMinX.Value = (decimal)emitter.MinPoint.X;
			numEmitterBoxMinY.Value = (decimal)emitter.MinPoint.Y;
			numEmitterBoxMinZ.Value = (decimal)emitter.MinPoint.Z;

			numEmitterBoxMaxX.Value = (decimal)emitter.MaxPoint.X;
			numEmitterBoxMaxY.Value = (decimal)emitter.MaxPoint.Y;
			numEmitterBoxMaxZ.Value = (decimal)emitter.MaxPoint.Z;
		}

		protected virtual void OnEmitterChange(EventArgs e)
		{
			if (EmitterChanged != null)
				EmitterChanged(this, e);
		}

		#endregion

		#region Event Handlers

		private void numEmitterBoxMinX_ValueChanged(object sender, EventArgs e)
		{
			Emitter.MinPoint = new Vector3((float)numEmitterBoxMinX.Value, Emitter.MinPoint.Y, Emitter.MinPoint.Z);
			OnEmitterChange(new EventArgs());
		}

		private void numEmitterBoxMinY_ValueChanged(object sender, EventArgs e)
		{
			Emitter.MinPoint = new Vector3(Emitter.MinPoint.X, (float)numEmitterBoxMinY.Value, Emitter.MinPoint.Z);
			OnEmitterChange(new EventArgs());
		}

		private void numEmitterBoxMinZ_ValueChanged(object sender, EventArgs e)
		{
			Emitter.MinPoint = new Vector3(Emitter.MinPoint.X, Emitter.MinPoint.Y, (float)numEmitterBoxMinZ.Value);
			OnEmitterChange(new EventArgs());
		}

		private void numEmitterBoxMaxX_ValueChanged(object sender, EventArgs e)
		{
			Emitter.MaxPoint = new Vector3((float)numEmitterBoxMaxX.Value, Emitter.MaxPoint.Y, Emitter.MaxPoint.Z);
			OnEmitterChange(new EventArgs());
		}

		private void numEmitterBoxMaxY_ValueChanged(object sender, EventArgs e)
		{
			Emitter.MaxPoint = new Vector3(Emitter.MaxPoint.X, (float)numEmitterBoxMaxY.Value, Emitter.MaxPoint.Z);
			OnEmitterChange(new EventArgs());
		}

		private void numEmitterBoxMaxZ_ValueChanged(object sender, EventArgs e)
		{
			Emitter.MaxPoint = new Vector3(Emitter.MaxPoint.X, Emitter.MaxPoint.Y, (float)numEmitterBoxMaxZ.Value);
			OnEmitterChange(new EventArgs());
		}

		#endregion
	}
}
