#region Using Directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using Microsoft.DirectX;

using JadEngine.Particles;

#endregion

namespace Viewer
{
	public partial class ParticleSystemEmitterSpherePanel: UserControl
	{
		#region Events

		public event EventHandler EmitterChanged;

		#endregion

		#region Fields

		public JEmitterSphere Emitter;

		#endregion

		#region Constructors

		public ParticleSystemEmitterSpherePanel()
		{
			InitializeComponent();
		}

		#endregion

		#region Methods

		public void UpdateEmitter(JEmitterSphere emitter)
		{
			Emitter = emitter;

			numEmitterSphereRadius.Value = (decimal)emitter.Radius;
			chkEmitterSphereOnSphere.Checked = emitter.OnSphere;
		}

		protected virtual void OnEmitterChange(EventArgs e)
		{
			if (EmitterChanged != null)
				EmitterChanged(this, e);
		}

		#endregion

		#region Event Handlers

		private void numEmitterSphereRadius_ValueChanged(object sender, EventArgs e)
		{
			Emitter.Radius = (float)numEmitterSphereRadius.Value;
			OnEmitterChange(new EventArgs());
		}

		private void checkBox1_CheckedChanged(object sender, EventArgs e)
		{
			Emitter.OnSphere = chkEmitterSphereOnSphere.Checked;
			OnEmitterChange(new EventArgs());
		}

		#endregion
	}
}
