#region Using directives

using System;
using System.IO;

#endregion

namespace Tutorial
{
	/// <summary>
	/// Class that holds the main method. Its the application entry point
	/// </summary>
	public class JMain
	{
		#region Methods

		/// <summary>
		/// Application entry point
		/// </summary>
		[STAThreadAttribute]
		static void Main()
		{
			// Set the engine base directory (where the configuration.xml file is located)
			JadEngine.Core.JPath.ChangeDirectory();

			// Create a new file where well write console output
			StreamWriter sw = new StreamWriter("out.txt");

			// Redirect console output to this file
			Console.SetOut(sw);

			// Create the application object
			SimpleScene app = new SimpleScene();

			// Start the application
			app.Start();

			// Close console output file
			sw.Close();
		}

		#endregion
	}
}