#region Using Directives

using System;
using System.Collections.Generic;
using System.Text;

using JadEngine.Animation.Skeleton;
using JadEngine.Animation.Skin;

#endregion

namespace JadEngine.Animation
{
    class JSkeletalAnimation
    {
        #region Fields

        /// <summary>
        /// Animation clips
        /// </summary>
        private JAnimationClip[] clips;

        /// <summary>
        /// Reference to skin information
        /// </summary>
        private JSkin skin;

        /// <summary>
        /// Reference to skeleton
        /// </summary>
        private JSkeleton skeleton;

        #endregion

        #region Constructors

        /// <summary>
        /// Default constructor
        /// </summary>
        public JSkeletalAnimation()
        {
            clips = null;
            skin = null;
            skeleton = null;
        }

        #endregion

        #region Methods

        /// <summary>
        /// Plays an animation clip with a given speed
        /// </summary>
        /// <param name="name">Clip's name to play</param>
        /// <param name="speed">Animation speed, float multiplier</param>
        public void StartAnimationClip(string name, float speed)
        {
        }

        /// <summary>
        /// Plays a sequence of animation clips
        /// </summary>
        /// <param name="name">Array with clip names to be played in order</param>
        /// <param name="speed">Array of play speeds corresponding to each clip, float multiplier</param>
        public void StartAnimationSequence(string[] name, float[] speed)
        {
        }

        /// <summary>
        /// Updates the animation using time parameter
        /// </summary>
        /// <param name="time">Time passed since last update</param>
        public void UpdateAnimation(float time)
        {
        }

        #endregion

    }
}
