#region Using directives

using System;
using System.IO;

using JadEngine.Core;
using JadEngine.Collections;

#endregion

namespace JadEngine.Core
{
	/// <summary>
	/// TODO
	/// </summary>
	public class JEffectFragment : IJListable
	{
		#region Fields

		/// <summary>
		/// TODO
		/// </summary>
		static int IDGlobal = 0;

		/// <summary>
		/// TODO
		/// </summary>
		int id;

		/// <summary>
		/// TODO
		/// </summary>
		protected string name;

		/// <summary>
		/// TODO
		/// </summary>
		string Code;

		/// <summary>
		/// Maintains the vars list that are enumerated in AllInOne
		/// </summary>
		public JListString EnumValues;

		/// <summary>
		/// TODO
		/// </summary>
		public string Vars;

		/// <summary>
		/// TODO
		/// </summary>
		public string VS;

		/// <summary>
		/// TODO
		/// </summary>
		public string PS;

		#endregion

		#region Constructors

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="filename">TODO</param>
		/// <param name="stream">TODO</param>
		public JEffectFragment(string filename, Stream stream)
		{
			// Assign the ID to be able to identify this fragment
			id = ++IDGlobal;

			StreamReader st = new StreamReader(stream);
			Code = st.ReadToEnd();
			st.Close();

			name = Path.GetFileNameWithoutExtension(filename);

			VS = null;
			PS = null;

			Build();
		}

		#endregion

		#region Properties

		/// <summary>
		/// Gets or sets the name value
		/// </summary>
		public string Name
		{
			get { return name; }
			set { name = value; }
		}

		/// <summary>
		/// Gets the ID value
		/// </summary>
		public int ID
		{
			get { return id; }
		}

		#endregion

		#region Methods

		/// <summary>
		/// TODO
		/// </summary>
		void Build()
		{
			// Search the enum
			int psEnd = Code.IndexOf("#end Enum");

			if (psEnd != -1)
			{
				EnumValues = new JListString();

				JEffectFragments.ParseEnum(EnumValues, Code.Substring(0, psEnd));

				Code = Code.Substring(psEnd + 9);
			}

			// Search the VAR start
			int vsInit = Code.IndexOf("#region VAR");

			if (vsInit != -1)
			{
				vsInit += 12;

				int vsEnd = Code.IndexOf("#end VAR");

				if (vsEnd == -1)
					throw new Exception("Not found '#end VAR'");

				Vars = "// " + name + "\n" + Code.Substring(vsInit, (vsEnd) - (vsInit)) + "\n\n";
			}

			// Search the VS start
			vsInit = Code.IndexOf("#region VS");

			if (vsInit != -1)
			{
				vsInit += 11;

				int vsEnd = Code.IndexOf("#end VS");

				if (vsEnd == -1)
					throw new Exception("Not found '#end VS'");

				VS = "// " + name + "\n" + "{\n" + Code.Substring(vsInit, (vsEnd) - (vsInit)) + "\n}\n";
			}

			// Now the PS
			int psInit = Code.IndexOf("#region PS");

			if (psInit != -1)
			{
				psInit += 11;

				psEnd = Code.IndexOf("#end PS");

				if (psEnd == -1)
					throw new Exception("Not found '#end PS'");

				PS = "// " + name + "\n" + "{\n" + Code.Substring(psInit, (psEnd) - (psInit)) + "\n}\n";
			}
		}

		#endregion
	}
}
