//#define _DEBUG

#region Using directives

using System.IO;
using System.Collections;
using System.Collections.Generic;
using System.Globalization;

using Microsoft.DirectX;
using System.Drawing;

using JadEngine.Tools;
using JadEngine.Tools.Parser;
using JadEngine.Video;
using JadEngine.Import;

#endregion

namespace JadEngine.Import
{
	/// <summary>
	/// TODO
	/// </summary>
	public class JadConverter
	{
		#region Internal Classes

		/// <summary>
		/// TODO
		/// </summary>
		private class JHeader
		{
			#region Fields
			
			/// <summary>
			/// TODO
			/// </summary>
			public int Version;
	
			/// <summary>
			/// TODO
			/// </summary>
			public int NumMaterials;
			
			/// <summary>
			/// TODO
			/// </summary>
			public int NumGeomObjects;
			
			/// <summary>
			/// TODO
			/// </summary>
			public int NumLights;
			
			/// <summary>
			/// TODO
			/// </summary>
			public int NumParticleEffects;

			#endregion
		}

		/// <summary>
		/// TODO
		/// </summary>
		private class JGlobalParams
		{
			#region Fields
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> AmbientColor;
			
			/// <summary>
			/// TODO
			/// </summary>
			public string FogType;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> FogColor;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float FogNear;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float FogFar;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float FogTop;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float FogBottom;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float FogDensity;

			#endregion
		}

		/// <summary>
		/// TODO
		/// </summary>
		private class JTexMap
		{
			#region Fields
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Name;
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Class;
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Type;
			
			/// <summary>
			/// TODO
			/// </summary>
			public int MapChannel;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float Amount;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float U_Tile;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float V_Tile;
			
			/// <summary>
			/// TODO
			/// </summary>
			public string FileName;

			/// <summary>
			/// TODO
			/// </summary>
			/// <remarks>Haddd: modified to pack the maps</remarks>
			public JPackNode lightMapNode;

			#endregion
		}

		/// <summary>
		/// TODO
		/// </summary>
		private class JMaterial
		{
			#region Fields
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Name;
			
			/// <summary>
			/// TODO
			/// </summary>
			public int Index;
			
			/// <summary>
			/// TODO
			/// </summary>
			public int FinalIndex;
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Class;
			
			/// <summary>
			/// TODO
			/// </summary>
			public int NumSubMaterials;
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Script;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<JMaterial> SubMaterials;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> DiffuseColor;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> SpecularColor;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float SpecularPower;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> EmissiveColor;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float IndexOfRefraction;
			
			/// <summary>
			/// TODO
			/// </summary>
			public int NumMaps;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<JTexMap> Maps;

			#endregion
			
			#region Methods

			/// <summary>
			/// TODO
			/// </summary>
			/// <param name="mapType">TODO</param>
			/// <returns>TODO</returns>
			public JTexMap GetMap(string mapType)
			{
				foreach (JTexMap texMap in Maps)
					if (texMap.Type == mapType)
						return texMap;

				return null;
			}

			#endregion
		}

		/// <summary>
		/// TODO
		/// </summary>
		private class JGeomObject
		{
			#region Structs
			
			/// <summary>
			/// TODO
			/// </summary>
			public struct Vertex
			{
				#region Fields
				
				/// <summary>
				/// TODO
				/// </summary>
				public int Index;
				
				/// <summary>
				/// TODO
				/// </summary>
				public float[] Coords;
				
				/// <summary>
				/// TODO
				/// </summary>
				public float[] Normals;
				
				/// <summary>
				/// TODO
				/// </summary>
				public float[] TexCoords;

				#endregion
			}

			/// <summary>
			/// TODO
			/// </summary>
			public struct Face
			{
				#region Fields
				
				/// <summary>
				/// TODO
				/// </summary>
				public int Index;
				
				/// <summary>
				/// TODO
				/// </summary>
				public int A;
				
				/// <summary>
				/// TODO
				/// </summary>
				public int B;
				
				/// <summary>
				/// TODO
				/// </summary>
				public int C;
				
				/// <summary>
				/// TODO
				/// </summary>
				public int MatID;

				#endregion
			}

			#endregion

			#region Fields
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Name;
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Type;
			
			/// <summary>
			/// TODO
			/// </summary>
			public bool receiveShadows;
			
			/// <summary>
			/// TODO
			/// </summary>
			public bool castShadows;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float mass;
			
			/// <summary>
			/// TODO
			/// </summary>
			public int MaterialID;
			
			/// <summary>
			/// TODO
			/// </summary>
			public int NumMapChannels;
			
			/// <summary>
			/// TODO
			/// </summary>
			public int NumVerts;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<Vertex> Vertices;
			
			/// <summary>
			/// TODO
			/// </summary>
			public int NumFaces;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<Face> Faces;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> Min;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> Max;
			
			/// <summary>
			/// TODO
			/// </summary>
			public bool IsXRef;
			
			/// <summary>
			/// TODO
			/// </summary>
			public string XRefFileName;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> Pivot;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> Position;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> Rotation;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> Scale;
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Parent;

			#endregion
			
			#region Methods

			/// <summary>
			/// TODO
			/// </summary>
			/// <param name="materials">TODO</param>
			/// <returns>TODO</returns>
			public JTexMap GetLightmap(List<JMaterial> materials)
			{
				JTexMap lightMap;

				if (materials[MaterialID].NumSubMaterials > 0)
					lightMap = materials[MaterialID].SubMaterials[0].GetMap("Lightmap");
				
				else
					lightMap = materials[MaterialID].GetMap("Lightmap");

				return lightMap;
			}

			#endregion
		}

		/// <summary>
		/// TODO
		/// </summary>
		private class JLight
		{
			#region Fields
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Name;
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Type;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> Position;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> Rotation;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> Color;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float Multiplier;
			
			/// <summary>
			/// TODO
			/// </summary>
			public bool AffectDiffuse;
			
			/// <summary>
			/// TODO
			/// </summary>
			public bool AffectSpecular;
			
			/// <summary>
			/// TODO
			/// </summary>
			public bool CastShadows;
			
			/// <summary>
			/// TODO
			/// </summary>
			public string AttenuationDecay;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float DecayRadius;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float FarAttenStart;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float FarAttenEnd;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float FallOff;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float HotSpot;
			
			/// <summary>
			/// TODO
			/// </summary>
			public bool UseProjector;
			
			/// <summary>
			/// TODO
			/// </summary>
			public string ProjectorFileName;
			
			/// <summary>
			/// TODO
			/// </summary>
			public bool UseShafts;
			
			/// <summary>
			/// TODO
			/// </summary>
			public string ShaftsFileName;
			
			/// <summary>
			/// TODO
			/// </summary>
			public int ShaftsSlicePlanes;
			
			/// <summary>
			/// TODO
			/// </summary>
			public bool UseVolume;
			
			/// <summary>
			/// TODO
			/// </summary>
			public float VolumePower;

			#endregion
		}

		/// <summary>
		/// TODO
		/// </summary>
		private class JParticleFX
		{
			#region Fields
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Name;
			
			/// <summary>
			/// TODO
			/// </summary>
			public string Script;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> Position;
			
			/// <summary>
			/// TODO
			/// </summary>
			public List<float> Rotation;

			#endregion
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <remarks>Haddd: modified to pack the lightmaps</remarks>
		private class JLightmap
		{
			#region Fields
			
			/// <summary>
			/// Original lighmap texture
			/// </summary>
			public JTexture texture;
			
			/// <summary>
			/// Reference to the Texmap used
			/// </summary>
			public JTexMap texMap;
			
			/// <summary>
			/// Node where the texture has been placed
			/// </summary>
			public JPackNode node;
			
			#endregion
		}

		#endregion

		#region Structs

		/// <summary>
		/// TODO
		/// </summary>
		private struct JWorkingVertex
		{
			#region Fields

			/// <summary>
			/// TODO
			/// </summary>
			public int NumMapChannels;

			/// <summary>
			/// TODO
			/// </summary>
			public JGeomObject.Vertex Vertex;

			#endregion

			#region Methods
			
			/// <summary>
			/// Test if two values are the same
			/// </summary>
			/// <param name="obj">The object to compare</param>
			/// <returns>True if the two objects are equal, false if not</returns>
			public override bool Equals(object obj)
			{
                // Check for null values and compare run-time types.
                if (obj == null || GetType() != obj.GetType())
                    return false;

				JWorkingVertex v = (JWorkingVertex)obj;

				if (Vertex.Coords[0] != v.Vertex.Coords[0])
					return false;
				if (Vertex.Coords[1] != v.Vertex.Coords[1])
					return false;
				if (Vertex.Coords[2] != v.Vertex.Coords[2])
					return false;

				if (Vertex.Normals[0] != v.Vertex.Normals[0])
					return false;
				if (Vertex.Normals[1] != v.Vertex.Normals[1])
					return false;
				if (Vertex.Normals[2] != v.Vertex.Normals[2])
					return false;

				for (int t = 0; t < NumMapChannels; t++)
				{
					if (Vertex.TexCoords[t * 2 + 0] != v.Vertex.TexCoords[t * 2 + 0])
						return false;
					
					if (Vertex.TexCoords[t * 2 + 1] != v.Vertex.TexCoords[t * 2 + 1])
						return false;
				}

				return true;
			}
            /// <summary>
            /// GetHashCode override
            /// </summary>
            public override int GetHashCode() 
            {
                return (
                    Vertex.Coords[0].GetHashCode() ^
                    Vertex.Coords[1].GetHashCode() ^
                    Vertex.Coords[2].GetHashCode() ^
                    Vertex.Normals[0].GetHashCode() ^
                    Vertex.Normals[1].GetHashCode() ^
                    Vertex.Normals[2].GetHashCode()
                );
            }

			#endregion
		}

		/// <summary>
		/// This struct is necesary to use the hash table. If arrays are used
		/// the built in GetHashCode do not analize the contents of the array.
		/// </summary>
		private struct JVertexForHashCode
		{
			#region Fields
			
			/// <summary>
			/// TODO
			/// </summary>
			Vector3 position;
			
			/// <summary>
			/// TODO
			/// </summary>
			Vector3 normal;
			
			/// <summary>
			/// TODO
			/// </summary>
			Vector2 t0;

			/// <summary>
			/// TODO
			/// </summary>
			Vector2 t1;

			/// <summary>
			/// TODO
			/// </summary>
			Vector2 t2;

			#endregion

			#region Methods
			
			/// <summary>
			/// Fills the struct with a WorkingVertex
			/// </summary>
			/// <param name="v">A filled WorkingVertex</param>
			public void FromWorkingVertex(JWorkingVertex v)
			{
				position = new Vector3(v.Vertex.Coords[0], v.Vertex.Coords[1], v.Vertex.Coords[2]);
				normal = new Vector3(v.Vertex.Normals[0], v.Vertex.Normals[1], v.Vertex.Normals[2]);

				for (int t = 0; t < v.NumMapChannels; t++)
				{
					switch (t)
					{
						case 0:
							t0 = new Vector2(v.Vertex.TexCoords[t * 2 + 0], v.Vertex.TexCoords[t * 2 + 1]);
							break;
							
						case 1:
							t1 = new Vector2(v.Vertex.TexCoords[t * 2 + 0], v.Vertex.TexCoords[t * 2 + 1]);
							break;
							
						case 2:
							t2 = new Vector2(v.Vertex.TexCoords[t * 2 + 0], v.Vertex.TexCoords[t * 2 + 1]);
							break;
					}
				}
			}

			#endregion
		}
		
		#endregion
		
		#region Fields

		/// <summary>
		/// TODO
		/// </summary>
		private const int JAD_VERSION = 14;
		
		/// <summary>
		/// TODO
		/// </summary>
		private JParser parser;
		
		/// <summary>
		/// TODO
		/// </summary>
		private JHeader header;
		
		/// <summary>
		/// TODO
		/// </summary>
		private JGlobalParams globalParams;
		
		/// <summary>
		/// TODO
		/// </summary>
		private List<JMaterial> materials;
		
		/// <summary>
		/// TODO
		/// </summary>
		private List<JGeomObject> geomObjects;
		
		/// <summary>
		/// TODO
		/// </summary>
		private List<JLight> lights;
		
		/// <summary>
		/// TODO
		/// </summary>
		private List<JParticleFX> particles;
		
		/// <summary>
		/// TODO
		/// </summary>
		private bool hasLightmaps;
		
		/// <summary>
		/// TODO
		/// </summary>
		private List<JLightmap> lightmaps;
		
		/// <summary>
		/// TODO
		/// </summary>
		private StreamWriter file;
#if(_DEBUG)		
		/// <summary>
		/// TODO
		/// </summary>
		private StreamWriter dbgFile;
#endif

		/// <summary>
		/// TODO
		/// </summary>
		NumberFormatInfo nFormat;

		/// <summary>
		/// TODO
		/// </summary>
		public static bool PackLightMaps = false;

		/// <summary>
		/// Tells what was the last material ID set. Its used to calculate the final index of the materials
		/// </summary>
		private int lastMaterialID;

		/// <summary>
		/// TODO
		/// </summary>
		private int lastIndex;

		/// <summary>
		/// TODO
		/// </summary>
		private Hashtable vertexHashList;

		#endregion

		#region Constructors

		/// <summary>
		/// TODO
		/// </summary>
		public JadConverter()
		{
			// Set the "." as a decimal separator symbol
			nFormat = new NumberFormatInfo();
			nFormat.NumberDecimalSeparator = ".";
		}

		#endregion

		#region Methods

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="fileName">TODO</param>
		public void Convert(string fileName)
		{
#if(_DEBUG)
			dbgFile = new StreamWriter(fileName + ".debug.txt");
#endif
			// Haddd: modified
			hasLightmaps = false;
			lightmaps = new List<JLightmap>();

			// Create the parser
			parser = new JParser();

			// Load the file in the parser
			if (!parser.LoadFromPath("3D", fileName))
				parser.Error("Couldn't load file: {0}", fileName);

#if(_DEBUG)
			dbgFile.WriteLine("File \"{0}\" loaded\n", fileName);
#endif
			// Parse the header
			ParseHeader();

			// Parse the global parameters
			ParseGlobalParams();

			// Parse the materials
			for (int i = 0; i < header.NumMaterials; i++)
				ParseMaterials("", true, null);

			// Parse the GeomObjects
			for (int i = 0; i < header.NumGeomObjects; i++)
				ParseGeomObjects();

			// Parse the lights
			for (int i = 0; i < header.NumLights; i++)
				ParseLights();

			// Parse the particle effects
			for (int i = 0; i < header.NumParticleEffects; i++)
				ParseParticleEffects();

			// Parse if its necessary to pack the lightmaps
			if (PackLightMaps)
				PackLightMapsAndConvert(fileName);
			
			else
				hasLightmaps = false;

			// Output file
			file = new StreamWriter(fileName);

			// Convert the header
			ConvertHeader();

			// Convert the global parameters
			ConvertGlobalParams();

			// Convert the materials
			ConvertMaterials();

			// Convert the GeomObjects
			ConvertGeomObjects();

			// Convert the lights
			ConvertLights();

			// Convert the particle effects
			ConvertParticleEffects();

			file.Close();

#if(_DEBUG)
			dbgFile.Close();
#endif
		}

		#endregion

		#region Methods to load the header

		/// <summary>
		/// TODO
		/// </summary>
		private void ParseHeader()
		{
			// Create the header
			header = new JHeader();

			// Version
			parser.ExpectTokenString("PreHadddVersion");
			header.Version = parser.ParseInt();

			if (header.Version != JAD_VERSION)
				parser.Error("Invalid version {0}. Should be version {1}", header.Version, JAD_VERSION);

			// Number of materials
			parser.ExpectTokenString("numMaterials");
			header.NumMaterials = parser.ParseInt();

			// Create the materials list
			materials = new List<JMaterial>(header.NumMaterials);

			// Number of GeomObjects
			parser.ExpectTokenString("numGeomObjects");
			header.NumGeomObjects = parser.ParseInt();

			// Create the GeomObjects list
			geomObjects = new List<JGeomObject>(header.NumGeomObjects);

			// Number of lights
			parser.ExpectTokenString("numLights");
			header.NumLights = parser.ParseInt();

			// Create the lights list
			lights = new List<JLight>(header.NumLights);

			// Number of particle effects
			parser.ExpectTokenString("numParticleEffects");
			header.NumParticleEffects = parser.ParseInt();

			// Create the particle effects list
			particles = new List<JParticleFX>(header.NumParticleEffects);

#if(_DEBUG)
			dbgFile.WriteLine("version: {0}\n", header.Version);
			dbgFile.WriteLine("numMaterials: {0}", header.NumMaterials);
			dbgFile.WriteLine("numGeomObjects: {0}", header.NumGeomObjects);
			dbgFile.WriteLine("numLights: {0}\n", header.NumLights);
			dbgFile.WriteLine("numParticleEffects: {0}\n", header.NumParticleEffects);
#endif
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="mtl">TODO</param>
		/// <returns>TODO</returns>
		private int CountMaterials(JMaterial mtl)
		{
			int numMaterials = 0;

			if (mtl.NumSubMaterials == 0)
				return 1;

			foreach (JMaterial auxMtl in mtl.SubMaterials)
				numMaterials += CountMaterials(auxMtl);

			return numMaterials;
		}

		/// <summary>
		/// TODO
		/// </summary>
		private void ConvertHeader()
		{
			// Version
			file.WriteLine("HadddVersion {0}\n", header.Version);

			// Count the numbers of materials to export
			int numMaterials = 0;
			foreach (JMaterial mtl in materials)
				numMaterials += CountMaterials(mtl);

			// Number of materials
			file.WriteLine("numMaterials {0}", numMaterials);
			
			// Number of GeomObjects
			file.WriteLine("numGeomObjects {0}", header.NumGeomObjects);
			
			// Number of lights
			file.WriteLine("numLights {0}", header.NumLights);
			
			// Number of particle effects
			file.WriteLine("numParticleEffects {0}\n", header.NumParticleEffects);
		}

		#endregion

		#region Methods to load the global parameters

		/// <summary>
		/// TODO
		/// </summary>
		private void ParseGlobalParams()
		{
			globalParams = new JGlobalParams();

			parser.ExpectTokenString("global");
			parser.ExpectTokenString("{");

			// Ambient color
			parser.ExpectTokenString("ambientColor");
			globalParams.AmbientColor = new List<float>(3);
			parser.Parse1DMatrix(3, globalParams.AmbientColor);

			// Fog
			parser.ExpectTokenString("fogType");
			globalParams.FogType = parser.ParseString();

			if (globalParams.FogType != "none")
			{
				parser.ExpectTokenString("fogColor");
				globalParams.FogColor = new List<float>(3);
				parser.Parse1DMatrix(3, globalParams.FogColor);

				if (globalParams.FogType == "linear" || globalParams.FogType == "exponential")
				{
					parser.ExpectTokenString("fogNear");
					globalParams.FogNear = parser.ParseFloat();
					parser.ExpectTokenString("fogFar");
					globalParams.FogFar = parser.ParseFloat();
				}
				
				else if (globalParams.FogType == "layered")
				{
					parser.ExpectTokenString("fogTop");
					globalParams.FogTop = parser.ParseFloat();
					parser.ExpectTokenString("fogBottom");
					globalParams.FogBottom = parser.ParseFloat();
					parser.ExpectTokenString("fogDensity");
					globalParams.FogDensity = parser.ParseFloat();
				}
			}

			parser.ExpectTokenString("}");

#if(_DEBUG)
			dbgFile.WriteLine("globalParams");
			dbgFile.WriteLine("\tambientColor ( {0} {1} {2} )", globalParams.AmbientColor[0], globalParams.AmbientColor[1], globalParams.AmbientColor[2]);
			dbgFile.WriteLine("\tfogType \"{0}\"", globalParams.FogType);
			if (globalParams.FogType != "none")
			{
				dbgFile.WriteLine("\tfogColor ( {0} {1} {2} )", globalParams.FogColor[0], globalParams.FogColor[1], globalParams.FogColor[2]);

				if (globalParams.FogType == "linear" || globalParams.FogType == "exponential")
				{
					dbgFile.WriteLine("\tfogNear {0}", globalParams.FogNear);
					dbgFile.WriteLine("\tfogFar {0}", globalParams.FogFar);
				}
				else if (globalParams.FogType == "layered")
				{
					dbgFile.WriteLine("\tfogTop {0}", globalParams.FogTop);
					dbgFile.WriteLine("\tfogBottom {0}", globalParams.FogBottom);
					dbgFile.WriteLine("\tfogDensity {0}", globalParams.FogDensity);
				}
			}
#endif
		}

		/// <summary>
		/// TODO
		/// </summary>
		private void ConvertGlobalParams()
		{
			file.WriteLine("global {");

			file.WriteLine("\tambientColor ( {0} {1} {2} )\n", globalParams.AmbientColor[0].ToString(nFormat), globalParams.AmbientColor[1].ToString(nFormat), globalParams.AmbientColor[2].ToString(nFormat));

			file.WriteLine("\tfogType \"{0}\"", globalParams.FogType);

			if (globalParams.FogType != "none")
			{
				file.WriteLine("\tfogColor ( {0} {1} {2} )", globalParams.FogColor[0].ToString(nFormat), globalParams.FogColor[1].ToString(nFormat), globalParams.FogColor[2].ToString(nFormat));

				if (globalParams.FogType == "linear" || globalParams.FogType == "exponential")
				{
					file.WriteLine("\tfogNear {0}", globalParams.FogNear.ToString(nFormat));
					file.WriteLine("\tfogFar {0}", globalParams.FogFar.ToString(nFormat));
				}
				
				else if (globalParams.FogType == "layered")
				{
					file.WriteLine("\tfogTop {0}", globalParams.FogTop.ToString(nFormat));
					file.WriteLine("\tfogBottom {0}", globalParams.FogBottom.ToString(nFormat));
					file.WriteLine("\tfogDensity {0}", globalParams.FogDensity.ToString(nFormat));
				}
			}

			file.WriteLine("}\n");
		}

		#endregion

		#region Methods for the materials

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="indent">TODO</param>
		/// <param name="topLevelMaterial">TODO</param>
		/// <param name="inMtl">TODO</param>
		private void ParseMaterials(string indent, bool topLevelMaterial, JMaterial inMtl)
		{
			JToken token = new JToken();
			JMaterial auxMtl = new JMaterial();

			parser.ExpectTokenString("material");

			// Material name
			auxMtl.Name = parser.ParseString().ToLower();

			parser.ExpectTokenString("{");

			// Material index
			parser.ExpectTokenString("index");
			auxMtl.Index = parser.ParseInt();

			// Material class
			parser.ExpectTokenString("class");
			parser.ReadToken(token);
			auxMtl.Class = token.Text;

			// Number of submaterials
			parser.ExpectTokenString("numSubMaterials");
			auxMtl.NumSubMaterials = parser.ParseInt();

			// Create the submaterials list
			auxMtl.SubMaterials = new List<JMaterial>(auxMtl.NumSubMaterials);

			// Material or sub-material?
			if (topLevelMaterial)
				materials.Add(auxMtl); // Add the material

			else
				inMtl.SubMaterials.Add(auxMtl); // Add the sub-material
			

#if(_DEBUG)
			dbgFile.WriteLine(indent + "material {0}", auxMtl.Name);
			dbgFile.WriteLine(indent + "\tindex {0}", auxMtl.Index);
			dbgFile.WriteLine(indent + "\tclass {0}", auxMtl.Class);
			dbgFile.WriteLine(indent + "\tnumSubMaterials {0}", auxMtl.NumSubMaterials);
#endif

			if (auxMtl.NumSubMaterials == 0)
			{
				// Final index of the sub-material
				auxMtl.FinalIndex = lastMaterialID++;

#if(_DEBUG)
				dbgFile.WriteLine(indent + "\tfinalIndex {0}", auxMtl.FinalIndex);
#endif
				// TODO (VICENTE): THIS MUST BE CHANGED
				// If its a material of the JadMaterial type, read the script
				auxMtl.Script = string.Empty;
				if (auxMtl.Class == "HadddMaterial")
				{
					// Material script
					parser.ExpectTokenString("script");
					auxMtl.Script = parser.ParseString();
#if(_DEBUG)
					dbgFile.WriteLine(indent + "\tscript {0}", auxMtl.Script);
#endif
				}

				// Diffuse color
				auxMtl.DiffuseColor = new List<float>(3);
				parser.ExpectTokenString("diffuseColor");
				parser.Parse1DMatrix(3, auxMtl.DiffuseColor);

				// Specular color
				auxMtl.SpecularColor = new List<float>(3);
				parser.ExpectTokenString("specularColor");
				parser.Parse1DMatrix(3, auxMtl.SpecularColor);

				// Specular power
				parser.ExpectTokenString("specularPower");
				auxMtl.SpecularPower = parser.ParseFloat();

				// Emissive color
				auxMtl.EmissiveColor = new List<float>(3);
				parser.ExpectTokenString("emissiveColor");
				parser.Parse1DMatrix(3, auxMtl.EmissiveColor);

				// Index of refraction
				parser.ExpectTokenString("indexOfRefraction");
				auxMtl.IndexOfRefraction = parser.ParseFloat();

				// Number of texture maps
				parser.ExpectTokenString("numMaps");
				auxMtl.NumMaps = parser.ParseInt();

				// Create the list of texture maps
				auxMtl.Maps = new List<JTexMap>(auxMtl.NumMaps);
#if(_DEBUG)
				dbgFile.WriteLine(indent + "\tdiffuseColor ( {0} {1} {2} )", auxMtl.DiffuseColor[0], auxMtl.DiffuseColor[1], auxMtl.DiffuseColor[2]);
				dbgFile.WriteLine(indent + "\tspecularColor ( {0} {1} {2} )", auxMtl.SpecularColor[0], auxMtl.SpecularColor[1], auxMtl.SpecularColor[2]);
				dbgFile.WriteLine(indent + "\tspecularPower {0}", auxMtl.SpecularPower);
				dbgFile.WriteLine(indent + "\temissiveColor ( {0} {1} {2} )", auxMtl.EmissiveColor[0], auxMtl.EmissiveColor[1], auxMtl.EmissiveColor[2]);
				dbgFile.WriteLine(indent + "\tindexOfRefraction {0}", auxMtl.IndexOfRefraction);
				dbgFile.WriteLine(indent + "\tnumMaps {0}", auxMtl.NumMaps);
#endif
				// Parse the texture maps
				for (int i = 0; i < auxMtl.NumMaps; i++)
				{
					JTexMap texMap;
					ParseTextureMap(indent + "\t", out texMap);
					auxMtl.Maps.Add(texMap);
				}
			}

			else
				for (int i = 0; i < auxMtl.NumSubMaterials; i++) // Parse the sub-materials
					ParseMaterials(indent + "\t", false, auxMtl);

			// End of the material
			parser.ExpectTokenString("}");
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="indent">TODO</param>
		/// <param name="texMap">TODO</param>
		private void ParseTextureMap(string indent, out JTexMap texMap)
		{
			JToken token = new JToken();

			texMap = new JTexMap();

			parser.ExpectTokenString("map");

			// Map name
			texMap.Name = parser.ParseString().ToLower();

			parser.ExpectTokenString("{");

			// Map type
			parser.ExpectTokenString("type");
			parser.ReadToken(token);
			texMap.Type = token.Text;

			// Map class
			parser.ExpectTokenString("class");
			parser.ReadToken(token);
			texMap.Class = token.Text;

			// Map channel
			parser.ExpectTokenString("mapChannel");
			texMap.MapChannel = parser.ParseInt();

			// SubNo
			parser.ExpectTokenString("subno");
			int subno = parser.ParseInt();

			// Amount
			parser.ExpectTokenString("amount");
			texMap.Amount = parser.ParseFloat();

			// U Tile
			parser.ExpectTokenString("u_tile");
			texMap.U_Tile = parser.ParseFloat();

			// V Tile
			parser.ExpectTokenString("v_tile");
			texMap.V_Tile = parser.ParseFloat();

			// Bitmap file
			parser.ExpectTokenString("bitmap");
			texMap.FileName = parser.ParseString();

			// End of the texture map
			parser.ExpectTokenString("}");

			// Haddd: modified to know quickly if the scene has lightmaps
			texMap.lightMapNode = null;

			if (texMap.Type == "Lightmap")
			{
				hasLightmaps = true;

				JLightmap lm = new JLightmap();

				// Create the texture
				lm.texture = Jad.Video.Textures.Create2D(texMap.FileName, true);

				// GSae the information to modify the name later
				lm.texMap = texMap;   

				// Add it to the list
				lightmaps.Add(lm);
			}

#if(_DEBUG)
			dbgFile.WriteLine(indent + "map {0}", texMap.Name);
			dbgFile.WriteLine(indent + "\ttype {0}", texMap.Type);
			dbgFile.WriteLine(indent + "\tclass {0}", texMap.Class);
			dbgFile.WriteLine(indent + "\tmapChannel {0}", texMap.MapChannel);
			dbgFile.WriteLine(indent + "\tsubno {0}", subno);
			dbgFile.WriteLine(indent + "\tamount {0}", texMap.Amount);
			dbgFile.WriteLine(indent + "\tu_tile {0}", texMap.U_Tile);
			dbgFile.WriteLine(indent + "\tv_tile {0}", texMap.V_Tile);
			dbgFile.WriteLine(indent + "\tbitmap \"{0}\"", texMap.FileName);
#endif
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="mtl">TODO</param>
		private void WriteMaterial(JMaterial mtl)
		{
			if (mtl.NumSubMaterials > 0)
				foreach (JMaterial subMtl in mtl.SubMaterials)
					WriteMaterial(subMtl);
			
			else
			{
				file.WriteLine("material \"{0}\" {{\n", mtl.Name);

				if (mtl.Script.Length == 0 || mtl.Script == "undefined")
				{
					file.WriteLine("\tnumMaps {0}\n", mtl.Maps.Count);

					file.WriteLine("\tdiffuseColor ( {0} {1} {2} )", mtl.DiffuseColor[0].ToString(nFormat),
					               mtl.DiffuseColor[1].ToString(nFormat), mtl.DiffuseColor[2].ToString(nFormat));
					file.WriteLine("\tspecularColor ( {0} {1} {2} )", mtl.SpecularColor[0].ToString(nFormat),
					               mtl.SpecularColor[1].ToString(nFormat), mtl.SpecularColor[2].ToString(nFormat));
					file.WriteLine("\tspecularPower {0}", mtl.SpecularPower.ToString(nFormat));
					file.WriteLine("\temissiveColor ( {0} {1} {2} )", mtl.EmissiveColor[0].ToString(nFormat),
					               mtl.EmissiveColor[1].ToString(nFormat), mtl.EmissiveColor[2].ToString(nFormat));
					file.WriteLine("\tindexOfRefraction {0}\n", mtl.IndexOfRefraction.ToString(nFormat));

					foreach (JTexMap texMap in mtl.Maps)
					{
						file.WriteLine("\tmap \"{0}\" {{\n", texMap.Name);

						file.WriteLine("\t\ttype {0}", texMap.Type);
						file.WriteLine("\t\tmapChannel {0}", texMap.MapChannel);
						file.WriteLine("\t\tamount {0}", texMap.Amount.ToString(nFormat));
						file.WriteLine("\t\tu_tile {0}", texMap.U_Tile.ToString(nFormat));
						file.WriteLine("\t\tv_tile {0}", texMap.V_Tile.ToString(nFormat));
						file.WriteLine("\t\tfileName \"{0}\"", texMap.FileName);

						file.WriteLine("\t}");
					}
				}
				
				else
					file.WriteLine("\tscript \"{0}\"", mtl.Script);

				file.WriteLine("}\n");
			}
		}

		/// <summary>
		/// TODO
		/// </summary>
		private void ConvertMaterials()
		{
			foreach (JMaterial mtl in materials)
				WriteMaterial(mtl);
		}

		#endregion

		#region Methods for the geometry

		/// <summary>
		/// TODO
		/// </summary>
		private void ParseGeomObjects()
		{
			JToken token = new JToken();

			JGeomObject auxGeom = new JGeomObject();

			parser.ReadToken(token);
			if (token != "geomObject" && token != "XRefGeomObject")
			{
				parser.Error("expected 'geomObject' or 'XRefGeomObject' but found '{1}'", token.Text);
				return;
			}

			auxGeom.IsXRef = (token == "XRefGeomObject");

			// Name
			auxGeom.Name = parser.ParseString().ToLower();

			parser.ExpectTokenString("{");

			// Filename
			if (auxGeom.IsXRef)
			{
				parser.ExpectTokenString("fileName");
				auxGeom.XRefFileName = parser.ParseString();
			}

			// Type
			parser.ExpectTokenString("type");
			auxGeom.Type = parser.ParseString();

			// Receive shadows
			parser.ExpectTokenString("receiveShadows");
			auxGeom.receiveShadows = parser.ParseBool();

			// Cast shadows
			parser.ExpectTokenString("castShadows");
			auxGeom.castShadows = parser.ParseBool();

			// Mass
			parser.ExpectTokenString("mass");
			auxGeom.mass = parser.ParseFloat();

			if (!auxGeom.IsXRef)
			{
				// Material ID
				parser.ExpectTokenString("materialID");
				auxGeom.MaterialID = parser.ParseInt();

				// Number of mapping channels
				parser.ExpectTokenString("numMapChannels");
				auxGeom.NumMapChannels = parser.ParseInt();
			}

			// Parent & Transformation

			// Parent
			parser.ExpectTokenString("parent");
			auxGeom.Parent = parser.ParseString().ToLower();
			
			// Pivot
			auxGeom.Pivot = new List<float>(3);
			parser.ExpectTokenString("pivot");
			parser.Parse1DMatrix(3, auxGeom.Pivot);
			
			// Position
			auxGeom.Position = new List<float>(3);
			parser.ExpectTokenString("position");
			parser.Parse1DMatrix(3, auxGeom.Position = new List<float>(3));
			
			// Rotation
			auxGeom.Rotation = new List<float>(3);
			parser.ExpectTokenString("rotation");
			parser.Parse1DMatrix(3, auxGeom.Rotation);
			
			// Scale
			auxGeom.Scale = new List<float>(3);
			parser.ExpectTokenString("scale");
			parser.Parse1DMatrix(3, auxGeom.Scale);

			// Strat the bounding box
			auxGeom.Min = new List<float>(3);
			auxGeom.Min.Add(float.MaxValue);
			auxGeom.Min.Add(float.MaxValue);
			auxGeom.Min.Add(float.MaxValue);
			auxGeom.Max = new List<float>(3);
			auxGeom.Max.Add(float.MinValue);
			auxGeom.Max.Add(float.MinValue);
			auxGeom.Max.Add(float.MinValue);

#if(_DEBUG)
			if (auxGeom.IsXRef)
			{
				dbgFile.WriteLine("XRefGeomObject {0}", auxGeom.Name);
				dbgFile.WriteLine("\tfileName \"{0}\"", auxGeom.XRefFileName);
			}

			else
				dbgFile.WriteLine("geomObject {0}", auxGeom.Name);

			dbgFile.WriteLine("\ttype \"{0}\"", auxGeom.Type);
			dbgFile.WriteLine("\treceiveShadows {0}", auxGeom.receiveShadows);
			dbgFile.WriteLine("\tcastShadows {0}", auxGeom.castShadows);
			dbgFile.WriteLine("\tmass {0}", auxGeom.mass);

			dbgFile.WriteLine("\tparent \"{0}\"", auxGeom.Parent);
			dbgFile.WriteLine("\tpivot ( {0} {1} {2} )", auxGeom.Pivot[0], auxGeom.Pivot[1], auxGeom.Pivot[2]);
			dbgFile.WriteLine("\tposition ( {0} {1} {2} )", auxGeom.Position[0], auxGeom.Position[1], auxGeom.Position[2]);
			dbgFile.WriteLine("\trotation ( {0} {1} {2} )", auxGeom.Rotation[0], auxGeom.Rotation[1], auxGeom.Rotation[2]);
			dbgFile.WriteLine("\tscale ( {0} {1} {2} )", auxGeom.Scale[0], auxGeom.Scale[1], auxGeom.Scale[2]);

			if (!auxGeom.IsXRef)
			{
				dbgFile.WriteLine("\tmaterialID {0}", auxGeom.MaterialID);
				dbgFile.WriteLine("\tnumMapChannels {0}", auxGeom.NumMapChannels);
			}
#endif
			if (!auxGeom.IsXRef)
			{
				// Number of vertex
				parser.ExpectTokenString("numVerts");
				auxGeom.NumVerts = parser.ParseInt();

				// Number of faces
				auxGeom.NumFaces = auxGeom.NumVerts / 3;

#if(_DEBUG)
				dbgFile.WriteLine("\tnumVerts {0}", auxGeom.NumVerts);
#endif

				// Create the faces list
				auxGeom.Faces = new List<JGeomObject.Face>(auxGeom.NumFaces);

				// Create the vertex list
				auxGeom.Vertices = new List<JGeomObject.Vertex>(auxGeom.NumVerts);

				// Parse the vertex
				for (int i = 0; i < auxGeom.NumVerts; i++)
				{
					JGeomObject.Vertex auxVertex;

					parser.ExpectTokenString("vert");
					auxVertex.Index = parser.ParseInt();

					if (auxVertex.Index != i)
						parser.Error("Expected vertex number {0}, found {1}", i, auxVertex.Index);

					// Vertex coordinates
					auxVertex.Coords = new float[3];
					parser.Parse1DMatrix(3, auxVertex.Coords);

					// Normal
					auxVertex.Normals = new float[3];
					parser.Parse1DMatrix(3, auxVertex.Normals);

					// Texture coordinates
					auxVertex.TexCoords = new float[auxGeom.NumMapChannels * 2];
					for (int nChannel = 0; nChannel < auxGeom.NumMapChannels; nChannel++)
					{
						float[] uv = new float[2];
						parser.Parse1DMatrix(2, uv);

						auxVertex.TexCoords[nChannel * 2 + 0] = uv[0];
						auxVertex.TexCoords[nChannel * 2 + 1] = uv[1];
					}

					// Material ID
					int MtlID = parser.ParseInt();
					if (i % 3 == 0)
					{
						JGeomObject.Face auxFace = new JGeomObject.Face();
						auxFace.Index = i / 3;
						auxFace.A = i + 0;
						auxFace.B = i + 1;
						auxFace.C = i + 2;
						auxFace.MatID = MtlID;
						auxGeom.Faces.Add(auxFace);
					}

					// Add the vertex to the list
					auxGeom.Vertices.Add(auxVertex);

					// Calculate the minimum and the maximum of the mesh to generate the bounding box

					// Minimum
					if (auxVertex.Coords[0] < auxGeom.Min[0])
						auxGeom.Min[0] = auxVertex.Coords[0];
					if (auxVertex.Coords[1] < auxGeom.Min[1])
						auxGeom.Min[1] = auxVertex.Coords[1];
					if (auxVertex.Coords[2] < auxGeom.Min[2])
						auxGeom.Min[2] = auxVertex.Coords[2];

					// Maximum
					if (auxVertex.Coords[0] > auxGeom.Max[0])
						auxGeom.Max[0] = auxVertex.Coords[0];
					if (auxVertex.Coords[1] > auxGeom.Max[1])
						auxGeom.Max[1] = auxVertex.Coords[1];
					if (auxVertex.Coords[2] > auxGeom.Max[2])
						auxGeom.Max[2] = auxVertex.Coords[2];

#if(_DEBUG)
					dbgFile.Write("\t\tvert {0} ( {1} {2} {3} )", auxVertex.Index, auxVertex.Coords[0], auxVertex.Coords[1], auxVertex.Coords[2]);
					dbgFile.Write(" ( {0} {1} {2} )", auxVertex.Normals[0], auxVertex.Normals[1], auxVertex.Normals[2]);
					
					for (int nChannel = 0; nChannel < auxGeom.NumMapChannels; nChannel++)
						dbgFile.Write(" ( {0} {1} )", auxVertex.TexCoords[nChannel * 2], auxVertex.TexCoords[nChannel * 2 + 1]);
					
					dbgFile.WriteLine(" {0}", auxGeom.Faces[i / 3].MatID);
#endif
				}
			}

			// End of the GeomObject
			parser.ExpectTokenString("}");

			// Add the object to the geometry list
			geomObjects.Add(auxGeom);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="vertexList">TODO</param>
		/// <param name="indexList">TODO</param>
		/// <param name="vertex">TODO</param>
        private void InsertVertex(List<JWorkingVertex> vertexList, List<int> indexList, JWorkingVertex vertex)
        {
            JVertexForHashCode hashVertex=new JVertexForHashCode(); int nVertex;

            // Convert the vertex to a valid hashVertex
            hashVertex.FromWorkingVertex(vertex);

            //If exists, only need to get the index
			if (vertexHashList.ContainsKey(hashVertex))
				nVertex = (int) vertexHashList[hashVertex];
			
			else
			{
				// Doesnt exist, so add it to the vertex list
				vertexList.Add(vertex);

				nVertex = lastIndex;

				vertexHashList.Add(hashVertex, lastIndex);

				lastIndex++;
			}

			// Add this vertex to the index list
            indexList.Add(nVertex);
        }

		/// <summary>
		/// Modifies the texture coordinates of the lightmap
		/// </summary>
		/// <param name="vertex">TODO</param>
		/// <param name="map">TODO</param>
		void ChangeCoordsForLightMap(ref JWorkingVertex vertex, JTexMap map)
		{
			// In the map theres a reference to the final node where the original lightmap 
			// has been saved
			
			JPackNode node = map.lightMapNode;

			// Get the final rectangle where the lightmap is located
			Rectangle r = node.rc;

			// Assume that the lightmap coordinates are in the n 1 coordinate
			float u = vertex.Vertex.TexCoords[2];
			float v = vertex.Vertex.TexCoords[3];

			// Find the definitive lightmap size
			float widthFinalMap = (float)node.packet.destTexture.SurfaceDes.Width;
			float heightFinalMap = (float)node.packet.destTexture.SurfaceDes.Height;

			// Change the point to the final texture coordinates and after that divide
			// by the width and height
			
			float uf = ((float)r.Left + (u * (float)r.Width)) / widthFinalMap;
			float vf = ((float)r.Top + (v * (float)r.Height)) / heightFinalMap;

			vertex.Vertex.TexCoords[2] = uf;
			vertex.Vertex.TexCoords[3] = vf;
		}

		/// <summary>
		/// TODO
		/// </summary>
		private void ConvertGeomObjects()
		{
            // Create the hash table
            vertexHashList = new Hashtable();
            
            for (int g = 0; g < geomObjects.Count; g++)
			{
				JGeomObject auxGeom = geomObjects[g];

				Jad.LogWriter.WriteLine("Transforming:" + auxGeom.Name);

				List<JWorkingVertex> vertices = new List<JWorkingVertex>();
				List<int> indices = new List<int>(auxGeom.NumFaces * 3);
				List<int> matIDs = new List<int>(auxGeom.NumFaces);
				List<int> uniqueMatIDs = new List<int>();

				int finalMatID;

				JTexMap texlightMap = null;

				// Get the lightmap that this object uses
				if (hasLightmaps)
					texlightMap = auxGeom.GetLightmap(materials);

				// Its very important to reset this var
				lastIndex = 0;

				for (int f = 0; f < auxGeom.NumFaces; f++)
				{
					JGeomObject.Face auxFace = auxGeom.Faces[f];

					// Get the final index set for this face
					JMaterial auxMtl = materials[auxGeom.MaterialID];

					if (auxMtl.NumSubMaterials > 0)
						finalMatID = auxMtl.SubMaterials[auxFace.MatID].FinalIndex;
					
					else
						finalMatID = auxMtl.FinalIndex;

					// Add the final ID of the material
					matIDs.Add(finalMatID);

					// Fill the list of unique material IDs for this object
					if (uniqueMatIDs.BinarySearch(finalMatID) < 0)
					{
						uniqueMatIDs.Add(finalMatID);
						uniqueMatIDs.Sort();
					}

					// First vertex
					JWorkingVertex v1 = new JWorkingVertex();

					v1.NumMapChannels = auxGeom.NumMapChannels;
					v1.Vertex = auxGeom.Vertices[auxFace.A];

					if (hasLightmaps)
						ChangeCoordsForLightMap(ref v1, texlightMap);

					InsertVertex(vertices, indices, v1);

					// Second vertex
					JWorkingVertex v2 = new JWorkingVertex();

					v2.NumMapChannels = auxGeom.NumMapChannels;
					v2.Vertex = auxGeom.Vertices[auxFace.B];

					if (hasLightmaps)
						ChangeCoordsForLightMap(ref v2, texlightMap);

					InsertVertex(vertices, indices, v2);

					// Third vertex
					JWorkingVertex v3 = new JWorkingVertex();

					v3.NumMapChannels = auxGeom.NumMapChannels;
					v3.Vertex = auxGeom.Vertices[auxFace.C];

					if (hasLightmaps)
						ChangeCoordsForLightMap(ref v3, texlightMap);

					InsertVertex(vertices, indices, v3);
				}

				// Start to write in the file

				if (auxGeom.IsXRef)
				{
					file.WriteLine("XRefGeomObject \"{0}\" {{\n", auxGeom.Name);
					file.WriteLine("\tfileName \"{0}\"\n", auxGeom.XRefFileName);
				}

				else
					file.WriteLine("geomObject \"{0}\" {{\n", auxGeom.Name);


				file.WriteLine("\ttype \"{0}\"", auxGeom.Type);

				file.WriteLine("\treceiveShadows {0}", auxGeom.receiveShadows);
				file.WriteLine("\tcastShadows {0}", auxGeom.castShadows);

				file.WriteLine("\tmass {0}\n", auxGeom.mass.ToString(nFormat));

				file.WriteLine("\tparent \"{0}\"", auxGeom.Parent);
				file.WriteLine("\tpivot ( {0} {1} {2} )", auxGeom.Pivot[0].ToString(nFormat), auxGeom.Pivot[1].ToString(nFormat), auxGeom.Pivot[2].ToString(nFormat));
				file.WriteLine("\tposition ( {0} {1} {2} )", auxGeom.Position[0].ToString(nFormat), auxGeom.Position[1].ToString(nFormat), auxGeom.Position[2].ToString(nFormat));
				file.WriteLine("\trotation ( {0} {1} {2} )", auxGeom.Rotation[0].ToString(nFormat), auxGeom.Rotation[1].ToString(nFormat), auxGeom.Rotation[2].ToString(nFormat));
				file.WriteLine("\tscale ( {0} {1} {2} )\n", auxGeom.Scale[0].ToString(nFormat), auxGeom.Scale[1].ToString(nFormat), auxGeom.Scale[2].ToString(nFormat));

				if (!auxGeom.IsXRef)
				{
					file.WriteLine("\tnumMapChannels {0}\n", auxGeom.NumMapChannels);

					file.WriteLine("\tnumUniqueMatIDs {0}", uniqueMatIDs.Count);
					file.Write("\t");
					for (int i = 0; i < uniqueMatIDs.Count; i++)
					{
						string space = (i == uniqueMatIDs.Count - 1) ? "\n\n" : " ";
						file.Write("{0}{1}", uniqueMatIDs[i], space);
					}

					file.WriteLine("\tbounds ( {0} {1} {2} ) ( {3} {4} {5} )\n", auxGeom.Min[0].ToString(nFormat),
																				 auxGeom.Min[1].ToString(nFormat),
																				 auxGeom.Min[2].ToString(nFormat),
																				 auxGeom.Max[0].ToString(nFormat),
																				 auxGeom.Max[1].ToString(nFormat),
																				 auxGeom.Max[2].ToString(nFormat));

					file.WriteLine("\tnumVerts {0}", vertices.Count);
					for (int i = 0; i < vertices.Count; i++)
					{
						JWorkingVertex auxVertex = vertices[i];

						file.Write("\tvert {0} ( {1} {2} {3} )", i, auxVertex.Vertex.Coords[0].ToString(nFormat), auxVertex.Vertex.Coords[1].ToString(nFormat), auxVertex.Vertex.Coords[2].ToString(nFormat));

						file.Write(" ( {0} {1} {2} )", auxVertex.Vertex.Normals[0].ToString(nFormat), auxVertex.Vertex.Normals[1].ToString(nFormat), auxVertex.Vertex.Normals[2].ToString(nFormat));

						for (int j = 0; j < auxGeom.NumMapChannels; j++)
							file.Write(" ( {0} {1} )", auxVertex.Vertex.TexCoords[j * 2 + 0].ToString(nFormat), auxVertex.Vertex.TexCoords[j * 2 + 1].ToString(nFormat));

						file.Write("\n");
					}

					file.WriteLine();

					int numFaces = indices.Count / 3;
					file.WriteLine("\tnumFaces {0}", numFaces);
					for (int i = 0; i < numFaces; i++)
					{
						int A = indices[i * 3 + 0];
						int B = indices[i * 3 + 1];
						int C = indices[i * 3 + 2];

						int matID = uniqueMatIDs.IndexOf(matIDs[i]);

						file.WriteLine("\tface {0} {1} {2} {3} {4}", i, A, B, C, matID);
					}
				}

				file.WriteLine("}\n");
			}
		}

		#endregion

		#region Methods for the lights

		/// <summary>
		/// TODO
		/// </summary>
		private void ParseLights()
		{
			JLight auxLight = new JLight();
			JToken token = new JToken();

			parser.ExpectTokenString("light");

			// Name
			auxLight.Name = parser.ParseString().ToLower();

			parser.ExpectTokenString("{");

			// Type
			parser.ExpectTokenString("type");
			parser.ExpectTokenString("#");
			parser.ReadToken(token);
			auxLight.Type = token.Text;

			// Position
			auxLight.Position = new List<float>(3);
			parser.ExpectTokenString("position");
			parser.Parse1DMatrix(3, auxLight.Position);

#if(_DEBUG)
			dbgFile.WriteLine("light {0}", auxLight.Name);
			dbgFile.WriteLine("\ttype {0}", auxLight.Type);
			dbgFile.WriteLine("\tposition ( {0} {1} {2} )", auxLight.Position[0], auxLight.Position[1], auxLight.Position[2]);
#endif

			// If the list is "spot" or "direct", read the direction
			if (auxLight.Type == "targetSpot" || auxLight.Type == "freeSpot" || auxLight.Type == "targetDirect" || auxLight.Type == "freeDirect")
			{
				// Direction
				auxLight.Rotation = new List<float>(4);
				parser.ExpectTokenString("rotation");
				parser.Parse1DMatrix(4, auxLight.Rotation);
#if(_DEBUG)
				dbgFile.WriteLine("\trotation ( {0} {1} {2} {3} )", auxLight.Rotation[0], auxLight.Rotation[1], auxLight.Rotation[2], auxLight.Rotation[3]);
#endif
			}

			// Casts shadows?
			parser.ExpectTokenString("castShadows");
			auxLight.CastShadows = parser.ParseBool();

			// Multiplier
			parser.ExpectTokenString("multiplier");
			auxLight.Multiplier = parser.ParseFloat();

			// Color
			auxLight.Color = new List<float>(3);
			parser.ExpectTokenString("color");
			parser.Parse1DMatrix(3, auxLight.Color);

			// Attenuation type
			parser.ExpectTokenString("attenuationDecay");
			parser.ReadToken(token);
			auxLight.AttenuationDecay = token.Text;

			if (auxLight.AttenuationDecay == "Inverse" || auxLight.AttenuationDecay == "InverseSquare")
			{
				// Attenuation radius
				parser.ExpectTokenString("decayRadius");
				auxLight.DecayRadius = parser.ParseFloat();
			}
			
			else if (auxLight.AttenuationDecay == "DualRadius")
			{
				// Internal radius of dual attenuation
				parser.ExpectTokenString("farAttenStart");
				auxLight.FarAttenStart = parser.ParseFloat();

				// External radius of dual attenuation				
				parser.ExpectTokenString("farAttenEnd");
				auxLight.FarAttenEnd = parser.ParseFloat();
			}

			if (auxLight.Type == "targetSpot" || auxLight.Type == "freeSpot" || auxLight.Type == "targetDirect" || auxLight.Type == "freeDirect")
			{
				// FallOff
				parser.ExpectTokenString("fallOff");
				auxLight.FallOff = parser.ParseFloat();

				// HotSpot
				parser.ExpectTokenString("hotSpot");
				auxLight.HotSpot = parser.ParseFloat();
			}

			// Affects the diffuse component?
			parser.ExpectTokenString("affectDiffuse");
			auxLight.AffectDiffuse = parser.ParseBool();

			// Affects the specual component?
			parser.ExpectTokenString("affectSpecular");
			auxLight.AffectSpecular = parser.ParseBool();

			// Is the projector active?
			parser.ExpectTokenString("useProjector");
			auxLight.UseProjector = parser.ParseBool();

#if(_DEBUG)
			dbgFile.WriteLine("\tmultiplier {0}", auxLight.Multiplier);
			dbgFile.WriteLine("\tcolor ( {0} {1} {2} )", auxLight.Color[0], auxLight.Color[1], auxLight.Color[2]);
			dbgFile.WriteLine("\tcastShadows {0}", auxLight.CastShadows);
			dbgFile.WriteLine("\tattenuationDecay {0}", auxLight.AttenuationDecay);
			
			if (auxLight.AttenuationDecay == "Inverse" || auxLight.AttenuationDecay == "InverseSquare")
				dbgFile.WriteLine("\tdecayRadius {0}", auxLight.DecayRadius);
			
			else if (auxLight.AttenuationDecay == "DualRadius")
			{
				dbgFile.WriteLine("\tfarAttenStart {0}", auxLight.FarAttenStart);
				dbgFile.WriteLine("\tfarAttenEnd {0}", auxLight.FarAttenEnd);
			}

			if (auxLight.Type == "targetSpot" || auxLight.Type == "freeSpot")
			{
				dbgFile.WriteLine("\tfallOff {0}", auxLight.FallOff);
				dbgFile.WriteLine("\thotSpot {0}", auxLight.HotSpot);
			}
			
			dbgFile.WriteLine("\taffectDiffuse {0}", auxLight.AffectDiffuse);
			dbgFile.WriteLine("\taffectSpecular {0}", auxLight.AffectSpecular);
			dbgFile.WriteLine("\tuseProjector {0}", auxLight.UseProjector);
#endif
			// If using the projector, parse the texture map file of the projector
			if (auxLight.UseProjector)
			{
				parser.ExpectTokenString("projectorMap");
				auxLight.ProjectorFileName = parser.ParseString();
#if(_DEBUG)
				dbgFile.WriteLine("\tprojectorMap {0}", auxLight.ProjectorFileName);
#endif
			}

			// Are the light shafts active?
			parser.ExpectTokenString("useShafts");
			auxLight.UseShafts = parser.ParseBool();

			if (auxLight.UseShafts)
			{
				// File of the map that contains the cookie
				parser.ExpectTokenString("shaftsMap");
				auxLight.ShaftsFileName = parser.ParseString();

				// Slice planes that form the shafts
				parser.ExpectTokenString("slicePlanes");
				auxLight.ShaftsSlicePlanes = parser.ParseInt();
			}

			// Is the light volume active?
			parser.ExpectTokenString("useVolume");
			auxLight.UseVolume = parser.ParseBool();

			// Volume power
			if (auxLight.UseVolume)
			{
				parser.ExpectTokenString("volumePower");
				auxLight.VolumePower = parser.ParseFloat();
			}

#if(_DEBUG)
			dbgFile.WriteLine("\tuseShafts {0}", auxLight.UseShafts);
			
			if (auxLight.UseShafts)
			{
				dbgFile.WriteLine("\tshaftsMap {0}", auxLight.ShaftsFileName);
				dbgFile.WriteLine("\tslicePlanes {0}", auxLight.ShaftsSlicePlanes);
			}
			
			dbgFile.WriteLine("\tuseVolume {0}", auxLight.UseVolume);
			
			if (auxLight.UseVolume)
				dbgFile.WriteLine("\tvolumePower {0}", auxLight.VolumePower);
#endif
			// End of the light
			parser.ExpectTokenString("}");

			// Add the light to the lights list
			lights.Add(auxLight);
		}

		/// <summary>
		/// TODO
		/// </summary>
		private void ConvertLights()
		{
			foreach (JLight light in lights)
			{
				file.WriteLine("light \"{0}\" {{\n", light.Name);

				file.WriteLine("\ttype {0}", light.Type);
				file.WriteLine();
				file.WriteLine("\tposition ( {0} {1} {2} )", light.Position[0].ToString(nFormat), light.Position[1].ToString(nFormat), light.Position[2].ToString(nFormat));
				
				if (light.Type == "targetSpot" || light.Type == "freeSpot" || light.Type == "targetDirect" || light.Type == "freeDirect")
					file.WriteLine("\trotation ( {0} {1} {2} {3} )", light.Rotation[0].ToString(nFormat), light.Rotation[1].ToString(nFormat), light.Rotation[2].ToString(nFormat), light.Rotation[3].ToString(nFormat));
				
				file.WriteLine();
				file.WriteLine("\tcastShadows {0}", light.CastShadows);
				file.WriteLine();
				file.WriteLine("\tmultiplier {0}", light.Multiplier.ToString(nFormat));
				file.WriteLine("\tcolor ( {0} {1} {2} )", light.Color[0].ToString(nFormat), light.Color[1].ToString(nFormat), light.Color[2].ToString(nFormat));
				file.WriteLine("\tattenuationDecay {0}", light.AttenuationDecay);
				
				if (light.AttenuationDecay == "Inverse" || light.AttenuationDecay == "InverseSquare")
					file.WriteLine("\tdecayRadius {0}", light.DecayRadius.ToString(nFormat));
				
				else if (light.AttenuationDecay == "DualRadius")
				{
					file.WriteLine("\tfarAttenStart {0}", light.FarAttenStart.ToString(nFormat));
					file.WriteLine("\tfarAttenEnd {0}", light.FarAttenEnd.ToString(nFormat));
				}
				
				file.WriteLine();

				if (light.Type == "targetSpot" || light.Type == "freeSpot" || light.Type == "targetDirect" || light.Type == "freeDirect")
				{
					file.WriteLine("\tfallOff {0}", light.FallOff.ToString(nFormat));
					file.WriteLine("\thotSpot {0}", light.HotSpot.ToString(nFormat));
				}
				
				file.WriteLine();

				file.WriteLine("\taffectDiffuse {0}", light.AffectDiffuse);
				file.WriteLine("\taffectSpecular {0}", light.AffectSpecular);
				file.WriteLine();

				file.WriteLine("\tuseProjector {0}", light.UseProjector);

				if (light.UseProjector)
					file.WriteLine("\tprojectorMap \"{0}\"", light.ProjectorFileName);

				file.WriteLine();

				file.WriteLine("\tuseShafts {0}", light.UseShafts);

				if (light.UseShafts)
				{
					file.WriteLine("\tshaftsMap \"{0}\"", light.ShaftsFileName);
					file.WriteLine("\tslicePlanes {0}", light.ShaftsSlicePlanes);
				}
				file.WriteLine();

				file.WriteLine("\tuseVolume {0}", light.UseVolume);
				
				if (light.UseVolume)
					file.WriteLine("\tvolumePower {0}", light.VolumePower.ToString(nFormat));

				file.WriteLine();
				file.WriteLine("}\n");
			}
		}

		#endregion

		#region Methods for the particle effects

		/// <summary>
		/// TODO
		/// </summary>
		private void ParseParticleEffects()
		{
			JParticleFX auxParticleFX = new JParticleFX();

			parser.ExpectTokenString("particleEffect");

			// Name
			auxParticleFX.Name = parser.ParseString().ToLower();

			parser.ExpectTokenString("{");

			// Script
			parser.ExpectTokenString("script");
			auxParticleFX.Script = parser.ParseString();

			// Position
			auxParticleFX.Position = new List<float>(3);
			parser.ExpectTokenString("position");
			parser.Parse1DMatrix(3, auxParticleFX.Position);

			// Rotation
			auxParticleFX.Rotation = new List<float>(4);
			parser.ExpectTokenString("rotation");
			parser.Parse1DMatrix(4, auxParticleFX.Rotation);

#if(_DEBUG)
			dbgFile.WriteLine("particleEffect {0}", auxParticleFX.Name);
			dbgFile.WriteLine("\tscript \"{0}\"", auxParticleFX.Script);
			dbgFile.WriteLine("\tposition ( {0} {1} {2} )", auxParticleFX.Position[0], auxParticleFX.Position[1], auxParticleFX.Position[2]);
			dbgFile.WriteLine("\trotation ( {0} {1} {2} {3} )", auxParticleFX.Rotation[0], auxParticleFX.Rotation[1], auxParticleFX.Rotation[2], auxParticleFX.Rotation[3]);
#endif
			// End of the particle effect
			parser.ExpectTokenString("}");

			// Add the particle effect to the particles effect list
			particles.Add(auxParticleFX);
		}

		/// <summary>
		/// TODO
		/// </summary>
		private void ConvertParticleEffects()
		{
			foreach (JParticleFX pFX in particles)
			{
				file.WriteLine("particleEffect \"{0}\" {{\n", pFX.Name);

				file.WriteLine("\tscript \"{0}\"\n", pFX.Script);

				file.WriteLine("\tposition ( {0} {1} {2} )", pFX.Position[0].ToString(nFormat), pFX.Position[1].ToString(nFormat), pFX.Position[2].ToString(nFormat));
				file.WriteLine("\trotation ( {0} {1} {2} {3} )", pFX.Rotation[0].ToString(nFormat), pFX.Rotation[1].ToString(nFormat), pFX.Rotation[2].ToString(nFormat), pFX.Rotation[3].ToString(nFormat));

				file.WriteLine("}\n");
			}
		}

		#endregion

		#region Methods for the PackLightMap

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="filename">TODO</param>
		void PackLightMapsAndConvert(string filename)
		{
			// If there are no lightmaps, exit
			if (!hasLightmaps)
				return;

			// Tell the packer to pack in 512x512 textures
			JLightMapPacker packer = new JLightMapPacker(512, 512);

			// Visit the created texture list 

			// Take care to visit only once time each texture (control that there
			// arent repeated textures)

			foreach (JLightmap lm in lightmaps)
			{
				if (lm.texture.LoadingParams.ColorKey == 0)
				{
					lm.node = packer.Insert(lm.texture);

					// Mark the texture as used
					lm.texture.LoadingParams.ColorKey = 1;
				}
			}

			// Create the smallest size textures possible 

			packer.Optimize();

			// Save them in C:\

			string path = Path.GetDirectoryName(filename) + @"\";

			packer.SaveTexture(path);

			// Search the texture name created
			foreach (JLightmap lm in lightmaps)
			{
				string fileName = packer.FindSourceTexture(lm.texture);

				// Assing the new name of the texture
				lm.texMap.FileName = fileName;

				// Tell it the node where it has been placed to set again the texture coordinates
				lm.texMap.lightMapNode = lm.node;
			}
		}

		#endregion
	}
}
