// Name:			JBillboard.cs
// Author:			Jonathan Garca aka BeRSeRKeR
// Date:			14/12/04 15:35
// Description:	Class that implement a billboard

#region Using directives

using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

using JadEngine.Video;
using JadEngine.Core;
using JadEngine.Scene;

#endregion

namespace JadEngine.Scene
{
	/// <summary>
	/// TODO
	/// </summary>
	/// <remarks>TODO: Must inherit from JNode</remarks>
	public class JBillboard // : JNode
	{
		#region Fields

		/// <summary>
		/// TODO
		/// </summary>
		private Vector3 position;
		
		/// <summary>
		/// TODO
		/// </summary>
		private float width;
		
		/// <summary>
		/// TODO
		/// </summary>
		private float height;
		
		/// <summary>
		/// TODO
		/// </summary>
        private JColor color;
        
		/// <summary>
		/// TODO
		/// </summary>
		private JTexture texture;
		
		/// <summary>
		/// TODO
		/// </summary>
		private JEffect effect;
		
		/// <summary>
		/// TODO
		/// </summary>
        private CustomVertex.PositionTextured[] vertices;

		#endregion

		#region Constructors

		/// <summary>
		/// TODO
		/// </summary>
		public JBillboard() //: base(name)
		{
			// Default color
			color = new JColor(1.0f, 1.0f, 1.0f, 1.0f);

			// JTexture
			texture = null;

			// Effect
			effect = null;

			// Allocate memory for the 4 vertices that form the billboard
			vertices = new CustomVertex.PositionTextured[4];
		}

		#endregion
		
		#region Properties

		/// <summary>
		/// TODO
		/// </summary>
		public Vector3 Position
		{
			get { return position; }
			set { position = value; }
		}

		/// <summary>
		/// TODO
		/// </summary>
		public float Width
		{
			get { return width; }
			set { width = value; }
		}

		/// <summary>
		/// TODO
		/// </summary>
		public float Height
		{
			get { return height; }
			set { height = value; }
		}

		/// <summary>
		/// TODO
		/// </summary>
        public JColor Color
        {
			get { return color; }
			set { color = value; }
		}

		/// <summary>
		/// TODO
		/// </summary>
		public JTexture Texture
		{
			get { return texture; }
			set { texture = value; }
		}

		/// <summary>
		/// TODO
		/// </summary>
		public JEffect Effect
		{
			get { return effect; }
			set { effect = value; }
		}

		#endregion

		#region Methods

		/// <summary>
		/// TODO
		/// </summary>
		public void Render()
		{
			// Reference to the active camera
			JCamera camera = Jad.Scene.Camera;

			// Build the billboard (it always faces the camera)
			Vector3 up		= camera.Up * height * 0.5f;
			Vector3 right	= camera.Right * width * 0.5f;

			Vector3 v0 = -right - up + Position;
			Vector3 v1 = -right + up + Position;
			Vector3 v2 =  right - up + Position;
			Vector3 v3 =  right + up + Position;

			// Define the vertices forming a triangle strip
			vertices[0] = new CustomVertex.PositionTextured(v0,  0.0f, 1.0f);
            vertices[1] = new CustomVertex.PositionTextured(v1,  0.0f, 0.0f);
            vertices[2] = new CustomVertex.PositionTextured(v2,  1.0f, 1.0f);
            vertices[3] = new CustomVertex.PositionTextured(v3, 1.0f, 0.0f);

			// Configure the effect
			effect.DXResource.Technique = effect.handlers.renderScene;
			effect.Begin();

			effect.DXResource.SetValue(effect.handlers.worldViewProjection, camera.ViewProjection);
			effect.DXResource.SetValue(effect.handlers.textureDiffuse, texture.DXResource);
            effect.DXResource.SetValue(effect.handlers.materialHandler.Diffuse, color.ToVector4());
            Jad.Video.Device.VertexFormat = CustomVertex.PositionTextured.Format;

			effect.BeginPass(0);
			effect.Commit();

			// Render
			Jad.Video.Device.DrawUserPrimitives(PrimitiveType.TriangleStrip, 2, vertices);

			effect.EndPass();

			effect.End();
		}

		#endregion
	}
}
