#region Using Directives

using System;
using System.CodeDom.Compiler;
using Microsoft.VisualBasic;

#endregion

namespace JadEngine.Scripting.Languages
{
	/// <summary>
	/// VisualBasic provider for the scripting engine
	/// </summary>
	public class VisualBasic : JScriptLanguage
	{
		#region Fields
		private static CodeDomProvider _codeDomProvider = new VBCodeProvider();
		#endregion

		/// <summary>
		/// Return the VisualBasic code provider
		/// </summary>
		public override System.CodeDom.Compiler.CodeDomProvider CodeDomProvider
		{
			get
			{
				return _codeDomProvider;
			}
		}

		/// <summary>
		/// Format the Import statement
		/// </summary>
		public override string FormatUsingStatement(string namespaceName)
		{
			return "Imports " + namespaceName + Environment.NewLine;
		}


		/// <summary>
		/// Take code and wrap it in a class definition
		/// </summary>
		/// <param name="className">The name to use for the class</param>
		/// <param name="code">The code to wrap</param>
		/// <returns>The wrapped code</returns>
		public override string WrapInClass(string className, string code)
		{
			return Environment.NewLine + "Public Class " + className + Environment.NewLine + code + Environment.NewLine + "End Class" + Environment.NewLine;
		}
	}
}
