#region Using directives

using Microsoft.DirectX.DirectSound;

using JadEngine.Tools;

#endregion

namespace JadEngine.Sound
{
    /// <summary>
    /// A 3D sound sample
    /// </summary>
    /// <remarks>The 3D sound MUST be mono</remarks>
    public class JSample3D : JSample
    {
        #region Fields

        /// <summary>
        /// Device that corresponds to the DSound3D object
        /// </summary>
        Buffer3D buffer3D = null;

        #endregion

        #region Constructors

    	/// <summary>
    	/// TODO
    	/// </summary>
		/// <param name="name">TODO</param>
		/// <param name="description">TODO</param>
		/// <param name="mode">TODO</param>
        public JSample3D(string name, BufferDescription description, Mode3D mode):base(name,description)
        {
            if (Buffer.Caps.LocateInHardware)
				Jad.LogWriter.WriteLine("Loading 3D sound '" + name + "' in hardware");
    		
            else
				Jad.LogWriter.WriteLine("Loading 3D sound '" + name + "' in software");
            
    		// Create the 3D buffer setting it to deferred so the changes will execute when
    		// a commit is done in the Listener

            buffer3D = new Buffer3D(Buffer);
            buffer3D.Deferred = true;
            buffer3D.Mode = mode;
        }

        #endregion

		#region Properties

		/// <summary>
		/// Gets the device that corresponds to the DSound3D object
		/// </summary>
		public Buffer3D Buffer3D
		{
			get { return buffer3D; }
		}

		#endregion
    }
}
