#region Using directives

using System;
using System.Collections.Generic;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

using JadEngine.Scene;
using JadEngine.Tools;
using JadEngine.Core;

#endregion

namespace JadEngine.Video
{
    /// <summary>
    /// All the video states
    /// </summary>
    /// <remarks>Not used yet</remarks>
    public struct JRenderVideoStates
	{
		#region Fields
    	
    	/// <summary>
    	/// TODO
    	/// </summary>
		public bool ZEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public Compare ZBufferFunction;

		/// <summary>
		/// TODO
		/// </summary>
		public bool ZBufferWriteEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public bool ScissorTestEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public bool FillMode;

		/// <summary>
		/// TODO
		/// </summary>
		public ShadeMode ShadeMode;

		/// <summary>
		/// TODO
		/// </summary>
		public int ClipPlaneEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public bool MultisampleAntiAlias;

		/// <summary>
		/// TODO
		/// </summary>
		public int MultisampleMask;

		/// <summary>
		/// TODO
		/// </summary>
		public ColorWriteEnable ColorWriteEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public ColorWriteEnable ColorWriteEnable1;

		/// <summary>
		/// TODO
		/// </summary>
		public ColorWriteEnable ColorWriteEnable2;

		/// <summary>
		/// TODO
		/// </summary>
		public ColorWriteEnable ColorWriteEnable3;

		/// <summary>
		/// TODO
		/// </summary>
		public BlendOperation BlendOperation;

		/// <summary>
		/// TODO
		/// </summary>
		public float SlopeScaleDepthBias;

		/// <summary>
		/// TODO
		/// </summary>
		public bool TwoSidedStencilMode;

		/// <summary>
		/// TODO
		/// </summary>
		public StencilOperation CounterClockwiseStencilFail;

		/// <summary>
		/// TODO
		/// </summary>
		public StencilOperation CounterClockwiseStencilZBufferFail;

		/// <summary>
		/// TODO
		/// </summary>
		public StencilOperation CounterClockwiseStencilPass;

		/// <summary>
		/// TODO
		/// </summary>
		public Compare CounterClockwiseStencilFunction;

		/// <summary>
		/// TODO
		/// </summary>
		public bool SrgbWriteEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public float DepthBias;

		/// <summary>
		/// TODO
		/// </summary>
		public bool StencilEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public StencilOperation StencilFail;

		/// <summary>
		/// TODO
		/// </summary>
		public StencilOperation StencilZBufferFail;

		/// <summary>
		/// TODO
		/// </summary>
		public StencilOperation StencilPass;

		/// <summary>
		/// TODO
		/// </summary>
		public Compare StencilFunction;

		/// <summary>
		/// TODO
		/// </summary>
		public int ReferenceStencil;

		/// <summary>
		/// TODO
		/// </summary>
		public int StencilMask;

		/// <summary>
		/// TODO
		/// </summary>
		public int StencilWriteMask;

		/// <summary>
		/// TODO
		/// </summary>
        public bool SeparateAlphaBlendEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public Blend SourceBlendAlpha;

		/// <summary>
		/// TODO
		/// </summary>
		public Blend DestinationBlendAlpha;

		/// <summary>
		/// TODO
		/// </summary>
		public BlendOperation BlendOperationAlpha;

		/// <summary>
		/// TODO
		/// </summary>
		public bool AlphaTestEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public int ReferenceAlpha;

		/// <summary>
		/// TODO
		/// </summary>
		public Compare AlphaFunction;

		/// <summary>
		/// TODO
		/// </summary>
		public bool LastPixel;

		/// <summary>
		/// TODO
		/// </summary>
		public Blend SourceBlend;

		/// <summary>
		/// TODO
		/// </summary>
		public Blend DestinationBlend;

		/// <summary>
		/// TODO
		/// </summary>
		public Cull CullMode;

		/// <summary>
		/// TODO
		/// </summary>
		public bool AlphaBlendEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public int TextureFactor;

		/// <summary>
		/// TODO
		/// </summary>
		public WrapCoordinates Wrap0, Wrap1, Wrap2, Wrap3, Wrap4, Wrap5, Wrap6, Wrap7;

		/// <summary>
		/// TODO
		/// </summary>
		public bool Clipping;

		#endregion
    	
		#region Methods

		/// <summary>
		/// Sets the default values
		/// </summary>
        public void Initialize()
        {
            FillMode = false;
            ZEnable = true;
            ShadeMode = ShadeMode.Gouraud;
            ClipPlaneEnable = 0;
            MultisampleAntiAlias = true;
            MultisampleMask = -1;

            ColorWriteEnable = ColorWriteEnable.RedGreenBlueAlpha;
            ColorWriteEnable1 = ColorWriteEnable.RedGreenBlueAlpha;
            ColorWriteEnable2 = ColorWriteEnable.RedGreenBlueAlpha;
            ColorWriteEnable3 = ColorWriteEnable.RedGreenBlueAlpha;

            BlendOperation = BlendOperation.Add;
            ScissorTestEnable = false;
            SlopeScaleDepthBias = 0;
            TwoSidedStencilMode = false;

            CounterClockwiseStencilFail = StencilOperation.Keep;
            CounterClockwiseStencilZBufferFail = StencilOperation.Keep;
            CounterClockwiseStencilPass = StencilOperation.Keep;
            CounterClockwiseStencilFunction = Compare.Always;

            SrgbWriteEnable = false;
            DepthBias = 0;
            SeparateAlphaBlendEnable = false;

            SourceBlendAlpha = Blend.One;
            DestinationBlendAlpha = Blend.Zero;
            BlendOperationAlpha = BlendOperation.Add;

            ZBufferWriteEnable = true;
            AlphaTestEnable = false;
            LastPixel = true;
            SourceBlend = Blend.One;
            DestinationBlend = Blend.Zero;
            CullMode = Cull.CounterClockwise;
            ZBufferFunction = Compare.LessEqual;
            ReferenceAlpha = 0;
            AlphaFunction = Compare.Always;
            AlphaBlendEnable = false;
            StencilEnable = false;

            StencilFail = StencilOperation.Keep;
            StencilZBufferFail = StencilOperation.Keep;
            StencilPass = StencilOperation.Keep;
            StencilFunction = Compare.Always;

            ReferenceStencil = 0;
            StencilMask=-1;
            StencilWriteMask=-1;

            TextureFactor = 0;

            Wrap0 = WrapCoordinates.Zero;
            Wrap1 = WrapCoordinates.Zero;
            Wrap2 = WrapCoordinates.Zero;
            Wrap3 = WrapCoordinates.Zero;
            Wrap4 = WrapCoordinates.Zero;
            Wrap5 = WrapCoordinates.Zero;
            Wrap6 = WrapCoordinates.Zero;
            Wrap7 = WrapCoordinates.Zero;

            Clipping = true;
		}

		/// <summary>
        /// Sends the states to the hardware using the <see cref="JStateManager"/>
        /// </summary>
        public void Process()
        {
            JVideoStates sm = Jad.Video.StateManager.Active;

            sm.SetRenderState(RenderStates.ZEnable, ZEnable);
            sm.SetRenderState(RenderStates.ZBufferFunction, (int)ZBufferFunction);
            sm.SetRenderState(RenderStates.ZBufferWriteEnable, ZBufferWriteEnable);
            sm.SetRenderState(RenderStates.ScissorTestEnable, ScissorTestEnable);
            sm.SetRenderState(RenderStates.FillMode, FillMode);
            sm.SetRenderState(RenderStates.MultisampleMask, (int)MultisampleMask);
            sm.SetRenderState(RenderStates.ColorWriteEnable, (int)ColorWriteEnable);
            sm.SetRenderState(RenderStates.ColorWriteEnable1, (int)ColorWriteEnable1);
            sm.SetRenderState(RenderStates.ColorWriteEnable2, (int)ColorWriteEnable2);
            sm.SetRenderState(RenderStates.ColorWriteEnable3, (int)ColorWriteEnable3);
            sm.SetRenderState(RenderStates.BlendOperation, (int)BlendOperation);
            sm.SetRenderState(RenderStates.SlopeScaleDepthBias, SlopeScaleDepthBias);
            sm.SetRenderState(RenderStates.TwoSidedStencilMode, TwoSidedStencilMode);
            sm.SetRenderState(RenderStates.CounterClockwiseStencilFail, (int)CounterClockwiseStencilFail);
            sm.SetRenderState(RenderStates.CounterClockwiseStencilZBufferFail, (int)CounterClockwiseStencilZBufferFail);
            sm.SetRenderState(RenderStates.CounterClockwiseStencilPass, (int)CounterClockwiseStencilPass);
            sm.SetRenderState(RenderStates.CounterClockwiseStencilFunction, (int)CounterClockwiseStencilFunction);
            sm.SetRenderState(RenderStates.SrgbWriteEnable, SrgbWriteEnable);
            sm.SetRenderState(RenderStates.DepthBias, DepthBias);
            sm.SetRenderState(RenderStates.StencilEnable, StencilEnable);
            sm.SetRenderState(RenderStates.StencilFail, (int)StencilFail);
            sm.SetRenderState(RenderStates.StencilZBufferFail, (int)StencilZBufferFail);
            sm.SetRenderState(RenderStates.StencilPass, (int)StencilPass);
            sm.SetRenderState(RenderStates.StencilFunction, (int)StencilFunction);
            sm.SetRenderState(RenderStates.ReferenceStencil, ReferenceStencil);
            sm.SetRenderState(RenderStates.StencilMask, StencilMask);
            sm.SetRenderState(RenderStates.StencilWriteMask, StencilWriteMask);
            sm.SetRenderState(RenderStates.SeparateAlphaBlendEnable, SeparateAlphaBlendEnable);
            sm.SetRenderState(RenderStates.SourceBlendAlpha, (int)SourceBlendAlpha);
            sm.SetRenderState(RenderStates.DestinationBlendAlpha, (int)DestinationBlendAlpha);
            sm.SetRenderState(RenderStates.BlendOperationAlpha, (int)BlendOperationAlpha);
            sm.SetRenderState(RenderStates.AlphaTestEnable, AlphaTestEnable);
            sm.SetRenderState(RenderStates.ReferenceAlpha, ReferenceAlpha);
            sm.SetRenderState(RenderStates.AlphaFunction, (int)AlphaFunction);
            sm.SetRenderState(RenderStates.LastPixel, LastPixel);
            sm.SetRenderState(RenderStates.SourceBlend, (int)SourceBlend);
            sm.SetRenderState(RenderStates.DestinationBlend, (int)DestinationBlend);
            sm.SetRenderState(RenderStates.CullMode, (int)CullMode);
            sm.SetRenderState(RenderStates.AlphaBlendEnable, AlphaBlendEnable);
            sm.SetRenderState(RenderStates.TextureFactor, TextureFactor);
            sm.SetRenderState(RenderStates.Wrap0, (int)Wrap0);
            sm.SetRenderState(RenderStates.Wrap1, (int)Wrap1);
            sm.SetRenderState(RenderStates.Wrap2, (int)Wrap2);
            sm.SetRenderState(RenderStates.Wrap3, (int)Wrap3);
            sm.SetRenderState(RenderStates.Wrap4, (int)Wrap4);
            sm.SetRenderState(RenderStates.Wrap5, (int)Wrap5);
            sm.SetRenderState(RenderStates.Wrap6, (int)Wrap6);
            sm.SetRenderState(RenderStates.Wrap7, (int)Wrap7);
            sm.SetRenderState(RenderStates.Clipping, Clipping);
		}

		#endregion
	}

    /// <summary>
    /// The <see cref="JMaterial"/> video states
    /// </summary>
    public struct JMaterialStates
	{
		#region Fields
    	
		/// <summary>
		/// TODO
		/// </summary>
		public FillMode FillMode;

		/// <summary>
		/// TODO
		/// </summary>
		public ShadeMode ShadeMode;

		/// <summary>
		/// TODO
		/// </summary>
		public Cull CullMode;

		/// <summary>
		/// TODO
		/// </summary>
		public float DepthBias;
        
    	/// <summary>
    	/// Only set it to true for a postprocess material
    	/// </summary>
        public bool ZBufferWriteEnable;

		#endregion

		#region Methods
    	
		/// <summary>
        /// Sets the default values
        /// </summary>
        public void Initialize()
        {
            FillMode = FillMode.Solid;
            ShadeMode = ShadeMode.Gouraud;
            CullMode = Cull.CounterClockwise;
            ZBufferWriteEnable = false;
            DepthBias = 0;
        }

        /// <summary>
        /// Sends the states to the hardware using the <see cref="JStateManager"/>
        /// </summary>
        public void Process()
        {
            JStateManager sm = Jad.Video.StateManager;

            sm.SetRenderState(RenderStates.FillMode, (int)FillMode);
            sm.SetRenderState(RenderStates.ShadeMode, (int)ShadeMode);
            sm.SetRenderState(RenderStates.CullMode, (int)CullMode);
            sm.SetRenderState(RenderStates.DepthBias, DepthBias);
		}

		#endregion

		#region Serialize

		/// <summary>Current FileVersion</summary>
		const int fileVersion = 1;

		/// <summary>
		/// Loads the values from the binary file
		/// </summary>
		/// <param name="import">A valid instance</param>
		/// <returns>True if everything is ok</returns>
		internal bool Load(JBinaryImport import)
		{
			int fileVersionLoaded = import.LoadInt32();

			FillMode = (FillMode)import.LoadInt32();
			ShadeMode = (ShadeMode)import.LoadInt32();
			CullMode = (Cull)import.LoadInt32();
			DepthBias = import.LoadSingle();
			ZBufferWriteEnable = import.LoadBoolean();

			return true;
		}

		/// <summary>
		/// Save the values to the binary file
		/// </summary>
		/// <param name="export">A valid instance</param>
		/// <returns>True if everything is ok</returns>
		internal bool Save(JBinaryExport export)
		{
			export.Save(fileVersion);

			export.Save((int)FillMode);
			export.Save((int)ShadeMode);
			export.Save((int)CullMode);
			export.Save(DepthBias);
			export.Save(ZBufferWriteEnable);

			return true;
		}

		#endregion
	}

	/// <summary>
	/// TODO
	/// </summary>
    public struct JMaterialLayerStates
	{
		#region Fields
		
		/// <summary>
		/// TODO
		/// </summary>
        public BlendOperation BlendOperation;

		/// <summary>
		/// TODO
		/// </summary>
		public bool AlphaTestEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public int ReferenceAlpha;

		/// <summary>
		/// TODO
		/// </summary>
		public Compare AlphaFunction;

		/// <summary>
		/// TODO
		/// </summary>
		public Blend SourceBlend;

		/// <summary>
		/// TODO
		/// </summary>
		public Blend DestinationBlend;

		/// <summary>
		/// TODO
		/// </summary>
		public bool AlphaBlendEnable;

		#endregion

		#region Methods
		
		/// <summary>
		/// Sets the default values
		/// </summary>
        public void Initialize()
        {
            BlendOperation = BlendOperation.Add;

            AlphaTestEnable = false;
            SourceBlend = Blend.One;
            DestinationBlend = Blend.Zero;
            ReferenceAlpha = 0;
            AlphaFunction = Compare.Always;
            AlphaBlendEnable = false;
        }

        /// <summary>
        /// Sends the states to the hardware using the <see cref="JStateManager"/>
        /// </summary>
        public void Process()
        {
            JStateManager sm = Jad.Video.StateManager;

            sm.SetRenderState(RenderStates.BlendOperation, (int)BlendOperation);
            sm.SetRenderState(RenderStates.AlphaTestEnable, AlphaTestEnable);
            sm.SetRenderState(RenderStates.ReferenceAlpha, ReferenceAlpha);
            sm.SetRenderState(RenderStates.AlphaFunction, (int)AlphaFunction);
            sm.SetRenderState(RenderStates.SourceBlend, (int)SourceBlend);
            sm.SetRenderState(RenderStates.DestinationBlend, (int)DestinationBlend);
            sm.SetRenderState(RenderStates.AlphaBlendEnable, AlphaBlendEnable);
		}

		#endregion
	}

    /// <summary>
    /// The sampler states for one stage. This samplers will be used in <see cref="JMaterialLayer"/>
    /// </summary>
    public struct JSamplerVideoStates
	{
		#region Fields
    	
		/// <summary>
    	/// TODO
    	/// </summary>
        public TextureAddress AddressU;

		/// <summary>
		/// TODO
		/// </summary>
		public TextureAddress AddressV;

		/// <summary>
		/// TODO
		/// </summary>
		public TextureAddress AddressW;

		/// <summary>
		/// TODO
		/// </summary>
		public System.Drawing.Color BorderColor;

		/// <summary>
		/// TODO
		/// </summary>
		public TextureFilter MagFilter;

		/// <summary>
		/// TODO
		/// </summary>
		public TextureFilter MinFilter;

		/// <summary>
		/// TODO
		/// </summary>
		public TextureFilter MipFilter;

		/// <summary>
		/// TODO
		/// </summary>
		public float MipMapLevelOfDetailBias;

		/// <summary>
		/// TODO
		/// </summary>
		public int MaxMipLevel;

		/// <summary>
		/// TODO
		/// </summary>
		public int MaxAnisotropy;

		/// <summary>
		/// TODO
		/// </summary>
		public bool SrgbTexture;

		/// <summary>
		/// TODO
		/// </summary>
		public int ElementIndex;

		/// <summary>
		/// TODO
		/// </summary>
		public int DMapOffset;

		#endregion

		#region Methods
    	
		/// <summary>
		/// Sets the default values
		/// </summary>
        public void Initialize()
        {
            AddressU = TextureAddress.Wrap;
            AddressV = TextureAddress.Wrap;
            AddressW = TextureAddress.Wrap;
            BorderColor = System.Drawing.Color.Black;
            MagFilter = TextureFilter.Linear;
            MinFilter = TextureFilter.Linear;
            MipFilter = TextureFilter.Linear;
            MipMapLevelOfDetailBias = 0;
            MaxMipLevel = 0;
            MaxAnisotropy = 1;
            SrgbTexture = false;
            ElementIndex = 0;
            DMapOffset = 0;
        }

        /// <summary>
        /// Sends the states to the hardware using the <see cref="JStateManager"/>
        /// </summary>
        public void Process(int stage)
        {
            JStateManager sm = Jad.Video.StateManager;

            sm.SetSamplerState(stage, SamplerStageStates.AddressU, (int)AddressU);
            sm.SetSamplerState(stage, SamplerStageStates.AddressV, (int)AddressV);
            sm.SetSamplerState(stage, SamplerStageStates.AddressW, (int)AddressW);
            sm.SetSamplerState(stage, SamplerStageStates.BorderColor, BorderColor.ToArgb());
            sm.SetSamplerState(stage, SamplerStageStates.MagFilter, (int)MagFilter);
            sm.SetSamplerState(stage, SamplerStageStates.MinFilter, (int)MinFilter);
            sm.SetSamplerState(stage, SamplerStageStates.MipFilter, (int)MipFilter);
            sm.SetSamplerState(stage, SamplerStageStates.MipMapLevelOfDetailBias, MipMapLevelOfDetailBias);
            sm.SetSamplerState(stage, SamplerStageStates.MaxMipLevel, MaxMipLevel);
            sm.SetSamplerState(stage, SamplerStageStates.MaxAnisotropy, MaxAnisotropy);
            sm.SetSamplerState(stage, SamplerStageStates.SrgbTexture, SrgbTexture);
            sm.SetSamplerState(stage, SamplerStageStates.ElementIndex, ElementIndex);
            sm.SetSamplerState(stage, SamplerStageStates.DMapOffset, DMapOffset);
		}

		#endregion

		#region Serialize

		/// <summary>Current FileVersion</summary>
		const int fileVersion = 1;

		/// <summary>
		/// Loads the values from the binary file
		/// </summary>
		/// <param name="import">A valid instance</param>
		/// <returns>True if everything is ok</returns>
		internal bool Load(JBinaryImport import)
		{
			int fileVersionLoaded = import.LoadInt32();

			AddressU = (TextureAddress)import.LoadInt32();
			AddressV = (TextureAddress)import.LoadInt32();
			AddressW = (TextureAddress)import.LoadInt32();
			BorderColor = System.Drawing.Color.FromArgb(import.LoadInt32());
			MagFilter = (TextureFilter)import.LoadInt32();
			MinFilter = (TextureFilter)import.LoadInt32();
			MipFilter = (TextureFilter)import.LoadInt32();
			MipMapLevelOfDetailBias=import.LoadSingle();
			MaxMipLevel = import.LoadInt32();
			MaxAnisotropy = import.LoadInt32();
			SrgbTexture = import.LoadBoolean();
			ElementIndex = import.LoadInt32();
			DMapOffset = import.LoadInt32();

			return true;
		}

		/// <summary>
		/// Save the values to the binary file
		/// </summary>
		/// <param name="export">A valid instance</param>
		/// <returns>True if everything is ok</returns>
		internal bool Save(JBinaryExport export)
		{
			export.Save(fileVersion);
			export.Save((int)AddressU);
			export.Save((int)AddressV);
			export.Save((int)AddressW);
			export.Save(BorderColor.ToArgb());
			export.Save((int)MagFilter);
			export.Save((int)MinFilter);
			export.Save((int)MipFilter);
			export.Save(MipMapLevelOfDetailBias);
			export.Save(MaxMipLevel);
			export.Save(MaxAnisotropy);
			export.Save(SrgbTexture);
			export.Save(ElementIndex);
			export.Save(DMapOffset);
			return true;
		}

		#endregion
	}

	/// <summary>
	/// TODO
	/// </summary>
    public class JVideoStates
    {
        #region Inner Classes

		/// <summary>
		/// TODO
		/// </summary>
        public class JRenderState
		{
			#region Fields
        	
			/// <summary>
        	/// TODO
        	/// </summary>
            public RenderStates state;

			/// <summary>
			/// TODO
			/// </summary>
			public int iOldValue;

        	/// <summary>
        	/// TODO
        	/// </summary>
        	public int iValue;

        	/// <summary>
			/// TODO
			/// </summary>
			public bool bOldValue;

        	/// <summary>
        	/// TODO
        	/// </summary>
        	public bool bValue;

        	/// <summary>
			/// TODO
			/// </summary>
			public float fOldValue;

        	/// <summary>
        	/// TODO
        	/// </summary>
        	public float fValue;

        	/// <summary>
			/// TODO
			/// </summary>
			public byte type;

			#endregion
		}

		/// <summary>
		/// TODO
		/// </summary>
		public class JTextureStageState
		{
			#region Fields

			/// <summary>
			/// TODO
			/// </summary>
			public int stage;

			/// <summary>
			/// TODO
			/// </summary>
			public TextureStageStates state;

			/// <summary>
			/// TODO
			/// </summary>
			public int iOldValue;

        	/// <summary>
        	/// TODO
        	/// </summary>
        	public int iValue;

        	/// <summary>
			/// TODO
			/// </summary>
			public bool bOldValue;

        	/// <summary>
        	/// TODO
        	/// </summary>
        	public bool bValue;

        	/// <summary>
			/// TODO
			/// </summary>
			public float fOldValue;

        	/// <summary>
        	/// TODO
        	/// </summary>
        	public float fValue;

        	/// <summary>
			/// TODO
			/// </summary>
			public byte type;

			#endregion
		}

		/// <summary>
		/// TODO
		/// </summary>
		public class JSamplerStageState
		{
			#region Fields
			
			/// <summary>
			/// TODO
			/// </summary>
			public int stage;

			/// <summary>
			/// TODO
			/// </summary>
			public SamplerStageStates state;

			/// <summary>
			/// TODO
			/// </summary>
			public int iOldValue;

			/// <summary>
			/// TODO
			/// </summary>
			public int iValue;

			/// <summary>
			/// TODO
			/// </summary>
			public bool bOldValue;

			/// <summary>
			/// TODO
			/// </summary>
			public bool bValue;

			/// <summary>
			/// TODO
			/// </summary>
			public float fOldValue;

			/// <summary>
			/// TODO
			/// </summary>
			public float fValue;

			/// <summary>
			/// TODO
			/// </summary>
			public byte type;

			#endregion
		}

        #endregion

        #region Fields

		/// <summary>
		/// TODO
		/// </summary>
		List<JRenderState> renderStates;

		/// <summary>
		/// TODO
		/// </summary>
		List<JTextureStageState> textureStageStates;

		/// <summary>
		/// TODO
		/// </summary>
		List<JSamplerStageState> samplerStageStates;

        #endregion

        #region Constructors

		/// <summary>
		/// Default constructor
		/// </summary>
        public JVideoStates()
        {
            renderStates = new List<JRenderState>();
            textureStageStates = new List<JTextureStageState>();
            samplerStageStates = new List<JSamplerStageState>();
        }

        #endregion

        #region RenderState Methods

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetRenderState(RenderStates state, int value)
        {
            JRenderState r = new JRenderState();
            r.state = state;
            r.type = 0;
            r.iOldValue = Jad.Video.Device.GetRenderStateInt32(state);

            renderStates.Add(r);

			Jad.Video.StateManager.SetRenderState(state, value);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void SetRenderState(RenderStates state, bool value)
        {
            JRenderState r = new JRenderState();
            r.state = state;
            r.type = 1;
            r.bOldValue = Jad.Video.Device.GetRenderStateBoolean(state);

            renderStates.Add(r);

			Jad.Video.StateManager.SetRenderState(state, value);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void SetRenderState(RenderStates state, float value)
        {
            JRenderState r = new JRenderState();
            r.state = state;
            r.type = 1;
            r.fOldValue = Jad.Video.Device.GetRenderStateSingle(state);

            renderStates.Add(r);

			Jad.Video.StateManager.SetRenderState(state, value);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void AddRenderState(RenderStates state, int value)
        {
            JRenderState r = new JRenderState();
            r.state = state;
            r.type = 0;
            r.iValue = value;

            renderStates.Add(r);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void AddRenderState(RenderStates state, bool value)
        {
            JRenderState r = new JRenderState();
            r.state = state;
            r.type = 1;
            r.bValue = value;

            renderStates.Add(r);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void AddRenderState(RenderStates state, float value)
        {
            JRenderState r = new JRenderState();
            r.state = state;
            r.type = 1;
            r.fValue = value;

            renderStates.Add(r);
        }

        #endregion

        #region TextureStageState Methods

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void SetTextureStageState(int stage, TextureStageStates state, int value)
        {
            JTextureStageState r = new JTextureStageState();
            r.stage = stage;
            r.state = state;
            r.type = 0;
            r.iOldValue = Jad.Video.Device.GetTextureStageStateInt32(stage,state);

            textureStageStates.Add(r);

            Jad.Video.StateManager.SetTextureStageState(stage,state, value);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void SetTextureStageState(int stage, TextureStageStates state, bool value)
        {
            JTextureStageState r = new JTextureStageState();
            r.stage = stage;
            r.state = state;
            r.type = 1;
            r.bOldValue = Jad.Video.Device.GetTextureStageStateBoolean(stage, state);

            textureStageStates.Add(r);

			Jad.Video.StateManager.SetTextureStageState(stage, state, value);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void SetTextureStageState(int stage, TextureStageStates state, float value)
        {
            JTextureStageState r = new JTextureStageState();
            r.stage = stage;
            r.state = state;
            r.type = 2;
            r.fOldValue = Jad.Video.Device.GetTextureStageStateSingle(stage, state);

            textureStageStates.Add(r);

			Jad.Video.StateManager.SetTextureStageState(stage, state, value);
        }
		
		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void AddTextureStageState(int stage, TextureStageStates state, int value)
        {
            JTextureStageState r = new JTextureStageState();
            r.stage = stage;
            r.state = state;
            r.type = 0;
            r.iValue = value;

            textureStageStates.Add(r);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void AddTextureStageState(int stage, TextureStageStates state, bool value)
        {
            JTextureStageState r = new JTextureStageState();
            r.stage = stage;
            r.state = state;
            r.type = 1;
            r.bValue = value;

            textureStageStates.Add(r);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void AddTextureStageState(int stage, TextureStageStates state, float value)
        {
            JTextureStageState r = new JTextureStageState();
            r.stage = stage;
            r.state = state;
            r.type = 2;
            r.fValue = value;

            textureStageStates.Add(r);
        }

        #endregion

        #region SamplerState Methods

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void SetSamplerState(int stage, SamplerStageStates state, int value)
        {
            JSamplerStageState r = new JSamplerStageState();
            r.stage = stage;
            r.state = state;
            r.type = 0;
            r.iOldValue = Jad.Video.Device.GetSamplerStageStateInt32(stage, state);

            samplerStageStates.Add(r);

			Jad.Video.StateManager.SetSamplerState(stage, state, value);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void SetSamplerState(int stage, SamplerStageStates state, bool value)
        {
            JSamplerStageState r = new JSamplerStageState();
            r.stage = stage;
            r.state = state;
            r.type = 1;
            r.bOldValue = Jad.Video.Device.GetSamplerStageStateBoolean(stage, state);

            samplerStageStates.Add(r);

			Jad.Video.StateManager.SetSamplerState(stage, state, value);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void SetSamplerState(int stage, SamplerStageStates state, float value)
        {
            JSamplerStageState r = new JSamplerStageState();
            r.stage = stage;
            r.state = state;
            r.type = 2;
            r.fOldValue = Jad.Video.Device.GetSamplerStageStateSingle(stage, state);

            samplerStageStates.Add(r);

			Jad.Video.StateManager.SetSamplerState(stage, state, value);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void AddSamplerState(int stage, SamplerStageStates state, int value)
        {
            JSamplerStageState r = new JSamplerStageState();
            r.stage = stage;
            r.state = state;
            r.type = 0;
            r.iValue = value;

            samplerStageStates.Add(r);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void AddSamplerState(int stage, SamplerStageStates state, bool value)
        {
            JSamplerStageState r = new JSamplerStageState();
            r.stage = stage;
            r.state = state;
            r.type = 1;
            r.bValue = value;

            samplerStageStates.Add(r);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public void AddSamplerState(int stage, SamplerStageStates state, float value)
        {
            JSamplerStageState r = new JSamplerStageState();
            r.stage = stage;
            r.state = state;
            r.type = 2;
            r.fValue = value;

            samplerStageStates.Add(r);
        }

        #endregion

        #region Methods

        /// <summary>
        /// Restores the captured states
        /// </summary>
        public void Restore()
        {
        	// The list is reversed because the same state can have being changed
        	// several times and the good one is the first one
        	
            // Render States
            renderStates.Reverse();

            foreach (JRenderState r in renderStates)
            {
                switch (r.type)
                {
                    case 0:
                        Jad.Video.StateManager.SetRenderState(r.state, r.iOldValue);
                        break;
                    case 1:
                        Jad.Video.StateManager.SetRenderState(r.state, r.bOldValue);
                        break;
                    case 2:
                        Jad.Video.StateManager.SetRenderState(r.state, r.fOldValue);
                        break;
                }
            }

            // Texture Stage States
            textureStageStates.Reverse();

            foreach (JTextureStageState r in textureStageStates)
            {
                switch (r.type)
                {
                    case 0:
                        Jad.Video.StateManager.SetTextureStageState(r.stage, r.state, r.iOldValue);
                        break;
                    case 1:
                        Jad.Video.StateManager.SetTextureStageState(r.stage, r.state, r.bOldValue);
                        break;
                    case 2:
                        Jad.Video.StateManager.SetTextureStageState(r.stage, r.state, r.fOldValue);
                        break;
                }
            }

            // Sampler Stage States
            samplerStageStates.Reverse();

            foreach (JSamplerStageState r in samplerStageStates)
            {
                switch (r.type)
                {
                    case 0:
                        Jad.Video.StateManager.SetSamplerState(r.stage, r.state, r.iOldValue);
                        break;
                    case 1:
                        Jad.Video.StateManager.SetSamplerState(r.stage, r.state, r.bOldValue);
                        break;
                    case 2:
                        Jad.Video.StateManager.SetSamplerState(r.stage, r.state, r.fOldValue);
                        break;
                }
            }
        }

        /// <summary>
        /// Process the states in the list
        /// </summary>
        public void Process()
        {
        	// Take the old value and save it to be able to restore it later
            // After that set the states
        	
        	// Render States
            foreach (JRenderState r in renderStates)
            {
                switch (r.type)
                {
                    case 0:
                        r.iOldValue = Jad.Video.Device.GetRenderStateInt32(r.state);
                        Jad.Video.StateManager.SetRenderState(r.state, r.iValue);
                        break;
                    case 1:
                        r.bOldValue = Jad.Video.Device.GetRenderStateBoolean(r.state);
                        Jad.Video.StateManager.SetRenderState(r.state, r.bValue);
                        break;
                    case 2:
                        r.fOldValue = Jad.Video.Device.GetRenderStateSingle(r.state);
                        Jad.Video.StateManager.SetRenderState(r.state, r.fValue);
                        break;
                }
            }

            // Texture Stage States
            foreach (JTextureStageState r in textureStageStates)
            {
                switch (r.type)
                {
                    case 0:
                        r.iOldValue = Jad.Video.Device.GetTextureStageStateInt32(r.stage,r.state);
                        Jad.Video.StateManager.SetTextureStageState(r.stage, r.state, r.iValue);
                        break;
                    case 1:
                        r.bOldValue = Jad.Video.Device.GetTextureStageStateBoolean(r.stage, r.state);
                        Jad.Video.StateManager.SetTextureStageState(r.stage, r.state, r.bValue);
                        break;
                    case 2:
                        r.fOldValue = Jad.Video.Device.GetTextureStageStateSingle(r.stage, r.state);
                        Jad.Video.StateManager.SetTextureStageState(r.stage, r.state, r.fValue);
                        break;
                }
            }

            // Sampler Stage States
            foreach (JSamplerStageState r in samplerStageStates)
            {
                switch (r.type)
                {
                    case 0:
                        r.iOldValue = Jad.Video.Device.GetSamplerStageStateInt32(r.stage, r.state);
                        Jad.Video.StateManager.SetSamplerState(r.stage, r.state, r.iValue);
                        break;
                    case 1:
                        r.bOldValue = Jad.Video.Device.GetSamplerStageStateBoolean(r.stage, r.state);
                        Jad.Video.StateManager.SetSamplerState(r.stage, r.state, r.bValue);
                        break;
                    case 2:
                        r.fOldValue = Jad.Video.Device.GetSamplerStageStateSingle(r.stage, r.state);
                        Jad.Video.StateManager.SetSamplerState(r.stage, r.state, r.fValue);
                        break;
                }
            }
        }

        #endregion
    }

	/// <summary>
	/// TODO
	/// </summary>
    public class JStateManager
    {
        #region Fields

		/// <summary>
		/// Used on the Effect State Manager
		/// </summary>
		internal static VertexShader lastVS;
		
		/// <summary>
		/// Used on the Effect State Manager
		/// </summary>
		internal static PixelShader lastPS;

		/// <summary>
		/// The max number of stages supported
		/// </summary>
		public const int MAXStages=8;

        /// <summary>
        /// The array to save sampler values
        /// </summary>
        int[,] sampler = new int[MAXStages, 14];
        
		/// <summary>
		/// The array to save render states values
		/// </summary>
        int[] render = new int[255];
        
		/// <summary>
		/// The array to save texture states values
		/// </summary>
        int[,] texture = new int[MAXStages, 33];

        /// <summary>
        /// Let's the user decide if use or not the cache. Normally always true...
        /// </summary>
        public bool UseCache = true;

		/// <summary>
		/// TODO
		/// </summary>
        List<JVideoStates> videoStates;

		/// <summary>
		/// TODO
		/// </summary>
		JVideoStates active;

        #endregion

        #region Constructors

		/// <summary>
		/// Default constructor
		/// </summary>
        public JStateManager()
        {
            videoStates = new List<JVideoStates>();
            active = null;
        }

        #endregion

		#region Properties

		/// <summary>
		/// TODO
		/// </summary>
		public JVideoStates Active
		{
			get { return active; }
		}

		#endregion
		
        #region Methods

        /// <summary>
        /// Starts the capture to restore the changes at the end
        /// </summary>
        public void Begin()
        {
        	// Set the new one as active, and add it to the list
            active = new JVideoStates();

            videoStates.Add(active);
        }

        /// <summary>
        /// Restore the states
        /// </summary>
        public void End()
        {
            // Restore the states
            active.Restore();

            // Delete it
            videoStates.Remove(active);

            // Activate the last one
            if (videoStates.Count == 0)
                active = null;
        	
            else
                active = videoStates[videoStates.Count - 1];
        }

        #endregion

		#region State Methods

        /// <summary>
        /// Get the current values for all the states
        /// </summary>
		public void Initialize()
		{
			lastPS = null;
			lastVS = null;

			Direct3DXException.IgnoreExceptions();

			for (int i = 0; i <= render.GetUpperBound(0); i++)
			{
				try
				{
					render[i] = Jad.Video.Device.GetRenderStateInt32((RenderStates)i);
				}
				
				catch(DirectXException)
				{
				}
			}

			for (int s = 0; s < MAXStages; s++)
			{
				for (int i = 0; i <= sampler.GetUpperBound(1); i++)
					sampler[s, i] = Jad.Video.Device.GetSamplerStageStateInt32(s, (SamplerStageStates) i);

				for (int i = 0; i <= texture.GetUpperBound(1); i++)
					texture[s, i] = Jad.Video.Device.GetTextureStageStateInt32(s, (TextureStageStates) i);
			}

			Direct3DXException.EnableExceptions();
		}

		#endregion

		#region RenderState Methods

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetRenderState(RenderStates state, int value)
		{
			int r = (int)state;

			int lastValue = render[r];

			// If its the same value, dont modify the state
            if (UseCache && lastValue == value) return;

			render[r] = value;

			Jad.Video.Device.SetRenderState(state, value);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetRenderState(RenderStates state, bool value)
		{
			SetRenderState(state, (int)(value ? 1 : 0));
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public unsafe void SetRenderState(RenderStates state, float value)
		{
            int r = (int)state;

            int lastValue = render[r];

            Int32* ptr = (Int32*)&value;

            int v = *ptr;

			// If its the last value, dont modify the state
            if (UseCache && lastValue == v) return;

            render[r] = v;

            Jad.Video.Device.SetRenderState(state, value);
        }

		#endregion

		#region TextureStageState Methods

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetTextureStageState(int stage, TextureStageStates state, int value)
		{
			int r = ((int)state);

			int lastValue = texture[stage,r];

			// If its the same value, dont modify the state
            if (UseCache && lastValue == value) return;

			texture[stage, r] = value;

			Jad.Video.Device.SetTextureStageState(stage, state, value);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetTextureStageState(int stage, TextureStageStates state, bool value)
		{
			SetTextureStageState(stage, state, (int)(value ? 1 : 0));
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetTextureStageState(int stage, TextureStageStates state, float value)
		{
			SetTextureStageState(stage, state, (int)unchecked(value));
		}

		#endregion

		#region SamplerState Methods

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetSamplerState(int stage, SamplerStageStates state, int value)
		{
			int r = ((int)state);

			int lastValue = sampler[stage, r];

			// If its the same value, dont modify the state
            if (UseCache && lastValue == value) return;

			sampler[stage, r] = value;
            
			Jad.Video.Device.SetSamplerState(stage, state, value);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetSamplerState(int stage, SamplerStageStates state, bool value)
		{
			SetSamplerState(stage,state,(int)(value ? 1 : 0));
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public unsafe void SetSamplerState(int stage, SamplerStageStates state, float value)
		{
			int r = (int)state;

			int lastValue = sampler[stage, r];

			Int32* ptr = (Int32*)&value;

			int v = *ptr;

			// If its the same value, dont modify the state
			if (UseCache && lastValue == v) return;

			sampler[stage, r] = v;

			Jad.Video.Device.SetSamplerState(stage, state, value);
		}

		#endregion
	}

    /// <summary>
    /// The effect state manager class. This class hooks the DX effect, and all the
    /// states changes through this class methods
    /// </summary>
    internal class JEffectStateManager : EffectStateManager
	{
		#region Methods

    	/// <summary>
    	/// TODO
    	/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public override void SetRenderState(RenderStates state, int value)
        {
            Jad.Video.StateManager.SetRenderState(state, value);
        }

    	/// <summary>
    	/// TODO
    	/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public override void SetTextureStageState(int stage, TextureStageStates state, int value)
        {
            Jad.Video.StateManager.SetTextureStageState(stage, state, value);
        }

    	/// <summary>
		/// TODO
    	/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
        public override void SetSamplerState(int stage, SamplerStageStates state, int value)
        {
            Jad.Video.StateManager.SetSamplerState(stage, state, value);
        }

        /// <summary>
        /// TODO
        /// </summary>
		/// <param name="t">TODO</param>
		/// <param name="m">TODO</param>
		/// <remarks>Not used by the engine</remarks>
    	public override void SetTransform(TransformType t, ref Matrix m)
        {
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="m">TODO</param>
		/// <remarks>Not used by the engine</remarks>
        public override void SetMaterial(ref Material m)
        {
        }
        
		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="n">TODO</param>
		/// <param name="l">TODO</param>
		/// <remarks>Not used by the engine</remarks>
        public override void LightEnable(int n, bool l)
        {
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="f">TODO</param>
		/// <remarks>Not used by the engine</remarks>
        public override void SetNPatchMode(float f)
        {
        }
    	
        /// <summary>
    	/// TODO
    	/// </summary>
    	/// <param name="v">TODO</param>
    	/// <remarks>Without any changes, as its not used in the effects</remarks>
        public override void SetVertexFormat(VertexFormats v)
        {
            Jad.Video.Device.VertexFormat = v;
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="n">TODO</param>
		/// <param name="l">TODO</param>
		/// <remarks>Without any changes, as its not used in the effects</remarks>
        public override void SetLight(int n, Light l)
        {
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="canal">TODO</param>
		/// <param name="textura">TODO</param>
		/// <remarks>Without any changes, as its not used in the effects</remarks>
        public override void SetTexture(int canal, BaseTexture textura)
        {
            Jad.Video.Device.SetTexture(canal, textura);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="shader">TODO</param>
		/// <remarks>Without any changes, as its not used in the effects</remarks>
        public override void SetPixelShader(PixelShader shader)
        {
			if (shader != JStateManager.lastPS)
			{
				Jad.Video.Device.PixelShader = shader;
				JStateManager.lastPS = shader;
			}
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="shader">TODO</param>
		/// <remarks>Without any changes, as its not used in the effects</remarks>
        public override void SetVertexShader(VertexShader shader)
        {
			if (shader != JStateManager.lastVS)
			{
				Jad.Video.Device.VertexShader = shader;
				JStateManager.lastVS = shader;
			}
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="n">TODO</param>
		/// <param name="s">TODO</param>
		/// <param name="v">TODO</param>
		/// <remarks>Without any changes, as its not used in the effects</remarks>
        public override void SetVertexShaderConstantSingle(int n, GraphicsStream s, int v)
        {
            Jad.Video.Device.SetVertexShaderConstantSingle(n, s, v);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="n">TODO</param>
		/// <param name="s">TODO</param>
		/// <param name="v">TODO</param>
		/// <remarks>Without any changes, as its not used in the effects</remarks>
        public override void SetVertexShaderConstantInt32(int n, GraphicsStream s, int v)
        {
            Jad.Video.Device.SetVertexShaderConstantInt32(n, s, v);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="n">TODO</param>
		/// <param name="s">TODO</param>
		/// <param name="v">TODO</param>
		/// <remarks>Without any changes, as its not used in the effects</remarks>
        public override void SetVertexShaderConstantBoolean(int n, GraphicsStream s, int v)
        {
            Jad.Video.Device.SetVertexShaderConstantBoolean(n, s, v);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="n">TODO</param>
		/// <param name="s">TODO</param>
		/// <param name="v">TODO</param>
		/// <remarks>Without any changes, as its not used in the effects</remarks>
        public override void SetPixelShaderConstantSingle(int n, GraphicsStream s, int v)
        {
            Jad.Video.Device.SetPixelShaderConstantSingle(n, s, v);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="n">TODO</param>
		/// <param name="s">TODO</param>
		/// <param name="v">TODO</param>
		/// <remarks>Without any changes, as its not used in the effects</remarks>
        public override void SetPixelShaderConstantInt32(int n, GraphicsStream s, int v)
        {
            Jad.Video.Device.SetPixelShaderConstantInt32(n, s, v);
        }

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="n">TODO</param>
		/// <param name="s">TODO</param>
		/// <param name="v">TODO</param>
		/// <remarks>Without any changes, as its not used in the effects</remarks>
        public override void SetPixelShaderConstantBoolean(int n, GraphicsStream s, int v)
        {
            Jad.Video.Device.SetPixelShaderConstantBoolean(n, s, v);
		}
    	
		#endregion
	}
}
