using System;
using System.Collections.Generic;
using System.Text;
using JadEngine.Scripting;
using Boo.Lang;
using Boo.Lang.CodeDom;
using System.CodeDom.Compiler;

namespace JadScript
{
	public class LangBoo : JScriptLanguage 
	{
		private static CodeDomProvider _provider = new Boo.Lang.CodeDom.BooCodeProvider();

		public override System.CodeDom.Compiler.CodeDomProvider CodeDomProvider
		{
			get { return _provider; }
		}

		public override string FormatUsingStatement(string namespaceName)
		{
			return "import " + namespaceName + Environment.NewLine;
		}

		public override string WrapInClass(string className, string code)
		{
			StringBuilder newCode = new StringBuilder();
			newCode.AppendLine("class " + className + "(object):");
			string[] lines = code.Split(new string[] { Environment.NewLine }, StringSplitOptions.None);
			foreach (string line in lines)
				newCode.AppendLine("\t" + line);

			newCode.AppendLine();
			return newCode.ToString();
		}
	}
}
