//----------------------------------------------------------------------------------
//*********** Las siguientes variables DEBEN tener EXACTAMENTE este nombre ***********

// Definimos el tipo MATRIX como una matriz de 4x4 floats

#define MATRIX matrix<float, 4, 4>

MATRIX WorldViewProjection;		// World * View * Projection

struct Camara {
	float4	posicion;
};

//--------------------------------------------------------------------------------------------------
// Light struct. We must do this way to minimize the shader's constant table
//--------------------------------------------------------------------------------------------------

#define LIGHT_FarAttenStart Light_FarAttenStart_End_hotSpot_FallOff.x
#define LIGHT_FarAttenEnd Light_FarAttenStart_End_hotSpot_FallOff.y
#define LIGHT_HotSpot Light_FarAttenStart_End_hotSpot_FallOff.z
#define LIGHT_FallOff Light_FarAttenStart_End_hotSpot_FallOff.w

#define LIGHT_Position Light_Position.xyz
#define LIGHT_Direction Light_Direction.xyz
#define LIGHT_Color Light_Color
#define LIGHT_PowVolumetric Light_Position.w

float4 Light_FarAttenStart_End_hotSpot_FallOff;

float4 Light_Position;
float4 Light_Color;
float4 Light_Direction;			// w free
MATRIX	Light_ProjectorTransformation;
MATRIX	Light_ShadowMapTransformation;

//--------------------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------------------
// Material struct. We must do this way to minimize the shader's constant table
//--------------------------------------------------------------------------------------------------
#define MATERIAL_SpecularPower Material_SpecularPower_Bumpiness_Reflectivity_Transmittance.x
#define MATERIAL_Bumpiness Material_SpecularPower_Bumpiness_Reflectivity_Transmittance.y
#define MATERIAL_Reflectivity Material_SpecularPower_Bumpiness_Reflectivity_Transmittance.z
#define MATERIAL_Transmittance Material_SpecularPower_Bumpiness_Reflectivity_Transmittance.w
#define MATERIAL_Specular Material_Specular
#define MATERIAL_Diffuse Material_Diffuse
#define MATERIAL_Emissive Material_Emissive.xyz
#define MATERIAL_IntensityEmissive Material_Emissive.w
#define MATERIAL_IOR Material_IOR.x

float4	Material_Specular;
float4	Material_SpecularPower_Bumpiness_Reflectivity_Transmittance;
float4	Material_Diffuse;
float4	Material_Emissive;
float4	Material_IOR;	// y, z, w free

//--------------------------------------------------------------------------------------------------

#define ENV_Ambient Env_Ambient_TimeElapsed.xyz
#define ENV_Time Env_Ambient_TimeElapsed.w

#define ENV_ScreenWidth Env_Screen_Shadows.x
#define ENV_ScreenHeight Env_Screen_Shadows.y
#define ENV_ShadowWidth Env_Screen_Shadows.z
#define ENV_ShadowHeight Env_Screen_Shadows.w

float4	Env_Ambient_TimeElapsed;
float4	Env_Screen_Shadows;	// los 2 primeros informan del ancho/alto del RT. Los 2 siguientes del ancho/alto de las sombras

//------------------------------------------------------------------------------------
// Mapas de textura. Por desgracia no se puede aadir la textura dentro de la estructura
//------------------------------------------------------------------------------------

struct map {
	float2	tile;		// u,v del tiling de la textura
};


// definimos las variables que utilizaremos en los shaders asociadas a los mapas
// Siempre utilizaremos diffuse, as que se ha aadido en este include

map mapDiffuse;
texture texturaDiffuse;
texture texturaNormal;
