AllInOne

struct VS_INPUT
{
	float4 position :	POSITION;
};

struct VS_OUTPUT
{
	float4 position :	POSITION;
};

VS_OUTPUT VShader(VS_INPUT vin)
{
	VS_OUTPUT vout;
   
	vout.position = mul(vin.position, WorldViewProjection);

	return vout;
}

float4 PShader() : COLOR0
{
	return MATERIAL_Diffuse;
}

technique RenderScene
{
	pass p0
	{
		VertexShader = compile vs_1_1 VShader();
		PixelShader = compile ps_1_1 PShader();
	}
}

/*
----------------------------------------------------------------------------------------------
	SHADOWS
----------------------------------------------------------------------------------------------
*/

float ConstExtrusion;
float3 PosLuz;
Matrix mLightClip,mWorldInvLight;

VS_OUTPUT VShaderVolumeInfinite(VS_INPUT vin,uniform bool DirectLight)
{
	VS_OUTPUT vout;
   
   float4 pos=vin.position;
   
   if(pos.z<=-5000.0f) 
   {
   	pos.z+=10000.0f;
   	
   	
	  // Transform vertex to WorldLight space
	  pos = mul( pos, mWorldInvLight );

	  pos.w=0;
   	
	  // Multiple the vertex with vMask, transform to clip space and output
	  vout.position = mul( pos , mLightClip );
   }
   else
		vout.position = mul(pos,WorldViewProjection);

	return vout;
}

VS_OUTPUT VShaderVolumeTraditional(VS_INPUT vin,uniform bool DirectLight)
{
	VS_OUTPUT vout;
   
   float4 pos=vin.position;
   
   if(pos.z<=-5000.0f) 
   {
   	pos.z+=10000.0f;
   	
	float3 extrusionDir;
	
	if(DirectLight)
		extrusionDir=PosLuz;
	else
		extrusionDir=normalize((float3)pos-PosLuz)*ConstExtrusion;
   	
   	pos+=float4(extrusionDir,0);
   	
   }

	vout.position = mul(pos, WorldViewProjection);

	return vout;
}

technique RenderVolume
{
	pass p0
	{
		VertexShader = compile vs_2_0 VShaderVolumeTraditional(false);
		PixelShader = compile ps_1_1 PShader();
	}
}

technique RenderVolumeInfinite
{
	pass p0
	{
		VertexShader = compile vs_2_0 VShaderVolumeInfinite(false);
		PixelShader = compile ps_1_1 PShader();
	}
}

technique RenderVolume_DirectLight
{
	pass p0
	{
		VertexShader = compile vs_2_0 VShaderVolumeTraditional(true);
		PixelShader = compile ps_1_1 PShader();
	}
}

technique RenderVolumeInfinite_DirectLight
{
	pass p0
	{
		VertexShader = compile vs_2_0 VShaderVolumeInfinite(true);
		PixelShader = compile ps_1_1 PShader();
	}
}
