AllInOne

texture textureDiffuse;
sampler base_map =
sampler_state
{
	Texture		= <textureDiffuse>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

struct VS_INPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct VS_OUTPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct PS_INPUT
{
   float2 texcoord0:     TEXCOORD0;
};

VS_OUTPUT VShader( VS_INPUT vin )
{
   VS_OUTPUT vout;
   
	vout.position = mul(vin.position, WorldViewProjection);
	vout.texcoord0 = vin.texcoord0;

	return vout;
}

float4 PShader(PS_INPUT pin):COLOR0
{
	
   return tex2D( base_map, pin.texcoord0 )*MATERIAL_Diffuse;

}

technique RenderScene
{
    pass p0
    {
        VertexShader = compile vs_1_1 VShader();
        PixelShader = compile ps_1_1 PShader();
    }
}

