//----------------------------------------------------------------------------------
//***********Las siguientes variables DEBEN tener EXACTAMENTE este nombre***********

texture textureDiffuse;              // Mapa de textura diffuse
texture textureDiffuse2;              // Otro Mapa de textura diffuse
texture textureRenderTarget1;			// Textura del RT1
//----------------------------------------------------------------------------------

struct VS_INPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct VS_OUTPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct PS_INPUT
{
   float2 texcoord0:     TEXCOORD0;
};

sampler map_diffuse = 
sampler_state
{
    Texture = <textureDiffuse>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

sampler map_diffuse2 = 
sampler_state
{
    Texture = <textureDiffuse2>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

sampler map_RenderTarget1 = 
sampler_state
{
    Texture = <textureRenderTarget1>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

VS_OUTPUT VShader( VS_INPUT vin )
{
   VS_OUTPUT vout;
   
   vout.position = vin.position;
   vout.texcoord0 = vin.texcoord0;

   return vout;
}


//------------------------------------------------------------------------------------------------------------------
//											GAUSSIAN BLUR
//------------------------------------------------------------------------------------------------------------------


sampler input_texture= 
sampler_state
{
    Texture = <textureDiffuse>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    
	AddressU = Clamp;
	AddressV = Clamp;
};

float4 samples_weights[16];

float4 PShader(float2 texCoord: TEXCOORD0,uniform int numSamples) : COLOR 
{
	float4 sum = 0.0f;
	

	for (int i = 0; i < numSamples; i++) 
	{
		sum += tex2D(input_texture, texCoord + samples_weights[i].xy) * samples_weights[i].z;
		
	}
	
	return sum;

}


//	Permitimos 16 samples com mximo

int CurNumSamples = 3;
PixelShader psArray[16] = { 
	compile ps_2_0 PShader(1), 
	compile ps_2_0 PShader(2), 
	compile ps_2_0 PShader(3), 
	compile ps_2_0 PShader(4), 
	compile ps_2_0 PShader(5), 
	compile ps_2_0 PShader(6), 
	compile ps_2_0 PShader(7), 
	compile ps_2_0 PShader(8), 
	compile ps_2_0 PShader(9), 
	compile ps_2_0 PShader(10), 
	compile ps_2_0 PShader(11), 
	compile ps_2_0 PShader(12), 
	compile ps_2_0 PShader(13), 
	compile ps_2_0 PShader(14), 
	compile ps_2_0 PShader(15),
	compile ps_2_0 PShader(16)
};

technique RenderScene
{
	pass p0
	{
		VertexShader = compile vs_2_0 VShader();
		PixelShader = (psArray[CurNumSamples]);
	}
}
