//High pass filter. Used to get only the luminance values greater than a parameter
//----------------------------------------------------------------------------------
//***********Las siguientes variables DEBEN tener EXACTAMENTE este nombre***********

texture textureDiffuse;              // Mapa de textura diffuse
texture textureDiffuse2;              // Otro Mapa de textura diffuse
texture textureRenderTarget1;			// Textura del RT1
//----------------------------------------------------------------------------------

float highPassValue;
float multiplier;

struct VS_INPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct VS_OUTPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct PS_INPUT
{
   float2 texcoord0:     TEXCOORD0;
};

sampler map_diffuse = 
sampler_state
{
    Texture = <textureDiffuse>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

sampler map_RenderTarget1 = 
sampler_state
{
    Texture = <textureRenderTarget1>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

VS_OUTPUT VShader( VS_INPUT vin )
{
   VS_OUTPUT vout;
   
   vout.position = vin.position;
   vout.texcoord0 = vin.texcoord0;

   return vout;
}
float3 Luminancia={ 0.3f,0.59f,0.11f };

float4 PShader(PS_INPUT pin):COLOR0
{

	float4 finalColor=0;
	
	float color;
	
	float3 sourceColor=tex2D( map_diffuse, pin.texcoord0 );
	
	color= dot(sourceColor,Luminancia);
   
	if(color>=highPassValue) finalColor=float4(sourceColor*multiplier,1.0f);
	
	return finalColor;

}

technique RenderScene
{
    pass p0
    {
        VertexShader = compile vs_2_0 VShader();
        PixelShader = compile ps_2_0 PShader();
    }
}

