//------------------------------------------------------------------------------------------------------------------
//											Radial Blur
//------------------------------------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------
//***********Las siguientes variables DEBEN tener EXACTAMENTE este nombre***********

float Alpha;

texture textureDiffuse;              // Mapa de textura diffuse
//----------------------------------------------------------------------------------

struct VS_INPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct VS_OUTPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct PS_INPUT
{
   float2 texcoord0:     TEXCOORD0;
};

sampler map_diffuse = 
sampler_state
{
    Texture = <textureDiffuse>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

VS_OUTPUT VShader( VS_INPUT vin )
{
   VS_OUTPUT vout;
   
   vout.position = vin.position;
   vout.texcoord0 = vin.texcoord0;

   return vout;
}



float4 PShader( float2 texCoord: TEXCOORD0 ) : COLOR
{
    float4 color = tex2D( map_diffuse, texCoord );
    color.a=Alpha;

	return color;
}

technique RenderScene
{
    pass p0
    {
	    AlphaBlendEnable=true;
	    SrcBlend=SRCALPHA;
	    DestBlend=ONE;
        VertexShader = compile vs_2_0 VShader();
        PixelShader = compile ps_2_0 PShader();
    }
}

