//--------------------------------------------------------------------------------------------------
// ALLINONE:PixelShader
//--------------------------------------------------------------------------------------------------
struct PS_IN
{
	float4 texCoord0	: TEXCOORD0;
	float4 screenCoord	: TEXCOORD1;
	float4 diffuse		: COLOR0;
	float4 specular		: COLOR1;
};

float4 PShader(PS_IN data_in) : COLOR0
{
	float3 fragmentColor = 0.0f;
	
	float dof=0;
	
	// If Glow effect is activated and exists an emissive map...
	if(Uniform_emissiveEnabled)
	{
		if(Uniform_emissiveModel==EMISSIVEMODEL_TEXTURE)
			fragmentColor=tex2D(emissive_map, data_in.texCoord0);
			
		if(Uniform_emissiveModel==EMISSIVEMODEL_COLOR)
			fragmentColor=MATERIAL_Emissive;
			
		if(Uniform_emissiveModel==EMISSIVEMODEL_DIFFUSE)
		{
			fragmentColor=tex2Dproj(BackBuffer_map, data_in.screenCoord);
		}
		
		fragmentColor*=MATERIAL_IntensityEmissive;
		
	}
	
	if(Uniform_DOF)
	{
		dof=ComputeDepthBlur(data_in.texCoord0.z);
	}
	
	return float4(fragmentColor,dof);
}


