struct VS_OUT
{
	float4 position		: POSITION;
	float4 texCoord0	: TEXCOORD0;	// Esto incluye la 0 y la 1
	float4 screenCoord	: TEXCOORD1;
	float4 diffuse		: COLOR0;
	float4 specular		: COLOR1;
};

VS_OUT VShader( VS_IN data_in)
{
	VS_OUT data_out = (VS_OUT)0;

	data_out.diffuse=float4(1,1,1,1);
	
	float4 finalPosition	= data_in.position0;
	float3 finalNormal		= data_in.normal0;
	float3 finalTangent		= data_in.tangent0;
	
	// ALLINONE:Geometry

	// Pasamos la posicin a clip-space
	data_out.position = mul(finalPosition, WorldViewProjection);

	// Coordenada de textura
	data_out.texCoord0.xy = data_in.texCoord0 * mapDiffuse.tile;
	
    // Coordenadas en Screen Space
    data_out.screenCoord=ToScreenSpace(data_out.position);
	
	if(Uniform_DOF)
	{
		// put z depth in view space on texCoord0.z
		float4 wvPosition = mul(finalPosition, WorldView);
		data_out.texCoord0.z = wvPosition.z;
	}
			
	return data_out;
}
