struct VS_OUT
{
	float4 position		: POSITION;
	float2 texCoord0	: TEXCOORD0;
	float4 diffuse		: COLOR0;
	float4 specular		: COLOR1;
};

MATRIX WorldViewProjectionCurrent;
MATRIX WorldViewProjectionLast;

MATRIX WorldViewProjectionCurrentMirror;
MATRIX WorldViewProjectionLastMirror;

VS_OUT VShader( VS_IN data_in)
{
	VS_OUT data_out = (VS_OUT)0;

	data_out.diffuse=float4(1,1,1,1);
	
	float4 finalPosition	= data_in.position0;
	float3 finalNormal		= data_in.normal0;
	float3 finalTangent		= data_in.tangent0;
	
	// ALLINONE:Geometry

    float4 vPosProjSpaceCurrent; 
    float4 vPosProjSpaceLast;
	float2 velocity;
	
	// Pasamos la posicin a clip-space
	data_out.position = mul(finalPosition, WorldViewProjection);
	
	vPosProjSpaceCurrent=mul(finalPosition, WorldViewProjectionCurrent);

	
    // Transform from object space to homogeneous projection space
    vPosProjSpaceLast = mul(finalPosition, WorldViewProjectionLast);
    
    // Convert to non-homogeneous points [-1,1] by dividing by w 
    vPosProjSpaceCurrent.xyz /= abs(vPosProjSpaceCurrent.w);
    vPosProjSpaceLast.xyz /= abs(vPosProjSpaceLast.w);

    // Vertex's velocity (in non-homogeneous projection space) is the position this frame minus 
    // its position last frame.  This information is stored in a texture coord.  The pixel shader 
    // will read the texture coordinate with a sampler and use it to output each pixel's velocity.
    velocity = vPosProjSpaceCurrent - vPosProjSpaceLast;    
    
    // The velocity is now between (-2,2) so divide by 2 to get it to (-1,1)
    velocity /= 2.0f;   
	
    // Store the velocity in a texture coord
    data_out.texCoord0 = velocity;
		
	return data_out;
}
