using System;
using System.Collections.Generic;
using System.Text;

namespace JadEngine.Animation
{
    /// <summary>
    /// Interface for Animations
    /// </summary>
    public interface IJAnimation
    {
        #region Methods

        /// <summary>
        /// Plays an animation clip with a given speed
        /// </summary>
        /// <param name="name">Clip's name to play</param>
        /// <param name="speed">Animation speed, float multiplier</param>
        /// <param name="start">Start time</param>
        /// <param name="stop">Stop time</param>
        /// <param name="type">Playback type</param>
        void StartAnimationClip(string name, float speed, JAnimationClip.PlaybackType type);

        /// <summary>
        /// Stops an animation clip currently playing
        /// </summary>
        /// <param name="name"></param>
        void StopAnimationClip(string name);

        /// <summary>
        /// Updates the animation using time parameter
        /// </summary>
        /// <param name="time">Time passed since last update</param>
        void UpdateAnimation(float time);

    #endregion
    }
}
