#region Using Directives

using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.DirectX;
using JadEngine.Mathematics;
using JadEngine.Scene;
using JadEngine.Video;


#endregion

namespace JadEngine.Animation
{
    /// <summary>
    /// TODO
    /// </summary>
    public class JAnimationMorphTargetKey : JAnimationKey
    {
        #region Fields

        /// <summary>
        /// Morph target
        /// </summary>
        private JMesh _target;

		/// <summary>
		/// Current mesh (computed as result from interpolation)
		/// </summary>
		private JMesh _currentMesh;

        #endregion

        #region Constructors

        /// <summary>
        /// Default constructor
        /// </summary>
        public JAnimationMorphTargetKey()
        {
			_currentMesh = new JMesh(Jad.Video.Meshes);
        }

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="m"></param>
        public JAnimationMorphTargetKey(JMeshObject m)
        {
            _target = m.Mesh;
			_currentMesh = new JMesh(Jad.Video.Meshes);
        }

        #endregion

        #region Properties

        /// <summary>
        /// TODO
        /// </summary>
        public JMesh MorphTarget
        {
            get { return _target; }
            set { _target = value; }
        }

		/// <summary>
		/// TODO
		/// </summary>
		public JMesh CurrentKey
		{
			get { return _currentMesh; }
			set { _currentMesh = value; }
		}

        #endregion

        #region Methods

        /// <summary>
        /// Interpolates two animation keys
        /// </summary>
        /// <param name="key">Source key</param>
        /// <param name="percent">Weight of this key in the interpolation</param>
		/// <param name="type">Interpolation type</param>
        public override void ComputeKeyframe(JAnimationKey key, float percent, JInterpolationType type)
        {
            JMesh m2 = this._target;//target mesh
            JMesh m1 = ((JAnimationMorphTargetKey)key).MorphTarget;//source mesh
			JMesh r = _currentMesh;//result of interpolation

            JInterpolator.Vector3.InterpolateArrays(r.VertexBuffer.Position, m1.VertexBuffer.Position, m2.VertexBuffer.Position, 
                (double)percent, type);
        }

        #endregion
    }
}
