#region Using Directives 

using System;
using System.Collections.Generic;
using System.Text;

using JadEngine.Mathematics;
using JadEngine.Mathematics.Geometry;
using JadEngine.Scene;
using Microsoft.DirectX;

#endregion

namespace JadEngine.Animation.Skeleton
{
    class JBone
    {
        #region Fields

        /// <summary>
        /// Name for the bone
        /// </summary>
        private string name;
        
        /// <summary>
        /// Parent bone
        /// </summary>
        private JBone parent;

        /// <summary>
        /// Local transformation matrix
        /// </summary>
        private Matrix localTM;

        /// <summary>
        /// World transformation matrix
        /// </summary>
        private Matrix worldTM;

        /// <summary>
        /// Child Bones list
        /// </summary>
        private List<JBone> childBones;

        /// <summary>
        /// Child Node list
        /// </summary>
        private List<JNode> childNodes;

        #endregion

        #region Constructors

        public JBone(string name)
        {
            this.name = name;
            parent = null;
            localTM = Matrix.Identity;
            worldTM = Matrix.Identity;
            childBones = new List<JBone>();
            childNodes = new List<JNode>();
        }

        #endregion

        #region Properties
        #endregion

        #region Methods
        #endregion
    }
}
