#region Using directives

using System;
using System.IO;

using JadEngine.Core;
using JadEngine.Collections;
using System.Collections.Generic;

#endregion

/*
 * 24/03/08
 *	-Changed to derive from JEngineElement
 */

namespace JadEngine.Core
{
	/// <summary>
	/// TODO
	/// </summary>
	public class JEffectFragment : JObject
	{
		#region Fields			

		/// <summary>
		/// TODO
		/// </summary>
		string Code;

		/// <summary>
		/// Maintains the vars list that are enumerated in AllInOne
		/// </summary>
		public JListString EnumValues;

		/// <summary>
		/// TODO
		/// </summary>
		public string Vars;

		/// <summary>
		/// TODO
		/// </summary>
		public string VS;

		/// <summary>
		/// TODO
		/// </summary>
		public string PS;

		public string Name;

		#endregion

		#region Constructors

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="filename">TODO</param>
		/// <param name="stream">TODO</param>
		public JEffectFragment(string filename, Stream stream)
		{			
			StreamReader st = new StreamReader(stream);
			Code = st.ReadToEnd();
			st.Close();

			Name = Path.GetFileNameWithoutExtension(filename);

			VS = null;
			PS = null;

			Build();
		}

		#endregion		

		#region Methods

		/// <summary>
		/// TODO
		/// </summary>
		void Build()
		{
			// Search the enum
			int psEnd = Code.IndexOf("#end Enum");

			if (psEnd != -1)
			{
				EnumValues = new JListString();

				JEffectFragmentManager.ParseEnum(EnumValues, Code.Substring(0, psEnd));

				Code = Code.Substring(psEnd + 9);
			}

			// Search the VAR start
			int vsInit = Code.IndexOf("#region VAR");

			if (vsInit != -1)
			{
				vsInit += 12;

				int vsEnd = Code.IndexOf("#end VAR");

				if (vsEnd == -1)
					throw new Exception("Not found '#end VAR'");

				Vars = "// " + Name + "\n" + Code.Substring(vsInit, (vsEnd) - (vsInit)) + "\n\n";
			}

			// Search the VS start
			vsInit = Code.IndexOf("#region VS");

			if (vsInit != -1)
			{
				vsInit += 11;

				int vsEnd = Code.IndexOf("#end VS");

				if (vsEnd == -1)
					throw new Exception("Not found '#end VS'");

				VS = "// " + Name + "\n" + "{\n" + Code.Substring(vsInit, (vsEnd) - (vsInit)) + "\n}\n";
			}

			// Now the PS
			int psInit = Code.IndexOf("#region PS");

			if (psInit != -1)
			{
				psInit += 11;

				psEnd = Code.IndexOf("#end PS");

				if (psEnd == -1)
					throw new Exception("Not found '#end PS'");

				PS = "// " + Name + "\n" + "{\n" + Code.Substring(psInit, (psEnd) - (psInit)) + "\n}\n";
			}
		}

		#endregion
	}
}
