#region Using Directives
using System;
using System.Collections.Generic;
using System.Text;
#endregion

/*
 * 29/01/08
 *	-Added
 */

namespace JadEngine.Core
{
	/// <summary>
	/// Holds a set of pre-defined colors.
	/// </summary>
	public static class JColors
	{
		#region Static Properties

		/// <summary>
		/// Returns the color Snow
		/// </summary>
		public static JColor Snow
		{
			get { return new JColor(1f, 0.9803922f, 0.9803922f, 1f); }
		}


		/// <summary>
		/// Returns the color GhostWhite
		/// </summary>
		public static JColor GhostWhite
		{
			get { return new JColor(0.972549f, 0.972549f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color WhiteSmoke
		/// </summary>
		public static JColor WhiteSmoke
		{
			get { return new JColor(0.9607843f, 0.9607843f, 0.9607843f, 1f); }
		}


		/// <summary>
		/// Returns the color Gainsboro
		/// </summary>
		public static JColor Gainsboro
		{
			get { return new JColor(0.8627451f, 0.8627451f, 0.8627451f, 1f); }
		}


		/// <summary>
		/// Returns the color FloralWhite
		/// </summary>
		public static JColor FloralWhite
		{
			get { return new JColor(1f, 0.9803922f, 0.9411765f, 1f); }
		}


		/// <summary>
		/// Returns the color OldLace
		/// </summary>
		public static JColor OldLace
		{
			get { return new JColor(0.9921569f, 0.9607843f, 0.9019608f, 1f); }
		}


		/// <summary>
		/// Returns the color Linen
		/// </summary>
		public static JColor Linen
		{
			get { return new JColor(0.9803922f, 0.9411765f, 0.9019608f, 1f); }
		}


		/// <summary>
		/// Returns the color AntiqueWhite
		/// </summary>
		public static JColor AntiqueWhite
		{
			get { return new JColor(0.9803922f, 0.9215686f, 0.8431373f, 1f); }
		}


		/// <summary>
		/// Returns the color PapayaWhip
		/// </summary>
		public static JColor PapayaWhip
		{
			get { return new JColor(1f, 0.9372549f, 0.8352941f, 1f); }
		}


		/// <summary>
		/// Returns the color BlanchedAlmond
		/// </summary>
		public static JColor BlanchedAlmond
		{
			get { return new JColor(1f, 0.9215686f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color Bisque
		/// </summary>
		public static JColor Bisque
		{
			get { return new JColor(1f, 0.8941177f, 0.7686275f, 1f); }
		}


		/// <summary>
		/// Returns the color PeachPuff
		/// </summary>
		public static JColor PeachPuff
		{
			get { return new JColor(1f, 0.854902f, 0.7254902f, 1f); }
		}


		/// <summary>
		/// Returns the color NavajoWhite
		/// </summary>
		public static JColor NavajoWhite
		{
			get { return new JColor(1f, 0.8705882f, 0.6784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Moccasin
		/// </summary>
		public static JColor Moccasin
		{
			get { return new JColor(1f, 0.8941177f, 0.7098039f, 1f); }
		}


		/// <summary>
		/// Returns the color Cornsilk
		/// </summary>
		public static JColor Cornsilk
		{
			get { return new JColor(1f, 0.972549f, 0.8627451f, 1f); }
		}


		/// <summary>
		/// Returns the color Ivory
		/// </summary>
		public static JColor Ivory
		{
			get { return new JColor(1f, 1f, 0.9411765f, 1f); }
		}


		/// <summary>
		/// Returns the color LemonChiffon
		/// </summary>
		public static JColor LemonChiffon
		{
			get { return new JColor(1f, 0.9803922f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color Seashell
		/// </summary>
		public static JColor Seashell
		{
			get { return new JColor(1f, 0.9607843f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color Honeydew
		/// </summary>
		public static JColor Honeydew
		{
			get { return new JColor(0.9411765f, 1f, 0.9411765f, 1f); }
		}


		/// <summary>
		/// Returns the color MintCream
		/// </summary>
		public static JColor MintCream
		{
			get { return new JColor(0.9607843f, 1f, 0.9803922f, 1f); }
		}


		/// <summary>
		/// Returns the color Azure
		/// </summary>
		public static JColor Azure
		{
			get { return new JColor(0.9411765f, 1f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color AliceBlue
		/// </summary>
		public static JColor AliceBlue
		{
			get { return new JColor(0.9411765f, 0.972549f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color Lavender
		/// </summary>
		public static JColor Lavender
		{
			get { return new JColor(0.9019608f, 0.9019608f, 0.9803922f, 1f); }
		}


		/// <summary>
		/// Returns the color LavenderBlush
		/// </summary>
		public static JColor LavenderBlush
		{
			get { return new JColor(1f, 0.9411765f, 0.9607843f, 1f); }
		}


		/// <summary>
		/// Returns the color MistyRose
		/// </summary>
		public static JColor MistyRose
		{
			get { return new JColor(1f, 0.8941177f, 0.8823529f, 1f); }
		}


		/// <summary>
		/// Returns the color White
		/// </summary>
		public static JColor White
		{
			get { return new JColor(1f, 1f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color Black
		/// </summary>
		public static JColor Black
		{
			get { return new JColor(0f, 0f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkSlateGray
		/// </summary>
		public static JColor DarkSlateGray
		{
			get { return new JColor(0.1843137f, 0.3098039f, 0.3098039f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkSlateGrey
		/// </summary>
		public static JColor DarkSlateGrey
		{
			get { return new JColor(0.1843137f, 0.3098039f, 0.3098039f, 1f); }
		}


		/// <summary>
		/// Returns the color DimGray
		/// </summary>
		public static JColor DimGray
		{
			get { return new JColor(0.4117647f, 0.4117647f, 0.4117647f, 1f); }
		}


		/// <summary>
		/// Returns the color DimGrey
		/// </summary>
		public static JColor DimGrey
		{
			get { return new JColor(0.4117647f, 0.4117647f, 0.4117647f, 1f); }
		}


		/// <summary>
		/// Returns the color SlateGray
		/// </summary>
		public static JColor SlateGray
		{
			get { return new JColor(0.4392157f, 0.5019608f, 0.5647059f, 1f); }
		}


		/// <summary>
		/// Returns the color SlateGrey
		/// </summary>
		public static JColor SlateGrey
		{
			get { return new JColor(0.4392157f, 0.5019608f, 0.5647059f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSlateGray
		/// </summary>
		public static JColor LightSlateGray
		{
			get { return new JColor(0.4666667f, 0.5333334f, 0.6f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSlateGrey
		/// </summary>
		public static JColor LightSlateGrey
		{
			get { return new JColor(0.4666667f, 0.5333334f, 0.6f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray
		/// </summary>
		public static JColor Gray
		{
			get { return new JColor(0.7450981f, 0.7450981f, 0.7450981f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey
		/// </summary>
		public static JColor Grey
		{
			get { return new JColor(0.7450981f, 0.7450981f, 0.7450981f, 1f); }
		}


		/// <summary>
		/// Returns the color LightGrey
		/// </summary>
		public static JColor LightGrey
		{
			get { return new JColor(0.827451f, 0.827451f, 0.827451f, 1f); }
		}


		/// <summary>
		/// Returns the color LightGray
		/// </summary>
		public static JColor LightGray
		{
			get { return new JColor(0.827451f, 0.827451f, 0.827451f, 1f); }
		}


		/// <summary>
		/// Returns the color MidnightBlue
		/// </summary>
		public static JColor MidnightBlue
		{
			get { return new JColor(0.09803922f, 0.09803922f, 0.4392157f, 1f); }
		}


		/// <summary>
		/// Returns the color Navy
		/// </summary>
		public static JColor Navy
		{
			get { return new JColor(0f, 0f, 0.5019608f, 1f); }
		}


		/// <summary>
		/// Returns the color NavyBlue
		/// </summary>
		public static JColor NavyBlue
		{
			get { return new JColor(0f, 0f, 0.5019608f, 1f); }
		}


		/// <summary>
		/// Returns the color CornflowerBlue
		/// </summary>
		public static JColor CornflowerBlue
		{
			get { return new JColor(0.3921569f, 0.5843138f, 0.9294118f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkSlateBlue
		/// </summary>
		public static JColor DarkSlateBlue
		{
			get { return new JColor(0.282353f, 0.2392157f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color SlateBlue
		/// </summary>
		public static JColor SlateBlue
		{
			get { return new JColor(0.4156863f, 0.3529412f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumSlateBlue
		/// </summary>
		public static JColor MediumSlateBlue
		{
			get { return new JColor(0.4823529f, 0.4078431f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSlateBlue
		/// </summary>
		public static JColor LightSlateBlue
		{
			get { return new JColor(0.5176471f, 0.4392157f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumBlue
		/// </summary>
		public static JColor MediumBlue
		{
			get { return new JColor(0f, 0f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color RoyalBlue
		/// </summary>
		public static JColor RoyalBlue
		{
			get { return new JColor(0.254902f, 0.4117647f, 0.8823529f, 1f); }
		}


		/// <summary>
		/// Returns the color Blue
		/// </summary>
		public static JColor Blue
		{
			get { return new JColor(0f, 0f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color DodgerBlue
		/// </summary>
		public static JColor DodgerBlue
		{
			get { return new JColor(0.1176471f, 0.5647059f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color DeepSkyBlue
		/// </summary>
		public static JColor DeepSkyBlue
		{
			get { return new JColor(0f, 0.7490196f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color SkyBlue
		/// </summary>
		public static JColor SkyBlue
		{
			get { return new JColor(0.5294118f, 0.8078431f, 0.9215686f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSkyBlue
		/// </summary>
		public static JColor LightSkyBlue
		{
			get { return new JColor(0.5294118f, 0.8078431f, 0.9803922f, 1f); }
		}


		/// <summary>
		/// Returns the color SteelBlue
		/// </summary>
		public static JColor SteelBlue
		{
			get { return new JColor(0.2745098f, 0.509804f, 0.7058824f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSteelBlue
		/// </summary>
		public static JColor LightSteelBlue
		{
			get { return new JColor(0.6901961f, 0.7686275f, 0.8705882f, 1f); }
		}


		/// <summary>
		/// Returns the color LightBlue
		/// </summary>
		public static JColor LightBlue
		{
			get { return new JColor(0.6784314f, 0.8470588f, 0.9019608f, 1f); }
		}


		/// <summary>
		/// Returns the color PowderBlue
		/// </summary>
		public static JColor PowderBlue
		{
			get { return new JColor(0.6901961f, 0.8784314f, 0.9019608f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleTurquoise
		/// </summary>
		public static JColor PaleTurquoise
		{
			get { return new JColor(0.6862745f, 0.9333333f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkTurquoise
		/// </summary>
		public static JColor DarkTurquoise
		{
			get { return new JColor(0f, 0.8078431f, 0.8196079f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumTurquoise
		/// </summary>
		public static JColor MediumTurquoise
		{
			get { return new JColor(0.282353f, 0.8196079f, 0.8f, 1f); }
		}


		/// <summary>
		/// Returns the color Turquoise
		/// </summary>
		public static JColor Turquoise
		{
			get { return new JColor(0.2509804f, 0.8784314f, 0.8156863f, 1f); }
		}


		/// <summary>
		/// Returns the color Cyan
		/// </summary>
		public static JColor Cyan
		{
			get { return new JColor(0f, 1f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color LightCyan
		/// </summary>
		public static JColor LightCyan
		{
			get { return new JColor(0.8784314f, 1f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color CadetBlue
		/// </summary>
		public static JColor CadetBlue
		{
			get { return new JColor(0.372549f, 0.6196079f, 0.627451f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumAquamarine
		/// </summary>
		public static JColor MediumAquamarine
		{
			get { return new JColor(0.4f, 0.8039216f, 0.6666667f, 1f); }
		}


		/// <summary>
		/// Returns the color Aquamarine
		/// </summary>
		public static JColor Aquamarine
		{
			get { return new JColor(0.4980392f, 1f, 0.8313726f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkGreen
		/// </summary>
		public static JColor DarkGreen
		{
			get { return new JColor(0f, 0.3921569f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkOliveGreen
		/// </summary>
		public static JColor DarkOliveGreen
		{
			get { return new JColor(0.3333333f, 0.4196078f, 0.1843137f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkSeaGreen
		/// </summary>
		public static JColor DarkSeaGreen
		{
			get { return new JColor(0.5607843f, 0.7372549f, 0.5607843f, 1f); }
		}


		/// <summary>
		/// Returns the color SeaGreen
		/// </summary>
		public static JColor SeaGreen
		{
			get { return new JColor(0.1803922f, 0.5450981f, 0.3411765f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumSeaGreen
		/// </summary>
		public static JColor MediumSeaGreen
		{
			get { return new JColor(0.2352941f, 0.7019608f, 0.4431373f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSeaGreen
		/// </summary>
		public static JColor LightSeaGreen
		{
			get { return new JColor(0.1254902f, 0.6980392f, 0.6666667f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleGreen
		/// </summary>
		public static JColor PaleGreen
		{
			get { return new JColor(0.5960785f, 0.9843137f, 0.5960785f, 1f); }
		}


		/// <summary>
		/// Returns the color SpringGreen
		/// </summary>
		public static JColor SpringGreen
		{
			get { return new JColor(0f, 1f, 0.4980392f, 1f); }
		}


		/// <summary>
		/// Returns the color LawnGreen
		/// </summary>
		public static JColor LawnGreen
		{
			get { return new JColor(0.4862745f, 0.9882353f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Green
		/// </summary>
		public static JColor Green
		{
			get { return new JColor(0f, 1f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Chartreuse
		/// </summary>
		public static JColor Chartreuse
		{
			get { return new JColor(0.4980392f, 1f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumSpringGreen
		/// </summary>
		public static JColor MediumSpringGreen
		{
			get { return new JColor(0f, 0.9803922f, 0.6039216f, 1f); }
		}


		/// <summary>
		/// Returns the color GreenYellow
		/// </summary>
		public static JColor GreenYellow
		{
			get { return new JColor(0.6784314f, 1f, 0.1843137f, 1f); }
		}


		/// <summary>
		/// Returns the color LimeGreen
		/// </summary>
		public static JColor LimeGreen
		{
			get { return new JColor(0.1960784f, 0.8039216f, 0.1960784f, 1f); }
		}


		/// <summary>
		/// Returns the color YellowGreen
		/// </summary>
		public static JColor YellowGreen
		{
			get { return new JColor(0.6039216f, 0.8039216f, 0.1960784f, 1f); }
		}


		/// <summary>
		/// Returns the color ForestGreen
		/// </summary>
		public static JColor ForestGreen
		{
			get { return new JColor(0.1333333f, 0.5450981f, 0.1333333f, 1f); }
		}


		/// <summary>
		/// Returns the color OliveDrab
		/// </summary>
		public static JColor OliveDrab
		{
			get { return new JColor(0.4196078f, 0.5568628f, 0.1372549f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkKhaki
		/// </summary>
		public static JColor DarkKhaki
		{
			get { return new JColor(0.7411765f, 0.7176471f, 0.4196078f, 1f); }
		}


		/// <summary>
		/// Returns the color Khaki
		/// </summary>
		public static JColor Khaki
		{
			get { return new JColor(0.9411765f, 0.9019608f, 0.5490196f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleGoldenrod
		/// </summary>
		public static JColor PaleGoldenrod
		{
			get { return new JColor(0.9333333f, 0.9098039f, 0.6666667f, 1f); }
		}


		/// <summary>
		/// Returns the color LightGoldenrodYellow
		/// </summary>
		public static JColor LightGoldenrodYellow
		{
			get { return new JColor(0.9803922f, 0.9803922f, 0.8235294f, 1f); }
		}


		/// <summary>
		/// Returns the color LightYellow
		/// </summary>
		public static JColor LightYellow
		{
			get { return new JColor(1f, 1f, 0.8784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Yellow
		/// </summary>
		public static JColor Yellow
		{
			get { return new JColor(1f, 1f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Gold
		/// </summary>
		public static JColor Gold
		{
			get { return new JColor(1f, 0.8431373f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color LightGoldenrod
		/// </summary>
		public static JColor LightGoldenrod
		{
			get { return new JColor(0.9333333f, 0.8666667f, 0.509804f, 1f); }
		}


		/// <summary>
		/// Returns the color Goldenrod
		/// </summary>
		public static JColor Goldenrod
		{
			get { return new JColor(0.854902f, 0.6470588f, 0.1254902f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkGoldenrod
		/// </summary>
		public static JColor DarkGoldenrod
		{
			get { return new JColor(0.7215686f, 0.5254902f, 0.04313726f, 1f); }
		}


		/// <summary>
		/// Returns the color RosyBrown
		/// </summary>
		public static JColor RosyBrown
		{
			get { return new JColor(0.7372549f, 0.5607843f, 0.5607843f, 1f); }
		}


		/// <summary>
		/// Returns the color IndianRed
		/// </summary>
		public static JColor IndianRed
		{
			get { return new JColor(0.8039216f, 0.3607843f, 0.3607843f, 1f); }
		}


		/// <summary>
		/// Returns the color SaddleBrown
		/// </summary>
		public static JColor SaddleBrown
		{
			get { return new JColor(0.5450981f, 0.2705882f, 0.07450981f, 1f); }
		}


		/// <summary>
		/// Returns the color Sienna
		/// </summary>
		public static JColor Sienna
		{
			get { return new JColor(0.627451f, 0.3215686f, 0.1764706f, 1f); }
		}


		/// <summary>
		/// Returns the color Peru
		/// </summary>
		public static JColor Peru
		{
			get { return new JColor(0.8039216f, 0.5215687f, 0.2470588f, 1f); }
		}


		/// <summary>
		/// Returns the color Burlywood
		/// </summary>
		public static JColor Burlywood
		{
			get { return new JColor(0.8705882f, 0.7215686f, 0.5294118f, 1f); }
		}


		/// <summary>
		/// Returns the color Beige
		/// </summary>
		public static JColor Beige
		{
			get { return new JColor(0.9607843f, 0.9607843f, 0.8627451f, 1f); }
		}


		/// <summary>
		/// Returns the color Wheat
		/// </summary>
		public static JColor Wheat
		{
			get { return new JColor(0.9607843f, 0.8705882f, 0.7019608f, 1f); }
		}


		/// <summary>
		/// Returns the color SandyBrown
		/// </summary>
		public static JColor SandyBrown
		{
			get { return new JColor(0.9568627f, 0.6431373f, 0.3764706f, 1f); }
		}


		/// <summary>
		/// Returns the color Tan
		/// </summary>
		public static JColor Tan
		{
			get { return new JColor(0.8235294f, 0.7058824f, 0.5490196f, 1f); }
		}


		/// <summary>
		/// Returns the color Chocolate
		/// </summary>
		public static JColor Chocolate
		{
			get { return new JColor(0.8235294f, 0.4117647f, 0.1176471f, 1f); }
		}


		/// <summary>
		/// Returns the color Firebrick
		/// </summary>
		public static JColor Firebrick
		{
			get { return new JColor(0.6980392f, 0.1333333f, 0.1333333f, 1f); }
		}


		/// <summary>
		/// Returns the color Brown
		/// </summary>
		public static JColor Brown
		{
			get { return new JColor(0.6470588f, 0.1647059f, 0.1647059f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkSalmon
		/// </summary>
		public static JColor DarkSalmon
		{
			get { return new JColor(0.9137255f, 0.5882353f, 0.4784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Salmon
		/// </summary>
		public static JColor Salmon
		{
			get { return new JColor(0.9803922f, 0.5019608f, 0.4470588f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSalmon
		/// </summary>
		public static JColor LightSalmon
		{
			get { return new JColor(1f, 0.627451f, 0.4784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Orange
		/// </summary>
		public static JColor Orange
		{
			get { return new JColor(1f, 0.6470588f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkOrange
		/// </summary>
		public static JColor DarkOrange
		{
			get { return new JColor(1f, 0.5490196f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Coral
		/// </summary>
		public static JColor Coral
		{
			get { return new JColor(1f, 0.4980392f, 0.3137255f, 1f); }
		}


		/// <summary>
		/// Returns the color LightCoral
		/// </summary>
		public static JColor LightCoral
		{
			get { return new JColor(0.9411765f, 0.5019608f, 0.5019608f, 1f); }
		}


		/// <summary>
		/// Returns the color Tomato
		/// </summary>
		public static JColor Tomato
		{
			get { return new JColor(1f, 0.3882353f, 0.2784314f, 1f); }
		}


		/// <summary>
		/// Returns the color OrangeRed
		/// </summary>
		public static JColor OrangeRed
		{
			get { return new JColor(1f, 0.2705882f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Red
		/// </summary>
		public static JColor Red
		{
			get { return new JColor(1f, 0f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color HotPink
		/// </summary>
		public static JColor HotPink
		{
			get { return new JColor(1f, 0.4117647f, 0.7058824f, 1f); }
		}


		/// <summary>
		/// Returns the color DeepPink
		/// </summary>
		public static JColor DeepPink
		{
			get { return new JColor(1f, 0.07843138f, 0.5764706f, 1f); }
		}


		/// <summary>
		/// Returns the color Pink
		/// </summary>
		public static JColor Pink
		{
			get { return new JColor(1f, 0.7529412f, 0.7960784f, 1f); }
		}


		/// <summary>
		/// Returns the color LightPink
		/// </summary>
		public static JColor LightPink
		{
			get { return new JColor(1f, 0.7137255f, 0.7568628f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleVioletRed
		/// </summary>
		public static JColor PaleVioletRed
		{
			get { return new JColor(0.8588235f, 0.4392157f, 0.5764706f, 1f); }
		}


		/// <summary>
		/// Returns the color Maroon
		/// </summary>
		public static JColor Maroon
		{
			get { return new JColor(0.6901961f, 0.1882353f, 0.3764706f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumVioletRed
		/// </summary>
		public static JColor MediumVioletRed
		{
			get { return new JColor(0.7803922f, 0.08235294f, 0.5215687f, 1f); }
		}


		/// <summary>
		/// Returns the color VioletRed
		/// </summary>
		public static JColor VioletRed
		{
			get { return new JColor(0.8156863f, 0.1254902f, 0.5647059f, 1f); }
		}


		/// <summary>
		/// Returns the color Magenta
		/// </summary>
		public static JColor Magenta
		{
			get { return new JColor(1f, 0f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color Violet
		/// </summary>
		public static JColor Violet
		{
			get { return new JColor(0.9333333f, 0.509804f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color Plum
		/// </summary>
		public static JColor Plum
		{
			get { return new JColor(0.8666667f, 0.627451f, 0.8666667f, 1f); }
		}


		/// <summary>
		/// Returns the color Orchid
		/// </summary>
		public static JColor Orchid
		{
			get { return new JColor(0.854902f, 0.4392157f, 0.8392157f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumOrchid
		/// </summary>
		public static JColor MediumOrchid
		{
			get { return new JColor(0.7294118f, 0.3333333f, 0.827451f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkOrchid
		/// </summary>
		public static JColor DarkOrchid
		{
			get { return new JColor(0.6f, 0.1960784f, 0.8f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkViolet
		/// </summary>
		public static JColor DarkViolet
		{
			get { return new JColor(0.5803922f, 0f, 0.827451f, 1f); }
		}


		/// <summary>
		/// Returns the color BlueViolet
		/// </summary>
		public static JColor BlueViolet
		{
			get { return new JColor(0.5411765f, 0.1686275f, 0.8862745f, 1f); }
		}


		/// <summary>
		/// Returns the color Purple
		/// </summary>
		public static JColor Purple
		{
			get { return new JColor(0.627451f, 0.1254902f, 0.9411765f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumPurple
		/// </summary>
		public static JColor MediumPurple
		{
			get { return new JColor(0.5764706f, 0.4392157f, 0.8588235f, 1f); }
		}


		/// <summary>
		/// Returns the color Thistle
		/// </summary>
		public static JColor Thistle
		{
			get { return new JColor(0.8470588f, 0.7490196f, 0.8470588f, 1f); }
		}


		/// <summary>
		/// Returns the color Snow1
		/// </summary>
		public static JColor Snow1
		{
			get { return new JColor(1f, 0.9803922f, 0.9803922f, 1f); }
		}


		/// <summary>
		/// Returns the color Snow2
		/// </summary>
		public static JColor Snow2
		{
			get { return new JColor(0.9333333f, 0.9137255f, 0.9137255f, 1f); }
		}


		/// <summary>
		/// Returns the color Snow3
		/// </summary>
		public static JColor Snow3
		{
			get { return new JColor(0.8039216f, 0.7882353f, 0.7882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Snow4
		/// </summary>
		public static JColor Snow4
		{
			get { return new JColor(0.5450981f, 0.5372549f, 0.5372549f, 1f); }
		}


		/// <summary>
		/// Returns the color Seashell1
		/// </summary>
		public static JColor Seashell1
		{
			get { return new JColor(1f, 0.9607843f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color Seashell2
		/// </summary>
		public static JColor Seashell2
		{
			get { return new JColor(0.9333333f, 0.8980392f, 0.8705882f, 1f); }
		}


		/// <summary>
		/// Returns the color Seashell3
		/// </summary>
		public static JColor Seashell3
		{
			get { return new JColor(0.8039216f, 0.772549f, 0.7490196f, 1f); }
		}


		/// <summary>
		/// Returns the color Seashell4
		/// </summary>
		public static JColor Seashell4
		{
			get { return new JColor(0.5450981f, 0.5254902f, 0.509804f, 1f); }
		}


		/// <summary>
		/// Returns the color AntiqueWhite1
		/// </summary>
		public static JColor AntiqueWhite1
		{
			get { return new JColor(1f, 0.9372549f, 0.8588235f, 1f); }
		}


		/// <summary>
		/// Returns the color AntiqueWhite2
		/// </summary>
		public static JColor AntiqueWhite2
		{
			get { return new JColor(0.9333333f, 0.8745098f, 0.8f, 1f); }
		}


		/// <summary>
		/// Returns the color AntiqueWhite3
		/// </summary>
		public static JColor AntiqueWhite3
		{
			get { return new JColor(0.8039216f, 0.7529412f, 0.6901961f, 1f); }
		}


		/// <summary>
		/// Returns the color AntiqueWhite4
		/// </summary>
		public static JColor AntiqueWhite4
		{
			get { return new JColor(0.5450981f, 0.5137255f, 0.4705882f, 1f); }
		}


		/// <summary>
		/// Returns the color Bisque1
		/// </summary>
		public static JColor Bisque1
		{
			get { return new JColor(1f, 0.8941177f, 0.7686275f, 1f); }
		}


		/// <summary>
		/// Returns the color Bisque2
		/// </summary>
		public static JColor Bisque2
		{
			get { return new JColor(0.9333333f, 0.8352941f, 0.7176471f, 1f); }
		}


		/// <summary>
		/// Returns the color Bisque3
		/// </summary>
		public static JColor Bisque3
		{
			get { return new JColor(0.8039216f, 0.7176471f, 0.6196079f, 1f); }
		}


		/// <summary>
		/// Returns the color Bisque4
		/// </summary>
		public static JColor Bisque4
		{
			get { return new JColor(0.5450981f, 0.4901961f, 0.4196078f, 1f); }
		}


		/// <summary>
		/// Returns the color PeachPuff1
		/// </summary>
		public static JColor PeachPuff1
		{
			get { return new JColor(1f, 0.854902f, 0.7254902f, 1f); }
		}


		/// <summary>
		/// Returns the color PeachPuff2
		/// </summary>
		public static JColor PeachPuff2
		{
			get { return new JColor(0.9333333f, 0.7960784f, 0.6784314f, 1f); }
		}


		/// <summary>
		/// Returns the color PeachPuff3
		/// </summary>
		public static JColor PeachPuff3
		{
			get { return new JColor(0.8039216f, 0.6862745f, 0.5843138f, 1f); }
		}


		/// <summary>
		/// Returns the color PeachPuff4
		/// </summary>
		public static JColor PeachPuff4
		{
			get { return new JColor(0.5450981f, 0.4666667f, 0.3960784f, 1f); }
		}


		/// <summary>
		/// Returns the color NavajoWhite1
		/// </summary>
		public static JColor NavajoWhite1
		{
			get { return new JColor(1f, 0.8705882f, 0.6784314f, 1f); }
		}


		/// <summary>
		/// Returns the color NavajoWhite2
		/// </summary>
		public static JColor NavajoWhite2
		{
			get { return new JColor(0.9333333f, 0.8117647f, 0.6313726f, 1f); }
		}


		/// <summary>
		/// Returns the color NavajoWhite3
		/// </summary>
		public static JColor NavajoWhite3
		{
			get { return new JColor(0.8039216f, 0.7019608f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color NavajoWhite4
		/// </summary>
		public static JColor NavajoWhite4
		{
			get { return new JColor(0.5450981f, 0.4745098f, 0.3686275f, 1f); }
		}


		/// <summary>
		/// Returns the color LemonChiffon1
		/// </summary>
		public static JColor LemonChiffon1
		{
			get { return new JColor(1f, 0.9803922f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color LemonChiffon2
		/// </summary>
		public static JColor LemonChiffon2
		{
			get { return new JColor(0.9333333f, 0.9137255f, 0.7490196f, 1f); }
		}


		/// <summary>
		/// Returns the color LemonChiffon3
		/// </summary>
		public static JColor LemonChiffon3
		{
			get { return new JColor(0.8039216f, 0.7882353f, 0.6470588f, 1f); }
		}


		/// <summary>
		/// Returns the color LemonChiffon4
		/// </summary>
		public static JColor LemonChiffon4
		{
			get { return new JColor(0.5450981f, 0.5372549f, 0.4392157f, 1f); }
		}


		/// <summary>
		/// Returns the color Cornsilk1
		/// </summary>
		public static JColor Cornsilk1
		{
			get { return new JColor(1f, 0.972549f, 0.8627451f, 1f); }
		}


		/// <summary>
		/// Returns the color Cornsilk2
		/// </summary>
		public static JColor Cornsilk2
		{
			get { return new JColor(0.9333333f, 0.9098039f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color Cornsilk3
		/// </summary>
		public static JColor Cornsilk3
		{
			get { return new JColor(0.8039216f, 0.7843137f, 0.6941177f, 1f); }
		}


		/// <summary>
		/// Returns the color Cornsilk4
		/// </summary>
		public static JColor Cornsilk4
		{
			get { return new JColor(0.5450981f, 0.5333334f, 0.4705882f, 1f); }
		}


		/// <summary>
		/// Returns the color Ivory1
		/// </summary>
		public static JColor Ivory1
		{
			get { return new JColor(1f, 1f, 0.9411765f, 1f); }
		}


		/// <summary>
		/// Returns the color Ivory2
		/// </summary>
		public static JColor Ivory2
		{
			get { return new JColor(0.9333333f, 0.9333333f, 0.8784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Ivory3
		/// </summary>
		public static JColor Ivory3
		{
			get { return new JColor(0.8039216f, 0.8039216f, 0.7568628f, 1f); }
		}


		/// <summary>
		/// Returns the color Ivory4
		/// </summary>
		public static JColor Ivory4
		{
			get { return new JColor(0.5450981f, 0.5450981f, 0.5137255f, 1f); }
		}


		/// <summary>
		/// Returns the color Honeydew1
		/// </summary>
		public static JColor Honeydew1
		{
			get { return new JColor(0.9411765f, 1f, 0.9411765f, 1f); }
		}


		/// <summary>
		/// Returns the color Honeydew2
		/// </summary>
		public static JColor Honeydew2
		{
			get { return new JColor(0.8784314f, 0.9333333f, 0.8784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Honeydew3
		/// </summary>
		public static JColor Honeydew3
		{
			get { return new JColor(0.7568628f, 0.8039216f, 0.7568628f, 1f); }
		}


		/// <summary>
		/// Returns the color Honeydew4
		/// </summary>
		public static JColor Honeydew4
		{
			get { return new JColor(0.5137255f, 0.5450981f, 0.5137255f, 1f); }
		}


		/// <summary>
		/// Returns the color LavenderBlush1
		/// </summary>
		public static JColor LavenderBlush1
		{
			get { return new JColor(1f, 0.9411765f, 0.9607843f, 1f); }
		}


		/// <summary>
		/// Returns the color LavenderBlush2
		/// </summary>
		public static JColor LavenderBlush2
		{
			get { return new JColor(0.9333333f, 0.8784314f, 0.8980392f, 1f); }
		}


		/// <summary>
		/// Returns the color LavenderBlush3
		/// </summary>
		public static JColor LavenderBlush3
		{
			get { return new JColor(0.8039216f, 0.7568628f, 0.772549f, 1f); }
		}


		/// <summary>
		/// Returns the color LavenderBlush4
		/// </summary>
		public static JColor LavenderBlush4
		{
			get { return new JColor(0.5450981f, 0.5137255f, 0.5254902f, 1f); }
		}


		/// <summary>
		/// Returns the color MistyRose1
		/// </summary>
		public static JColor MistyRose1
		{
			get { return new JColor(1f, 0.8941177f, 0.8823529f, 1f); }
		}


		/// <summary>
		/// Returns the color MistyRose2
		/// </summary>
		public static JColor MistyRose2
		{
			get { return new JColor(0.9333333f, 0.8352941f, 0.8235294f, 1f); }
		}


		/// <summary>
		/// Returns the color MistyRose3
		/// </summary>
		public static JColor MistyRose3
		{
			get { return new JColor(0.8039216f, 0.7176471f, 0.7098039f, 1f); }
		}


		/// <summary>
		/// Returns the color MistyRose4
		/// </summary>
		public static JColor MistyRose4
		{
			get { return new JColor(0.5450981f, 0.4901961f, 0.4823529f, 1f); }
		}


		/// <summary>
		/// Returns the color Azure1
		/// </summary>
		public static JColor Azure1
		{
			get { return new JColor(0.9411765f, 1f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color Azure2
		/// </summary>
		public static JColor Azure2
		{
			get { return new JColor(0.8784314f, 0.9333333f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color Azure3
		/// </summary>
		public static JColor Azure3
		{
			get { return new JColor(0.7568628f, 0.8039216f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color Azure4
		/// </summary>
		public static JColor Azure4
		{
			get { return new JColor(0.5137255f, 0.5450981f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color SlateBlue1
		/// </summary>
		public static JColor SlateBlue1
		{
			get { return new JColor(0.5137255f, 0.4352941f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color SlateBlue2
		/// </summary>
		public static JColor SlateBlue2
		{
			get { return new JColor(0.4784314f, 0.4039216f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color SlateBlue3
		/// </summary>
		public static JColor SlateBlue3
		{
			get { return new JColor(0.4117647f, 0.3490196f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color SlateBlue4
		/// </summary>
		public static JColor SlateBlue4
		{
			get { return new JColor(0.2784314f, 0.2352941f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color RoyalBlue1
		/// </summary>
		public static JColor RoyalBlue1
		{
			get { return new JColor(0.282353f, 0.4627451f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color RoyalBlue2
		/// </summary>
		public static JColor RoyalBlue2
		{
			get { return new JColor(0.2627451f, 0.4313726f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color RoyalBlue3
		/// </summary>
		public static JColor RoyalBlue3
		{
			get { return new JColor(0.227451f, 0.372549f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color RoyalBlue4
		/// </summary>
		public static JColor RoyalBlue4
		{
			get { return new JColor(0.1529412f, 0.2509804f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color Blue1
		/// </summary>
		public static JColor Blue1
		{
			get { return new JColor(0f, 0f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color Blue2
		/// </summary>
		public static JColor Blue2
		{
			get { return new JColor(0f, 0f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color Blue3
		/// </summary>
		public static JColor Blue3
		{
			get { return new JColor(0f, 0f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color Blue4
		/// </summary>
		public static JColor Blue4
		{
			get { return new JColor(0f, 0f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color DodgerBlue1
		/// </summary>
		public static JColor DodgerBlue1
		{
			get { return new JColor(0.1176471f, 0.5647059f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color DodgerBlue2
		/// </summary>
		public static JColor DodgerBlue2
		{
			get { return new JColor(0.1098039f, 0.5254902f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color DodgerBlue3
		/// </summary>
		public static JColor DodgerBlue3
		{
			get { return new JColor(0.09411765f, 0.454902f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color DodgerBlue4
		/// </summary>
		public static JColor DodgerBlue4
		{
			get { return new JColor(0.0627451f, 0.3058824f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color SteelBlue1
		/// </summary>
		public static JColor SteelBlue1
		{
			get { return new JColor(0.3882353f, 0.7215686f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color SteelBlue2
		/// </summary>
		public static JColor SteelBlue2
		{
			get { return new JColor(0.3607843f, 0.6745098f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color SteelBlue3
		/// </summary>
		public static JColor SteelBlue3
		{
			get { return new JColor(0.3098039f, 0.5803922f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color SteelBlue4
		/// </summary>
		public static JColor SteelBlue4
		{
			get { return new JColor(0.2117647f, 0.3921569f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color DeepSkyBlue1
		/// </summary>
		public static JColor DeepSkyBlue1
		{
			get { return new JColor(0f, 0.7490196f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color DeepSkyBlue2
		/// </summary>
		public static JColor DeepSkyBlue2
		{
			get { return new JColor(0f, 0.6980392f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color DeepSkyBlue3
		/// </summary>
		public static JColor DeepSkyBlue3
		{
			get { return new JColor(0f, 0.6039216f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color DeepSkyBlue4
		/// </summary>
		public static JColor DeepSkyBlue4
		{
			get { return new JColor(0f, 0.4078431f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color SkyBlue1
		/// </summary>
		public static JColor SkyBlue1
		{
			get { return new JColor(0.5294118f, 0.8078431f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color SkyBlue2
		/// </summary>
		public static JColor SkyBlue2
		{
			get { return new JColor(0.4941176f, 0.7529412f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color SkyBlue3
		/// </summary>
		public static JColor SkyBlue3
		{
			get { return new JColor(0.4235294f, 0.6509804f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color SkyBlue4
		/// </summary>
		public static JColor SkyBlue4
		{
			get { return new JColor(0.2901961f, 0.4392157f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSkyBlue1
		/// </summary>
		public static JColor LightSkyBlue1
		{
			get { return new JColor(0.6901961f, 0.8862745f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSkyBlue2
		/// </summary>
		public static JColor LightSkyBlue2
		{
			get { return new JColor(0.6431373f, 0.827451f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSkyBlue3
		/// </summary>
		public static JColor LightSkyBlue3
		{
			get { return new JColor(0.5529412f, 0.7137255f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSkyBlue4
		/// </summary>
		public static JColor LightSkyBlue4
		{
			get { return new JColor(0.3764706f, 0.4823529f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color SlateGray1
		/// </summary>
		public static JColor SlateGray1
		{
			get { return new JColor(0.7764706f, 0.8862745f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color SlateGray2
		/// </summary>
		public static JColor SlateGray2
		{
			get { return new JColor(0.7254902f, 0.827451f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color SlateGray3
		/// </summary>
		public static JColor SlateGray3
		{
			get { return new JColor(0.6235294f, 0.7137255f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color SlateGray4
		/// </summary>
		public static JColor SlateGray4
		{
			get { return new JColor(0.4235294f, 0.4823529f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSteelBlue1
		/// </summary>
		public static JColor LightSteelBlue1
		{
			get { return new JColor(0.7921569f, 0.8823529f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSteelBlue2
		/// </summary>
		public static JColor LightSteelBlue2
		{
			get { return new JColor(0.7372549f, 0.8235294f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSteelBlue3
		/// </summary>
		public static JColor LightSteelBlue3
		{
			get { return new JColor(0.6352941f, 0.7098039f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSteelBlue4
		/// </summary>
		public static JColor LightSteelBlue4
		{
			get { return new JColor(0.4313726f, 0.4823529f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color LightBlue1
		/// </summary>
		public static JColor LightBlue1
		{
			get { return new JColor(0.7490196f, 0.9372549f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color LightBlue2
		/// </summary>
		public static JColor LightBlue2
		{
			get { return new JColor(0.6980392f, 0.8745098f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color LightBlue3
		/// </summary>
		public static JColor LightBlue3
		{
			get { return new JColor(0.6039216f, 0.7529412f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color LightBlue4
		/// </summary>
		public static JColor LightBlue4
		{
			get { return new JColor(0.4078431f, 0.5137255f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color LightCyan1
		/// </summary>
		public static JColor LightCyan1
		{
			get { return new JColor(0.8784314f, 1f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color LightCyan2
		/// </summary>
		public static JColor LightCyan2
		{
			get { return new JColor(0.8196079f, 0.9333333f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color LightCyan3
		/// </summary>
		public static JColor LightCyan3
		{
			get { return new JColor(0.7058824f, 0.8039216f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color LightCyan4
		/// </summary>
		public static JColor LightCyan4
		{
			get { return new JColor(0.4784314f, 0.5450981f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleTurquoise1
		/// </summary>
		public static JColor PaleTurquoise1
		{
			get { return new JColor(0.7333333f, 1f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleTurquoise2
		/// </summary>
		public static JColor PaleTurquoise2
		{
			get { return new JColor(0.682353f, 0.9333333f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleTurquoise3
		/// </summary>
		public static JColor PaleTurquoise3
		{
			get { return new JColor(0.5882353f, 0.8039216f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleTurquoise4
		/// </summary>
		public static JColor PaleTurquoise4
		{
			get { return new JColor(0.4f, 0.5450981f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color CadetBlue1
		/// </summary>
		public static JColor CadetBlue1
		{
			get { return new JColor(0.5960785f, 0.9607843f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color CadetBlue2
		/// </summary>
		public static JColor CadetBlue2
		{
			get { return new JColor(0.5568628f, 0.8980392f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color CadetBlue3
		/// </summary>
		public static JColor CadetBlue3
		{
			get { return new JColor(0.4784314f, 0.772549f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color CadetBlue4
		/// </summary>
		public static JColor CadetBlue4
		{
			get { return new JColor(0.3254902f, 0.5254902f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color Turquoise1
		/// </summary>
		public static JColor Turquoise1
		{
			get { return new JColor(0f, 0.9607843f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color Turquoise2
		/// </summary>
		public static JColor Turquoise2
		{
			get { return new JColor(0f, 0.8980392f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color Turquoise3
		/// </summary>
		public static JColor Turquoise3
		{
			get { return new JColor(0f, 0.772549f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color Turquoise4
		/// </summary>
		public static JColor Turquoise4
		{
			get { return new JColor(0f, 0.5254902f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color Cyan1
		/// </summary>
		public static JColor Cyan1
		{
			get { return new JColor(0f, 1f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color Cyan2
		/// </summary>
		public static JColor Cyan2
		{
			get { return new JColor(0f, 0.9333333f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color Cyan3
		/// </summary>
		public static JColor Cyan3
		{
			get { return new JColor(0f, 0.8039216f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color Cyan4
		/// </summary>
		public static JColor Cyan4
		{
			get { return new JColor(0f, 0.5450981f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkSlateGray1
		/// </summary>
		public static JColor DarkSlateGray1
		{
			get { return new JColor(0.5921569f, 1f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkSlateGray2
		/// </summary>
		public static JColor DarkSlateGray2
		{
			get { return new JColor(0.5529412f, 0.9333333f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkSlateGray3
		/// </summary>
		public static JColor DarkSlateGray3
		{
			get { return new JColor(0.4745098f, 0.8039216f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkSlateGray4
		/// </summary>
		public static JColor DarkSlateGray4
		{
			get { return new JColor(0.3215686f, 0.5450981f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color Aquamarine1
		/// </summary>
		public static JColor Aquamarine1
		{
			get { return new JColor(0.4980392f, 1f, 0.8313726f, 1f); }
		}


		/// <summary>
		/// Returns the color Aquamarine2
		/// </summary>
		public static JColor Aquamarine2
		{
			get { return new JColor(0.4627451f, 0.9333333f, 0.7764706f, 1f); }
		}


		/// <summary>
		/// Returns the color Aquamarine3
		/// </summary>
		public static JColor Aquamarine3
		{
			get { return new JColor(0.4f, 0.8039216f, 0.6666667f, 1f); }
		}


		/// <summary>
		/// Returns the color Aquamarine4
		/// </summary>
		public static JColor Aquamarine4
		{
			get { return new JColor(0.2705882f, 0.5450981f, 0.454902f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkSeaGreen1
		/// </summary>
		public static JColor DarkSeaGreen1
		{
			get { return new JColor(0.7568628f, 1f, 0.7568628f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkSeaGreen2
		/// </summary>
		public static JColor DarkSeaGreen2
		{
			get { return new JColor(0.7058824f, 0.9333333f, 0.7058824f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkSeaGreen3
		/// </summary>
		public static JColor DarkSeaGreen3
		{
			get { return new JColor(0.6078432f, 0.8039216f, 0.6078432f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkSeaGreen4
		/// </summary>
		public static JColor DarkSeaGreen4
		{
			get { return new JColor(0.4117647f, 0.5450981f, 0.4117647f, 1f); }
		}


		/// <summary>
		/// Returns the color SeaGreen1
		/// </summary>
		public static JColor SeaGreen1
		{
			get { return new JColor(0.3294118f, 1f, 0.6235294f, 1f); }
		}


		/// <summary>
		/// Returns the color SeaGreen2
		/// </summary>
		public static JColor SeaGreen2
		{
			get { return new JColor(0.3058824f, 0.9333333f, 0.5803922f, 1f); }
		}


		/// <summary>
		/// Returns the color SeaGreen3
		/// </summary>
		public static JColor SeaGreen3
		{
			get { return new JColor(0.2627451f, 0.8039216f, 0.5019608f, 1f); }
		}


		/// <summary>
		/// Returns the color SeaGreen4
		/// </summary>
		public static JColor SeaGreen4
		{
			get { return new JColor(0.1803922f, 0.5450981f, 0.3411765f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleGreen1
		/// </summary>
		public static JColor PaleGreen1
		{
			get { return new JColor(0.6039216f, 1f, 0.6039216f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleGreen2
		/// </summary>
		public static JColor PaleGreen2
		{
			get { return new JColor(0.5647059f, 0.9333333f, 0.5647059f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleGreen3
		/// </summary>
		public static JColor PaleGreen3
		{
			get { return new JColor(0.4862745f, 0.8039216f, 0.4862745f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleGreen4
		/// </summary>
		public static JColor PaleGreen4
		{
			get { return new JColor(0.3294118f, 0.5450981f, 0.3294118f, 1f); }
		}


		/// <summary>
		/// Returns the color SpringGreen1
		/// </summary>
		public static JColor SpringGreen1
		{
			get { return new JColor(0f, 1f, 0.4980392f, 1f); }
		}


		/// <summary>
		/// Returns the color SpringGreen2
		/// </summary>
		public static JColor SpringGreen2
		{
			get { return new JColor(0f, 0.9333333f, 0.4627451f, 1f); }
		}


		/// <summary>
		/// Returns the color SpringGreen3
		/// </summary>
		public static JColor SpringGreen3
		{
			get { return new JColor(0f, 0.8039216f, 0.4f, 1f); }
		}


		/// <summary>
		/// Returns the color SpringGreen4
		/// </summary>
		public static JColor SpringGreen4
		{
			get { return new JColor(0f, 0.5450981f, 0.2705882f, 1f); }
		}


		/// <summary>
		/// Returns the color Green1
		/// </summary>
		public static JColor Green1
		{
			get { return new JColor(0f, 1f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Green2
		/// </summary>
		public static JColor Green2
		{
			get { return new JColor(0f, 0.9333333f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Green3
		/// </summary>
		public static JColor Green3
		{
			get { return new JColor(0f, 0.8039216f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Green4
		/// </summary>
		public static JColor Green4
		{
			get { return new JColor(0f, 0.5450981f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Chartreuse1
		/// </summary>
		public static JColor Chartreuse1
		{
			get { return new JColor(0.4980392f, 1f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Chartreuse2
		/// </summary>
		public static JColor Chartreuse2
		{
			get { return new JColor(0.4627451f, 0.9333333f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Chartreuse3
		/// </summary>
		public static JColor Chartreuse3
		{
			get { return new JColor(0.4f, 0.8039216f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Chartreuse4
		/// </summary>
		public static JColor Chartreuse4
		{
			get { return new JColor(0.2705882f, 0.5450981f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color OliveDrab1
		/// </summary>
		public static JColor OliveDrab1
		{
			get { return new JColor(0.7529412f, 1f, 0.2431373f, 1f); }
		}


		/// <summary>
		/// Returns the color OliveDrab2
		/// </summary>
		public static JColor OliveDrab2
		{
			get { return new JColor(0.7019608f, 0.9333333f, 0.227451f, 1f); }
		}


		/// <summary>
		/// Returns the color OliveDrab3
		/// </summary>
		public static JColor OliveDrab3
		{
			get { return new JColor(0.6039216f, 0.8039216f, 0.1960784f, 1f); }
		}


		/// <summary>
		/// Returns the color OliveDrab4
		/// </summary>
		public static JColor OliveDrab4
		{
			get { return new JColor(0.4117647f, 0.5450981f, 0.1333333f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkOliveGreen1
		/// </summary>
		public static JColor DarkOliveGreen1
		{
			get { return new JColor(0.7921569f, 1f, 0.4392157f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkOliveGreen2
		/// </summary>
		public static JColor DarkOliveGreen2
		{
			get { return new JColor(0.7372549f, 0.9333333f, 0.4078431f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkOliveGreen3
		/// </summary>
		public static JColor DarkOliveGreen3
		{
			get { return new JColor(0.6352941f, 0.8039216f, 0.3529412f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkOliveGreen4
		/// </summary>
		public static JColor DarkOliveGreen4
		{
			get { return new JColor(0.4313726f, 0.5450981f, 0.2392157f, 1f); }
		}


		/// <summary>
		/// Returns the color Khaki1
		/// </summary>
		public static JColor Khaki1
		{
			get { return new JColor(1f, 0.9647059f, 0.5607843f, 1f); }
		}


		/// <summary>
		/// Returns the color Khaki2
		/// </summary>
		public static JColor Khaki2
		{
			get { return new JColor(0.9333333f, 0.9019608f, 0.5215687f, 1f); }
		}


		/// <summary>
		/// Returns the color Khaki3
		/// </summary>
		public static JColor Khaki3
		{
			get { return new JColor(0.8039216f, 0.7764706f, 0.4509804f, 1f); }
		}


		/// <summary>
		/// Returns the color Khaki4
		/// </summary>
		public static JColor Khaki4
		{
			get { return new JColor(0.5450981f, 0.5254902f, 0.3058824f, 1f); }
		}


		/// <summary>
		/// Returns the color LightGoldenrod1
		/// </summary>
		public static JColor LightGoldenrod1
		{
			get { return new JColor(1f, 0.9254902f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color LightGoldenrod2
		/// </summary>
		public static JColor LightGoldenrod2
		{
			get { return new JColor(0.9333333f, 0.8627451f, 0.509804f, 1f); }
		}


		/// <summary>
		/// Returns the color LightGoldenrod3
		/// </summary>
		public static JColor LightGoldenrod3
		{
			get { return new JColor(0.8039216f, 0.7450981f, 0.4392157f, 1f); }
		}


		/// <summary>
		/// Returns the color LightGoldenrod4
		/// </summary>
		public static JColor LightGoldenrod4
		{
			get { return new JColor(0.5450981f, 0.5058824f, 0.2980392f, 1f); }
		}


		/// <summary>
		/// Returns the color LightYellow1
		/// </summary>
		public static JColor LightYellow1
		{
			get { return new JColor(1f, 1f, 0.8784314f, 1f); }
		}


		/// <summary>
		/// Returns the color LightYellow2
		/// </summary>
		public static JColor LightYellow2
		{
			get { return new JColor(0.9333333f, 0.9333333f, 0.8196079f, 1f); }
		}


		/// <summary>
		/// Returns the color LightYellow3
		/// </summary>
		public static JColor LightYellow3
		{
			get { return new JColor(0.8039216f, 0.8039216f, 0.7058824f, 1f); }
		}


		/// <summary>
		/// Returns the color LightYellow4
		/// </summary>
		public static JColor LightYellow4
		{
			get { return new JColor(0.5450981f, 0.5450981f, 0.4784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Yellow1
		/// </summary>
		public static JColor Yellow1
		{
			get { return new JColor(1f, 1f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Yellow2
		/// </summary>
		public static JColor Yellow2
		{
			get { return new JColor(0.9333333f, 0.9333333f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Yellow3
		/// </summary>
		public static JColor Yellow3
		{
			get { return new JColor(0.8039216f, 0.8039216f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Yellow4
		/// </summary>
		public static JColor Yellow4
		{
			get { return new JColor(0.5450981f, 0.5450981f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Gold1
		/// </summary>
		public static JColor Gold1
		{
			get { return new JColor(1f, 0.8431373f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Gold2
		/// </summary>
		public static JColor Gold2
		{
			get { return new JColor(0.9333333f, 0.7882353f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Gold3
		/// </summary>
		public static JColor Gold3
		{
			get { return new JColor(0.8039216f, 0.6784314f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Gold4
		/// </summary>
		public static JColor Gold4
		{
			get { return new JColor(0.5450981f, 0.4588235f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Goldenrod1
		/// </summary>
		public static JColor Goldenrod1
		{
			get { return new JColor(1f, 0.7568628f, 0.145098f, 1f); }
		}


		/// <summary>
		/// Returns the color Goldenrod2
		/// </summary>
		public static JColor Goldenrod2
		{
			get { return new JColor(0.9333333f, 0.7058824f, 0.1333333f, 1f); }
		}


		/// <summary>
		/// Returns the color Goldenrod3
		/// </summary>
		public static JColor Goldenrod3
		{
			get { return new JColor(0.8039216f, 0.6078432f, 0.1137255f, 1f); }
		}


		/// <summary>
		/// Returns the color Goldenrod4
		/// </summary>
		public static JColor Goldenrod4
		{
			get { return new JColor(0.5450981f, 0.4117647f, 0.07843138f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkGoldenrod1
		/// </summary>
		public static JColor DarkGoldenrod1
		{
			get { return new JColor(1f, 0.7254902f, 0.05882353f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkGoldenrod2
		/// </summary>
		public static JColor DarkGoldenrod2
		{
			get { return new JColor(0.9333333f, 0.6784314f, 0.05490196f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkGoldenrod3
		/// </summary>
		public static JColor DarkGoldenrod3
		{
			get { return new JColor(0.8039216f, 0.5843138f, 0.04705882f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkGoldenrod4
		/// </summary>
		public static JColor DarkGoldenrod4
		{
			get { return new JColor(0.5450981f, 0.3960784f, 0.03137255f, 1f); }
		}


		/// <summary>
		/// Returns the color RosyBrown1
		/// </summary>
		public static JColor RosyBrown1
		{
			get { return new JColor(1f, 0.7568628f, 0.7568628f, 1f); }
		}


		/// <summary>
		/// Returns the color RosyBrown2
		/// </summary>
		public static JColor RosyBrown2
		{
			get { return new JColor(0.9333333f, 0.7058824f, 0.7058824f, 1f); }
		}


		/// <summary>
		/// Returns the color RosyBrown3
		/// </summary>
		public static JColor RosyBrown3
		{
			get { return new JColor(0.8039216f, 0.6078432f, 0.6078432f, 1f); }
		}


		/// <summary>
		/// Returns the color RosyBrown4
		/// </summary>
		public static JColor RosyBrown4
		{
			get { return new JColor(0.5450981f, 0.4117647f, 0.4117647f, 1f); }
		}


		/// <summary>
		/// Returns the color IndianRed1
		/// </summary>
		public static JColor IndianRed1
		{
			get { return new JColor(1f, 0.4156863f, 0.4156863f, 1f); }
		}


		/// <summary>
		/// Returns the color IndianRed2
		/// </summary>
		public static JColor IndianRed2
		{
			get { return new JColor(0.9333333f, 0.3882353f, 0.3882353f, 1f); }
		}


		/// <summary>
		/// Returns the color IndianRed3
		/// </summary>
		public static JColor IndianRed3
		{
			get { return new JColor(0.8039216f, 0.3333333f, 0.3333333f, 1f); }
		}


		/// <summary>
		/// Returns the color IndianRed4
		/// </summary>
		public static JColor IndianRed4
		{
			get { return new JColor(0.5450981f, 0.227451f, 0.227451f, 1f); }
		}


		/// <summary>
		/// Returns the color Sienna1
		/// </summary>
		public static JColor Sienna1
		{
			get { return new JColor(1f, 0.509804f, 0.2784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Sienna2
		/// </summary>
		public static JColor Sienna2
		{
			get { return new JColor(0.9333333f, 0.4745098f, 0.2588235f, 1f); }
		}


		/// <summary>
		/// Returns the color Sienna3
		/// </summary>
		public static JColor Sienna3
		{
			get { return new JColor(0.8039216f, 0.4078431f, 0.2235294f, 1f); }
		}


		/// <summary>
		/// Returns the color Sienna4
		/// </summary>
		public static JColor Sienna4
		{
			get { return new JColor(0.5450981f, 0.2784314f, 0.1490196f, 1f); }
		}


		/// <summary>
		/// Returns the color Burlywood1
		/// </summary>
		public static JColor Burlywood1
		{
			get { return new JColor(1f, 0.827451f, 0.6078432f, 1f); }
		}


		/// <summary>
		/// Returns the color Burlywood2
		/// </summary>
		public static JColor Burlywood2
		{
			get { return new JColor(0.9333333f, 0.772549f, 0.5686275f, 1f); }
		}


		/// <summary>
		/// Returns the color Burlywood3
		/// </summary>
		public static JColor Burlywood3
		{
			get { return new JColor(0.8039216f, 0.6666667f, 0.4901961f, 1f); }
		}


		/// <summary>
		/// Returns the color Burlywood4
		/// </summary>
		public static JColor Burlywood4
		{
			get { return new JColor(0.5450981f, 0.4509804f, 0.3333333f, 1f); }
		}


		/// <summary>
		/// Returns the color Wheat1
		/// </summary>
		public static JColor Wheat1
		{
			get { return new JColor(1f, 0.9058824f, 0.7294118f, 1f); }
		}


		/// <summary>
		/// Returns the color Wheat2
		/// </summary>
		public static JColor Wheat2
		{
			get { return new JColor(0.9333333f, 0.8470588f, 0.682353f, 1f); }
		}


		/// <summary>
		/// Returns the color Wheat3
		/// </summary>
		public static JColor Wheat3
		{
			get { return new JColor(0.8039216f, 0.7294118f, 0.5882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Wheat4
		/// </summary>
		public static JColor Wheat4
		{
			get { return new JColor(0.5450981f, 0.4941176f, 0.4f, 1f); }
		}


		/// <summary>
		/// Returns the color Tan1
		/// </summary>
		public static JColor Tan1
		{
			get { return new JColor(1f, 0.6470588f, 0.3098039f, 1f); }
		}


		/// <summary>
		/// Returns the color Tan2
		/// </summary>
		public static JColor Tan2
		{
			get { return new JColor(0.9333333f, 0.6039216f, 0.2862745f, 1f); }
		}


		/// <summary>
		/// Returns the color Tan3
		/// </summary>
		public static JColor Tan3
		{
			get { return new JColor(0.8039216f, 0.5215687f, 0.2470588f, 1f); }
		}


		/// <summary>
		/// Returns the color Tan4
		/// </summary>
		public static JColor Tan4
		{
			get { return new JColor(0.5450981f, 0.3529412f, 0.1686275f, 1f); }
		}


		/// <summary>
		/// Returns the color Chocolate1
		/// </summary>
		public static JColor Chocolate1
		{
			get { return new JColor(1f, 0.4980392f, 0.1411765f, 1f); }
		}


		/// <summary>
		/// Returns the color Chocolate2
		/// </summary>
		public static JColor Chocolate2
		{
			get { return new JColor(0.9333333f, 0.4627451f, 0.1294118f, 1f); }
		}


		/// <summary>
		/// Returns the color Chocolate3
		/// </summary>
		public static JColor Chocolate3
		{
			get { return new JColor(0.8039216f, 0.4f, 0.1137255f, 1f); }
		}


		/// <summary>
		/// Returns the color Chocolate4
		/// </summary>
		public static JColor Chocolate4
		{
			get { return new JColor(0.5450981f, 0.2705882f, 0.07450981f, 1f); }
		}


		/// <summary>
		/// Returns the color Firebrick1
		/// </summary>
		public static JColor Firebrick1
		{
			get { return new JColor(1f, 0.1882353f, 0.1882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Firebrick2
		/// </summary>
		public static JColor Firebrick2
		{
			get { return new JColor(0.9333333f, 0.172549f, 0.172549f, 1f); }
		}


		/// <summary>
		/// Returns the color Firebrick3
		/// </summary>
		public static JColor Firebrick3
		{
			get { return new JColor(0.8039216f, 0.1490196f, 0.1490196f, 1f); }
		}


		/// <summary>
		/// Returns the color Firebrick4
		/// </summary>
		public static JColor Firebrick4
		{
			get { return new JColor(0.5450981f, 0.1019608f, 0.1019608f, 1f); }
		}


		/// <summary>
		/// Returns the color Brown1
		/// </summary>
		public static JColor Brown1
		{
			get { return new JColor(1f, 0.2509804f, 0.2509804f, 1f); }
		}


		/// <summary>
		/// Returns the color Brown2
		/// </summary>
		public static JColor Brown2
		{
			get { return new JColor(0.9333333f, 0.2313726f, 0.2313726f, 1f); }
		}


		/// <summary>
		/// Returns the color Brown3
		/// </summary>
		public static JColor Brown3
		{
			get { return new JColor(0.8039216f, 0.2f, 0.2f, 1f); }
		}


		/// <summary>
		/// Returns the color Brown4
		/// </summary>
		public static JColor Brown4
		{
			get { return new JColor(0.5450981f, 0.1372549f, 0.1372549f, 1f); }
		}


		/// <summary>
		/// Returns the color Salmon1
		/// </summary>
		public static JColor Salmon1
		{
			get { return new JColor(1f, 0.5490196f, 0.4117647f, 1f); }
		}


		/// <summary>
		/// Returns the color Salmon2
		/// </summary>
		public static JColor Salmon2
		{
			get { return new JColor(0.9333333f, 0.509804f, 0.3843137f, 1f); }
		}


		/// <summary>
		/// Returns the color Salmon3
		/// </summary>
		public static JColor Salmon3
		{
			get { return new JColor(0.8039216f, 0.4392157f, 0.3294118f, 1f); }
		}


		/// <summary>
		/// Returns the color Salmon4
		/// </summary>
		public static JColor Salmon4
		{
			get { return new JColor(0.5450981f, 0.2980392f, 0.2235294f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSalmon1
		/// </summary>
		public static JColor LightSalmon1
		{
			get { return new JColor(1f, 0.627451f, 0.4784314f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSalmon2
		/// </summary>
		public static JColor LightSalmon2
		{
			get { return new JColor(0.9333333f, 0.5843138f, 0.4470588f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSalmon3
		/// </summary>
		public static JColor LightSalmon3
		{
			get { return new JColor(0.8039216f, 0.5058824f, 0.3843137f, 1f); }
		}


		/// <summary>
		/// Returns the color LightSalmon4
		/// </summary>
		public static JColor LightSalmon4
		{
			get { return new JColor(0.5450981f, 0.3411765f, 0.2588235f, 1f); }
		}


		/// <summary>
		/// Returns the color Orange1
		/// </summary>
		public static JColor Orange1
		{
			get { return new JColor(1f, 0.6470588f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Orange2
		/// </summary>
		public static JColor Orange2
		{
			get { return new JColor(0.9333333f, 0.6039216f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Orange3
		/// </summary>
		public static JColor Orange3
		{
			get { return new JColor(0.8039216f, 0.5215687f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Orange4
		/// </summary>
		public static JColor Orange4
		{
			get { return new JColor(0.5450981f, 0.3529412f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkOrange1
		/// </summary>
		public static JColor DarkOrange1
		{
			get { return new JColor(1f, 0.4980392f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkOrange2
		/// </summary>
		public static JColor DarkOrange2
		{
			get { return new JColor(0.9333333f, 0.4627451f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkOrange3
		/// </summary>
		public static JColor DarkOrange3
		{
			get { return new JColor(0.8039216f, 0.4f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkOrange4
		/// </summary>
		public static JColor DarkOrange4
		{
			get { return new JColor(0.5450981f, 0.2705882f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Coral1
		/// </summary>
		public static JColor Coral1
		{
			get { return new JColor(1f, 0.4470588f, 0.3372549f, 1f); }
		}


		/// <summary>
		/// Returns the color Coral2
		/// </summary>
		public static JColor Coral2
		{
			get { return new JColor(0.9333333f, 0.4156863f, 0.3137255f, 1f); }
		}


		/// <summary>
		/// Returns the color Coral3
		/// </summary>
		public static JColor Coral3
		{
			get { return new JColor(0.8039216f, 0.3568628f, 0.2705882f, 1f); }
		}


		/// <summary>
		/// Returns the color Coral4
		/// </summary>
		public static JColor Coral4
		{
			get { return new JColor(0.5450981f, 0.2431373f, 0.1843137f, 1f); }
		}


		/// <summary>
		/// Returns the color Tomato1
		/// </summary>
		public static JColor Tomato1
		{
			get { return new JColor(1f, 0.3882353f, 0.2784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Tomato2
		/// </summary>
		public static JColor Tomato2
		{
			get { return new JColor(0.9333333f, 0.3607843f, 0.2588235f, 1f); }
		}


		/// <summary>
		/// Returns the color Tomato3
		/// </summary>
		public static JColor Tomato3
		{
			get { return new JColor(0.8039216f, 0.3098039f, 0.2235294f, 1f); }
		}


		/// <summary>
		/// Returns the color Tomato4
		/// </summary>
		public static JColor Tomato4
		{
			get { return new JColor(0.5450981f, 0.2117647f, 0.1490196f, 1f); }
		}


		/// <summary>
		/// Returns the color OrangeRed1
		/// </summary>
		public static JColor OrangeRed1
		{
			get { return new JColor(1f, 0.2705882f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color OrangeRed2
		/// </summary>
		public static JColor OrangeRed2
		{
			get { return new JColor(0.9333333f, 0.2509804f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color OrangeRed3
		/// </summary>
		public static JColor OrangeRed3
		{
			get { return new JColor(0.8039216f, 0.2156863f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color OrangeRed4
		/// </summary>
		public static JColor OrangeRed4
		{
			get { return new JColor(0.5450981f, 0.145098f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Red1
		/// </summary>
		public static JColor Red1
		{
			get { return new JColor(1f, 0f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Red2
		/// </summary>
		public static JColor Red2
		{
			get { return new JColor(0.9333333f, 0f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Red3
		/// </summary>
		public static JColor Red3
		{
			get { return new JColor(0.8039216f, 0f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Red4
		/// </summary>
		public static JColor Red4
		{
			get { return new JColor(0.5450981f, 0f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color DeepPink1
		/// </summary>
		public static JColor DeepPink1
		{
			get { return new JColor(1f, 0.07843138f, 0.5764706f, 1f); }
		}


		/// <summary>
		/// Returns the color DeepPink2
		/// </summary>
		public static JColor DeepPink2
		{
			get { return new JColor(0.9333333f, 0.07058824f, 0.5372549f, 1f); }
		}


		/// <summary>
		/// Returns the color DeepPink3
		/// </summary>
		public static JColor DeepPink3
		{
			get { return new JColor(0.8039216f, 0.0627451f, 0.4627451f, 1f); }
		}


		/// <summary>
		/// Returns the color DeepPink4
		/// </summary>
		public static JColor DeepPink4
		{
			get { return new JColor(0.5450981f, 0.03921569f, 0.3137255f, 1f); }
		}


		/// <summary>
		/// Returns the color HotPink1
		/// </summary>
		public static JColor HotPink1
		{
			get { return new JColor(1f, 0.4313726f, 0.7058824f, 1f); }
		}


		/// <summary>
		/// Returns the color HotPink2
		/// </summary>
		public static JColor HotPink2
		{
			get { return new JColor(0.9333333f, 0.4156863f, 0.654902f, 1f); }
		}


		/// <summary>
		/// Returns the color HotPink3
		/// </summary>
		public static JColor HotPink3
		{
			get { return new JColor(0.8039216f, 0.3764706f, 0.5647059f, 1f); }
		}


		/// <summary>
		/// Returns the color HotPink4
		/// </summary>
		public static JColor HotPink4
		{
			get { return new JColor(0.5450981f, 0.227451f, 0.3843137f, 1f); }
		}


		/// <summary>
		/// Returns the color Pink1
		/// </summary>
		public static JColor Pink1
		{
			get { return new JColor(1f, 0.7098039f, 0.772549f, 1f); }
		}


		/// <summary>
		/// Returns the color Pink2
		/// </summary>
		public static JColor Pink2
		{
			get { return new JColor(0.9333333f, 0.6627451f, 0.7215686f, 1f); }
		}


		/// <summary>
		/// Returns the color Pink3
		/// </summary>
		public static JColor Pink3
		{
			get { return new JColor(0.8039216f, 0.5686275f, 0.6196079f, 1f); }
		}


		/// <summary>
		/// Returns the color Pink4
		/// </summary>
		public static JColor Pink4
		{
			get { return new JColor(0.5450981f, 0.3882353f, 0.4235294f, 1f); }
		}


		/// <summary>
		/// Returns the color LightPink1
		/// </summary>
		public static JColor LightPink1
		{
			get { return new JColor(1f, 0.682353f, 0.7254902f, 1f); }
		}


		/// <summary>
		/// Returns the color LightPink2
		/// </summary>
		public static JColor LightPink2
		{
			get { return new JColor(0.9333333f, 0.6352941f, 0.6784314f, 1f); }
		}


		/// <summary>
		/// Returns the color LightPink3
		/// </summary>
		public static JColor LightPink3
		{
			get { return new JColor(0.8039216f, 0.5490196f, 0.5843138f, 1f); }
		}


		/// <summary>
		/// Returns the color LightPink4
		/// </summary>
		public static JColor LightPink4
		{
			get { return new JColor(0.5450981f, 0.372549f, 0.3960784f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleVioletRed1
		/// </summary>
		public static JColor PaleVioletRed1
		{
			get { return new JColor(1f, 0.509804f, 0.6705883f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleVioletRed2
		/// </summary>
		public static JColor PaleVioletRed2
		{
			get { return new JColor(0.9333333f, 0.4745098f, 0.6235294f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleVioletRed3
		/// </summary>
		public static JColor PaleVioletRed3
		{
			get { return new JColor(0.8039216f, 0.4078431f, 0.5372549f, 1f); }
		}


		/// <summary>
		/// Returns the color PaleVioletRed4
		/// </summary>
		public static JColor PaleVioletRed4
		{
			get { return new JColor(0.5450981f, 0.2784314f, 0.3647059f, 1f); }
		}


		/// <summary>
		/// Returns the color Maroon1
		/// </summary>
		public static JColor Maroon1
		{
			get { return new JColor(1f, 0.2039216f, 0.7019608f, 1f); }
		}


		/// <summary>
		/// Returns the color Maroon2
		/// </summary>
		public static JColor Maroon2
		{
			get { return new JColor(0.9333333f, 0.1882353f, 0.654902f, 1f); }
		}


		/// <summary>
		/// Returns the color Maroon3
		/// </summary>
		public static JColor Maroon3
		{
			get { return new JColor(0.8039216f, 0.1607843f, 0.5647059f, 1f); }
		}


		/// <summary>
		/// Returns the color Maroon4
		/// </summary>
		public static JColor Maroon4
		{
			get { return new JColor(0.5450981f, 0.1098039f, 0.3843137f, 1f); }
		}


		/// <summary>
		/// Returns the color VioletRed1
		/// </summary>
		public static JColor VioletRed1
		{
			get { return new JColor(1f, 0.2431373f, 0.5882353f, 1f); }
		}


		/// <summary>
		/// Returns the color VioletRed2
		/// </summary>
		public static JColor VioletRed2
		{
			get { return new JColor(0.9333333f, 0.227451f, 0.5490196f, 1f); }
		}


		/// <summary>
		/// Returns the color VioletRed3
		/// </summary>
		public static JColor VioletRed3
		{
			get { return new JColor(0.8039216f, 0.1960784f, 0.4705882f, 1f); }
		}


		/// <summary>
		/// Returns the color VioletRed4
		/// </summary>
		public static JColor VioletRed4
		{
			get { return new JColor(0.5450981f, 0.1333333f, 0.3215686f, 1f); }
		}


		/// <summary>
		/// Returns the color Magenta1
		/// </summary>
		public static JColor Magenta1
		{
			get { return new JColor(1f, 0f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color Magenta2
		/// </summary>
		public static JColor Magenta2
		{
			get { return new JColor(0.9333333f, 0f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color Magenta3
		/// </summary>
		public static JColor Magenta3
		{
			get { return new JColor(0.8039216f, 0f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color Magenta4
		/// </summary>
		public static JColor Magenta4
		{
			get { return new JColor(0.5450981f, 0f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color Orchid1
		/// </summary>
		public static JColor Orchid1
		{
			get { return new JColor(1f, 0.5137255f, 0.9803922f, 1f); }
		}


		/// <summary>
		/// Returns the color Orchid2
		/// </summary>
		public static JColor Orchid2
		{
			get { return new JColor(0.9333333f, 0.4784314f, 0.9137255f, 1f); }
		}


		/// <summary>
		/// Returns the color Orchid3
		/// </summary>
		public static JColor Orchid3
		{
			get { return new JColor(0.8039216f, 0.4117647f, 0.7882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Orchid4
		/// </summary>
		public static JColor Orchid4
		{
			get { return new JColor(0.5450981f, 0.2784314f, 0.5372549f, 1f); }
		}


		/// <summary>
		/// Returns the color Plum1
		/// </summary>
		public static JColor Plum1
		{
			get { return new JColor(1f, 0.7333333f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color Plum2
		/// </summary>
		public static JColor Plum2
		{
			get { return new JColor(0.9333333f, 0.682353f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color Plum3
		/// </summary>
		public static JColor Plum3
		{
			get { return new JColor(0.8039216f, 0.5882353f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color Plum4
		/// </summary>
		public static JColor Plum4
		{
			get { return new JColor(0.5450981f, 0.4f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumOrchid1
		/// </summary>
		public static JColor MediumOrchid1
		{
			get { return new JColor(0.8784314f, 0.4f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumOrchid2
		/// </summary>
		public static JColor MediumOrchid2
		{
			get { return new JColor(0.8196079f, 0.372549f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumOrchid3
		/// </summary>
		public static JColor MediumOrchid3
		{
			get { return new JColor(0.7058824f, 0.3215686f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumOrchid4
		/// </summary>
		public static JColor MediumOrchid4
		{
			get { return new JColor(0.4784314f, 0.2156863f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkOrchid1
		/// </summary>
		public static JColor DarkOrchid1
		{
			get { return new JColor(0.7490196f, 0.2431373f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkOrchid2
		/// </summary>
		public static JColor DarkOrchid2
		{
			get { return new JColor(0.6980392f, 0.227451f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkOrchid3
		/// </summary>
		public static JColor DarkOrchid3
		{
			get { return new JColor(0.6039216f, 0.1960784f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkOrchid4
		/// </summary>
		public static JColor DarkOrchid4
		{
			get { return new JColor(0.4078431f, 0.1333333f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color Purple1
		/// </summary>
		public static JColor Purple1
		{
			get { return new JColor(0.6078432f, 0.1882353f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color Purple2
		/// </summary>
		public static JColor Purple2
		{
			get { return new JColor(0.5686275f, 0.172549f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color Purple3
		/// </summary>
		public static JColor Purple3
		{
			get { return new JColor(0.4901961f, 0.1490196f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color Purple4
		/// </summary>
		public static JColor Purple4
		{
			get { return new JColor(0.3333333f, 0.1019608f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumPurple1
		/// </summary>
		public static JColor MediumPurple1
		{
			get { return new JColor(0.6705883f, 0.509804f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumPurple2
		/// </summary>
		public static JColor MediumPurple2
		{
			get { return new JColor(0.6235294f, 0.4745098f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumPurple3
		/// </summary>
		public static JColor MediumPurple3
		{
			get { return new JColor(0.5372549f, 0.4078431f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color MediumPurple4
		/// </summary>
		public static JColor MediumPurple4
		{
			get { return new JColor(0.3647059f, 0.2784314f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color Thistle1
		/// </summary>
		public static JColor Thistle1
		{
			get { return new JColor(1f, 0.8823529f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color Thistle2
		/// </summary>
		public static JColor Thistle2
		{
			get { return new JColor(0.9333333f, 0.8235294f, 0.9333333f, 1f); }
		}


		/// <summary>
		/// Returns the color Thistle3
		/// </summary>
		public static JColor Thistle3
		{
			get { return new JColor(0.8039216f, 0.7098039f, 0.8039216f, 1f); }
		}


		/// <summary>
		/// Returns the color Thistle4
		/// </summary>
		public static JColor Thistle4
		{
			get { return new JColor(0.5450981f, 0.4823529f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray0
		/// </summary>
		public static JColor Gray0
		{
			get { return new JColor(0f, 0f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey0
		/// </summary>
		public static JColor Grey0
		{
			get { return new JColor(0f, 0f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray1
		/// </summary>
		public static JColor Gray1
		{
			get { return new JColor(0.01176471f, 0.01176471f, 0.01176471f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey1
		/// </summary>
		public static JColor Grey1
		{
			get { return new JColor(0.01176471f, 0.01176471f, 0.01176471f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray2
		/// </summary>
		public static JColor Gray2
		{
			get { return new JColor(0.01960784f, 0.01960784f, 0.01960784f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey2
		/// </summary>
		public static JColor Grey2
		{
			get { return new JColor(0.01960784f, 0.01960784f, 0.01960784f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray3
		/// </summary>
		public static JColor Gray3
		{
			get { return new JColor(0.03137255f, 0.03137255f, 0.03137255f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey3
		/// </summary>
		public static JColor Grey3
		{
			get { return new JColor(0.03137255f, 0.03137255f, 0.03137255f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray4
		/// </summary>
		public static JColor Gray4
		{
			get { return new JColor(0.03921569f, 0.03921569f, 0.03921569f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey4
		/// </summary>
		public static JColor Grey4
		{
			get { return new JColor(0.03921569f, 0.03921569f, 0.03921569f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray5
		/// </summary>
		public static JColor Gray5
		{
			get { return new JColor(0.05098039f, 0.05098039f, 0.05098039f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey5
		/// </summary>
		public static JColor Grey5
		{
			get { return new JColor(0.05098039f, 0.05098039f, 0.05098039f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray6
		/// </summary>
		public static JColor Gray6
		{
			get { return new JColor(0.05882353f, 0.05882353f, 0.05882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey6
		/// </summary>
		public static JColor Grey6
		{
			get { return new JColor(0.05882353f, 0.05882353f, 0.05882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray7
		/// </summary>
		public static JColor Gray7
		{
			get { return new JColor(0.07058824f, 0.07058824f, 0.07058824f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey7
		/// </summary>
		public static JColor Grey7
		{
			get { return new JColor(0.07058824f, 0.07058824f, 0.07058824f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray8
		/// </summary>
		public static JColor Gray8
		{
			get { return new JColor(0.07843138f, 0.07843138f, 0.07843138f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey8
		/// </summary>
		public static JColor Grey8
		{
			get { return new JColor(0.07843138f, 0.07843138f, 0.07843138f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray9
		/// </summary>
		public static JColor Gray9
		{
			get { return new JColor(0.09019608f, 0.09019608f, 0.09019608f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey9
		/// </summary>
		public static JColor Grey9
		{
			get { return new JColor(0.09019608f, 0.09019608f, 0.09019608f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray10
		/// </summary>
		public static JColor Gray10
		{
			get { return new JColor(0.1019608f, 0.1019608f, 0.1019608f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey10
		/// </summary>
		public static JColor Grey10
		{
			get { return new JColor(0.1019608f, 0.1019608f, 0.1019608f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray11
		/// </summary>
		public static JColor Gray11
		{
			get { return new JColor(0.1098039f, 0.1098039f, 0.1098039f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey11
		/// </summary>
		public static JColor Grey11
		{
			get { return new JColor(0.1098039f, 0.1098039f, 0.1098039f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray12
		/// </summary>
		public static JColor Gray12
		{
			get { return new JColor(0.1215686f, 0.1215686f, 0.1215686f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey12
		/// </summary>
		public static JColor Grey12
		{
			get { return new JColor(0.1215686f, 0.1215686f, 0.1215686f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray13
		/// </summary>
		public static JColor Gray13
		{
			get { return new JColor(0.1294118f, 0.1294118f, 0.1294118f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey13
		/// </summary>
		public static JColor Grey13
		{
			get { return new JColor(0.1294118f, 0.1294118f, 0.1294118f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray14
		/// </summary>
		public static JColor Gray14
		{
			get { return new JColor(0.1411765f, 0.1411765f, 0.1411765f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey14
		/// </summary>
		public static JColor Grey14
		{
			get { return new JColor(0.1411765f, 0.1411765f, 0.1411765f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray15
		/// </summary>
		public static JColor Gray15
		{
			get { return new JColor(0.1490196f, 0.1490196f, 0.1490196f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey15
		/// </summary>
		public static JColor Grey15
		{
			get { return new JColor(0.1490196f, 0.1490196f, 0.1490196f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray16
		/// </summary>
		public static JColor Gray16
		{
			get { return new JColor(0.1607843f, 0.1607843f, 0.1607843f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey16
		/// </summary>
		public static JColor Grey16
		{
			get { return new JColor(0.1607843f, 0.1607843f, 0.1607843f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray17
		/// </summary>
		public static JColor Gray17
		{
			get { return new JColor(0.1686275f, 0.1686275f, 0.1686275f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey17
		/// </summary>
		public static JColor Grey17
		{
			get { return new JColor(0.1686275f, 0.1686275f, 0.1686275f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray18
		/// </summary>
		public static JColor Gray18
		{
			get { return new JColor(0.1803922f, 0.1803922f, 0.1803922f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey18
		/// </summary>
		public static JColor Grey18
		{
			get { return new JColor(0.1803922f, 0.1803922f, 0.1803922f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray19
		/// </summary>
		public static JColor Gray19
		{
			get { return new JColor(0.1882353f, 0.1882353f, 0.1882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey19
		/// </summary>
		public static JColor Grey19
		{
			get { return new JColor(0.1882353f, 0.1882353f, 0.1882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray20
		/// </summary>
		public static JColor Gray20
		{
			get { return new JColor(0.2f, 0.2f, 0.2f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey20
		/// </summary>
		public static JColor Grey20
		{
			get { return new JColor(0.2f, 0.2f, 0.2f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray21
		/// </summary>
		public static JColor Gray21
		{
			get { return new JColor(0.2117647f, 0.2117647f, 0.2117647f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey21
		/// </summary>
		public static JColor Grey21
		{
			get { return new JColor(0.2117647f, 0.2117647f, 0.2117647f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray22
		/// </summary>
		public static JColor Gray22
		{
			get { return new JColor(0.2196078f, 0.2196078f, 0.2196078f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey22
		/// </summary>
		public static JColor Grey22
		{
			get { return new JColor(0.2196078f, 0.2196078f, 0.2196078f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray23
		/// </summary>
		public static JColor Gray23
		{
			get { return new JColor(0.2313726f, 0.2313726f, 0.2313726f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey23
		/// </summary>
		public static JColor Grey23
		{
			get { return new JColor(0.2313726f, 0.2313726f, 0.2313726f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray24
		/// </summary>
		public static JColor Gray24
		{
			get { return new JColor(0.2392157f, 0.2392157f, 0.2392157f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey24
		/// </summary>
		public static JColor Grey24
		{
			get { return new JColor(0.2392157f, 0.2392157f, 0.2392157f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray25
		/// </summary>
		public static JColor Gray25
		{
			get { return new JColor(0.2509804f, 0.2509804f, 0.2509804f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey25
		/// </summary>
		public static JColor Grey25
		{
			get { return new JColor(0.2509804f, 0.2509804f, 0.2509804f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray26
		/// </summary>
		public static JColor Gray26
		{
			get { return new JColor(0.2588235f, 0.2588235f, 0.2588235f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey26
		/// </summary>
		public static JColor Grey26
		{
			get { return new JColor(0.2588235f, 0.2588235f, 0.2588235f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray27
		/// </summary>
		public static JColor Gray27
		{
			get { return new JColor(0.2705882f, 0.2705882f, 0.2705882f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey27
		/// </summary>
		public static JColor Grey27
		{
			get { return new JColor(0.2705882f, 0.2705882f, 0.2705882f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray28
		/// </summary>
		public static JColor Gray28
		{
			get { return new JColor(0.2784314f, 0.2784314f, 0.2784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey28
		/// </summary>
		public static JColor Grey28
		{
			get { return new JColor(0.2784314f, 0.2784314f, 0.2784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray29
		/// </summary>
		public static JColor Gray29
		{
			get { return new JColor(0.2901961f, 0.2901961f, 0.2901961f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey29
		/// </summary>
		public static JColor Grey29
		{
			get { return new JColor(0.2901961f, 0.2901961f, 0.2901961f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray30
		/// </summary>
		public static JColor Gray30
		{
			get { return new JColor(0.3019608f, 0.3019608f, 0.3019608f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey30
		/// </summary>
		public static JColor Grey30
		{
			get { return new JColor(0.3019608f, 0.3019608f, 0.3019608f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray31
		/// </summary>
		public static JColor Gray31
		{
			get { return new JColor(0.3098039f, 0.3098039f, 0.3098039f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey31
		/// </summary>
		public static JColor Grey31
		{
			get { return new JColor(0.3098039f, 0.3098039f, 0.3098039f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray32
		/// </summary>
		public static JColor Gray32
		{
			get { return new JColor(0.3215686f, 0.3215686f, 0.3215686f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey32
		/// </summary>
		public static JColor Grey32
		{
			get { return new JColor(0.3215686f, 0.3215686f, 0.3215686f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray33
		/// </summary>
		public static JColor Gray33
		{
			get { return new JColor(0.3294118f, 0.3294118f, 0.3294118f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey33
		/// </summary>
		public static JColor Grey33
		{
			get { return new JColor(0.3294118f, 0.3294118f, 0.3294118f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray34
		/// </summary>
		public static JColor Gray34
		{
			get { return new JColor(0.3411765f, 0.3411765f, 0.3411765f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey34
		/// </summary>
		public static JColor Grey34
		{
			get { return new JColor(0.3411765f, 0.3411765f, 0.3411765f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray35
		/// </summary>
		public static JColor Gray35
		{
			get { return new JColor(0.3490196f, 0.3490196f, 0.3490196f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey35
		/// </summary>
		public static JColor Grey35
		{
			get { return new JColor(0.3490196f, 0.3490196f, 0.3490196f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray36
		/// </summary>
		public static JColor Gray36
		{
			get { return new JColor(0.3607843f, 0.3607843f, 0.3607843f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey36
		/// </summary>
		public static JColor Grey36
		{
			get { return new JColor(0.3607843f, 0.3607843f, 0.3607843f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray37
		/// </summary>
		public static JColor Gray37
		{
			get { return new JColor(0.3686275f, 0.3686275f, 0.3686275f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey37
		/// </summary>
		public static JColor Grey37
		{
			get { return new JColor(0.3686275f, 0.3686275f, 0.3686275f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray38
		/// </summary>
		public static JColor Gray38
		{
			get { return new JColor(0.3803922f, 0.3803922f, 0.3803922f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey38
		/// </summary>
		public static JColor Grey38
		{
			get { return new JColor(0.3803922f, 0.3803922f, 0.3803922f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray39
		/// </summary>
		public static JColor Gray39
		{
			get { return new JColor(0.3882353f, 0.3882353f, 0.3882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey39
		/// </summary>
		public static JColor Grey39
		{
			get { return new JColor(0.3882353f, 0.3882353f, 0.3882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray40
		/// </summary>
		public static JColor Gray40
		{
			get { return new JColor(0.4f, 0.4f, 0.4f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey40
		/// </summary>
		public static JColor Grey40
		{
			get { return new JColor(0.4f, 0.4f, 0.4f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray41
		/// </summary>
		public static JColor Gray41
		{
			get { return new JColor(0.4117647f, 0.4117647f, 0.4117647f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey41
		/// </summary>
		public static JColor Grey41
		{
			get { return new JColor(0.4117647f, 0.4117647f, 0.4117647f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray42
		/// </summary>
		public static JColor Gray42
		{
			get { return new JColor(0.4196078f, 0.4196078f, 0.4196078f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey42
		/// </summary>
		public static JColor Grey42
		{
			get { return new JColor(0.4196078f, 0.4196078f, 0.4196078f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray43
		/// </summary>
		public static JColor Gray43
		{
			get { return new JColor(0.4313726f, 0.4313726f, 0.4313726f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey43
		/// </summary>
		public static JColor Grey43
		{
			get { return new JColor(0.4313726f, 0.4313726f, 0.4313726f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray44
		/// </summary>
		public static JColor Gray44
		{
			get { return new JColor(0.4392157f, 0.4392157f, 0.4392157f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey44
		/// </summary>
		public static JColor Grey44
		{
			get { return new JColor(0.4392157f, 0.4392157f, 0.4392157f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray45
		/// </summary>
		public static JColor Gray45
		{
			get { return new JColor(0.4509804f, 0.4509804f, 0.4509804f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey45
		/// </summary>
		public static JColor Grey45
		{
			get { return new JColor(0.4509804f, 0.4509804f, 0.4509804f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray46
		/// </summary>
		public static JColor Gray46
		{
			get { return new JColor(0.4588235f, 0.4588235f, 0.4588235f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey46
		/// </summary>
		public static JColor Grey46
		{
			get { return new JColor(0.4588235f, 0.4588235f, 0.4588235f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray47
		/// </summary>
		public static JColor Gray47
		{
			get { return new JColor(0.4705882f, 0.4705882f, 0.4705882f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey47
		/// </summary>
		public static JColor Grey47
		{
			get { return new JColor(0.4705882f, 0.4705882f, 0.4705882f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray48
		/// </summary>
		public static JColor Gray48
		{
			get { return new JColor(0.4784314f, 0.4784314f, 0.4784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey48
		/// </summary>
		public static JColor Grey48
		{
			get { return new JColor(0.4784314f, 0.4784314f, 0.4784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray49
		/// </summary>
		public static JColor Gray49
		{
			get { return new JColor(0.4901961f, 0.4901961f, 0.4901961f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey49
		/// </summary>
		public static JColor Grey49
		{
			get { return new JColor(0.4901961f, 0.4901961f, 0.4901961f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray50
		/// </summary>
		public static JColor Gray50
		{
			get { return new JColor(0.4980392f, 0.4980392f, 0.4980392f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey50
		/// </summary>
		public static JColor Grey50
		{
			get { return new JColor(0.4980392f, 0.4980392f, 0.4980392f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray51
		/// </summary>
		public static JColor Gray51
		{
			get { return new JColor(0.509804f, 0.509804f, 0.509804f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey51
		/// </summary>
		public static JColor Grey51
		{
			get { return new JColor(0.509804f, 0.509804f, 0.509804f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray52
		/// </summary>
		public static JColor Gray52
		{
			get { return new JColor(0.5215687f, 0.5215687f, 0.5215687f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey52
		/// </summary>
		public static JColor Grey52
		{
			get { return new JColor(0.5215687f, 0.5215687f, 0.5215687f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray53
		/// </summary>
		public static JColor Gray53
		{
			get { return new JColor(0.5294118f, 0.5294118f, 0.5294118f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey53
		/// </summary>
		public static JColor Grey53
		{
			get { return new JColor(0.5294118f, 0.5294118f, 0.5294118f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray54
		/// </summary>
		public static JColor Gray54
		{
			get { return new JColor(0.5411765f, 0.5411765f, 0.5411765f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey54
		/// </summary>
		public static JColor Grey54
		{
			get { return new JColor(0.5411765f, 0.5411765f, 0.5411765f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray55
		/// </summary>
		public static JColor Gray55
		{
			get { return new JColor(0.5490196f, 0.5490196f, 0.5490196f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey55
		/// </summary>
		public static JColor Grey55
		{
			get { return new JColor(0.5490196f, 0.5490196f, 0.5490196f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray56
		/// </summary>
		public static JColor Gray56
		{
			get { return new JColor(0.5607843f, 0.5607843f, 0.5607843f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey56
		/// </summary>
		public static JColor Grey56
		{
			get { return new JColor(0.5607843f, 0.5607843f, 0.5607843f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray57
		/// </summary>
		public static JColor Gray57
		{
			get { return new JColor(0.5686275f, 0.5686275f, 0.5686275f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey57
		/// </summary>
		public static JColor Grey57
		{
			get { return new JColor(0.5686275f, 0.5686275f, 0.5686275f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray58
		/// </summary>
		public static JColor Gray58
		{
			get { return new JColor(0.5803922f, 0.5803922f, 0.5803922f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey58
		/// </summary>
		public static JColor Grey58
		{
			get { return new JColor(0.5803922f, 0.5803922f, 0.5803922f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray59
		/// </summary>
		public static JColor Gray59
		{
			get { return new JColor(0.5882353f, 0.5882353f, 0.5882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey59
		/// </summary>
		public static JColor Grey59
		{
			get { return new JColor(0.5882353f, 0.5882353f, 0.5882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray60
		/// </summary>
		public static JColor Gray60
		{
			get { return new JColor(0.6f, 0.6f, 0.6f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey60
		/// </summary>
		public static JColor Grey60
		{
			get { return new JColor(0.6f, 0.6f, 0.6f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray61
		/// </summary>
		public static JColor Gray61
		{
			get { return new JColor(0.6117647f, 0.6117647f, 0.6117647f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey61
		/// </summary>
		public static JColor Grey61
		{
			get { return new JColor(0.6117647f, 0.6117647f, 0.6117647f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray62
		/// </summary>
		public static JColor Gray62
		{
			get { return new JColor(0.6196079f, 0.6196079f, 0.6196079f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey62
		/// </summary>
		public static JColor Grey62
		{
			get { return new JColor(0.6196079f, 0.6196079f, 0.6196079f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray63
		/// </summary>
		public static JColor Gray63
		{
			get { return new JColor(0.6313726f, 0.6313726f, 0.6313726f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey63
		/// </summary>
		public static JColor Grey63
		{
			get { return new JColor(0.6313726f, 0.6313726f, 0.6313726f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray64
		/// </summary>
		public static JColor Gray64
		{
			get { return new JColor(0.6392157f, 0.6392157f, 0.6392157f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey64
		/// </summary>
		public static JColor Grey64
		{
			get { return new JColor(0.6392157f, 0.6392157f, 0.6392157f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray65
		/// </summary>
		public static JColor Gray65
		{
			get { return new JColor(0.6509804f, 0.6509804f, 0.6509804f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey65
		/// </summary>
		public static JColor Grey65
		{
			get { return new JColor(0.6509804f, 0.6509804f, 0.6509804f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray66
		/// </summary>
		public static JColor Gray66
		{
			get { return new JColor(0.6588235f, 0.6588235f, 0.6588235f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey66
		/// </summary>
		public static JColor Grey66
		{
			get { return new JColor(0.6588235f, 0.6588235f, 0.6588235f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray67
		/// </summary>
		public static JColor Gray67
		{
			get { return new JColor(0.6705883f, 0.6705883f, 0.6705883f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey67
		/// </summary>
		public static JColor Grey67
		{
			get { return new JColor(0.6705883f, 0.6705883f, 0.6705883f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray68
		/// </summary>
		public static JColor Gray68
		{
			get { return new JColor(0.6784314f, 0.6784314f, 0.6784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey68
		/// </summary>
		public static JColor Grey68
		{
			get { return new JColor(0.6784314f, 0.6784314f, 0.6784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray69
		/// </summary>
		public static JColor Gray69
		{
			get { return new JColor(0.6901961f, 0.6901961f, 0.6901961f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey69
		/// </summary>
		public static JColor Grey69
		{
			get { return new JColor(0.6901961f, 0.6901961f, 0.6901961f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray70
		/// </summary>
		public static JColor Gray70
		{
			get { return new JColor(0.7019608f, 0.7019608f, 0.7019608f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey70
		/// </summary>
		public static JColor Grey70
		{
			get { return new JColor(0.7019608f, 0.7019608f, 0.7019608f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray71
		/// </summary>
		public static JColor Gray71
		{
			get { return new JColor(0.7098039f, 0.7098039f, 0.7098039f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey71
		/// </summary>
		public static JColor Grey71
		{
			get { return new JColor(0.7098039f, 0.7098039f, 0.7098039f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray72
		/// </summary>
		public static JColor Gray72
		{
			get { return new JColor(0.7215686f, 0.7215686f, 0.7215686f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey72
		/// </summary>
		public static JColor Grey72
		{
			get { return new JColor(0.7215686f, 0.7215686f, 0.7215686f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray73
		/// </summary>
		public static JColor Gray73
		{
			get { return new JColor(0.7294118f, 0.7294118f, 0.7294118f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey73
		/// </summary>
		public static JColor Grey73
		{
			get { return new JColor(0.7294118f, 0.7294118f, 0.7294118f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray74
		/// </summary>
		public static JColor Gray74
		{
			get { return new JColor(0.7411765f, 0.7411765f, 0.7411765f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey74
		/// </summary>
		public static JColor Grey74
		{
			get { return new JColor(0.7411765f, 0.7411765f, 0.7411765f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray75
		/// </summary>
		public static JColor Gray75
		{
			get { return new JColor(0.7490196f, 0.7490196f, 0.7490196f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey75
		/// </summary>
		public static JColor Grey75
		{
			get { return new JColor(0.7490196f, 0.7490196f, 0.7490196f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray76
		/// </summary>
		public static JColor Gray76
		{
			get { return new JColor(0.7607843f, 0.7607843f, 0.7607843f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey76
		/// </summary>
		public static JColor Grey76
		{
			get { return new JColor(0.7607843f, 0.7607843f, 0.7607843f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray77
		/// </summary>
		public static JColor Gray77
		{
			get { return new JColor(0.7686275f, 0.7686275f, 0.7686275f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey77
		/// </summary>
		public static JColor Grey77
		{
			get { return new JColor(0.7686275f, 0.7686275f, 0.7686275f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray78
		/// </summary>
		public static JColor Gray78
		{
			get { return new JColor(0.7803922f, 0.7803922f, 0.7803922f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey78
		/// </summary>
		public static JColor Grey78
		{
			get { return new JColor(0.7803922f, 0.7803922f, 0.7803922f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray79
		/// </summary>
		public static JColor Gray79
		{
			get { return new JColor(0.7882353f, 0.7882353f, 0.7882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey79
		/// </summary>
		public static JColor Grey79
		{
			get { return new JColor(0.7882353f, 0.7882353f, 0.7882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray80
		/// </summary>
		public static JColor Gray80
		{
			get { return new JColor(0.8f, 0.8f, 0.8f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey80
		/// </summary>
		public static JColor Grey80
		{
			get { return new JColor(0.8f, 0.8f, 0.8f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray81
		/// </summary>
		public static JColor Gray81
		{
			get { return new JColor(0.8117647f, 0.8117647f, 0.8117647f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey81
		/// </summary>
		public static JColor Grey81
		{
			get { return new JColor(0.8117647f, 0.8117647f, 0.8117647f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray82
		/// </summary>
		public static JColor Gray82
		{
			get { return new JColor(0.8196079f, 0.8196079f, 0.8196079f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey82
		/// </summary>
		public static JColor Grey82
		{
			get { return new JColor(0.8196079f, 0.8196079f, 0.8196079f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray83
		/// </summary>
		public static JColor Gray83
		{
			get { return new JColor(0.8313726f, 0.8313726f, 0.8313726f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey83
		/// </summary>
		public static JColor Grey83
		{
			get { return new JColor(0.8313726f, 0.8313726f, 0.8313726f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray84
		/// </summary>
		public static JColor Gray84
		{
			get { return new JColor(0.8392157f, 0.8392157f, 0.8392157f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey84
		/// </summary>
		public static JColor Grey84
		{
			get { return new JColor(0.8392157f, 0.8392157f, 0.8392157f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray85
		/// </summary>
		public static JColor Gray85
		{
			get { return new JColor(0.8509804f, 0.8509804f, 0.8509804f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey85
		/// </summary>
		public static JColor Grey85
		{
			get { return new JColor(0.8509804f, 0.8509804f, 0.8509804f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray86
		/// </summary>
		public static JColor Gray86
		{
			get { return new JColor(0.8588235f, 0.8588235f, 0.8588235f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey86
		/// </summary>
		public static JColor Grey86
		{
			get { return new JColor(0.8588235f, 0.8588235f, 0.8588235f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray87
		/// </summary>
		public static JColor Gray87
		{
			get { return new JColor(0.8705882f, 0.8705882f, 0.8705882f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey87
		/// </summary>
		public static JColor Grey87
		{
			get { return new JColor(0.8705882f, 0.8705882f, 0.8705882f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray88
		/// </summary>
		public static JColor Gray88
		{
			get { return new JColor(0.8784314f, 0.8784314f, 0.8784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey88
		/// </summary>
		public static JColor Grey88
		{
			get { return new JColor(0.8784314f, 0.8784314f, 0.8784314f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray89
		/// </summary>
		public static JColor Gray89
		{
			get { return new JColor(0.8901961f, 0.8901961f, 0.8901961f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey89
		/// </summary>
		public static JColor Grey89
		{
			get { return new JColor(0.8901961f, 0.8901961f, 0.8901961f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray90
		/// </summary>
		public static JColor Gray90
		{
			get { return new JColor(0.8980392f, 0.8980392f, 0.8980392f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey90
		/// </summary>
		public static JColor Grey90
		{
			get { return new JColor(0.8980392f, 0.8980392f, 0.8980392f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray91
		/// </summary>
		public static JColor Gray91
		{
			get { return new JColor(0.9098039f, 0.9098039f, 0.9098039f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey91
		/// </summary>
		public static JColor Grey91
		{
			get { return new JColor(0.9098039f, 0.9098039f, 0.9098039f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray92
		/// </summary>
		public static JColor Gray92
		{
			get { return new JColor(0.9215686f, 0.9215686f, 0.9215686f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey92
		/// </summary>
		public static JColor Grey92
		{
			get { return new JColor(0.9215686f, 0.9215686f, 0.9215686f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray93
		/// </summary>
		public static JColor Gray93
		{
			get { return new JColor(0.9294118f, 0.9294118f, 0.9294118f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey93
		/// </summary>
		public static JColor Grey93
		{
			get { return new JColor(0.9294118f, 0.9294118f, 0.9294118f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray94
		/// </summary>
		public static JColor Gray94
		{
			get { return new JColor(0.9411765f, 0.9411765f, 0.9411765f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey94
		/// </summary>
		public static JColor Grey94
		{
			get { return new JColor(0.9411765f, 0.9411765f, 0.9411765f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray95
		/// </summary>
		public static JColor Gray95
		{
			get { return new JColor(0.9490196f, 0.9490196f, 0.9490196f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey95
		/// </summary>
		public static JColor Grey95
		{
			get { return new JColor(0.9490196f, 0.9490196f, 0.9490196f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray96
		/// </summary>
		public static JColor Gray96
		{
			get { return new JColor(0.9607843f, 0.9607843f, 0.9607843f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey96
		/// </summary>
		public static JColor Grey96
		{
			get { return new JColor(0.9607843f, 0.9607843f, 0.9607843f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray97
		/// </summary>
		public static JColor Gray97
		{
			get { return new JColor(0.9686275f, 0.9686275f, 0.9686275f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey97
		/// </summary>
		public static JColor Grey97
		{
			get { return new JColor(0.9686275f, 0.9686275f, 0.9686275f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray98
		/// </summary>
		public static JColor Gray98
		{
			get { return new JColor(0.9803922f, 0.9803922f, 0.9803922f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey98
		/// </summary>
		public static JColor Grey98
		{
			get { return new JColor(0.9803922f, 0.9803922f, 0.9803922f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray99
		/// </summary>
		public static JColor Gray99
		{
			get { return new JColor(0.9882353f, 0.9882353f, 0.9882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey99
		/// </summary>
		public static JColor Grey99
		{
			get { return new JColor(0.9882353f, 0.9882353f, 0.9882353f, 1f); }
		}


		/// <summary>
		/// Returns the color Gray100
		/// </summary>
		public static JColor Gray100
		{
			get { return new JColor(1f, 1f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color Grey100
		/// </summary>
		public static JColor Grey100
		{
			get { return new JColor(1f, 1f, 1f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkGrey
		/// </summary>
		public static JColor DarkGrey
		{
			get { return new JColor(0.6627451f, 0.6627451f, 0.6627451f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkGray
		/// </summary>
		public static JColor DarkGray
		{
			get { return new JColor(0.6627451f, 0.6627451f, 0.6627451f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkBlue
		/// </summary>
		public static JColor DarkBlue
		{
			get { return new JColor(0f, 0f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkCyan
		/// </summary>
		public static JColor DarkCyan
		{
			get { return new JColor(0f, 0.5450981f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkMagenta
		/// </summary>
		public static JColor DarkMagenta
		{
			get { return new JColor(0.5450981f, 0f, 0.5450981f, 1f); }
		}


		/// <summary>
		/// Returns the color DarkRed
		/// </summary>
		public static JColor DarkRed
		{
			get { return new JColor(0.5450981f, 0f, 0f, 1f); }
		}


		/// <summary>
		/// Returns the color LightGreen
		/// </summary>
		public static JColor LightGreen
		{
			get { return new JColor(0.5647059f, 0.9333333f, 0.5647059f, 1f); }
		}
		#endregion
	}

}
