
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace JadEngine
{
	/// <summary>
	/// Implements a special type of object manager that has an additional dictionary. 
	/// It's used by the engine to ensure that resources that are loaded from a file are only loaded once.
	/// </summary>
	/// <typeparam name="T"></typeparam>
	public abstract class JObjectDictionaryManager<T> : JObjectManager<T> where T : IJObject
	{
		#region Fields

		protected Dictionary<string, T> _keys;

		#endregion

		#region Properties
		
		#endregion

		#region Constrcutor

		public JObjectDictionaryManager()
		{
			_keys = new Dictionary<string, T>();
		}

		#endregion

		#region Methods

		#endregion
	}
}