using System;

namespace JadEngine.Scene
{
    /// <summary>
    /// The type of attenuation.
    /// </summary>
    public enum JLightAttenuationType
    {
        /// <summary>
        /// Attenuation is not used for this light.
        /// </summary>
        None = 0,

        /// <summary>
        /// Linear between near and far.
        /// </summary>
        Inverse = 1,

        /// <summary>
        /// Linear squared between near and far.
        /// </summary>
        InverseSquare = 2,

        /// <summary>
        /// Smooth between near and far.
        /// </summary>
        DualRadius = 3,

        /// <summary>
        /// Standard style.
        /// </summary>
        Standard = 4
    }
}