using System;

namespace JadEngine.Scene
{
    /// <summary>
    /// The various light types that Jad suports.
    /// </summary>
    public enum JLightType
    {
        /// <summary>
        /// A point light.
        /// </summary>
        Omni = 0,

        /// <summary>
        /// A spot light.
        /// </summary>
        Spot = 1,

        /// <summary>
        /// A directional light that only has direction, but no position.
        /// </summary>
        Directional = 2,

        /// <summary>
        /// Indicates that the light type is unknown.
        /// </summary>
        Unknown = 3
    }
}