using System;
using JadEngine.Core;
using Microsoft.DirectX;
using JadEngine.Video;

namespace JadEngine.Scene
{
    /// <summary>
    /// Defines the possible parameters for the projectors.
    /// </summary>
    public class JLightProjector
    {
        #region Fields
        private bool _enabled;
        private Matrix _matrix;
        private JBaseTexture _map;
        #endregion

        #region Properties
        /// <summary>
        /// Gets or sets if the light should have it's projector component enabled.
        /// </summary>
        public bool Enabled
        {
            get { return _enabled; }
            set { _enabled = value; }
        }
        /// <summary>
        /// The matrix for the projector.
        /// </summary>
        public Matrix Matrix
        {
            get { return _matrix; }
            set { _matrix = value; }
        }
        /// <summary>
        /// The texture for the projector. Can be <see cref="JTexture"/> for spot lights or <see cref="JTextureCube"/> for omni lights
        /// </summary>
        public JBaseTexture Map
        {
            get { return _map; }
            set { _map = value; }
        }
        #endregion

        #region Methods

		//internal bool Load(JBinaryImport import)
		//{
		//    this._enabled = import.LoadBoolean();
		//    this._matrix = import.LoadMatrix();
		//    this._map = import.LoadTexture();

		//    return true;
		//}

		//internal bool Save(JBinaryExport export)
		//{
		//    export.Save(this._enabled);
		//    export.Save(this._matrix);
		//    export.Save(this._map);

		//    return true;
		//}

        #endregion
    }

}