using System;
using JadEngine.Core;

namespace JadEngine.Scene
{
    /// <summary>
    /// Parameters for the volumetric light component. This will give an effect
    /// like if the light would travel through dust or fog.
    /// </summary>
    public class JLightVolumetric
    {
        #region Fields
        private bool _enabled;        
        private float _powValue;
        #endregion

        #region Properties
        /// <summary>
        /// Gets or sets if the light should have it's volumetric component enabled.
        /// </summary>
        public bool Enabled
        {
            get { return _enabled; }
            set { _enabled = value; }
        }

        /// <summary>
        /// Gets or sets the power of the volumetric effect.
        /// TODO: Document valid range
        /// </summary>
        public float PowValue
        {
            get { return _powValue; }
            set { _powValue = value; }
        }
        #endregion

        #region Constructors
        /// <summary>
        /// Default constructor.
        /// </summary>
        public JLightVolumetric()
        {}

        /// <summary>
        /// Extended constructor.
        /// </summary>
        /// <param name="enabled">Sets if the volumetric effect should be enabled.</param>
        /// <param name="powValue">Sets the power of the volumetric effect.</param>
        public JLightVolumetric(bool enabled, float powValue)
        {
            this._enabled = enabled;
            this._powValue = powValue;
        }
        #endregion

        #region Methods
		//internal bool Load(JBinaryImport import)
		//{
		//    _enabled = import.LoadBoolean();
		//    _powValue = import.LoadSingle();

		//    return true;
		//}

		//internal bool Save(JBinaryExport export)
		//{
		//    export.Save(_enabled);
		//    export.Save(_powValue);
		//    return true;
		//}
        #endregion
    }
}