#region Using directives

using System;
using System.IO;
using System.Collections.Generic;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

using JadEngine.Core;
using JadEngine.Collections;
using JadEngine.Mathematics.Geometry;
using JadEngine.Particles;
using JadEngine.Physics;
using JadEngine.Video;

#endregion

namespace JadEngine.Scene
{
	/// <summary>
	/// This is a node that has Transformation, but not affect to the visibility
	/// It is used, for example to focus a light to an object. This dummy does not
	/// render, neither used for computing the hierarchical boxes or spheres.
	/// </summary>
	public class JDummy : JNode
	{
		#region Private Gizmo Class

		private class JDummyGizmo : JGizmo
		{
			#region Constructors

			/// <summary>
			/// Default constructor
			/// </summary>
			public JDummyGizmo()
				: base("dummy.tga")
			{
				// Vertices and indices arent needed
				NumVertices = NumIndices = 0;
			}
			#endregion
		}
		
		#endregion

		#region Fields
		private static JGizmo _dummyGizmo = new JDummyGizmo();
		#endregion

		#region Constructors

		/// <summary>
		/// Default constructor
		/// </summary>
		/// <param name="name">TODO</param>
		public JDummy()
			: base()
		{
			Gizmo = JDummy._dummyGizmo;
		}

		/// <summary>
		/// Loading constructor
		/// </summary>
		/// <param name="import">TODO</param>
        /// <param name="nodeName">The node name</param>
		//public JDummy(JBinaryImport import,string nodeName)
		//    : base(nodeName)
		//{
		//    Jad.Scene.Dummies.Add(this);
			
		//    Load(import);
		//}

		#endregion

		#region Methods		
		#endregion

		#region Serializable

		/// <summary>
		/// Current FileVersion
		/// </summary>
		int fileVersion = 1;

        /// <summary>Load from a binary importer</summary>
		//public bool Load(JBinaryImport import)
		//{
		//    int fileVersionLoader = import.LoadInt32();

		//    base.Load(import);

		//    import.Dispose();

		//    return true;
		//}

		/// <summary>
		/// Creates the files at the Dummies directory and stores the information
		/// about the object
		/// </summary>
		/// <param name="path">Relative path</param>
		/// <returns>The fileName</returns>
		//public override string Save(string path)
		//{
		//    string fileName = @"\Dummies\" + name;

		//    if (!Directory.Exists(path + @"\Dummies\"))
		//        Directory.CreateDirectory(path + @"\Dummies\");

		//    JBinaryExport export = new JBinaryExport(path + fileName);

		//    // Save the class name

		//    export.Save(this.GetType().FullName);

		//    export.Save(fileVersion);

		//    // Save the node information
		//    base.Save(export);

		//    export.Dispose();

		//    return fileName;
		//}

		#endregion
	}

	#region Dummies

	///// <summary>
	///// The dummies collection.
	///// </summary>
	//public class JDummies : JObjectManager<JDummy>
	//{
	//    #region Fields		

	//    #endregion

	//    #region List Properties

		

	//    #endregion

	//    #region Constructors

	//    /// <summary>
	//    /// Default constructor
	//    /// </summary>
	//    public JDummies()
	//    {		
	//    }

	//    #endregion

	//    #region Methods		

	//    /// <summary>
	//    /// Adds the dummy to he list and scene graph
	//    /// </summary>
	//    /// <param name="dummy"></param>
	//    public override void Add(JDummy dummy)
	//    {
	//        _items.Add(dummy);

	//        // Add the dummy to the scene graph
	//        Jad.Scene.Root.SceneGraph.AddChild(dummy);
	//    }		

	//    /// <summary>
	//    /// Creates a new <see cref="JDummy"/> instance and adds it to the internal list.
	//    /// </summary>
	//    /// <returns>The new JDummy instance.</returns>
	//    public override JDummy Create()
	//    {
	//        JDummy dummy = new JDummy();

	//        Add(dummy);

	//        return dummy;
	//    }

	//    /// <summary>
	//    /// Removes the specified element from the manager's internal list.
	//    /// </summary>
	//    /// <param name="element">The JDummy to remove.</param>
	//    public override void Delete(JDummy element)
	//    {
	//        _items.Remove(element);
	//    }

	//    /// <summary>
	//    /// Does a cleanup of the manager's internal data structures.
	//    /// </summary>
	//    public override void Cleanup()
	//    {
	//        _items.Clear();
	//    }
	//    #endregion
	//}

	#endregion
}
