#region Using directives

using System;
using System.Collections.Generic;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

using JadEngine.Core;
using JadEngine.Collections;
using JadEngine.Video;
using JadEngine.Particles;
using JadEngine.Mathematics;
using JadEngine.Mathematics.Geometry;
using JadEngine.Animation;

#endregion

namespace JadEngine.Scene
{
    /// <summary>
    /// This class holds the world mesh. This is a special mesh that
    /// it's not affected by the lights, and it's rendered before the ZPass, only once
    /// </summary>
    public class JWorld
    {
        /// <summary>
        /// Default constructor
        /// </summary>
        public JWorld()
        {
        }

        /// <summary>
        /// Updates the class 
        /// </summary>
        public virtual void Update(JScene scene)
        {
        }

        /// <summary>
        /// Renders only to the z buffer 
        /// </summary>
        public virtual void RenderZ(JScene scene)
        {
        }

        /// <summary>
        /// Renders the world
        /// </summary>
        public virtual void Render(JScene scene)
        {
        }

        public virtual void RenderFog(JScene scene)
        {
        }
    }
}
