using System;
using System.Collections.Generic;
using System.Text;
using JadEngine.VFS.Storage;

namespace JadEngine.Sound
{
    public interface IJSoundService : IDisposable
    {
        IJSoundSource CreateSource(string name, System.IO.Stream data);
        // So you can remove these in very large models
        void AddSource(IJSoundSource source);
        void RemoveSource(IJSoundSource source);
        // For listener/camera
        void SetPosition(float x, float y, float z);
        void SetOrientation(float[] orientation);
        void SetVelocity(float x, float y, float z);
    }
}
