using System;
using System.Collections.Generic;
using System.Text;

namespace JadEngine.Sound
{
    public interface IJSoundSource : IDisposable
    {
        String Name { get; }
        JSoundState State { get; }
        bool IsLooping { get; set; }

        float Frequency { get; }
        int Length { get; }
        float Pitch { get; set; }
        float Gain { get; set; }

        void Play();
        void Pause();
        void Resume();
        void Stop();

        void Rewind();

        void SetPosition(float x, float y, float z);
        void SetOrientation(float[] orientation);
        void SetVelocity(float x, float y, float z);
        void MakeGlobal();
    }
}
