using System;
using System.Collections.Generic;
using System.Text;

namespace JadEngine.Sound
{
    /// <summary>
    /// This class has two purposes: 
    /// 1. Act as a nop service to always have a default implementation (which actually does nothing)
    /// 2. As a base class for other plugins exposing <see cref="IJSoundService"/>
    /// </summary>
    public class JSoundServiceBase : IJSoundService
    {
        #region IJSoundService Members

        public virtual IJSoundSource CreateSource(string name, System.IO.Stream data)
        {
            return new JSoundSourceBase(name);
        }

        public virtual void AddSource(IJSoundSource source)
        {
        }

        public virtual void RemoveSource(IJSoundSource source)
        {
        }

        public virtual void SetPosition(float x, float y, float z)
        {
        }

        public virtual void SetOrientation(float[] orientation)
        {
        }

        public virtual void SetVelocity(float x, float y, float z)
        {
        }

        #endregion

        #region IDisposable Members

        public virtual void Dispose()
        {
        }

        #endregion
    }
}
