using System;
using System.Collections.Generic;
using System.Text;

namespace JadEngine.Sound
{
    /// <summary>
    /// Indicates the state of an <see cref="IJSoundSource"/>
    /// </summary>
    public enum JSoundState
    {
        /// <summary>
        /// The <see cref="IJSoundSource"/> is currently playing
        /// </summary>
        Playing = 0,
        /// <summary>
        /// The <see cref="IJSoundSource"/> is stopped
        /// </summary>
        Stopped,
        /// <summary>
        /// The <see cref="IJSoundSource"/> is paused and will continue when <see cref="IJSoundSource.Resume"/> is called
        /// </summary>
        Paused
    }
}
