#region Using directives

using System;
using System.IO;
using System.Collections.Generic;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

using JadEngine.Core;
using JadEngine.Collections;
using JadEngine.Scene;
using JadEngine.Tools;

#endregion

namespace JadEngine.Video
{
    /// <summary>
    /// Here we have then <see cref="EffectHandle"/> references used
    /// for the fog on the shaders.
    /// </summary>
    public class JEffectFogHandler
	{
		#region Fields

        /// <summary>
        /// The parent object
        /// </summary>
        JEffectHandles _parent;

        /// <summary>
		/// This is the effect Vector4 FogValues
		/// </summary>
		EffectHandle _fogValues;

		/// <summary>
        /// This is the effect Vector4 FogColor
		/// </summary>
		EffectHandle _fogColor;

		#endregion

        #region Properties

        /// <summary>
        /// This is the effect Vector4 FogValues
        /// </summary>
        public EffectHandle FogValues
        {
            get { return _fogValues; }
        }

        /// <summary>
        /// This is the effect Vector4 FogColor
        /// </summary>
        public EffectHandle FogColor
        {
            get { return _fogColor; }
        }

        /// <summary>
        /// Gets the effect DX resource
        /// </summary>
        Effect DXResource
        {
            get { return _parent.DXResource; }
        }

        #endregion

        #region Constructors

        /// <summary>
        /// Default constructor
        /// </summary>
        /// <param name="parent">A valid JEffectHandles object</param>
        internal JEffectFogHandler(JEffectHandles parent)
        {
            _parent = parent;
        }

        #endregion

        #region Methods

        /// <summary>
        /// Get the effect handlers
        /// </summary>
        internal void GetHandles()
        {
			_fogValues = DXResource.GetParameter(null, "FogValues");
			_fogColor = DXResource.GetParameter(null, "FogColor");

        }

        #endregion
    }
}
