#region Using directives

using System;
using System.IO;
using System.Collections.Generic;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

using JadEngine.Core;
using JadEngine.Collections;
using JadEngine.Scene;
using JadEngine.Tools;

#endregion

namespace JadEngine.Video
{
	/// <summary>
	/// Parameters used when loading an effect
	/// </summary>
	public class JEffectLoadingParams
	{
		#region Fields

		/// <summary>
		/// Errors that appear when loading the effect
		/// </summary>
		public string Errors;

		/// <summary>
		/// Flags used to create the effect
		/// </summary>
		public ShaderFlags Flags;

		/// <summary>
		/// The effect pool on loading
		/// </summary>
		public EffectPool Pool;

		/// <summary>
		/// Defines on loading
		/// </summary>
		public Macro[] Defines;

		/// <summary>
		/// Includes on loading
		/// </summary>
		public Include Includes;

		#endregion

		#region Constructors

		public JEffectLoadingParams()
		{
			Flags = ShaderFlags.None;
		}

		#endregion

	}
}
