#region Using directives

using System;

using Microsoft.DirectX.Direct3D;

using JadEngine.Core;
using JadEngine.Tools;

#endregion

/*
 * 04/02/08
 *	-Initial cleanup	
 */

namespace JadEngine.Video
{
	/// <summary>
	/// Class that holds a texture and its sampler states.
	/// When you are refering to a texture in a shader , you are actually using a sampler.
	/// </summary>
	public class JSampler
	{		
		#region Fields

		/// <summary>
		/// The texture.
		/// </summary>
		private JBaseTexture _texture;

		/// <summary>
		/// The sampler states to be applied.
		/// </summary>
		private JSamplerVideoStates _states;

		#endregion

        #region Properties

		/// <summary>
		/// Gets or sets the texture.
		/// </summary>
		/// <value>The texture.</value>
        public JBaseTexture Texture
        {
            get { return _texture; }
            set { _texture = value; }
        }

		/// <summary>
		/// Gets or sets the sampler states to be applied.
		/// </summary>
		/// <value>The states.</value>
		public JSamplerVideoStates States
		{
			get { return _states; }
			set { _states = value; }
		}

        #endregion

		#region Constructor

		public JSampler()
		{
			_states = new JSamplerVideoStates();
		}

		#endregion

		#region Methods

		/// <summary>
		/// Initializes the states to the default values and sets the texture=null
		/// </summary>
		//public void Initialize()
		//{
		//    States.Initialize();
		//    Texture = null;
		//}

		#endregion

		#region Serialize

		/// <summary>Current FileVersion</summary>
		private const int fileVersion = 1;

		/// <summary>
		/// Loads the values from the binary file.
		/// </summary>
		/// <param name="import">A valid instance.</param>
		/// <returns>True if everything is ok.</returns>
		//internal bool Load(JBinaryImport import)
		//{
		//    int fileVersionLoaded = import.LoadInt32();
		//    Texture = import.LoadTexture();
		//    States.Load(import);

		//    return true;
		//}

		/// <summary>
		/// Save the values to the binary file.
		/// </summary>
		/// <param name="export">A valid instance.</param>
		/// <returns>True if everything is ok.</returns>
		//internal bool Save(JBinaryExport export)
		//{
		//    export.Save(fileVersion);
		//    export.Save(Texture);
		//    States.Save(export);

		//    return true;
		//}

		#endregion
	}
}
