#region Using directives

using System;
using System.IO;
using System.Collections.Generic;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

using JadEngine.Mathematics.Geometry;
using JadEngine.Physics;
using JadEngine.Scene;
using JadEngine.Tools;
using JadEngine.Core;
using JadEngine.Collections;

#endregion

namespace JadEngine.Video
{
	public static partial class JFaceDelegates
	{
		/// <summary>
		/// Fills and array of float[9] provided by the face.User field
		/// </summary>
		/// <param name="face">Face information</param>
		/// <returns>Always returns true</returns>
		public static bool FaceCB(JForEachFaceParams face)
		{
			float[] v = (float[])face.User;

			v[0] = face.v0.X;
			v[1] = face.v0.Y;
			v[2] = face.v0.Z;
			v[3] = face.v1.X;
			v[4] = face.v1.Y;
			v[5] = face.v1.Z;
			v[6] = face.v2.X;
			v[7] = face.v2.Y;
			v[8] = face.v2.Z;

			return true;
		}

	}
}
