#region Using directives

using System;
using System.IO;
using System.Collections.Generic;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

using JadEngine.Mathematics.Geometry;
using JadEngine.Physics;
using JadEngine.Scene;
using JadEngine.Tools;
using JadEngine.Core;
using JadEngine.Collections;

#endregion

namespace JadEngine.Video
{
	public static partial class JFaceDelegates
	{
		/// <summary>
		/// Computes the face normal and save it at the Mesh.FacesNormal field
		/// </summary>
		/// <param name="face">Face information</param>
		/// <returns>Always true</returns>
		public static bool GenerateFaceNormalsCB(JForEachFaceParams face)
		{
			Vector3 cross1 = (face.v2 - face.v1);
			Vector3 cross2 = (face.v1 - face.v0);

			face.Mesh.FacesNormal[face.NumFace] = Vector3.Cross(cross1, cross2);

			return true;
		}

	}
}
