#region Using directives

using System;
using System.IO;
using System.Collections.Generic;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

using JadEngine.Mathematics.Geometry;
using JadEngine.Physics;
using JadEngine.Scene;
using JadEngine.Tools;
using JadEngine.Core;
using JadEngine.Collections;

#endregion

namespace JadEngine.Video
{
	public static partial class JFaceDelegates
	{
		/// <summary>
		/// Computes the intersection between the face and a ray provided by the user
		/// </summary>
		/// <param name="face">Face information</param>
		/// <returns>True if there is a collision</returns>
		public static bool IntersectCB(JForEachFaceParams face)
		{
			JIntersectParams v = (JIntersectParams)face.User;

			IntersectInformation i;

			// Test BackFaceCulling
			if (v.BackFaceCulling)
			{
				if (Vector3.Dot(v.Dir, face.Normal) < 0) return true;
			}

			if (Geometry.IntersectTri(face.v0, face.v1, face.v2, v.Start, v.Dir, out i))
			{
				if (i.Dist < v.Distance)
				{
					v.Distance = i.Dist;
					v.NumFaceCollision = face.NumFace;
				}
			}

			return true;
		}

	}
}
