#region Using directives

using System;
using System.IO;
using System.Collections.Generic;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

using JadEngine.Mathematics.Geometry;
using JadEngine.Physics;
using JadEngine.Scene;
using JadEngine.Tools;
using JadEngine.Core;
using JadEngine.Collections;

#endregion

namespace JadEngine.Video
{
	/// <summary>
	/// You can create methods to acces the faces of the mesh.
	/// This is a very simple way of working with the faces, something usual when dealing with 3D
	/// This struct is filled by the engine on each face, so you only worry about it, no matter
	/// the vertex structure or the index size.
	/// </summary>
	public struct JForEachFaceParams
	{
		#region Fields

		/// <summary>
		/// User field
		/// </summary>
		public Object User;

		/// <summary>
		/// The JMesh instance
		/// </summary>
		public JMesh Mesh;

		/// <summary>
		/// Face number
		/// </summary>
		public int NumFace;

		/// <summary>
		/// First Vertex
		/// </summary>
		public Vector3 v0;

		/// <summary>
		/// Second Vertex
		/// </summary>
		public Vector3 v1;

		/// <summary>
		/// Third Vertex
		/// </summary>
		public Vector3 v2;

		/// <summary>
		/// Normal
		/// </summary>
		public Vector3 Normal;

		/// <summary>
		/// Array of mesh vertices
		/// </summary>
		public Vector3[] Vertices;

		/// <summary>
		/// Index of the first vertex
		/// </summary>
		public int Vertex0Index;

		/// <summary>
		/// Index of the second vertex
		/// </summary>
		public int Vertex1Index;

		/// <summary>
		/// Index of the third vertex
		/// </summary>
		public int Vertex2Index;

		/// <summary>
		/// TODO
		/// </summary>
		public Matrix World;

		/// <summary>
		/// The parent object
		/// </summary>
		public JMeshObject MeshObject;

		#endregion
	}

}
