#region Using directives

using System;
using System.Collections.Generic;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

using JadEngine.Scene;
using JadEngine.Tools;
using JadEngine.Core;

#endregion

namespace JadEngine.Video
{
	/// <summary>
	/// Used to set all the Render video states
	/// </summary>
	public struct JRenderVideoStates
	{
		#region Fields

		/// <summary>
		/// TODO
		/// </summary>
		public bool ZEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public Compare ZBufferFunction;

		/// <summary>
		/// TODO
		/// </summary>
		public bool ZBufferWriteEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public bool ScissorTestEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public FillMode FillMode;

		/// <summary>
		/// TODO
		/// </summary>
		public ShadeMode ShadeMode;

		/// <summary>
		/// TODO
		/// </summary>
		public int ClipPlaneEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public bool MultisampleAntiAlias;

		/// <summary>
		/// TODO
		/// </summary>
		public int MultisampleMask;

		/// <summary>
		/// TODO
		/// </summary>
		public ColorWriteEnable ColorWriteEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public ColorWriteEnable ColorWriteEnable1;

		/// <summary>
		/// TODO
		/// </summary>
		public ColorWriteEnable ColorWriteEnable2;

		/// <summary>
		/// TODO
		/// </summary>
		public ColorWriteEnable ColorWriteEnable3;

		/// <summary>
		/// TODO
		/// </summary>
		public BlendOperation BlendOperation;

		/// <summary>
		/// TODO
		/// </summary>
		public float SlopeScaleDepthBias;

		/// <summary>
		/// TODO
		/// </summary>
		public bool TwoSidedStencilMode;

		/// <summary>
		/// TODO
		/// </summary>
		public StencilOperation CounterClockwiseStencilFail;

		/// <summary>
		/// TODO
		/// </summary>
		public StencilOperation CounterClockwiseStencilZBufferFail;

		/// <summary>
		/// TODO
		/// </summary>
		public StencilOperation CounterClockwiseStencilPass;

		/// <summary>
		/// TODO
		/// </summary>
		public Compare CounterClockwiseStencilFunction;

		/// <summary>
		/// TODO
		/// </summary>
		public bool SrgbWriteEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public float DepthBias;

		/// <summary>
		/// TODO
		/// </summary>
		public bool StencilEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public StencilOperation StencilFail;

		/// <summary>
		/// TODO
		/// </summary>
		public StencilOperation StencilZBufferFail;

		/// <summary>
		/// TODO
		/// </summary>
		public StencilOperation StencilPass;

		/// <summary>
		/// TODO
		/// </summary>
		public Compare StencilFunction;

		/// <summary>
		/// TODO
		/// </summary>
		public int ReferenceStencil;

		/// <summary>
		/// TODO
		/// </summary>
		public int StencilMask;

		/// <summary>
		/// TODO
		/// </summary>
		public int StencilWriteMask;

		/// <summary>
		/// TODO
		/// </summary>
		public bool SeparateAlphaBlendEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public Blend SourceBlendAlpha;

		/// <summary>
		/// TODO
		/// </summary>
		public Blend DestinationBlendAlpha;

		/// <summary>
		/// TODO
		/// </summary>
		public BlendOperation BlendOperationAlpha;

		/// <summary>
		/// TODO
		/// </summary>
		public bool AlphaTestEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public int ReferenceAlpha;

		/// <summary>
		/// TODO
		/// </summary>
		public Compare AlphaFunction;

		/// <summary>
		/// TODO
		/// </summary>
		public bool LastPixel;

		/// <summary>
		/// TODO
		/// </summary>
		public Blend SourceBlend;

		/// <summary>
		/// TODO
		/// </summary>
		public Blend DestinationBlend;

		/// <summary>
		/// TODO
		/// </summary>
		public Cull CullMode;

		/// <summary>
		/// TODO
		/// </summary>
		public bool AlphaBlendEnable;

		/// <summary>
		/// TODO
		/// </summary>
		public int TextureFactor;

		/// <summary>
		/// TODO
		/// </summary>
		public WrapCoordinates Wrap0, Wrap1, Wrap2, Wrap3, Wrap4, Wrap5, Wrap6, Wrap7;

		/// <summary>
		/// TODO
		/// </summary>
		public bool Clipping;

		#endregion

		#region Methods

		/// <summary>
		/// Sets the default values
		/// </summary>
		public void Initialize()
		{
            FillMode = FillMode.Solid;
			ZEnable = true;
			ShadeMode = ShadeMode.Gouraud;
			ClipPlaneEnable = 0;
			MultisampleAntiAlias = true;
			MultisampleMask = -1;

			ColorWriteEnable = ColorWriteEnable.RedGreenBlueAlpha;
			ColorWriteEnable1 = ColorWriteEnable.RedGreenBlueAlpha;
			ColorWriteEnable2 = ColorWriteEnable.RedGreenBlueAlpha;
			ColorWriteEnable3 = ColorWriteEnable.RedGreenBlueAlpha;

			BlendOperation = BlendOperation.Add;
			ScissorTestEnable = false;
			SlopeScaleDepthBias = 0;
			TwoSidedStencilMode = false;

			CounterClockwiseStencilFail = StencilOperation.Keep;
			CounterClockwiseStencilZBufferFail = StencilOperation.Keep;
			CounterClockwiseStencilPass = StencilOperation.Keep;
			CounterClockwiseStencilFunction = Compare.Always;

			SrgbWriteEnable = false;
			DepthBias = 0;
			SeparateAlphaBlendEnable = false;

			SourceBlendAlpha = Blend.One;
			DestinationBlendAlpha = Blend.Zero;
			BlendOperationAlpha = BlendOperation.Add;

			ZBufferWriteEnable = true;
			AlphaTestEnable = false;
			LastPixel = true;
			SourceBlend = Blend.One;
			DestinationBlend = Blend.Zero;
			CullMode = Cull.CounterClockwise;
			ZBufferFunction = Compare.LessEqual;
			ReferenceAlpha = 0;
			AlphaFunction = Compare.Always;
			AlphaBlendEnable = false;
			StencilEnable = false;

			StencilFail = StencilOperation.Keep;
			StencilZBufferFail = StencilOperation.Keep;
			StencilPass = StencilOperation.Keep;
			StencilFunction = Compare.Always;

			ReferenceStencil = 0;
			StencilMask = -1;
			StencilWriteMask = -1;

			TextureFactor = -1;

			Wrap0 = 0;
			Wrap1 = 0;
			Wrap2 = 0;
			Wrap3 = 0;
			Wrap4 = 0;
			Wrap5 = 0;
			Wrap6 = 0;
			Wrap7 = 0;

			Clipping = true;
		}

		/// <summary>
		/// Sends the states to the hardware using the <see cref="JStateManager"/>
		/// </summary>
		public void Process()
		{
			JStateManager sm = Jad.Video.StateManager;
            
			sm.SetRenderState(RenderStates.ZEnable, ZEnable);
			sm.SetRenderState(RenderStates.ZBufferFunction, (int)ZBufferFunction);
			sm.SetRenderState(RenderStates.ZBufferWriteEnable, ZBufferWriteEnable);
			sm.SetRenderState(RenderStates.ScissorTestEnable, ScissorTestEnable);
			sm.SetRenderState(RenderStates.FillMode, (int)FillMode);
			sm.SetRenderState(RenderStates.MultisampleMask, (int)MultisampleMask);
			sm.SetRenderState(RenderStates.ColorWriteEnable, (int)ColorWriteEnable);
			sm.SetRenderState(RenderStates.ColorWriteEnable1, (int)ColorWriteEnable1);
			sm.SetRenderState(RenderStates.ColorWriteEnable2, (int)ColorWriteEnable2);
			sm.SetRenderState(RenderStates.ColorWriteEnable3, (int)ColorWriteEnable3);
			sm.SetRenderState(RenderStates.BlendOperation, (int)BlendOperation);
			sm.SetRenderState(RenderStates.SlopeScaleDepthBias, SlopeScaleDepthBias);
			sm.SetRenderState(RenderStates.TwoSidedStencilMode, TwoSidedStencilMode);
			sm.SetRenderState(RenderStates.CounterClockwiseStencilFail, (int)CounterClockwiseStencilFail);
			sm.SetRenderState(RenderStates.CounterClockwiseStencilZBufferFail, (int)CounterClockwiseStencilZBufferFail);
			sm.SetRenderState(RenderStates.CounterClockwiseStencilPass, (int)CounterClockwiseStencilPass);
			sm.SetRenderState(RenderStates.CounterClockwiseStencilFunction, (int)CounterClockwiseStencilFunction);
			sm.SetRenderState(RenderStates.SrgbWriteEnable, SrgbWriteEnable);
			sm.SetRenderState(RenderStates.DepthBias, DepthBias);
			sm.SetRenderState(RenderStates.StencilEnable, StencilEnable);
			sm.SetRenderState(RenderStates.StencilFail, (int)StencilFail);
			sm.SetRenderState(RenderStates.StencilZBufferFail, (int)StencilZBufferFail);
			sm.SetRenderState(RenderStates.StencilPass, (int)StencilPass);
			sm.SetRenderState(RenderStates.StencilFunction, (int)StencilFunction);
			sm.SetRenderState(RenderStates.ReferenceStencil, ReferenceStencil);
			sm.SetRenderState(RenderStates.StencilMask, StencilMask);
			sm.SetRenderState(RenderStates.StencilWriteMask, StencilWriteMask);
			sm.SetRenderState(RenderStates.SeparateAlphaBlendEnable, SeparateAlphaBlendEnable);
			sm.SetRenderState(RenderStates.SourceBlendAlpha, (int)SourceBlendAlpha);
			sm.SetRenderState(RenderStates.DestinationBlendAlpha, (int)DestinationBlendAlpha);
			sm.SetRenderState(RenderStates.BlendOperationAlpha, (int)BlendOperationAlpha);
			sm.SetRenderState(RenderStates.AlphaTestEnable, AlphaTestEnable);
			sm.SetRenderState(RenderStates.ReferenceAlpha, ReferenceAlpha);
			sm.SetRenderState(RenderStates.AlphaFunction, (int)AlphaFunction);
			sm.SetRenderState(RenderStates.LastPixel, LastPixel);
			sm.SetRenderState(RenderStates.SourceBlend, (int)SourceBlend);
			sm.SetRenderState(RenderStates.DestinationBlend, (int)DestinationBlend);
			sm.SetRenderState(RenderStates.CullMode, (int)CullMode);
			sm.SetRenderState(RenderStates.AlphaBlendEnable, AlphaBlendEnable);
			sm.SetRenderState(RenderStates.TextureFactor, TextureFactor);
			sm.SetRenderState(RenderStates.Wrap0, (int)Wrap0);
			sm.SetRenderState(RenderStates.Wrap1, (int)Wrap1);
			sm.SetRenderState(RenderStates.Wrap2, (int)Wrap2);
			sm.SetRenderState(RenderStates.Wrap3, (int)Wrap3);
			sm.SetRenderState(RenderStates.Wrap4, (int)Wrap4);
			sm.SetRenderState(RenderStates.Wrap5, (int)Wrap5);
			sm.SetRenderState(RenderStates.Wrap6, (int)Wrap6);
			sm.SetRenderState(RenderStates.Wrap7, (int)Wrap7);
			sm.SetRenderState(RenderStates.Clipping, Clipping);
		}

		#endregion
	}

}
