#region Using directives

using System;
using System.Collections.Generic;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

using JadEngine.Scene;
using JadEngine.Tools;
using JadEngine.Core;

#endregion

namespace JadEngine.Video
{
	/// <summary>
	/// Used to cache the RenderStates, TextureStates and Sampler states
    /// It's an advanced option of settings the states. You can set the
    /// state that you want to cahnge, and only this will be changed on Process
    /// Currently used only on materials, but i think i could change it
    /// to JRenderVideoStates and  JSamplerVideoStates
	/// </summary>
	public class JVideoStates
	{
		#region Inner Classes

		/// <summary>
		/// TODO
		/// </summary>
		public class JRenderState
		{
			#region Fields

			/// <summary>
			/// TODO
			/// </summary>
			public RenderStates state;

			/// <summary>
			/// TODO
			/// </summary>
			public int iOldValue;

			/// <summary>
			/// TODO
			/// </summary>
			public int iValue;

			/// <summary>
			/// TODO
			/// </summary>
			public bool bOldValue;

			/// <summary>
			/// TODO
			/// </summary>
			public bool bValue;

			/// <summary>
			/// TODO
			/// </summary>
			public float fOldValue;

			/// <summary>
			/// TODO
			/// </summary>
			public float fValue;

			/// <summary>
			/// TODO
			/// </summary>
			public byte type;

			#endregion
		}

		/// <summary>
		/// TODO
		/// </summary>
		public class JTextureStageState
		{
			#region Fields

			/// <summary>
			/// TODO
			/// </summary>
			public int stage;

			/// <summary>
			/// TODO
			/// </summary>
			public TextureStageStates state;

			/// <summary>
			/// TODO
			/// </summary>
			public int iOldValue;

			/// <summary>
			/// TODO
			/// </summary>
			public int iValue;

			/// <summary>
			/// TODO
			/// </summary>
			public bool bOldValue;

			/// <summary>
			/// TODO
			/// </summary>
			public bool bValue;

			/// <summary>
			/// TODO
			/// </summary>
			public float fOldValue;

			/// <summary>
			/// TODO
			/// </summary>
			public float fValue;

			/// <summary>
			/// TODO
			/// </summary>
			public byte type;

			#endregion
		}

		/// <summary>
		/// TODO
		/// </summary>
		public class JSamplerStageState
		{
			#region Fields

			/// <summary>
			/// TODO
			/// </summary>
			public int stage;

			/// <summary>
			/// TODO
			/// </summary>
			public SamplerStageStates state;

			/// <summary>
			/// TODO
			/// </summary>
			public int iOldValue;

			/// <summary>
			/// TODO
			/// </summary>
			public int iValue;

			/// <summary>
			/// TODO
			/// </summary>
			public bool bOldValue;

			/// <summary>
			/// TODO
			/// </summary>
			public bool bValue;

			/// <summary>
			/// TODO
			/// </summary>
			public float fOldValue;

			/// <summary>
			/// TODO
			/// </summary>
			public float fValue;

			/// <summary>
			/// TODO
			/// </summary>
			public byte type;

			#endregion
		}

		#endregion

		#region Fields

		/// <summary>
		/// TODO
		/// </summary>
		List<JRenderState> renderStates;

		/// <summary>
		/// TODO
		/// </summary>
		List<JTextureStageState> textureStageStates;

		/// <summary>
		/// TODO
		/// </summary>
		List<JSamplerStageState> samplerStageStates;

		#endregion

		#region Constructors

		/// <summary>
		/// Default constructor
		/// </summary>
		public JVideoStates()
		{
			renderStates = new List<JRenderState>();
			textureStageStates = new List<JTextureStageState>();
			samplerStageStates = new List<JSamplerStageState>();
		}

		#endregion

		#region RenderState Methods

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetRenderState(RenderStates state, int value)
		{
			JRenderState r = new JRenderState();
			r.state = state;
			r.type = 0;
			r.iOldValue = Jad.Video.Device.GetRenderStateInt32(state);

			renderStates.Add(r);

			Jad.Video.StateManager.SetRenderState(state, value);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetRenderState(RenderStates state, bool value)
		{
			JRenderState r = new JRenderState();
			r.state = state;
			r.type = 1;
			r.bOldValue = Jad.Video.Device.GetRenderStateBoolean(state);

			renderStates.Add(r);

			Jad.Video.StateManager.SetRenderState(state, value);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetRenderState(RenderStates state, float value)
		{
			JRenderState r = new JRenderState();
			r.state = state;
			r.type = 1;
			r.fOldValue = Jad.Video.Device.GetRenderStateSingle(state);

			renderStates.Add(r);

			Jad.Video.StateManager.SetRenderState(state, value);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void AddRenderState(RenderStates state, int value)
		{
			JRenderState r = new JRenderState();
			r.state = state;
			r.type = 0;
			r.iValue = value;

			renderStates.Add(r);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void AddRenderState(RenderStates state, bool value)
		{
			JRenderState r = new JRenderState();
			r.state = state;
			r.type = 1;
			r.bValue = value;

			renderStates.Add(r);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void AddRenderState(RenderStates state, float value)
		{
			JRenderState r = new JRenderState();
			r.state = state;
			r.type = 1;
			r.fValue = value;

			renderStates.Add(r);
		}

		#endregion

		#region TextureStageState Methods

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetTextureStageState(int stage, TextureStageStates state, int value)
		{
			JTextureStageState r = new JTextureStageState();
			r.stage = stage;
			r.state = state;
			r.type = 0;
			r.iOldValue = Jad.Video.Device.GetTextureStageStateInt32(stage, state);

			textureStageStates.Add(r);

			Jad.Video.StateManager.SetTextureStageState(stage, state, value);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetTextureStageState(int stage, TextureStageStates state, bool value)
		{
			JTextureStageState r = new JTextureStageState();
			r.stage = stage;
			r.state = state;
			r.type = 1;
			r.bOldValue = Jad.Video.Device.GetTextureStageStateBoolean(stage, state);

			textureStageStates.Add(r);

			Jad.Video.StateManager.SetTextureStageState(stage, state, value);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetTextureStageState(int stage, TextureStageStates state, float value)
		{
			JTextureStageState r = new JTextureStageState();
			r.stage = stage;
			r.state = state;
			r.type = 2;
			r.fOldValue = Jad.Video.Device.GetTextureStageStateSingle(stage, state);

			textureStageStates.Add(r);

			Jad.Video.StateManager.SetTextureStageState(stage, state, value);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void AddTextureStageState(int stage, TextureStageStates state, int value)
		{
			JTextureStageState r = new JTextureStageState();
			r.stage = stage;
			r.state = state;
			r.type = 0;
			r.iValue = value;

			textureStageStates.Add(r);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void AddTextureStageState(int stage, TextureStageStates state, bool value)
		{
			JTextureStageState r = new JTextureStageState();
			r.stage = stage;
			r.state = state;
			r.type = 1;
			r.bValue = value;

			textureStageStates.Add(r);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void AddTextureStageState(int stage, TextureStageStates state, float value)
		{
			JTextureStageState r = new JTextureStageState();
			r.stage = stage;
			r.state = state;
			r.type = 2;
			r.fValue = value;

			textureStageStates.Add(r);
		}

		#endregion

		#region SamplerState Methods

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetSamplerState(int stage, SamplerStageStates state, int value)
		{
			JSamplerStageState r = new JSamplerStageState();
			r.stage = stage;
			r.state = state;
			r.type = 0;
			r.iOldValue = Jad.Video.Device.GetSamplerStageStateInt32(stage, state);

			samplerStageStates.Add(r);

			Jad.Video.StateManager.SetSamplerState(stage, state, value);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetSamplerState(int stage, SamplerStageStates state, bool value)
		{
			JSamplerStageState r = new JSamplerStageState();
			r.stage = stage;
			r.state = state;
			r.type = 1;
			r.bOldValue = Jad.Video.Device.GetSamplerStageStateBoolean(stage, state);

			samplerStageStates.Add(r);

			Jad.Video.StateManager.SetSamplerState(stage, state, value);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void SetSamplerState(int stage, SamplerStageStates state, float value)
		{
			JSamplerStageState r = new JSamplerStageState();
			r.stage = stage;
			r.state = state;
			r.type = 2;
			r.fOldValue = Jad.Video.Device.GetSamplerStageStateSingle(stage, state);

			samplerStageStates.Add(r);

			Jad.Video.StateManager.SetSamplerState(stage, state, value);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void AddSamplerState(int stage, SamplerStageStates state, int value)
		{
			JSamplerStageState r = new JSamplerStageState();
			r.stage = stage;
			r.state = state;
			r.type = 0;
			r.iValue = value;

			samplerStageStates.Add(r);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void AddSamplerState(int stage, SamplerStageStates state, bool value)
		{
			JSamplerStageState r = new JSamplerStageState();
			r.stage = stage;
			r.state = state;
			r.type = 1;
			r.bValue = value;

			samplerStageStates.Add(r);
		}

		/// <summary>
		/// TODO
		/// </summary>
		/// <param name="stage">TODO</param>
		/// <param name="state">TODO</param>
		/// <param name="value">TODO</param>
		public void AddSamplerState(int stage, SamplerStageStates state, float value)
		{
			JSamplerStageState r = new JSamplerStageState();
			r.stage = stage;
			r.state = state;
			r.type = 2;
			r.fValue = value;

			samplerStageStates.Add(r);
		}

		#endregion

		#region Methods

		/// <summary>
		/// Restores the captured states
		/// </summary>
		public void Restore()
		{
			// The list is reversed because the same state can have being changed
			// several times and the good one is the first one

			// Render States
			renderStates.Reverse();

			foreach (JRenderState r in renderStates)
			{
				switch (r.type)
				{
					case 0:
						Jad.Video.StateManager.SetRenderState(r.state, r.iOldValue);
						break;
					case 1:
						Jad.Video.StateManager.SetRenderState(r.state, r.bOldValue);
						break;
					case 2:
						Jad.Video.StateManager.SetRenderState(r.state, r.fOldValue);
						break;
				}
			}

			// Texture Stage States
			textureStageStates.Reverse();

			foreach (JTextureStageState r in textureStageStates)
			{
				switch (r.type)
				{
					case 0:
						Jad.Video.StateManager.SetTextureStageState(r.stage, r.state, r.iOldValue);
						break;
					case 1:
						Jad.Video.StateManager.SetTextureStageState(r.stage, r.state, r.bOldValue);
						break;
					case 2:
						Jad.Video.StateManager.SetTextureStageState(r.stage, r.state, r.fOldValue);
						break;
				}
			}

			// Sampler Stage States
			samplerStageStates.Reverse();

			foreach (JSamplerStageState r in samplerStageStates)
			{
				switch (r.type)
				{
					case 0:
						Jad.Video.StateManager.SetSamplerState(r.stage, r.state, r.iOldValue);
						break;
					case 1:
						Jad.Video.StateManager.SetSamplerState(r.stage, r.state, r.bOldValue);
						break;
					case 2:
						Jad.Video.StateManager.SetSamplerState(r.stage, r.state, r.fOldValue);
						break;
				}
			}
		}

		/// <summary>
		/// Process the states in the list
		/// </summary>
		public void Process()
		{
			// Take the old value and save it to be able to restore it later
			// After that set the states

			// Render States
			foreach (JRenderState r in renderStates)
			{
				switch (r.type)
				{
					case 0:
						r.iOldValue = Jad.Video.Device.GetRenderStateInt32(r.state);
						Jad.Video.StateManager.SetRenderState(r.state, r.iValue);
						break;
					case 1:
						r.bOldValue = Jad.Video.Device.GetRenderStateBoolean(r.state);
						Jad.Video.StateManager.SetRenderState(r.state, r.bValue);
						break;
					case 2:
						r.fOldValue = Jad.Video.Device.GetRenderStateSingle(r.state);
						Jad.Video.StateManager.SetRenderState(r.state, r.fValue);
						break;
				}
			}

			// Texture Stage States
			foreach (JTextureStageState r in textureStageStates)
			{
				switch (r.type)
				{
					case 0:
						r.iOldValue = Jad.Video.Device.GetTextureStageStateInt32(r.stage, r.state);
						Jad.Video.StateManager.SetTextureStageState(r.stage, r.state, r.iValue);
						break;
					case 1:
						r.bOldValue = Jad.Video.Device.GetTextureStageStateBoolean(r.stage, r.state);
						Jad.Video.StateManager.SetTextureStageState(r.stage, r.state, r.bValue);
						break;
					case 2:
						r.fOldValue = Jad.Video.Device.GetTextureStageStateSingle(r.stage, r.state);
						Jad.Video.StateManager.SetTextureStageState(r.stage, r.state, r.fValue);
						break;
				}
			}

			// Sampler Stage States
			foreach (JSamplerStageState r in samplerStageStates)
			{
				switch (r.type)
				{
					case 0:
						r.iOldValue = Jad.Video.Device.GetSamplerStageStateInt32(r.stage, r.state);
						Jad.Video.StateManager.SetSamplerState(r.stage, r.state, r.iValue);
						break;
					case 1:
						r.bOldValue = Jad.Video.Device.GetSamplerStageStateBoolean(r.stage, r.state);
						Jad.Video.StateManager.SetSamplerState(r.stage, r.state, r.bValue);
						break;
					case 2:
						r.fOldValue = Jad.Video.Device.GetSamplerStageStateSingle(r.stage, r.state);
						Jad.Video.StateManager.SetSamplerState(r.stage, r.state, r.fValue);
						break;
				}
			}
		}

		#endregion
	}

}
