using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.DirectX.Direct3D;

/*
 * 11/02/08
 *	-Created
 *	-Changed from struct to class
 */

namespace JadEngine.Video
{
	/// <summary>
	/// This class encapsulates texture parameters.
	/// </summary>
	public class JTextureParameters
	{
		#region Fields

		/// <summary>
		/// TODO
		/// </summary>
		private int _width;		

		/// <summary>
		/// TODO
		/// </summary>
		private int _height;		

		/// <summary>
		/// TODO
		/// </summary>
		private int _mip;		

		/// <summary>
		/// TODO
		/// </summary>
		private Usage _usage;		

		/// <summary>
		/// TODO
		/// </summary>
		private Format _format;		

		/// <summary>
		/// TODO
		/// </summary>
		private Pool _pool;		

		/// <summary>
		/// TODO
		/// </summary>
		private Filter _filter;		

		/// <summary>
		/// TODO
		/// </summary>
		private Filter _mipFilter;		

		/// <summary>
		/// TODO
		/// </summary>
		private int _colorKey;
		
		#endregion

		#region Properties

		/// <summary>
		/// Gets or sets the texture width.
		/// </summary>
		/// <value>The width.</value>
		public int Width
		{
			get { return _width; }
			set { _width = value; }
		}

		/// <summary>
		/// Gets or sets the texture height.
		/// </summary>
		/// <value>The height.</value>
		public int Height
		{
			get { return _height; }
			set { _height = value; }
		}

		/// <summary>
		/// Gets or sets the mip level.
		/// </summary>
		/// <value>The mip level.</value>
		public int Mip
		{
			get { return _mip; }
			set { _mip = value; }
		}

		/// <summary>
		/// Gets or sets the usage.
		/// </summary>
		/// <value>The usage.</value>
		public Usage Usage
		{
			get { return _usage; }
			set { _usage = value; }
		}

		/// <summary>
		/// Gets or sets the format.
		/// </summary>
		/// <value>The format.</value>
		public Format Format
		{
			get { return _format; }
			set { _format = value; }
		}

		/// <summary>
		/// Gets or sets the pool type.
		/// </summary>
		/// <value>The pool.</value>
		public Pool Pool
		{
			get { return _pool; }
			set { _pool = value; }
		}

		/// <summary>
		/// Gets or sets the filter type.
		/// </summary>
		/// <value>The filter.</value>
		public Filter Filter
		{
			get { return _filter; }
			set { _filter = value; }
		}

		/// <summary>
		/// Gets or sets the mip filter type.
		/// </summary>
		/// <value>The mip filter.</value>
		public Filter MipFilter
		{
			get { return _mipFilter; }
			set { _mipFilter = value; }
		}

		/// <summary>
		/// Gets or sets the color key.
		/// </summary>
		/// <value>The color key.</value>
		public int ColorKey
		{
			get { return _colorKey; }
			set { _colorKey = value; }
		}

		#endregion

		#region Constructor
		/// <summary>
		/// Initializes a new instance of the <see cref="JTextureParameters"/> class.
		/// </summary>
		public JTextureParameters()
		{
			_width = D3DX.Default;
			_height = D3DX.Default;
			_mip = D3DX.Default;
			_usage = Usage.None;
			_format = Format.Unknown;
			_pool = Pool.Managed;
			_filter = (Filter)D3DX.Default;
			_mipFilter = (Filter)D3DX.Default;
			_colorKey = 0;
		}
		#endregion
	}
}
