using System;
using System.Collections.Generic;
using System.Text;
using JadEngine.Sound;
using Pluto.Core;

namespace JadEngine.Plugins.Sound
{
    /// <summary>
    /// <see cref="IPlugin"/> which registers an implementation of an <see cref="IJSoundService"/>
    /// </summary>
    [ExposedService(typeof(IJSoundService))]
	public class JOpenALSoundServicePlugin : ServicePluginBase
    {
		/// <summary>
		/// Callback to create an <see cref="IJSoundService"/> defined as a <see cref="JOpenALSoundService"/>
		/// </summary>
		public T CreateService<T>()
			 where T : IJSoundService
		{
			IJSoundService i = new JOpenALSoundService();
			return (T) i;
		}

		/// <summary>
		/// Register our <see cref="IJSoundService"/>
		/// </summary>
		protected override bool RegisterServices(IPlutoServiceContainer serviceContainer)
		{
			serviceContainer.AddService<IJSoundService>(this.CreateService<IJSoundService>);
			return true;
		}
	}
}
