//----------------------------------------------------------------------------------

#include "Definitions.h"

struct VS_INPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct VS_OUTPUT
{
   float4 position:     POSITION;
   float2 texcoord0:     TEXCOORD0;
};

VS_OUTPUT VShader( VS_INPUT vin )
{
   VS_OUTPUT vout;
   
   float4 Posicion_Vertice=vin.position;
   
	// Calculamos la posicin final del punto
	// Si esto lo hacemos al principio, el shader puede detectar que no va a dibujarse y salir del shader
	// De esta forma ganaremos velocidad
	
   vout.position = mul(Posicion_Vertice,WorldViewProjection);
   vout.position.z = vout.position.w;
	
    // Pasamos las coordenadas de textura modificadas para que haya repeticin
    //vout.texcoord0 = vin.texcoord0*0.0f;
    vout.texcoord0 = 0.0f;


   return vout;
}

sampler map_diffuse = 
sampler_state
{
    Texture = <texturaDiffuse>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;

	AddressU = Clamp;
	AddressV = Clamp;
};

texture3D texturaNoise;

sampler3D map_noise = 
sampler_state
{
    Texture = <texturaNoise>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;

	AddressU = Wrap;
	AddressV = Wrap;
	AddressW = Wrap;
};

texture texturaCamera;

sampler map_camara = 
sampler_state
{
    Texture = <texturaCamera>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;

	AddressU = Wrap;
	AddressV = Wrap;
};

struct PS_INPUT
{
   float2 texcoord0:     TEXCOORD0;
};

struct PS_OUTPUT
{
   float4 color0:       COLOR0;
};

bool bon;
float noiseValue;

PS_OUTPUT PShader( PS_INPUT pin )
{
   PS_OUTPUT pout;float4 color,overlay,backbuffer;
   

	// Recogemos los valores de la textura.
	
   color= tex3D( map_noise, float3(pin.texcoord0.x*2.0f,pin.texcoord0.y*2.0f,ENV_Time));
   
   backbuffer=tex2D(map_diffuse,pin.texcoord0);
   
   color=lerp(color,backbuffer,noiseValue);
   
   overlay=tex2D(map_camara,pin.texcoord0);
   
   if(overlay.r>0.2f) color=overlay;
   
   // Si est activado el on y como lo hemos dibujado en azul, significa que es all donde el rojo =0
   if(bon)
   	if(overlay.b>=0.2f) color=float4(overlay.b,0,0,1);
   
   pout.color0=color;
	
   return pout;
}

technique RenderScene
{
	pass p0
	{
		VertexShader = compile vs_2_0 VShader();
		PixelShader = compile ps_2_0 PShader();
	}
}
