//----------------------------------------------------------------------------------
//***********Las siguientes variables DEBEN tener EXACTAMENTE este nombre***********

float4x4    WorldViewProjection;

texture texturaDiffuse;              // Mapa de textura diffuse

float4 offset;

//----------------------------------------------------------------------------------

struct VS_INPUT
{
   float4 position:     POSITION;
   float4 color:        COLOR0;
   float2 texcoord0:    TEXCOORD0;
};

struct VS_OUTPUT
{
   float4 position:     POSITION;
   float4 diffuse:      COLOR0;
   float2 texcoord0:    TEXCOORD0;
};

VS_OUTPUT VShader( VS_INPUT vin )
{
    VS_OUTPUT vout;
   
    float4 Posicion_Vertice = float4(vin.position.xyz + offset.xyz, 1.0f);
   
	// Calculamos la posicin final del punto
	// Si esto lo hacemos al principio, el shader puede detectar que no va a dibujarse y salir del shader
	// De esta forma ganaremos velocidad
    vout.position = mul(Posicion_Vertice,WorldViewProjection);

    // Pasamos el color del vrtice
    vout.diffuse = vin.color;

    // Pasamos las coordenadas de textura intactas
    vout.texcoord0 = vin.texcoord0;

    return vout;
}


sampler map_diffuse = 
sampler_state
{
    Texture = <texturaDiffuse>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

struct PS_INPUT
{
    float4 diffuse:     COLOR0;
    float2 texcoord0:   TEXCOORD0;
};

struct PS_OUTPUT
{
   float4 color0:   COLOR0;
};

PS_OUTPUT PShader( PS_INPUT pin )
{
    PS_OUTPUT pout;
   
    // Recogemos los valores de la textura.
    pout.color0 = tex2D( map_diffuse, pin.texcoord0 ) * pin.diffuse;
	
    return pout;
}

technique RenderScene
{
    pass p0
    {
        VertexShader = compile vs_1_1 VShader();
        PixelShader = compile ps_1_1 PShader();
    }
}

