//----------------------------------------------------------------------------------
//***********Las siguientes variables DEBEN tener EXACTAMENTE este nombre***********

texture textureDiffuse;              // Mapa de textura diffuse
texture textureDiffuse2;              // Otro Mapa de textura diffuse
texture textureRenderTarget1;			// Textura del RT1
//----------------------------------------------------------------------------------

struct VS_INPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct VS_OUTPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct PS_INPUT
{
   float2 texcoord0:     TEXCOORD0;
};

sampler map_diffuse = 
sampler_state
{
    Texture = <textureDiffuse>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

sampler map_RenderTarget1 = 
sampler_state
{
    Texture = <textureRenderTarget1>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

VS_OUTPUT VShader( VS_INPUT vin )
{
   VS_OUTPUT vout;
   
   vout.position = vin.position;
   vout.texcoord0 = vin.texcoord0;

   return vout;
}

float4 PShader(PS_INPUT pin):COLOR0
{
	
   return tex2D( map_diffuse, pin.texcoord0 );

}

technique RenderScene
{
    pass p0
    {
        VertexShader = compile vs_2_0 VShader();
        PixelShader = compile ps_2_0 PShader();
    }
}

//------------------------------------------------------------------------------------------------------------------
//											BLEND
// Activa el alpha blending y mezcla utilizando ONE-ONE la textura con el RT
//------------------------------------------------------------------------------------------------------------------

float4 PShader_Blend(PS_INPUT pin):COLOR0
{
   return tex2D( map_diffuse, pin.texcoord0 );

}

technique Blend
{
    pass p0
    {
		VertexShader = compile vs_2_0 VShader();
        PixelShader = compile ps_2_0 PShader_Blend();
    }
}

//------------------------------------------------------------------------------------------------------------------
//											LUMINANCIA
//------------------------------------------------------------------------------------------------------------------

float4 Luminancia={ 0.3f,0.59f,0.11f,1.0f };
float4 ColorFinal= { 1,0.9f,0.5f,1 };
float4 PShader_Luminancia(PS_INPUT pin):COLOR0
{

	float color;
	
   color= dot((float3)tex2D( map_diffuse, pin.texcoord0 ),Luminancia);
   
   return lerp(float4(0,0,0,1),ColorFinal,color);

}

technique Luminancia
{
    pass p0
    {
        VertexShader = compile vs_2_0 VShader();
        PixelShader = compile ps_2_0 PShader_Luminancia();
    }
}

//------------------------------------------------------------------------------------------------------------------
//											Copy
//------------------------------------------------------------------------------------------------------------------
float4 PShader_Copy(PS_INPUT pin):COLOR0
{
   return tex2D( map_diffuse, pin.texcoord0 );
}

technique Copy
{
    pass p0
    {
        VertexShader = compile vs_2_0 VShader();
        PixelShader = compile ps_2_0 PShader_Copy();
    }
}

//------------------------------------------------------------------------------------------------------------------
//											Ambient
//------------------------------------------------------------------------------------------------------------------

float4	Material_Diffuse;

float4 PShader_Ambient(PS_INPUT pin):COLOR0
{
   return tex2D( map_diffuse, pin.texcoord0 )*Material_Diffuse;
}

technique Ambient
{
    pass p0
    {
        VertexShader = compile vs_2_0 VShader();
        PixelShader = compile ps_2_0 PShader_Ambient();
    }
}
