//----------------------------------------------------------------------------------
//***********Las siguientes variables DEBEN tener EXACTAMENTE este nombre***********

texture textureDiffuse;              // Mapa de textura diffuse
//----------------------------------------------------------------------------------

struct VS_INPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct VS_OUTPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct PS_INPUT
{
   float2 texcoord0:     TEXCOORD0;
};

sampler map_diffuse = 
sampler_state
{
    Texture = <textureDiffuse>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

float4 BlurOffset;

VS_OUTPUT VShader( VS_INPUT vin )
{
   VS_OUTPUT vout;
   
   vout.position = vin.position;
   vout.texcoord0 = vin.texcoord0;

   return vout;
}


//------------------------------------------------------------------------------------------------------------------
//											BLUR
//------------------------------------------------------------------------------------------------------------------


float PixelWeight[8];

float4 PShader(float2 texCoord: TEXCOORD0,uniform int numSamples) : COLOR 
{
	float4 sum = 0.0f;
	

	for (int i = 0; i < numSamples; i++) 
	{
		sum += tex2D(map_diffuse, texCoord + ( BlurOffset.xy * i ) ) * PixelWeight[i];
		sum += tex2D(map_diffuse, texCoord - ( BlurOffset.xy * i ) ) * PixelWeight[i];
		
	}
	
	return sum;

}


//	Permitimos 16 samples com mximo

int CurNumSamples = 3;
PixelShader psArray[8] = { 
	compile ps_2_0 PShader(1), 
	compile ps_2_0 PShader(2), 
	compile ps_2_0 PShader(3), 
	compile ps_2_0 PShader(4), 
	compile ps_2_0 PShader(5), 
	compile ps_2_0 PShader(6), 
	compile ps_2_0 PShader(7), 
	compile ps_2_0 PShader(8)
};

technique RenderScene
{
	pass p0
	{
		VertexShader = compile vs_2_0 VShader();
		PixelShader = (psArray[CurNumSamples]);
	}
}
