//----------------------------------------------------------------------------------
//***********Las siguientes variables DEBEN tener EXACTAMENTE este nombre***********

texture textureDiffuse;              // Mapa de textura diffuse
//----------------------------------------------------------------------------------

struct VS_INPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct VS_OUTPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

sampler map_diffuse = 
sampler_state
{
    Texture = <textureDiffuse>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};


VS_OUTPUT VShader( VS_INPUT vin )
{
   VS_OUTPUT vout;
   
   vout.position = vin.position;
   vout.texcoord0 = vin.texcoord0;

   return vout;
}


//------------------------------------------------------------------------------------------------------------------
//											SOBEL FILTER TO DETECT EGDES
//------------------------------------------------------------------------------------------------------------------

float offx,offy;

float4 PShader(float2 texCoord: TEXCOORD0) : COLOR 
{
   // Sample neighbor pixels
   float s00 = tex2D(map_diffuse, texCoord + float2(-offx, -offy));
   float s01 = tex2D(map_diffuse, texCoord + float2( 0,   -offy));
   float s02 = tex2D(map_diffuse, texCoord + float2( offx, -offy));

   float s10 = tex2D(map_diffuse, texCoord + float2(-offx,  0));
   float s12 = tex2D(map_diffuse, texCoord + float2( offx,  0));

   float s20 = tex2D(map_diffuse, texCoord + float2(-offx,  offy));
   float s21 = tex2D(map_diffuse, texCoord + float2( 0,    offy));
   float s22 = tex2D(map_diffuse, texCoord + float2( offx,  offy));

   // Sobel filter in X direction
   float sobelX = s00 + 2 * s10 + s20 - s02 - 2 * s12 - s22;
   // Sobel filter in Y direction
   float sobelY = s00 + 2 * s01 + s02 - s20 - 2 * s21 - s22;

   // Find edge, skip sqrt() to improve performance ...
   float edgeSqr = (sobelX * sobelX + sobelY * sobelY);

   // ... and threshold against a squared value instead.
   float4 color = 1.0-(edgeSqr > 0.07 * 0.07);
   
   return color;

}


technique RenderScene
{
	pass p0
	{
		VertexShader = compile vs_2_0 VShader();
		PixelShader = compile ps_2_0 PShader();
	}
}
