//----------------------------------------------------------------------------------
//***********Las siguientes variables DEBEN tener EXACTAMENTE este nombre***********

texture textureDiffuse;              // Mapa de textura diffuse
texture textureOriginal;              // Otro Mapa de textura diffuse
//----------------------------------------------------------------------------------

struct VS_INPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct VS_OUTPUT
{
   float4 position:     POSITION;
   float2 texcoord0:    TEXCOORD0;
};

struct PS_INPUT
{
   float2 texcoord0:     TEXCOORD0;
};

VS_OUTPUT VShader( VS_INPUT vin )
{
   VS_OUTPUT vout;
   
   vout.position = vin.position;
   vout.texcoord0 = vin.texcoord0;

   return vout;
}


sampler Original= 
sampler_state
{
    Texture = <textureOriginal>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    
	AddressU = Clamp;
	AddressV = Clamp;
};

sampler Blurred= 
sampler_state
{
    Texture = <textureDiffuse>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    
	AddressU = Clamp;
	AddressV = Clamp;
};

float ExposureLevel;
bool AutoExposureControl;
float ExposureAdjustSpeed;
float AverageBrightness;

float4 PShader(float2 texCoord: TEXCOORD0) : COLOR 
{
	float4 original = tex2D( Original, texCoord );
	float4 blur		= tex2D( Blurred, texCoord );

	float4 color	= lerp( original, blur, 0.4f );
	
	texCoord		   -= 0.5f;
	float vignette	= 1 - dot( texCoord, texCoord );
	color		   *= pow( vignette, 4.0 );	
	
	if (AutoExposureControl)
	{
		//ExposureLevel = lerp(ExposureLevel, 0.5 / AverageBrightness, ExposureAdjustSpeed);
	}
	
	color		   *= ExposureLevel;	

	return pow( color, 0.55 );	

}

technique RenderScene
{
	pass p0
	{
		VertexShader = compile vs_2_0 VShader();
		PixelShader = compile ps_2_0 PShader();
	}
}
