AllInOne

// Se utiliza para mostrar el valor del DOF en el motor
// Puesto que el RT donde se encuentra el DOF, comparte los bits con el Glow
// Y el DOF ocupa el canal alfa

texture textureDiffuse;

struct VS_INPUT
{
	float4 position:	POSITION;
	float2 texcoord0:	TEXCOORD0;
};

struct VS_OUTPUT
{
	float4 position:	POSITION;
	float2 texcoord0:	TEXCOORD0;
};

struct PS_INPUT
{
	float2 texcoord0:	TEXCOORD0;
};

sampler map_diffuse = 
sampler_state
{
    Texture = <textureDiffuse>;
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

VS_OUTPUT VShader( VS_INPUT data_in )
{
	VS_OUTPUT data_out;

	data_out.position = data_in.position;
	data_out.texcoord0 = data_in.texcoord0;

	return data_out;
}

float4 PShader( PS_INPUT data_in ) : COLOR0
{

	float4 fragmentColor = tex2D(map_diffuse, data_in.texcoord0);
	
	fragmentColor.rgb = fragmentColor.a;
	fragmentColor.a = 1.0f;

	return fragmentColor;
}

technique RenderScene
{
    pass p0
    {
        VertexShader = compile vs_1_1 VShader();
        PixelShader = compile ps_1_1 PShader();
    }
}