//----------------------------------------------------------------------------------

#include "Definitions.h"

struct VS_INPUT
{
	float4 position :	POSITION;
};

struct VS_OUTPUT
{
	float4 position :	POSITION;
};

VS_OUTPUT VShader(VS_INPUT vin)
{
	VS_OUTPUT vout;
   
	vout.position = mul(vin.position, WorldViewProjection);

	return vout;
}

float4 PShader() : COLOR0
{
	return MATERIAL_Diffuse;
}

technique RenderScene
{
	pass p0
	{
		VertexShader = compile vs_1_1 VShader();
		PixelShader = compile ps_1_1 PShader();
	}
}

float ConstExtrusion;
float3 PosLuz;

VS_OUTPUT VShaderVolume(VS_INPUT vin)
{
	VS_OUTPUT vout;
   
   float4 pos=vin.position;
   
   if(pos.z<=-5000.0f) 
   {
   	pos.z+=10000.0f;
   	
   	float3 extrusionDir=normalize((float3)pos-PosLuz)*ConstExtrusion;
   	
   	
   	pos+=float4(extrusionDir,0);
   }
   
	vout.position = mul(pos, WorldViewProjection);

	return vout;
}

technique RenderVolume
{
	pass p0
	{
		VertexShader = compile vs_2_0 VShaderVolume();
		PixelShader = compile ps_1_1 PShader();
	}
}
