//
float ComputeDepthBlur(float depth)
{
	float f;

	if(depth >= DOF_nearFocalPlaneDepth && depth <= DOF_farFocalPlaneDepth)
	{
		f = 0.0f;
	}
	else if(depth < DOF_nearFocalPlaneDepth)
	{
		// [-1, 0] range
		f = (depth - DOF_nearFocalPlaneDepth) / DOF_nearBlurDepthRange;
	}
	else
	{
		// [0, 1] range
		f = (depth - DOF_farFocalPlaneDepth) / DOF_farBlurDepthRange;

		// Truncamos f a la cantidad mxima de desenfoque
		f = clamp(f, 0, DOF_maxBlur);
	}

	// [0, 1] range
	return (f * 0.5f + 0.5f);
}
