float4 DistancePointLine( float3 Point, float3 LineStart, float3 LineEnd)
{
    float LineMag;
    float U;
    float3 Intersection;
    float3 LineVector=LineEnd-LineStart;
 
    LineMag = dot( LineVector,LineVector);
    
	// Debemos saturar porque si fuera > 1 significara que est detras del vrtice y por tanto no queremos verlo
	
    U=saturate(dot(Point-LineStart,LineVector)/(LineMag));
         
	Intersection= LineStart+U*(LineVector);
	
    return float4(Intersection,distance(Intersection,Point));
 
}

float bias(float value, float b)
{
   return (b > 0) ? pow(value, log(b) / log(0.5)) : 0;
}

float gain(float value, float g)
{
   return 0.5 * ((value < 0.5) ? bias(2 * value, 1 - g) : (2 - bias(2 - 2 * value, 1 - g)));
}

float3x3 GetTangentSpace(float3 T, float3 N)
{
   float3x3 objToTangentSpace;
   
   objToTangentSpace[0]=T;           // tangent
   objToTangentSpace[1]=cross(N, T); // binormal
   objToTangentSpace[2]=N;           // normal  
   
   return objToTangentSpace;
}
