using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;

namespace Tutorial
{
    public partial class Browser : Form
    {
        //private System.Reflection.Module[] _modules;
        private Process _tutorialProcess;

        public Browser()
        {
            InitializeComponent();
            //_modules = System.Reflection.Assembly.GetExecutingAssembly().GetModules(false);
            LoadConfig();
        }

        private void LoadConfig()
        {
            System.IO.StreamReader sr = new System.IO.StreamReader(@"./BrowserConfig.txt");
            sr.ReadLine();

            while (!sr.EndOfStream)
            {
                string tutorialName = "";
                while (sr.Peek() != (int)'|')
                {
                    tutorialName += (char)sr.Read();
                }

                Button tutorialButton = new Button();
                tutorialButton.Width = 378;
                tutorialButton.Height = 60;
                tutorialButton.TextAlign = ContentAlignment.MiddleLeft;
                tutorialButton.AutoSize = true;
                tutorialButton.AutoSizeMode = AutoSizeMode.GrowOnly;
                tutorialButton.Text = tutorialName;
                try
                {
                    tutorialButton.Image = new Bitmap(@".\Thumbs\" + tutorialName);
                }
                catch { }
                
                tutorialButton.TextImageRelation = TextImageRelation.ImageBeforeText;
                //tutorialButton.Tag = (JadEngine.JApplication)_modules[0].GetType("Tutorial." + tutorialName).GetConstructor(Type.EmptyTypes).Invoke(null);
                tutorialButton.Click += new EventHandler(tutorialButton_Click);
                browserLayoutPanel.Controls.Add(tutorialButton);

                sr.ReadLine();
            }
            sr.Close();
        }

        private void tutorialButton_Click(object sender, EventArgs e)
        {
            Button tutorialButton = (Button)sender;
            _tutorialProcess = new System.Diagnostics.Process();
            _tutorialProcess.StartInfo = new System.Diagnostics.ProcessStartInfo(@".\Tutorials.exe", tutorialButton.Text);
            _tutorialProcess.Exited += new EventHandler(_tutorialProcess_Exited);
            bool result = _tutorialProcess.Start();
            //this.Hide();
        }

        private void _tutorialProcess_Exited(object sender, EventArgs e)
        {
            //this.Show(); Because the process crashes instead of Exiting, this never throws
        }
    }
}
