using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using JadEngine.Scene;

namespace Tutorials.Complex.JadViewer
{
	public partial class MaterialProperties : Form
	{
		#region Fields
		private JNode _currentNode;

		#endregion

		#region Constructor

		public MaterialProperties()
		{
			InitializeComponent();
		}

		#endregion

		#region Properties
		public Image PreviewImage
		{
			get { return _pictureBoxMaterialPreview.Image; }
			set { _pictureBoxMaterialPreview.Image = value; }
		}

		public JNode CurrentNode
		{
			get { return _currentNode; }
			set 
			{ 
				_currentNode = value;
				FillGui();
			}

		}
		#endregion

		#region EventHandler

		private void MaterialProperties_FormClosing(object sender, FormClosingEventArgs e)
		{
			if (e.CloseReason == CloseReason.UserClosing)
			{
				e.Cancel = true;
				this.Visible = false;
			}

		}

		#endregion

		#region Methods
		private void FillGui()
		{

		}
		#endregion

		#region Events
		/// <summary>
		/// Occurs when a property of the current node has changed.
		/// </summary>
		public event EventHandler PropertyChanged;

		/// <summary>
		/// Fires the PropertyChanged event.
		/// </summary>
		private void OnPropertyChanged()
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, EventArgs.Empty);
			}
		}
		#endregion
	}
}