#region Using directives

using System;
using System.IO;
using System.Reflection;

using JadEngine;

#endregion

namespace Tutorial
{
	/// <summary>
	/// Class that holds the main method. Its the application entry point
	/// </summary>
    public class JMain
    {
        #region Fields

        private static Module[] _modules;

        #endregion

        #region Methods

        /// <summary>
        /// Application entry point
        /// </summary>
        [STAThreadAttribute]
        static void Main(string[] args)
        {
            if (args.Length != 0)
            {
                LoadTutorial(args[0]);
            }
            else
            {
                System.Windows.Forms.Application.EnableVisualStyles();
                System.Windows.Forms.Application.SetCompatibleTextRenderingDefault(true);
                System.Windows.Forms.Application.Run(new Browser());
            }
        }

        private static void LoadTutorial(string tutorialName)
        {
            _modules = Assembly.GetExecutingAssembly().GetModules(false);
            JApplication tutorialApp;
            try
            {
                tutorialApp = (JApplication)_modules[0].GetType("Tutorial." + tutorialName).GetConstructor(Type.EmptyTypes).Invoke(null);
                tutorialApp.Start();
            }
            catch (Exception)
            {
                Console.WriteLine("Error loading the specified tutorial.");
            }
        }

        #endregion
    }
}
