#region LGPL License
/*
Jad Engine Library
Copyright (C) 2007 Jad Engine Project Team

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
#endregion

#region Using Statements

using System;

using Pluto.Math;

#endregion

namespace Jade.Ai.Core
{
	public interface IMovableEntity : IEntity
	{
		#region Properties

		Vector3 Position { get; set; }
		Vector3 Velocity { get; set; }

		Vector3 Look { get; set; }
		Vector3 Up { get; set; }
		Vector3 Right { get; set; }

		float Mass { get; set; }

		float MaximumSpeed { get; set; }
		float MaximumForce { get; set; }
		float MaximumTurnRate { get; set; }

		#endregion
	}
}
