#region LGPL License
/*
Jad Engine Library
Copyright (C) 2007 Jad Engine Project Team

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
#endregion

#region Using Statements

using System;

using Jade.Ai.Core;

using Pluto.Math;

#endregion

namespace Jade.Ai.SteeringBehaviors
{
	public class Seek : SteeringBehavior
	{
		#region Fields and Properties

		private IMovableEntity _target;
		public IMovableEntity Target
		{
			get { return _target; }
			set { _target = value; }
		}

		#endregion

		#region Methods

		public override Vector3 Calculate()
		{
			Vector3 targetPos = _target.Position;
			Vector3 ownPos = Owner.Position;
			Vector3 direction = Vector3.Subtract(ref targetPos, ref ownPos);
			
			Vector3 desiredSpeed = Vector3.Multiply(ref direction, Owner.MaximumSpeed);

			Vector3 ownVel = Owner.Velocity;

			return Vector3.Subtract(ref desiredSpeed, ref ownVel);
		}

		#endregion
	}
}
