#region LGPL License
/*
Jad Engine Library
Copyright (C) 2007 Jad Engine Project Team

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
#endregion

#region Using Statements

using System;
using System.Collections.Generic;

using Jade.Ai.Core;

using Pluto.Math;

#endregion

namespace Jade.Ai.SteeringBehaviors
{
	public class WeightedSumManager : SteeringManager<float>
	{
		#region Constructors

		public WeightedSumManager(IMovableEntity owner)
			: base(owner) { }

		#endregion

		#region Methods

		public override Vector3 Calculate()
		{
			Vector3 total = Vector3.Zero;

			foreach (BehaviorDataPair<float> pair in BehaviorDataPairs.Values)
			{
				if (!pair.SteeringBehavior.Active)
					continue;

				Vector3 behaviorForce = pair.SteeringBehavior.Calculate();
				Vector3 modBehaviorForce = Vector3.Multiply(ref behaviorForce, pair.Data);
				
				total = Vector3.Add(ref total, ref modBehaviorForce);
			}

			//TRUNCATE THIS!
			return total;
		}

		#endregion
	}
}
