#pragma once
#if defined(DEBUG) | defined(_DEBUG)
#ifndef D3D_DEBUG_INFO
#define D3D_DEBUG_INFO
#endif
#endif

#using <mscorlib.dll>

#include <d3d9.h>
#include <d3dx9.h>
#include <string.h>
#include <vcclr.h>

#include "Exceptions.h"

#define FREEDX(resource) { \
	if (resource != NULL) \
	{ \
		resource->Release(); \
		resource = NULL; \
	} \
}
// converts from degrees to radians
#define DEGTORAD(degree) ((D3DX_PI / 180.0f) * (degree)) 
// converts from radians to degrees
#define RADTODEG(radian) ((180.0f / D3DX_PI) * (radian)) 

// Checks the result of a DirectX call.
// NOTE: This would, potentially, allow us to also add DX call logs, by putting extra logic in here
// That might be useful at some point in the future
#define DXCHECK(hresult) { GraphicsException::CheckHResult( hresult ); }

using namespace System;
using namespace System::Collections::Generic;
using namespace System::Runtime::InteropServices;

namespace JadeRenderingDx9 {

	public ref class D3D
	{
	private:
		static IDirect3D9* m_Direct3D;

	internal:
		static property IDirect3D9* InternalPointer
		{
			IDirect3D9* get() { return m_Direct3D; }
		}

		static void Initialize();
	};
}

