#pragma once

#include "D3D.h"

using namespace System;
using namespace System::Collections::Generic;

using namespace Jade::Rendering;

using namespace Pluto::Core;
using namespace Pluto::Configuration;

namespace JadeRenderingDx9 {

	// Our main rendering class
	[CompletionStatus(DevelopmentState::Complete)]
	ref class DXRenderer : public IRenderingSystem
	{
	public:
		static property String^ RendererName
		{
			String^ get()
			{
				return gcnew String("DX9 Renderer");
			}
		}

		// Get the Renderer name
		virtual property String^ Name
		{
			String^ get()
			{
				return RendererName;
			}
		}

		virtual property IList<Adapter^>^ Adapters
		{
			IList<Adapter^>^ get()
			{
				return _adapters;
			}
		}

		DXRenderer(IPlutoRootServiceProvider ^provider, IConfigurationService ^config);

		virtual ~DXRenderer(void);
	private:
		List<Adapter^> ^_adapters;
	};

}