#pragma once

using namespace System;

using namespace Jade::Core;
using namespace Jade::Resources;
using namespace Jade::Rendering;

using namespace Pluto::Core;

namespace JadeRenderingDx9 {

	ref class DXAdapter;
	ref class DXOutput;
	ref class DXRenderTarget;
	ref class DXDepthStencil;

	[CompletionStatus(DevelopmentState::Complete)]
	ref class DXWindow : public Window
	{
	private:
		DXAdapter^ _dxAdapter;
		DXOutput^ _dxOutput;
		DXRenderTarget^ _dxRenderTarget;
		DXDepthStencil^ _dxDepthStencil;

		bool CreateRenderSurface();

	protected:
		// TODO: This appears to work correctly.
		// If we are using swap chains, you should be able
		// to just recreate the render target surface instead of
		// resetting the entire device.  Since the resize only effects
		// the swap chain, resetting it should work.  
		// NOTE: This would only work with swap chain surfaces - device
		// surfaces would still need a full reset.  Uncommenting this
		// overrides the default resize behavior, preventing the 
		// event from firign which resets the device, and instead just
		// recreates the render target
		virtual void OnSizeChanged() override;

	public:

		virtual property OutputDevice^ Output 
		{
			OutputDevice^ get() override;
		};
		virtual property DepthStencilBase^ DepthStencil
		{
			DepthStencilBase^ get() override;
		};
		virtual property RenderTargetBase^ RenderTarget
		{
			RenderTargetBase^ get() override;
		};

		DXWindow(DXAdapter^ adapter, DXOutput^ output, int width, int height, IntPtr windowPointer);

		virtual ~DXWindow(void);

		virtual void Clear(Enums::ClearFlags flags, Color color, float z, int stencil) override;

		virtual void Present() override;
	};

}