#pragma once

#include "D3D.h"

using namespace System;
using namespace System::Collections::Generic;

using namespace Jade::Resources;

using namespace Pluto::Core;

namespace JadeRenderingDx9 {

	ref class DXAdapter;

	[CompletionStatus(DevelopmentState::Complete)]
	ref class IndexBufferHandler : ResourceHandlerBase
	{
	private:
		IDirect3DIndexBuffer9* _dxResource;
		IndexBuffer^ _indexBuffer;
		int _size;
		DXAdapter^ _adapter;

	protected:
		// We have to override this to free our DX resources
		virtual void FreeResources() override
		{
			FREEDX(_dxResource);
		}

		// And override this to update us correctly
		virtual void UpdateResources() override;

	private:
		void CreateIndexBuffer();

	internal:
		property IDirect3DIndexBuffer9* Resource
		{
			IDirect3DIndexBuffer9* get();
		}

	public:	
		IndexBufferHandler(DXAdapter^ adapter, IndexBuffer^ buffer);
	};

}