#include "StdAfx.h"

#include "DXAdapter.h"
#include "LightShaderHandler.h"
#include "DXEffectBuilder.h"

namespace JadeRenderingDx9 {

	LightShaderHandler::LightShaderHandler(DXAdapter^ adapter, DXEffectBuilder^ effectBuilder, Light^ light, RenderState^ renderState)
		: ResourceHandlerBase(adapter)
	{
		_effectBuilder = effectBuilder;
		_light = light;
		_renderState = renderState;

		this->AttachResource(_renderState);
		this->AttachResource(_light);
	}

	DXEffect^ LightShaderHandler::GetLightEffect(bool renderAmbient)
	{
		this->ValidateResources();

		if (renderAmbient)
		{
			if (_lightEffectAmbient == nullptr)
				_lightEffectAmbient = _effectBuilder->GenerateLightPass(_light, _renderState->Materials[0], true, _renderState);
			return _lightEffectAmbient;
		}
		else
		{
			if (_lightEffectNoAmbient == nullptr)
				_lightEffectNoAmbient = _effectBuilder->GenerateLightPass(_light, _renderState->Materials[0], false, _renderState);
			return _lightEffectNoAmbient;
		}
	}
}