#pragma once

#include "D3D.h"
#include "DXEffect.h"

using namespace System;

using namespace Jade::Resources;

namespace JadeRenderingDx9 {

	ref class DXAdapter;
	ref class DXEffectBuilder;

	ref class LightShaderHandler : ResourceHandlerBase
	{
	private:
		RenderState^ _renderState;
		Light^ _light;
		DXEffectBuilder^ _effectBuilder;

		// Our effects
		DXEffect^ _lightEffectNoAmbient;
		DXEffect^ _lightEffectAmbient;

	protected:
		// We have to override this to free our DX resources
		virtual void FreeResources() override
		{
			delete _lightEffectAmbient; _lightEffectAmbient = nullptr;
			delete _lightEffectNoAmbient; _lightEffectNoAmbient = nullptr;
		}

		// And override this to update us correctly
		virtual void UpdateResources() override
		{
			FreeResources();
		}
	public:
		LightShaderHandler(DXAdapter^ adapter, DXEffectBuilder^ effectBuilder, Light^ light, RenderState^ renderState);

		DXEffect^ GetLightEffect(bool renderAmbient);
	};

}