#pragma once

#include "D3D.h"

using namespace System;
using namespace System::Collections::Generic;

using namespace Jade::Resources;

using namespace Pluto::Core;

namespace JadeRenderingDx9 {

	ref class DXAdapter;

	[CompletionStatus(DevelopmentState::Complete)]
	ref class OverlayTextFontHandler: ResourceHandlerBase
	{
	private:
		ID3DXFont* _dxResource;
		OverlayTextFont^ _font;
		DXAdapter^ _adapter;
	protected:
		// We have to override this to free our DX resources
		virtual void FreeResources() override
		{
			FREEDX(_dxResource);
		}

		// And override this to update us correctly
		virtual void UpdateResources() override;

	public:
		OverlayTextFontHandler(DXAdapter^ adapter, OverlayTextFont^ font);

		property ID3DXFont* Resource
		{
			ID3DXFont* get();
		}
	};

}