#include "StdAfx.h"
#include "D3D.h"
#include "PlutoPlugin.h"

namespace JadeRenderingDx9 {

#pragma region D3D Initialization
	void D3D::Initialize()
	{
		if (m_Direct3D == NULL)
		{
			try
			{
				m_Direct3D = Direct3DCreate9( D3D_SDK_VERSION );
			}
			catch( SEHException^ ex )
			{
				throw gcnew ApplicationException( "Direct3D 9 was not found. Reinstalling DirectX may fix the problem.", ex );
			}

			try
			{
				BOOL d3dx = D3DXCheckVersion( D3D_SDK_VERSION, D3DX_SDK_VERSION );
			}
			catch( SEHException^ ex )
			{
				throw gcnew ApplicationException( "Direct3DX 9 was not found. Please install "
					"the latest DirectX end-user redistributable from Microsoft.", ex );
			}

		}

	}

#pragma endregion

#pragma region Plugin Loading

	bool PlutoPlugin::RegisterServices(IPlutoServiceContainer ^serviceContainer)
	{
		D3D::Initialize();

		serviceContainer->AddService<RenderingSystemFactory^>(gcnew DX9FixedFunctionRenderingSystemFactory(this->ServiceProvider), DXFixedFunctionRenderer::RendererName);
		serviceContainer->AddService<RenderingSystemFactory^>(gcnew DX9RenderingSystemFactory(this->ServiceProvider), DXRenderer::RendererName);
		return true;
	}

#pragma endregion

}