#include "StdAfx.h"

#include "DXAdapter.h"
#include "DXUtility.h"
#include "DXEffectBuilder.h"


namespace JadeRenderingDx9 {

	void DXAdapter::CleanupTextSprite()
	{
		FREEDX(this->TextSprite);
	}

	void DXAdapter::InitializeTextSprite()
	{
		this->CleanupTextSprite();

		ID3DXSprite* sprite;
		DXCHECK(D3DXCreateSprite( this->Device, &sprite ));

		TextSprite = sprite;
	}


	void DXAdapter::BeginFontRendering()
	{
		if (TextSprite == NULL)
			throw gcnew InvalidOperationException("The sprite does not exist");

		TextSprite->Begin(D3DXSPRITE_ALPHABLEND | D3DXSPRITE_SORT_TEXTURE);

	}

	/// <summary>
	/// Ends the text rendering
	/// </summary>
	void DXAdapter::EndFontRendering()
	{
		TextSprite->End();
	}


	void DXAdapter::DrawOverlayText(int x, int y, String^ text, OverlayTextFont^ font, Color color)
	{
		ID3DXFont* resource = GetFont(font);

		int rgbcolor = color.ToRGB();
		pin_ptr<const wchar_t> pinned_text = PtrToStringChars( text );

		RECT rect = { x, y, 0, 0 };

		resource->DrawText(this->TextSprite,  (LPCWSTR) pinned_text, text->Length, &rect, DT_NOCLIP, rgbcolor);

	}
}