#pragma once

#include "DXEffect.h"

using namespace System;
using namespace System::Collections::Generic;

using namespace Jade::Rendering;
using namespace Jade::Resources;
using namespace Jade::Entities;

namespace JadeRenderingDx9 {

	ref class DXAdapter;
	ref class DXEffectBuilder;

	ref class SpriteShaderHandler: ResourceHandlerBase
	{
	private:
		RenderState^ _renderState;
		Sprite^ _sprite;
		List<Light^>^ _lights;
		DXEffectBuilder^ _effectBuilder;

		DXEffect^ _spriteEffect;

	protected:
		// We have to override this to free our DX resources
		virtual void FreeResources() override
		{
			delete _spriteEffect;
			_spriteEffect = nullptr;
		}

		// And override this to update us correctly
		virtual void UpdateResources() override
		{
			FreeResources();
		}

	private:
		void OnLight_Disposing(Object^ sender, EventArgs^ e)
		{
			IsValid = false;
			// Clean up our list since our light was being disposed
			UpdateLightList(nullptr);
		}
		void UpdateLightList(IList<TransformedLight^>^ lights);

	public:
		SpriteShaderHandler(DXAdapter^ adapter, DXEffectBuilder^ effectBuilder, SpriteRenderList^ spriteList, RenderState^ renderState);
		virtual ~SpriteShaderHandler(void);

		void Check(IList<TransformedLight^>^ lights);

		DXEffect^ GetSpriteEffect();
	};

}