#pragma once

#include "D3D.h"

using namespace System;
using namespace System::Collections::Generic;

using namespace Jade::Resources;

using namespace Pluto::Core;

namespace JadeRenderingDx9 {

	ref class DXAdapter;

	[CompletionStatus(DevelopmentState::Complete)]
	ref class TextureHandler : ResourceHandlerBase
	{
	private:
		Texture^ _texture;
		IDirect3DBaseTexture9* _dxTexture;
		DXAdapter ^_adapter;

		void CopyTextureToBitmap(Object^ sender, TextureToBitmapEventArgs^ args);

	protected:
		// We have to override this to free our DX resources
		virtual void FreeResources() override
		{
			FREEDX(_dxTexture);
		}

		// And override this to update us correctly
		virtual void UpdateResources() override;
	public:
		TextureHandler(DXAdapter^ adapter, Texture^ texture);
		virtual ~TextureHandler(void);

		property IDirect3DBaseTexture9* DxTexture
		{
			IDirect3DBaseTexture9* get();
		}
	};

}