using System;
using System.Collections.Generic;
using System.Text;

namespace Jade.Core
{
	/// <summary>
	/// Returns a set of pre-defined colors
	/// </summary>
	public static class Colors
	{
		#region Static Properties

    /// <summary>
    /// Returns the color Snow
    /// </summary>
    public static Color Snow
    {
      get { return new Color(1f, 0.9803922f, 0.9803922f, 1f); }
    }


    /// <summary>
    /// Returns the color GhostWhite
    /// </summary>
    public static Color GhostWhite
    {
      get { return new Color(0.972549f, 0.972549f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color WhiteSmoke
    /// </summary>
    public static Color WhiteSmoke
    {
      get { return new Color(0.9607843f, 0.9607843f, 0.9607843f, 1f); }
    }


    /// <summary>
    /// Returns the color Gainsboro
    /// </summary>
    public static Color Gainsboro
    {
      get { return new Color(0.8627451f, 0.8627451f, 0.8627451f, 1f); }
    }


    /// <summary>
    /// Returns the color FloralWhite
    /// </summary>
    public static Color FloralWhite
    {
      get { return new Color(1f, 0.9803922f, 0.9411765f, 1f); }
    }


    /// <summary>
    /// Returns the color OldLace
    /// </summary>
    public static Color OldLace
    {
      get { return new Color(0.9921569f, 0.9607843f, 0.9019608f, 1f); }
    }


    /// <summary>
    /// Returns the color Linen
    /// </summary>
    public static Color Linen
    {
      get { return new Color(0.9803922f, 0.9411765f, 0.9019608f, 1f); }
    }


    /// <summary>
    /// Returns the color AntiqueWhite
    /// </summary>
    public static Color AntiqueWhite
    {
      get { return new Color(0.9803922f, 0.9215686f, 0.8431373f, 1f); }
    }


    /// <summary>
    /// Returns the color PapayaWhip
    /// </summary>
    public static Color PapayaWhip
    {
      get { return new Color(1f, 0.9372549f, 0.8352941f, 1f); }
    }


    /// <summary>
    /// Returns the color BlanchedAlmond
    /// </summary>
    public static Color BlanchedAlmond
    {
      get { return new Color(1f, 0.9215686f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color Bisque
    /// </summary>
    public static Color Bisque
    {
      get { return new Color(1f, 0.8941177f, 0.7686275f, 1f); }
    }


    /// <summary>
    /// Returns the color PeachPuff
    /// </summary>
    public static Color PeachPuff
    {
      get { return new Color(1f, 0.854902f, 0.7254902f, 1f); }
    }


    /// <summary>
    /// Returns the color NavajoWhite
    /// </summary>
    public static Color NavajoWhite
    {
      get { return new Color(1f, 0.8705882f, 0.6784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Moccasin
    /// </summary>
    public static Color Moccasin
    {
      get { return new Color(1f, 0.8941177f, 0.7098039f, 1f); }
    }


    /// <summary>
    /// Returns the color Cornsilk
    /// </summary>
    public static Color Cornsilk
    {
      get { return new Color(1f, 0.972549f, 0.8627451f, 1f); }
    }


    /// <summary>
    /// Returns the color Ivory
    /// </summary>
    public static Color Ivory
    {
      get { return new Color(1f, 1f, 0.9411765f, 1f); }
    }


    /// <summary>
    /// Returns the color LemonChiffon
    /// </summary>
    public static Color LemonChiffon
    {
      get { return new Color(1f, 0.9803922f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color Seashell
    /// </summary>
    public static Color Seashell
    {
      get { return new Color(1f, 0.9607843f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color Honeydew
    /// </summary>
    public static Color Honeydew
    {
      get { return new Color(0.9411765f, 1f, 0.9411765f, 1f); }
    }


    /// <summary>
    /// Returns the color MintCream
    /// </summary>
    public static Color MintCream
    {
      get { return new Color(0.9607843f, 1f, 0.9803922f, 1f); }
    }


    /// <summary>
    /// Returns the color Azure
    /// </summary>
    public static Color Azure
    {
      get { return new Color(0.9411765f, 1f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color AliceBlue
    /// </summary>
    public static Color AliceBlue
    {
      get { return new Color(0.9411765f, 0.972549f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color Lavender
    /// </summary>
    public static Color Lavender
    {
      get { return new Color(0.9019608f, 0.9019608f, 0.9803922f, 1f); }
    }


    /// <summary>
    /// Returns the color LavenderBlush
    /// </summary>
    public static Color LavenderBlush
    {
      get { return new Color(1f, 0.9411765f, 0.9607843f, 1f); }
    }


    /// <summary>
    /// Returns the color MistyRose
    /// </summary>
    public static Color MistyRose
    {
      get { return new Color(1f, 0.8941177f, 0.8823529f, 1f); }
    }


    /// <summary>
    /// Returns the color White
    /// </summary>
    public static Color White
    {
      get { return new Color(1f, 1f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color Black
    /// </summary>
    public static Color Black
    {
      get { return new Color(0f, 0f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkSlateGray
    /// </summary>
    public static Color DarkSlateGray
    {
      get { return new Color(0.1843137f, 0.3098039f, 0.3098039f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkSlateGrey
    /// </summary>
    public static Color DarkSlateGrey
    {
      get { return new Color(0.1843137f, 0.3098039f, 0.3098039f, 1f); }
    }


    /// <summary>
    /// Returns the color DimGray
    /// </summary>
    public static Color DimGray
    {
      get { return new Color(0.4117647f, 0.4117647f, 0.4117647f, 1f); }
    }


    /// <summary>
    /// Returns the color DimGrey
    /// </summary>
    public static Color DimGrey
    {
      get { return new Color(0.4117647f, 0.4117647f, 0.4117647f, 1f); }
    }


    /// <summary>
    /// Returns the color SlateGray
    /// </summary>
    public static Color SlateGray
    {
      get { return new Color(0.4392157f, 0.5019608f, 0.5647059f, 1f); }
    }


    /// <summary>
    /// Returns the color SlateGrey
    /// </summary>
    public static Color SlateGrey
    {
      get { return new Color(0.4392157f, 0.5019608f, 0.5647059f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSlateGray
    /// </summary>
    public static Color LightSlateGray
    {
      get { return new Color(0.4666667f, 0.5333334f, 0.6f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSlateGrey
    /// </summary>
    public static Color LightSlateGrey
    {
      get { return new Color(0.4666667f, 0.5333334f, 0.6f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray
    /// </summary>
    public static Color Gray
    {
      get { return new Color(0.7450981f, 0.7450981f, 0.7450981f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey
    /// </summary>
    public static Color Grey
    {
      get { return new Color(0.7450981f, 0.7450981f, 0.7450981f, 1f); }
    }


    /// <summary>
    /// Returns the color LightGrey
    /// </summary>
    public static Color LightGrey
    {
      get { return new Color(0.827451f, 0.827451f, 0.827451f, 1f); }
    }


    /// <summary>
    /// Returns the color LightGray
    /// </summary>
    public static Color LightGray
    {
      get { return new Color(0.827451f, 0.827451f, 0.827451f, 1f); }
    }


    /// <summary>
    /// Returns the color MidnightBlue
    /// </summary>
    public static Color MidnightBlue
    {
      get { return new Color(0.09803922f, 0.09803922f, 0.4392157f, 1f); }
    }


    /// <summary>
    /// Returns the color Navy
    /// </summary>
    public static Color Navy
    {
      get { return new Color(0f, 0f, 0.5019608f, 1f); }
    }


    /// <summary>
    /// Returns the color NavyBlue
    /// </summary>
    public static Color NavyBlue
    {
      get { return new Color(0f, 0f, 0.5019608f, 1f); }
    }


    /// <summary>
    /// Returns the color CornflowerBlue
    /// </summary>
    public static Color CornflowerBlue
    {
      get { return new Color(0.3921569f, 0.5843138f, 0.9294118f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkSlateBlue
    /// </summary>
    public static Color DarkSlateBlue
    {
      get { return new Color(0.282353f, 0.2392157f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color SlateBlue
    /// </summary>
    public static Color SlateBlue
    {
      get { return new Color(0.4156863f, 0.3529412f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumSlateBlue
    /// </summary>
    public static Color MediumSlateBlue
    {
      get { return new Color(0.4823529f, 0.4078431f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSlateBlue
    /// </summary>
    public static Color LightSlateBlue
    {
      get { return new Color(0.5176471f, 0.4392157f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumBlue
    /// </summary>
    public static Color MediumBlue
    {
      get { return new Color(0f, 0f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color RoyalBlue
    /// </summary>
    public static Color RoyalBlue
    {
      get { return new Color(0.254902f, 0.4117647f, 0.8823529f, 1f); }
    }


    /// <summary>
    /// Returns the color Blue
    /// </summary>
    public static Color Blue
    {
      get { return new Color(0f, 0f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color DodgerBlue
    /// </summary>
    public static Color DodgerBlue
    {
      get { return new Color(0.1176471f, 0.5647059f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color DeepSkyBlue
    /// </summary>
    public static Color DeepSkyBlue
    {
      get { return new Color(0f, 0.7490196f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color SkyBlue
    /// </summary>
    public static Color SkyBlue
    {
      get { return new Color(0.5294118f, 0.8078431f, 0.9215686f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSkyBlue
    /// </summary>
    public static Color LightSkyBlue
    {
      get { return new Color(0.5294118f, 0.8078431f, 0.9803922f, 1f); }
    }


    /// <summary>
    /// Returns the color SteelBlue
    /// </summary>
    public static Color SteelBlue
    {
      get { return new Color(0.2745098f, 0.509804f, 0.7058824f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSteelBlue
    /// </summary>
    public static Color LightSteelBlue
    {
      get { return new Color(0.6901961f, 0.7686275f, 0.8705882f, 1f); }
    }


    /// <summary>
    /// Returns the color LightBlue
    /// </summary>
    public static Color LightBlue
    {
      get { return new Color(0.6784314f, 0.8470588f, 0.9019608f, 1f); }
    }


    /// <summary>
    /// Returns the color PowderBlue
    /// </summary>
    public static Color PowderBlue
    {
      get { return new Color(0.6901961f, 0.8784314f, 0.9019608f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleTurquoise
    /// </summary>
    public static Color PaleTurquoise
    {
      get { return new Color(0.6862745f, 0.9333333f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkTurquoise
    /// </summary>
    public static Color DarkTurquoise
    {
      get { return new Color(0f, 0.8078431f, 0.8196079f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumTurquoise
    /// </summary>
    public static Color MediumTurquoise
    {
      get { return new Color(0.282353f, 0.8196079f, 0.8f, 1f); }
    }


    /// <summary>
    /// Returns the color Turquoise
    /// </summary>
    public static Color Turquoise
    {
      get { return new Color(0.2509804f, 0.8784314f, 0.8156863f, 1f); }
    }


    /// <summary>
    /// Returns the color Cyan
    /// </summary>
    public static Color Cyan
    {
      get { return new Color(0f, 1f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color LightCyan
    /// </summary>
    public static Color LightCyan
    {
      get { return new Color(0.8784314f, 1f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color CadetBlue
    /// </summary>
    public static Color CadetBlue
    {
      get { return new Color(0.372549f, 0.6196079f, 0.627451f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumAquamarine
    /// </summary>
    public static Color MediumAquamarine
    {
      get { return new Color(0.4f, 0.8039216f, 0.6666667f, 1f); }
    }


    /// <summary>
    /// Returns the color Aquamarine
    /// </summary>
    public static Color Aquamarine
    {
      get { return new Color(0.4980392f, 1f, 0.8313726f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkGreen
    /// </summary>
    public static Color DarkGreen
    {
      get { return new Color(0f, 0.3921569f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkOliveGreen
    /// </summary>
    public static Color DarkOliveGreen
    {
      get { return new Color(0.3333333f, 0.4196078f, 0.1843137f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkSeaGreen
    /// </summary>
    public static Color DarkSeaGreen
    {
      get { return new Color(0.5607843f, 0.7372549f, 0.5607843f, 1f); }
    }


    /// <summary>
    /// Returns the color SeaGreen
    /// </summary>
    public static Color SeaGreen
    {
      get { return new Color(0.1803922f, 0.5450981f, 0.3411765f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumSeaGreen
    /// </summary>
    public static Color MediumSeaGreen
    {
      get { return new Color(0.2352941f, 0.7019608f, 0.4431373f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSeaGreen
    /// </summary>
    public static Color LightSeaGreen
    {
      get { return new Color(0.1254902f, 0.6980392f, 0.6666667f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleGreen
    /// </summary>
    public static Color PaleGreen
    {
      get { return new Color(0.5960785f, 0.9843137f, 0.5960785f, 1f); }
    }


    /// <summary>
    /// Returns the color SpringGreen
    /// </summary>
    public static Color SpringGreen
    {
      get { return new Color(0f, 1f, 0.4980392f, 1f); }
    }


    /// <summary>
    /// Returns the color LawnGreen
    /// </summary>
    public static Color LawnGreen
    {
      get { return new Color(0.4862745f, 0.9882353f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Green
    /// </summary>
    public static Color Green
    {
      get { return new Color(0f, 1f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Chartreuse
    /// </summary>
    public static Color Chartreuse
    {
      get { return new Color(0.4980392f, 1f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumSpringGreen
    /// </summary>
    public static Color MediumSpringGreen
    {
      get { return new Color(0f, 0.9803922f, 0.6039216f, 1f); }
    }


    /// <summary>
    /// Returns the color GreenYellow
    /// </summary>
    public static Color GreenYellow
    {
      get { return new Color(0.6784314f, 1f, 0.1843137f, 1f); }
    }


    /// <summary>
    /// Returns the color LimeGreen
    /// </summary>
    public static Color LimeGreen
    {
      get { return new Color(0.1960784f, 0.8039216f, 0.1960784f, 1f); }
    }


    /// <summary>
    /// Returns the color YellowGreen
    /// </summary>
    public static Color YellowGreen
    {
      get { return new Color(0.6039216f, 0.8039216f, 0.1960784f, 1f); }
    }


    /// <summary>
    /// Returns the color ForestGreen
    /// </summary>
    public static Color ForestGreen
    {
      get { return new Color(0.1333333f, 0.5450981f, 0.1333333f, 1f); }
    }


    /// <summary>
    /// Returns the color OliveDrab
    /// </summary>
    public static Color OliveDrab
    {
      get { return new Color(0.4196078f, 0.5568628f, 0.1372549f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkKhaki
    /// </summary>
    public static Color DarkKhaki
    {
      get { return new Color(0.7411765f, 0.7176471f, 0.4196078f, 1f); }
    }


    /// <summary>
    /// Returns the color Khaki
    /// </summary>
    public static Color Khaki
    {
      get { return new Color(0.9411765f, 0.9019608f, 0.5490196f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleGoldenrod
    /// </summary>
    public static Color PaleGoldenrod
    {
      get { return new Color(0.9333333f, 0.9098039f, 0.6666667f, 1f); }
    }


    /// <summary>
    /// Returns the color LightGoldenrodYellow
    /// </summary>
    public static Color LightGoldenrodYellow
    {
      get { return new Color(0.9803922f, 0.9803922f, 0.8235294f, 1f); }
    }


    /// <summary>
    /// Returns the color LightYellow
    /// </summary>
    public static Color LightYellow
    {
      get { return new Color(1f, 1f, 0.8784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Yellow
    /// </summary>
    public static Color Yellow
    {
      get { return new Color(1f, 1f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Gold
    /// </summary>
    public static Color Gold
    {
      get { return new Color(1f, 0.8431373f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color LightGoldenrod
    /// </summary>
    public static Color LightGoldenrod
    {
      get { return new Color(0.9333333f, 0.8666667f, 0.509804f, 1f); }
    }


    /// <summary>
    /// Returns the color Goldenrod
    /// </summary>
    public static Color Goldenrod
    {
      get { return new Color(0.854902f, 0.6470588f, 0.1254902f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkGoldenrod
    /// </summary>
    public static Color DarkGoldenrod
    {
      get { return new Color(0.7215686f, 0.5254902f, 0.04313726f, 1f); }
    }


    /// <summary>
    /// Returns the color RosyBrown
    /// </summary>
    public static Color RosyBrown
    {
      get { return new Color(0.7372549f, 0.5607843f, 0.5607843f, 1f); }
    }


    /// <summary>
    /// Returns the color IndianRed
    /// </summary>
    public static Color IndianRed
    {
      get { return new Color(0.8039216f, 0.3607843f, 0.3607843f, 1f); }
    }


    /// <summary>
    /// Returns the color SaddleBrown
    /// </summary>
    public static Color SaddleBrown
    {
      get { return new Color(0.5450981f, 0.2705882f, 0.07450981f, 1f); }
    }


    /// <summary>
    /// Returns the color Sienna
    /// </summary>
    public static Color Sienna
    {
      get { return new Color(0.627451f, 0.3215686f, 0.1764706f, 1f); }
    }


    /// <summary>
    /// Returns the color Peru
    /// </summary>
    public static Color Peru
    {
      get { return new Color(0.8039216f, 0.5215687f, 0.2470588f, 1f); }
    }


    /// <summary>
    /// Returns the color Burlywood
    /// </summary>
    public static Color Burlywood
    {
      get { return new Color(0.8705882f, 0.7215686f, 0.5294118f, 1f); }
    }


    /// <summary>
    /// Returns the color Beige
    /// </summary>
    public static Color Beige
    {
      get { return new Color(0.9607843f, 0.9607843f, 0.8627451f, 1f); }
    }


    /// <summary>
    /// Returns the color Wheat
    /// </summary>
    public static Color Wheat
    {
      get { return new Color(0.9607843f, 0.8705882f, 0.7019608f, 1f); }
    }


    /// <summary>
    /// Returns the color SandyBrown
    /// </summary>
    public static Color SandyBrown
    {
      get { return new Color(0.9568627f, 0.6431373f, 0.3764706f, 1f); }
    }


    /// <summary>
    /// Returns the color Tan
    /// </summary>
    public static Color Tan
    {
      get { return new Color(0.8235294f, 0.7058824f, 0.5490196f, 1f); }
    }


    /// <summary>
    /// Returns the color Chocolate
    /// </summary>
    public static Color Chocolate
    {
      get { return new Color(0.8235294f, 0.4117647f, 0.1176471f, 1f); }
    }


    /// <summary>
    /// Returns the color Firebrick
    /// </summary>
    public static Color Firebrick
    {
      get { return new Color(0.6980392f, 0.1333333f, 0.1333333f, 1f); }
    }


    /// <summary>
    /// Returns the color Brown
    /// </summary>
    public static Color Brown
    {
      get { return new Color(0.6470588f, 0.1647059f, 0.1647059f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkSalmon
    /// </summary>
    public static Color DarkSalmon
    {
      get { return new Color(0.9137255f, 0.5882353f, 0.4784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Salmon
    /// </summary>
    public static Color Salmon
    {
      get { return new Color(0.9803922f, 0.5019608f, 0.4470588f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSalmon
    /// </summary>
    public static Color LightSalmon
    {
      get { return new Color(1f, 0.627451f, 0.4784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Orange
    /// </summary>
    public static Color Orange
    {
      get { return new Color(1f, 0.6470588f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkOrange
    /// </summary>
    public static Color DarkOrange
    {
      get { return new Color(1f, 0.5490196f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Coral
    /// </summary>
    public static Color Coral
    {
      get { return new Color(1f, 0.4980392f, 0.3137255f, 1f); }
    }


    /// <summary>
    /// Returns the color LightCoral
    /// </summary>
    public static Color LightCoral
    {
      get { return new Color(0.9411765f, 0.5019608f, 0.5019608f, 1f); }
    }


    /// <summary>
    /// Returns the color Tomato
    /// </summary>
    public static Color Tomato
    {
      get { return new Color(1f, 0.3882353f, 0.2784314f, 1f); }
    }


    /// <summary>
    /// Returns the color OrangeRed
    /// </summary>
    public static Color OrangeRed
    {
      get { return new Color(1f, 0.2705882f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Red
    /// </summary>
    public static Color Red
    {
      get { return new Color(1f, 0f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color HotPink
    /// </summary>
    public static Color HotPink
    {
      get { return new Color(1f, 0.4117647f, 0.7058824f, 1f); }
    }


    /// <summary>
    /// Returns the color DeepPink
    /// </summary>
    public static Color DeepPink
    {
      get { return new Color(1f, 0.07843138f, 0.5764706f, 1f); }
    }


    /// <summary>
    /// Returns the color Pink
    /// </summary>
    public static Color Pink
    {
      get { return new Color(1f, 0.7529412f, 0.7960784f, 1f); }
    }


    /// <summary>
    /// Returns the color LightPink
    /// </summary>
    public static Color LightPink
    {
      get { return new Color(1f, 0.7137255f, 0.7568628f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleVioletRed
    /// </summary>
    public static Color PaleVioletRed
    {
      get { return new Color(0.8588235f, 0.4392157f, 0.5764706f, 1f); }
    }


    /// <summary>
    /// Returns the color Maroon
    /// </summary>
    public static Color Maroon
    {
      get { return new Color(0.6901961f, 0.1882353f, 0.3764706f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumVioletRed
    /// </summary>
    public static Color MediumVioletRed
    {
      get { return new Color(0.7803922f, 0.08235294f, 0.5215687f, 1f); }
    }


    /// <summary>
    /// Returns the color VioletRed
    /// </summary>
    public static Color VioletRed
    {
      get { return new Color(0.8156863f, 0.1254902f, 0.5647059f, 1f); }
    }


    /// <summary>
    /// Returns the color Magenta
    /// </summary>
    public static Color Magenta
    {
      get { return new Color(1f, 0f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color Violet
    /// </summary>
    public static Color Violet
    {
      get { return new Color(0.9333333f, 0.509804f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color Plum
    /// </summary>
    public static Color Plum
    {
      get { return new Color(0.8666667f, 0.627451f, 0.8666667f, 1f); }
    }


    /// <summary>
    /// Returns the color Orchid
    /// </summary>
    public static Color Orchid
    {
      get { return new Color(0.854902f, 0.4392157f, 0.8392157f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumOrchid
    /// </summary>
    public static Color MediumOrchid
    {
      get { return new Color(0.7294118f, 0.3333333f, 0.827451f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkOrchid
    /// </summary>
    public static Color DarkOrchid
    {
      get { return new Color(0.6f, 0.1960784f, 0.8f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkViolet
    /// </summary>
    public static Color DarkViolet
    {
      get { return new Color(0.5803922f, 0f, 0.827451f, 1f); }
    }


    /// <summary>
    /// Returns the color BlueViolet
    /// </summary>
    public static Color BlueViolet
    {
      get { return new Color(0.5411765f, 0.1686275f, 0.8862745f, 1f); }
    }


    /// <summary>
    /// Returns the color Purple
    /// </summary>
    public static Color Purple
    {
      get { return new Color(0.627451f, 0.1254902f, 0.9411765f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumPurple
    /// </summary>
    public static Color MediumPurple
    {
      get { return new Color(0.5764706f, 0.4392157f, 0.8588235f, 1f); }
    }


    /// <summary>
    /// Returns the color Thistle
    /// </summary>
    public static Color Thistle
    {
      get { return new Color(0.8470588f, 0.7490196f, 0.8470588f, 1f); }
    }


    /// <summary>
    /// Returns the color Snow1
    /// </summary>
    public static Color Snow1
    {
      get { return new Color(1f, 0.9803922f, 0.9803922f, 1f); }
    }


    /// <summary>
    /// Returns the color Snow2
    /// </summary>
    public static Color Snow2
    {
      get { return new Color(0.9333333f, 0.9137255f, 0.9137255f, 1f); }
    }


    /// <summary>
    /// Returns the color Snow3
    /// </summary>
    public static Color Snow3
    {
      get { return new Color(0.8039216f, 0.7882353f, 0.7882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Snow4
    /// </summary>
    public static Color Snow4
    {
      get { return new Color(0.5450981f, 0.5372549f, 0.5372549f, 1f); }
    }


    /// <summary>
    /// Returns the color Seashell1
    /// </summary>
    public static Color Seashell1
    {
      get { return new Color(1f, 0.9607843f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color Seashell2
    /// </summary>
    public static Color Seashell2
    {
      get { return new Color(0.9333333f, 0.8980392f, 0.8705882f, 1f); }
    }


    /// <summary>
    /// Returns the color Seashell3
    /// </summary>
    public static Color Seashell3
    {
      get { return new Color(0.8039216f, 0.772549f, 0.7490196f, 1f); }
    }


    /// <summary>
    /// Returns the color Seashell4
    /// </summary>
    public static Color Seashell4
    {
      get { return new Color(0.5450981f, 0.5254902f, 0.509804f, 1f); }
    }


    /// <summary>
    /// Returns the color AntiqueWhite1
    /// </summary>
    public static Color AntiqueWhite1
    {
      get { return new Color(1f, 0.9372549f, 0.8588235f, 1f); }
    }


    /// <summary>
    /// Returns the color AntiqueWhite2
    /// </summary>
    public static Color AntiqueWhite2
    {
      get { return new Color(0.9333333f, 0.8745098f, 0.8f, 1f); }
    }


    /// <summary>
    /// Returns the color AntiqueWhite3
    /// </summary>
    public static Color AntiqueWhite3
    {
      get { return new Color(0.8039216f, 0.7529412f, 0.6901961f, 1f); }
    }


    /// <summary>
    /// Returns the color AntiqueWhite4
    /// </summary>
    public static Color AntiqueWhite4
    {
      get { return new Color(0.5450981f, 0.5137255f, 0.4705882f, 1f); }
    }


    /// <summary>
    /// Returns the color Bisque1
    /// </summary>
    public static Color Bisque1
    {
      get { return new Color(1f, 0.8941177f, 0.7686275f, 1f); }
    }


    /// <summary>
    /// Returns the color Bisque2
    /// </summary>
    public static Color Bisque2
    {
      get { return new Color(0.9333333f, 0.8352941f, 0.7176471f, 1f); }
    }


    /// <summary>
    /// Returns the color Bisque3
    /// </summary>
    public static Color Bisque3
    {
      get { return new Color(0.8039216f, 0.7176471f, 0.6196079f, 1f); }
    }


    /// <summary>
    /// Returns the color Bisque4
    /// </summary>
    public static Color Bisque4
    {
      get { return new Color(0.5450981f, 0.4901961f, 0.4196078f, 1f); }
    }


    /// <summary>
    /// Returns the color PeachPuff1
    /// </summary>
    public static Color PeachPuff1
    {
      get { return new Color(1f, 0.854902f, 0.7254902f, 1f); }
    }


    /// <summary>
    /// Returns the color PeachPuff2
    /// </summary>
    public static Color PeachPuff2
    {
      get { return new Color(0.9333333f, 0.7960784f, 0.6784314f, 1f); }
    }


    /// <summary>
    /// Returns the color PeachPuff3
    /// </summary>
    public static Color PeachPuff3
    {
      get { return new Color(0.8039216f, 0.6862745f, 0.5843138f, 1f); }
    }


    /// <summary>
    /// Returns the color PeachPuff4
    /// </summary>
    public static Color PeachPuff4
    {
      get { return new Color(0.5450981f, 0.4666667f, 0.3960784f, 1f); }
    }


    /// <summary>
    /// Returns the color NavajoWhite1
    /// </summary>
    public static Color NavajoWhite1
    {
      get { return new Color(1f, 0.8705882f, 0.6784314f, 1f); }
    }


    /// <summary>
    /// Returns the color NavajoWhite2
    /// </summary>
    public static Color NavajoWhite2
    {
      get { return new Color(0.9333333f, 0.8117647f, 0.6313726f, 1f); }
    }


    /// <summary>
    /// Returns the color NavajoWhite3
    /// </summary>
    public static Color NavajoWhite3
    {
      get { return new Color(0.8039216f, 0.7019608f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color NavajoWhite4
    /// </summary>
    public static Color NavajoWhite4
    {
      get { return new Color(0.5450981f, 0.4745098f, 0.3686275f, 1f); }
    }


    /// <summary>
    /// Returns the color LemonChiffon1
    /// </summary>
    public static Color LemonChiffon1
    {
      get { return new Color(1f, 0.9803922f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color LemonChiffon2
    /// </summary>
    public static Color LemonChiffon2
    {
      get { return new Color(0.9333333f, 0.9137255f, 0.7490196f, 1f); }
    }


    /// <summary>
    /// Returns the color LemonChiffon3
    /// </summary>
    public static Color LemonChiffon3
    {
      get { return new Color(0.8039216f, 0.7882353f, 0.6470588f, 1f); }
    }


    /// <summary>
    /// Returns the color LemonChiffon4
    /// </summary>
    public static Color LemonChiffon4
    {
      get { return new Color(0.5450981f, 0.5372549f, 0.4392157f, 1f); }
    }


    /// <summary>
    /// Returns the color Cornsilk1
    /// </summary>
    public static Color Cornsilk1
    {
      get { return new Color(1f, 0.972549f, 0.8627451f, 1f); }
    }


    /// <summary>
    /// Returns the color Cornsilk2
    /// </summary>
    public static Color Cornsilk2
    {
      get { return new Color(0.9333333f, 0.9098039f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color Cornsilk3
    /// </summary>
    public static Color Cornsilk3
    {
      get { return new Color(0.8039216f, 0.7843137f, 0.6941177f, 1f); }
    }


    /// <summary>
    /// Returns the color Cornsilk4
    /// </summary>
    public static Color Cornsilk4
    {
      get { return new Color(0.5450981f, 0.5333334f, 0.4705882f, 1f); }
    }


    /// <summary>
    /// Returns the color Ivory1
    /// </summary>
    public static Color Ivory1
    {
      get { return new Color(1f, 1f, 0.9411765f, 1f); }
    }


    /// <summary>
    /// Returns the color Ivory2
    /// </summary>
    public static Color Ivory2
    {
      get { return new Color(0.9333333f, 0.9333333f, 0.8784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Ivory3
    /// </summary>
    public static Color Ivory3
    {
      get { return new Color(0.8039216f, 0.8039216f, 0.7568628f, 1f); }
    }


    /// <summary>
    /// Returns the color Ivory4
    /// </summary>
    public static Color Ivory4
    {
      get { return new Color(0.5450981f, 0.5450981f, 0.5137255f, 1f); }
    }


    /// <summary>
    /// Returns the color Honeydew1
    /// </summary>
    public static Color Honeydew1
    {
      get { return new Color(0.9411765f, 1f, 0.9411765f, 1f); }
    }


    /// <summary>
    /// Returns the color Honeydew2
    /// </summary>
    public static Color Honeydew2
    {
      get { return new Color(0.8784314f, 0.9333333f, 0.8784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Honeydew3
    /// </summary>
    public static Color Honeydew3
    {
      get { return new Color(0.7568628f, 0.8039216f, 0.7568628f, 1f); }
    }


    /// <summary>
    /// Returns the color Honeydew4
    /// </summary>
    public static Color Honeydew4
    {
      get { return new Color(0.5137255f, 0.5450981f, 0.5137255f, 1f); }
    }


    /// <summary>
    /// Returns the color LavenderBlush1
    /// </summary>
    public static Color LavenderBlush1
    {
      get { return new Color(1f, 0.9411765f, 0.9607843f, 1f); }
    }


    /// <summary>
    /// Returns the color LavenderBlush2
    /// </summary>
    public static Color LavenderBlush2
    {
      get { return new Color(0.9333333f, 0.8784314f, 0.8980392f, 1f); }
    }


    /// <summary>
    /// Returns the color LavenderBlush3
    /// </summary>
    public static Color LavenderBlush3
    {
      get { return new Color(0.8039216f, 0.7568628f, 0.772549f, 1f); }
    }


    /// <summary>
    /// Returns the color LavenderBlush4
    /// </summary>
    public static Color LavenderBlush4
    {
      get { return new Color(0.5450981f, 0.5137255f, 0.5254902f, 1f); }
    }


    /// <summary>
    /// Returns the color MistyRose1
    /// </summary>
    public static Color MistyRose1
    {
      get { return new Color(1f, 0.8941177f, 0.8823529f, 1f); }
    }


    /// <summary>
    /// Returns the color MistyRose2
    /// </summary>
    public static Color MistyRose2
    {
      get { return new Color(0.9333333f, 0.8352941f, 0.8235294f, 1f); }
    }


    /// <summary>
    /// Returns the color MistyRose3
    /// </summary>
    public static Color MistyRose3
    {
      get { return new Color(0.8039216f, 0.7176471f, 0.7098039f, 1f); }
    }


    /// <summary>
    /// Returns the color MistyRose4
    /// </summary>
    public static Color MistyRose4
    {
      get { return new Color(0.5450981f, 0.4901961f, 0.4823529f, 1f); }
    }


    /// <summary>
    /// Returns the color Azure1
    /// </summary>
    public static Color Azure1
    {
      get { return new Color(0.9411765f, 1f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color Azure2
    /// </summary>
    public static Color Azure2
    {
      get { return new Color(0.8784314f, 0.9333333f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color Azure3
    /// </summary>
    public static Color Azure3
    {
      get { return new Color(0.7568628f, 0.8039216f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color Azure4
    /// </summary>
    public static Color Azure4
    {
      get { return new Color(0.5137255f, 0.5450981f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color SlateBlue1
    /// </summary>
    public static Color SlateBlue1
    {
      get { return new Color(0.5137255f, 0.4352941f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color SlateBlue2
    /// </summary>
    public static Color SlateBlue2
    {
      get { return new Color(0.4784314f, 0.4039216f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color SlateBlue3
    /// </summary>
    public static Color SlateBlue3
    {
      get { return new Color(0.4117647f, 0.3490196f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color SlateBlue4
    /// </summary>
    public static Color SlateBlue4
    {
      get { return new Color(0.2784314f, 0.2352941f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color RoyalBlue1
    /// </summary>
    public static Color RoyalBlue1
    {
      get { return new Color(0.282353f, 0.4627451f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color RoyalBlue2
    /// </summary>
    public static Color RoyalBlue2
    {
      get { return new Color(0.2627451f, 0.4313726f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color RoyalBlue3
    /// </summary>
    public static Color RoyalBlue3
    {
      get { return new Color(0.227451f, 0.372549f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color RoyalBlue4
    /// </summary>
    public static Color RoyalBlue4
    {
      get { return new Color(0.1529412f, 0.2509804f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color Blue1
    /// </summary>
    public static Color Blue1
    {
      get { return new Color(0f, 0f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color Blue2
    /// </summary>
    public static Color Blue2
    {
      get { return new Color(0f, 0f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color Blue3
    /// </summary>
    public static Color Blue3
    {
      get { return new Color(0f, 0f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color Blue4
    /// </summary>
    public static Color Blue4
    {
      get { return new Color(0f, 0f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color DodgerBlue1
    /// </summary>
    public static Color DodgerBlue1
    {
      get { return new Color(0.1176471f, 0.5647059f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color DodgerBlue2
    /// </summary>
    public static Color DodgerBlue2
    {
      get { return new Color(0.1098039f, 0.5254902f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color DodgerBlue3
    /// </summary>
    public static Color DodgerBlue3
    {
      get { return new Color(0.09411765f, 0.454902f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color DodgerBlue4
    /// </summary>
    public static Color DodgerBlue4
    {
      get { return new Color(0.0627451f, 0.3058824f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color SteelBlue1
    /// </summary>
    public static Color SteelBlue1
    {
      get { return new Color(0.3882353f, 0.7215686f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color SteelBlue2
    /// </summary>
    public static Color SteelBlue2
    {
      get { return new Color(0.3607843f, 0.6745098f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color SteelBlue3
    /// </summary>
    public static Color SteelBlue3
    {
      get { return new Color(0.3098039f, 0.5803922f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color SteelBlue4
    /// </summary>
    public static Color SteelBlue4
    {
      get { return new Color(0.2117647f, 0.3921569f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color DeepSkyBlue1
    /// </summary>
    public static Color DeepSkyBlue1
    {
      get { return new Color(0f, 0.7490196f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color DeepSkyBlue2
    /// </summary>
    public static Color DeepSkyBlue2
    {
      get { return new Color(0f, 0.6980392f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color DeepSkyBlue3
    /// </summary>
    public static Color DeepSkyBlue3
    {
      get { return new Color(0f, 0.6039216f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color DeepSkyBlue4
    /// </summary>
    public static Color DeepSkyBlue4
    {
      get { return new Color(0f, 0.4078431f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color SkyBlue1
    /// </summary>
    public static Color SkyBlue1
    {
      get { return new Color(0.5294118f, 0.8078431f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color SkyBlue2
    /// </summary>
    public static Color SkyBlue2
    {
      get { return new Color(0.4941176f, 0.7529412f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color SkyBlue3
    /// </summary>
    public static Color SkyBlue3
    {
      get { return new Color(0.4235294f, 0.6509804f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color SkyBlue4
    /// </summary>
    public static Color SkyBlue4
    {
      get { return new Color(0.2901961f, 0.4392157f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSkyBlue1
    /// </summary>
    public static Color LightSkyBlue1
    {
      get { return new Color(0.6901961f, 0.8862745f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSkyBlue2
    /// </summary>
    public static Color LightSkyBlue2
    {
      get { return new Color(0.6431373f, 0.827451f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSkyBlue3
    /// </summary>
    public static Color LightSkyBlue3
    {
      get { return new Color(0.5529412f, 0.7137255f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSkyBlue4
    /// </summary>
    public static Color LightSkyBlue4
    {
      get { return new Color(0.3764706f, 0.4823529f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color SlateGray1
    /// </summary>
    public static Color SlateGray1
    {
      get { return new Color(0.7764706f, 0.8862745f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color SlateGray2
    /// </summary>
    public static Color SlateGray2
    {
      get { return new Color(0.7254902f, 0.827451f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color SlateGray3
    /// </summary>
    public static Color SlateGray3
    {
      get { return new Color(0.6235294f, 0.7137255f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color SlateGray4
    /// </summary>
    public static Color SlateGray4
    {
      get { return new Color(0.4235294f, 0.4823529f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSteelBlue1
    /// </summary>
    public static Color LightSteelBlue1
    {
      get { return new Color(0.7921569f, 0.8823529f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSteelBlue2
    /// </summary>
    public static Color LightSteelBlue2
    {
      get { return new Color(0.7372549f, 0.8235294f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSteelBlue3
    /// </summary>
    public static Color LightSteelBlue3
    {
      get { return new Color(0.6352941f, 0.7098039f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSteelBlue4
    /// </summary>
    public static Color LightSteelBlue4
    {
      get { return new Color(0.4313726f, 0.4823529f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color LightBlue1
    /// </summary>
    public static Color LightBlue1
    {
      get { return new Color(0.7490196f, 0.9372549f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color LightBlue2
    /// </summary>
    public static Color LightBlue2
    {
      get { return new Color(0.6980392f, 0.8745098f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color LightBlue3
    /// </summary>
    public static Color LightBlue3
    {
      get { return new Color(0.6039216f, 0.7529412f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color LightBlue4
    /// </summary>
    public static Color LightBlue4
    {
      get { return new Color(0.4078431f, 0.5137255f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color LightCyan1
    /// </summary>
    public static Color LightCyan1
    {
      get { return new Color(0.8784314f, 1f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color LightCyan2
    /// </summary>
    public static Color LightCyan2
    {
      get { return new Color(0.8196079f, 0.9333333f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color LightCyan3
    /// </summary>
    public static Color LightCyan3
    {
      get { return new Color(0.7058824f, 0.8039216f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color LightCyan4
    /// </summary>
    public static Color LightCyan4
    {
      get { return new Color(0.4784314f, 0.5450981f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleTurquoise1
    /// </summary>
    public static Color PaleTurquoise1
    {
      get { return new Color(0.7333333f, 1f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleTurquoise2
    /// </summary>
    public static Color PaleTurquoise2
    {
      get { return new Color(0.682353f, 0.9333333f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleTurquoise3
    /// </summary>
    public static Color PaleTurquoise3
    {
      get { return new Color(0.5882353f, 0.8039216f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleTurquoise4
    /// </summary>
    public static Color PaleTurquoise4
    {
      get { return new Color(0.4f, 0.5450981f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color CadetBlue1
    /// </summary>
    public static Color CadetBlue1
    {
      get { return new Color(0.5960785f, 0.9607843f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color CadetBlue2
    /// </summary>
    public static Color CadetBlue2
    {
      get { return new Color(0.5568628f, 0.8980392f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color CadetBlue3
    /// </summary>
    public static Color CadetBlue3
    {
      get { return new Color(0.4784314f, 0.772549f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color CadetBlue4
    /// </summary>
    public static Color CadetBlue4
    {
      get { return new Color(0.3254902f, 0.5254902f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color Turquoise1
    /// </summary>
    public static Color Turquoise1
    {
      get { return new Color(0f, 0.9607843f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color Turquoise2
    /// </summary>
    public static Color Turquoise2
    {
      get { return new Color(0f, 0.8980392f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color Turquoise3
    /// </summary>
    public static Color Turquoise3
    {
      get { return new Color(0f, 0.772549f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color Turquoise4
    /// </summary>
    public static Color Turquoise4
    {
      get { return new Color(0f, 0.5254902f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color Cyan1
    /// </summary>
    public static Color Cyan1
    {
      get { return new Color(0f, 1f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color Cyan2
    /// </summary>
    public static Color Cyan2
    {
      get { return new Color(0f, 0.9333333f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color Cyan3
    /// </summary>
    public static Color Cyan3
    {
      get { return new Color(0f, 0.8039216f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color Cyan4
    /// </summary>
    public static Color Cyan4
    {
      get { return new Color(0f, 0.5450981f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkSlateGray1
    /// </summary>
    public static Color DarkSlateGray1
    {
      get { return new Color(0.5921569f, 1f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkSlateGray2
    /// </summary>
    public static Color DarkSlateGray2
    {
      get { return new Color(0.5529412f, 0.9333333f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkSlateGray3
    /// </summary>
    public static Color DarkSlateGray3
    {
      get { return new Color(0.4745098f, 0.8039216f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkSlateGray4
    /// </summary>
    public static Color DarkSlateGray4
    {
      get { return new Color(0.3215686f, 0.5450981f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color Aquamarine1
    /// </summary>
    public static Color Aquamarine1
    {
      get { return new Color(0.4980392f, 1f, 0.8313726f, 1f); }
    }


    /// <summary>
    /// Returns the color Aquamarine2
    /// </summary>
    public static Color Aquamarine2
    {
      get { return new Color(0.4627451f, 0.9333333f, 0.7764706f, 1f); }
    }


    /// <summary>
    /// Returns the color Aquamarine3
    /// </summary>
    public static Color Aquamarine3
    {
      get { return new Color(0.4f, 0.8039216f, 0.6666667f, 1f); }
    }


    /// <summary>
    /// Returns the color Aquamarine4
    /// </summary>
    public static Color Aquamarine4
    {
      get { return new Color(0.2705882f, 0.5450981f, 0.454902f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkSeaGreen1
    /// </summary>
    public static Color DarkSeaGreen1
    {
      get { return new Color(0.7568628f, 1f, 0.7568628f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkSeaGreen2
    /// </summary>
    public static Color DarkSeaGreen2
    {
      get { return new Color(0.7058824f, 0.9333333f, 0.7058824f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkSeaGreen3
    /// </summary>
    public static Color DarkSeaGreen3
    {
      get { return new Color(0.6078432f, 0.8039216f, 0.6078432f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkSeaGreen4
    /// </summary>
    public static Color DarkSeaGreen4
    {
      get { return new Color(0.4117647f, 0.5450981f, 0.4117647f, 1f); }
    }


    /// <summary>
    /// Returns the color SeaGreen1
    /// </summary>
    public static Color SeaGreen1
    {
      get { return new Color(0.3294118f, 1f, 0.6235294f, 1f); }
    }


    /// <summary>
    /// Returns the color SeaGreen2
    /// </summary>
    public static Color SeaGreen2
    {
      get { return new Color(0.3058824f, 0.9333333f, 0.5803922f, 1f); }
    }


    /// <summary>
    /// Returns the color SeaGreen3
    /// </summary>
    public static Color SeaGreen3
    {
      get { return new Color(0.2627451f, 0.8039216f, 0.5019608f, 1f); }
    }


    /// <summary>
    /// Returns the color SeaGreen4
    /// </summary>
    public static Color SeaGreen4
    {
      get { return new Color(0.1803922f, 0.5450981f, 0.3411765f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleGreen1
    /// </summary>
    public static Color PaleGreen1
    {
      get { return new Color(0.6039216f, 1f, 0.6039216f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleGreen2
    /// </summary>
    public static Color PaleGreen2
    {
      get { return new Color(0.5647059f, 0.9333333f, 0.5647059f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleGreen3
    /// </summary>
    public static Color PaleGreen3
    {
      get { return new Color(0.4862745f, 0.8039216f, 0.4862745f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleGreen4
    /// </summary>
    public static Color PaleGreen4
    {
      get { return new Color(0.3294118f, 0.5450981f, 0.3294118f, 1f); }
    }


    /// <summary>
    /// Returns the color SpringGreen1
    /// </summary>
    public static Color SpringGreen1
    {
      get { return new Color(0f, 1f, 0.4980392f, 1f); }
    }


    /// <summary>
    /// Returns the color SpringGreen2
    /// </summary>
    public static Color SpringGreen2
    {
      get { return new Color(0f, 0.9333333f, 0.4627451f, 1f); }
    }


    /// <summary>
    /// Returns the color SpringGreen3
    /// </summary>
    public static Color SpringGreen3
    {
      get { return new Color(0f, 0.8039216f, 0.4f, 1f); }
    }


    /// <summary>
    /// Returns the color SpringGreen4
    /// </summary>
    public static Color SpringGreen4
    {
      get { return new Color(0f, 0.5450981f, 0.2705882f, 1f); }
    }


    /// <summary>
    /// Returns the color Green1
    /// </summary>
    public static Color Green1
    {
      get { return new Color(0f, 1f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Green2
    /// </summary>
    public static Color Green2
    {
      get { return new Color(0f, 0.9333333f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Green3
    /// </summary>
    public static Color Green3
    {
      get { return new Color(0f, 0.8039216f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Green4
    /// </summary>
    public static Color Green4
    {
      get { return new Color(0f, 0.5450981f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Chartreuse1
    /// </summary>
    public static Color Chartreuse1
    {
      get { return new Color(0.4980392f, 1f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Chartreuse2
    /// </summary>
    public static Color Chartreuse2
    {
      get { return new Color(0.4627451f, 0.9333333f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Chartreuse3
    /// </summary>
    public static Color Chartreuse3
    {
      get { return new Color(0.4f, 0.8039216f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Chartreuse4
    /// </summary>
    public static Color Chartreuse4
    {
      get { return new Color(0.2705882f, 0.5450981f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color OliveDrab1
    /// </summary>
    public static Color OliveDrab1
    {
      get { return new Color(0.7529412f, 1f, 0.2431373f, 1f); }
    }


    /// <summary>
    /// Returns the color OliveDrab2
    /// </summary>
    public static Color OliveDrab2
    {
      get { return new Color(0.7019608f, 0.9333333f, 0.227451f, 1f); }
    }


    /// <summary>
    /// Returns the color OliveDrab3
    /// </summary>
    public static Color OliveDrab3
    {
      get { return new Color(0.6039216f, 0.8039216f, 0.1960784f, 1f); }
    }


    /// <summary>
    /// Returns the color OliveDrab4
    /// </summary>
    public static Color OliveDrab4
    {
      get { return new Color(0.4117647f, 0.5450981f, 0.1333333f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkOliveGreen1
    /// </summary>
    public static Color DarkOliveGreen1
    {
      get { return new Color(0.7921569f, 1f, 0.4392157f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkOliveGreen2
    /// </summary>
    public static Color DarkOliveGreen2
    {
      get { return new Color(0.7372549f, 0.9333333f, 0.4078431f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkOliveGreen3
    /// </summary>
    public static Color DarkOliveGreen3
    {
      get { return new Color(0.6352941f, 0.8039216f, 0.3529412f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkOliveGreen4
    /// </summary>
    public static Color DarkOliveGreen4
    {
      get { return new Color(0.4313726f, 0.5450981f, 0.2392157f, 1f); }
    }


    /// <summary>
    /// Returns the color Khaki1
    /// </summary>
    public static Color Khaki1
    {
      get { return new Color(1f, 0.9647059f, 0.5607843f, 1f); }
    }


    /// <summary>
    /// Returns the color Khaki2
    /// </summary>
    public static Color Khaki2
    {
      get { return new Color(0.9333333f, 0.9019608f, 0.5215687f, 1f); }
    }


    /// <summary>
    /// Returns the color Khaki3
    /// </summary>
    public static Color Khaki3
    {
      get { return new Color(0.8039216f, 0.7764706f, 0.4509804f, 1f); }
    }


    /// <summary>
    /// Returns the color Khaki4
    /// </summary>
    public static Color Khaki4
    {
      get { return new Color(0.5450981f, 0.5254902f, 0.3058824f, 1f); }
    }


    /// <summary>
    /// Returns the color LightGoldenrod1
    /// </summary>
    public static Color LightGoldenrod1
    {
      get { return new Color(1f, 0.9254902f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color LightGoldenrod2
    /// </summary>
    public static Color LightGoldenrod2
    {
      get { return new Color(0.9333333f, 0.8627451f, 0.509804f, 1f); }
    }


    /// <summary>
    /// Returns the color LightGoldenrod3
    /// </summary>
    public static Color LightGoldenrod3
    {
      get { return new Color(0.8039216f, 0.7450981f, 0.4392157f, 1f); }
    }


    /// <summary>
    /// Returns the color LightGoldenrod4
    /// </summary>
    public static Color LightGoldenrod4
    {
      get { return new Color(0.5450981f, 0.5058824f, 0.2980392f, 1f); }
    }


    /// <summary>
    /// Returns the color LightYellow1
    /// </summary>
    public static Color LightYellow1
    {
      get { return new Color(1f, 1f, 0.8784314f, 1f); }
    }


    /// <summary>
    /// Returns the color LightYellow2
    /// </summary>
    public static Color LightYellow2
    {
      get { return new Color(0.9333333f, 0.9333333f, 0.8196079f, 1f); }
    }


    /// <summary>
    /// Returns the color LightYellow3
    /// </summary>
    public static Color LightYellow3
    {
      get { return new Color(0.8039216f, 0.8039216f, 0.7058824f, 1f); }
    }


    /// <summary>
    /// Returns the color LightYellow4
    /// </summary>
    public static Color LightYellow4
    {
      get { return new Color(0.5450981f, 0.5450981f, 0.4784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Yellow1
    /// </summary>
    public static Color Yellow1
    {
      get { return new Color(1f, 1f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Yellow2
    /// </summary>
    public static Color Yellow2
    {
      get { return new Color(0.9333333f, 0.9333333f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Yellow3
    /// </summary>
    public static Color Yellow3
    {
      get { return new Color(0.8039216f, 0.8039216f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Yellow4
    /// </summary>
    public static Color Yellow4
    {
      get { return new Color(0.5450981f, 0.5450981f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Gold1
    /// </summary>
    public static Color Gold1
    {
      get { return new Color(1f, 0.8431373f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Gold2
    /// </summary>
    public static Color Gold2
    {
      get { return new Color(0.9333333f, 0.7882353f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Gold3
    /// </summary>
    public static Color Gold3
    {
      get { return new Color(0.8039216f, 0.6784314f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Gold4
    /// </summary>
    public static Color Gold4
    {
      get { return new Color(0.5450981f, 0.4588235f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Goldenrod1
    /// </summary>
    public static Color Goldenrod1
    {
      get { return new Color(1f, 0.7568628f, 0.145098f, 1f); }
    }


    /// <summary>
    /// Returns the color Goldenrod2
    /// </summary>
    public static Color Goldenrod2
    {
      get { return new Color(0.9333333f, 0.7058824f, 0.1333333f, 1f); }
    }


    /// <summary>
    /// Returns the color Goldenrod3
    /// </summary>
    public static Color Goldenrod3
    {
      get { return new Color(0.8039216f, 0.6078432f, 0.1137255f, 1f); }
    }


    /// <summary>
    /// Returns the color Goldenrod4
    /// </summary>
    public static Color Goldenrod4
    {
      get { return new Color(0.5450981f, 0.4117647f, 0.07843138f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkGoldenrod1
    /// </summary>
    public static Color DarkGoldenrod1
    {
      get { return new Color(1f, 0.7254902f, 0.05882353f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkGoldenrod2
    /// </summary>
    public static Color DarkGoldenrod2
    {
      get { return new Color(0.9333333f, 0.6784314f, 0.05490196f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkGoldenrod3
    /// </summary>
    public static Color DarkGoldenrod3
    {
      get { return new Color(0.8039216f, 0.5843138f, 0.04705882f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkGoldenrod4
    /// </summary>
    public static Color DarkGoldenrod4
    {
      get { return new Color(0.5450981f, 0.3960784f, 0.03137255f, 1f); }
    }


    /// <summary>
    /// Returns the color RosyBrown1
    /// </summary>
    public static Color RosyBrown1
    {
      get { return new Color(1f, 0.7568628f, 0.7568628f, 1f); }
    }


    /// <summary>
    /// Returns the color RosyBrown2
    /// </summary>
    public static Color RosyBrown2
    {
      get { return new Color(0.9333333f, 0.7058824f, 0.7058824f, 1f); }
    }


    /// <summary>
    /// Returns the color RosyBrown3
    /// </summary>
    public static Color RosyBrown3
    {
      get { return new Color(0.8039216f, 0.6078432f, 0.6078432f, 1f); }
    }


    /// <summary>
    /// Returns the color RosyBrown4
    /// </summary>
    public static Color RosyBrown4
    {
      get { return new Color(0.5450981f, 0.4117647f, 0.4117647f, 1f); }
    }


    /// <summary>
    /// Returns the color IndianRed1
    /// </summary>
    public static Color IndianRed1
    {
      get { return new Color(1f, 0.4156863f, 0.4156863f, 1f); }
    }


    /// <summary>
    /// Returns the color IndianRed2
    /// </summary>
    public static Color IndianRed2
    {
      get { return new Color(0.9333333f, 0.3882353f, 0.3882353f, 1f); }
    }


    /// <summary>
    /// Returns the color IndianRed3
    /// </summary>
    public static Color IndianRed3
    {
      get { return new Color(0.8039216f, 0.3333333f, 0.3333333f, 1f); }
    }


    /// <summary>
    /// Returns the color IndianRed4
    /// </summary>
    public static Color IndianRed4
    {
      get { return new Color(0.5450981f, 0.227451f, 0.227451f, 1f); }
    }


    /// <summary>
    /// Returns the color Sienna1
    /// </summary>
    public static Color Sienna1
    {
      get { return new Color(1f, 0.509804f, 0.2784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Sienna2
    /// </summary>
    public static Color Sienna2
    {
      get { return new Color(0.9333333f, 0.4745098f, 0.2588235f, 1f); }
    }


    /// <summary>
    /// Returns the color Sienna3
    /// </summary>
    public static Color Sienna3
    {
      get { return new Color(0.8039216f, 0.4078431f, 0.2235294f, 1f); }
    }


    /// <summary>
    /// Returns the color Sienna4
    /// </summary>
    public static Color Sienna4
    {
      get { return new Color(0.5450981f, 0.2784314f, 0.1490196f, 1f); }
    }


    /// <summary>
    /// Returns the color Burlywood1
    /// </summary>
    public static Color Burlywood1
    {
      get { return new Color(1f, 0.827451f, 0.6078432f, 1f); }
    }


    /// <summary>
    /// Returns the color Burlywood2
    /// </summary>
    public static Color Burlywood2
    {
      get { return new Color(0.9333333f, 0.772549f, 0.5686275f, 1f); }
    }


    /// <summary>
    /// Returns the color Burlywood3
    /// </summary>
    public static Color Burlywood3
    {
      get { return new Color(0.8039216f, 0.6666667f, 0.4901961f, 1f); }
    }


    /// <summary>
    /// Returns the color Burlywood4
    /// </summary>
    public static Color Burlywood4
    {
      get { return new Color(0.5450981f, 0.4509804f, 0.3333333f, 1f); }
    }


    /// <summary>
    /// Returns the color Wheat1
    /// </summary>
    public static Color Wheat1
    {
      get { return new Color(1f, 0.9058824f, 0.7294118f, 1f); }
    }


    /// <summary>
    /// Returns the color Wheat2
    /// </summary>
    public static Color Wheat2
    {
      get { return new Color(0.9333333f, 0.8470588f, 0.682353f, 1f); }
    }


    /// <summary>
    /// Returns the color Wheat3
    /// </summary>
    public static Color Wheat3
    {
      get { return new Color(0.8039216f, 0.7294118f, 0.5882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Wheat4
    /// </summary>
    public static Color Wheat4
    {
      get { return new Color(0.5450981f, 0.4941176f, 0.4f, 1f); }
    }


    /// <summary>
    /// Returns the color Tan1
    /// </summary>
    public static Color Tan1
    {
      get { return new Color(1f, 0.6470588f, 0.3098039f, 1f); }
    }


    /// <summary>
    /// Returns the color Tan2
    /// </summary>
    public static Color Tan2
    {
      get { return new Color(0.9333333f, 0.6039216f, 0.2862745f, 1f); }
    }


    /// <summary>
    /// Returns the color Tan3
    /// </summary>
    public static Color Tan3
    {
      get { return new Color(0.8039216f, 0.5215687f, 0.2470588f, 1f); }
    }


    /// <summary>
    /// Returns the color Tan4
    /// </summary>
    public static Color Tan4
    {
      get { return new Color(0.5450981f, 0.3529412f, 0.1686275f, 1f); }
    }


    /// <summary>
    /// Returns the color Chocolate1
    /// </summary>
    public static Color Chocolate1
    {
      get { return new Color(1f, 0.4980392f, 0.1411765f, 1f); }
    }


    /// <summary>
    /// Returns the color Chocolate2
    /// </summary>
    public static Color Chocolate2
    {
      get { return new Color(0.9333333f, 0.4627451f, 0.1294118f, 1f); }
    }


    /// <summary>
    /// Returns the color Chocolate3
    /// </summary>
    public static Color Chocolate3
    {
      get { return new Color(0.8039216f, 0.4f, 0.1137255f, 1f); }
    }


    /// <summary>
    /// Returns the color Chocolate4
    /// </summary>
    public static Color Chocolate4
    {
      get { return new Color(0.5450981f, 0.2705882f, 0.07450981f, 1f); }
    }


    /// <summary>
    /// Returns the color Firebrick1
    /// </summary>
    public static Color Firebrick1
    {
      get { return new Color(1f, 0.1882353f, 0.1882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Firebrick2
    /// </summary>
    public static Color Firebrick2
    {
      get { return new Color(0.9333333f, 0.172549f, 0.172549f, 1f); }
    }


    /// <summary>
    /// Returns the color Firebrick3
    /// </summary>
    public static Color Firebrick3
    {
      get { return new Color(0.8039216f, 0.1490196f, 0.1490196f, 1f); }
    }


    /// <summary>
    /// Returns the color Firebrick4
    /// </summary>
    public static Color Firebrick4
    {
      get { return new Color(0.5450981f, 0.1019608f, 0.1019608f, 1f); }
    }


    /// <summary>
    /// Returns the color Brown1
    /// </summary>
    public static Color Brown1
    {
      get { return new Color(1f, 0.2509804f, 0.2509804f, 1f); }
    }


    /// <summary>
    /// Returns the color Brown2
    /// </summary>
    public static Color Brown2
    {
      get { return new Color(0.9333333f, 0.2313726f, 0.2313726f, 1f); }
    }


    /// <summary>
    /// Returns the color Brown3
    /// </summary>
    public static Color Brown3
    {
      get { return new Color(0.8039216f, 0.2f, 0.2f, 1f); }
    }


    /// <summary>
    /// Returns the color Brown4
    /// </summary>
    public static Color Brown4
    {
      get { return new Color(0.5450981f, 0.1372549f, 0.1372549f, 1f); }
    }


    /// <summary>
    /// Returns the color Salmon1
    /// </summary>
    public static Color Salmon1
    {
      get { return new Color(1f, 0.5490196f, 0.4117647f, 1f); }
    }


    /// <summary>
    /// Returns the color Salmon2
    /// </summary>
    public static Color Salmon2
    {
      get { return new Color(0.9333333f, 0.509804f, 0.3843137f, 1f); }
    }


    /// <summary>
    /// Returns the color Salmon3
    /// </summary>
    public static Color Salmon3
    {
      get { return new Color(0.8039216f, 0.4392157f, 0.3294118f, 1f); }
    }


    /// <summary>
    /// Returns the color Salmon4
    /// </summary>
    public static Color Salmon4
    {
      get { return new Color(0.5450981f, 0.2980392f, 0.2235294f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSalmon1
    /// </summary>
    public static Color LightSalmon1
    {
      get { return new Color(1f, 0.627451f, 0.4784314f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSalmon2
    /// </summary>
    public static Color LightSalmon2
    {
      get { return new Color(0.9333333f, 0.5843138f, 0.4470588f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSalmon3
    /// </summary>
    public static Color LightSalmon3
    {
      get { return new Color(0.8039216f, 0.5058824f, 0.3843137f, 1f); }
    }


    /// <summary>
    /// Returns the color LightSalmon4
    /// </summary>
    public static Color LightSalmon4
    {
      get { return new Color(0.5450981f, 0.3411765f, 0.2588235f, 1f); }
    }


    /// <summary>
    /// Returns the color Orange1
    /// </summary>
    public static Color Orange1
    {
      get { return new Color(1f, 0.6470588f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Orange2
    /// </summary>
    public static Color Orange2
    {
      get { return new Color(0.9333333f, 0.6039216f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Orange3
    /// </summary>
    public static Color Orange3
    {
      get { return new Color(0.8039216f, 0.5215687f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Orange4
    /// </summary>
    public static Color Orange4
    {
      get { return new Color(0.5450981f, 0.3529412f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkOrange1
    /// </summary>
    public static Color DarkOrange1
    {
      get { return new Color(1f, 0.4980392f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkOrange2
    /// </summary>
    public static Color DarkOrange2
    {
      get { return new Color(0.9333333f, 0.4627451f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkOrange3
    /// </summary>
    public static Color DarkOrange3
    {
      get { return new Color(0.8039216f, 0.4f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkOrange4
    /// </summary>
    public static Color DarkOrange4
    {
      get { return new Color(0.5450981f, 0.2705882f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Coral1
    /// </summary>
    public static Color Coral1
    {
      get { return new Color(1f, 0.4470588f, 0.3372549f, 1f); }
    }


    /// <summary>
    /// Returns the color Coral2
    /// </summary>
    public static Color Coral2
    {
      get { return new Color(0.9333333f, 0.4156863f, 0.3137255f, 1f); }
    }


    /// <summary>
    /// Returns the color Coral3
    /// </summary>
    public static Color Coral3
    {
      get { return new Color(0.8039216f, 0.3568628f, 0.2705882f, 1f); }
    }


    /// <summary>
    /// Returns the color Coral4
    /// </summary>
    public static Color Coral4
    {
      get { return new Color(0.5450981f, 0.2431373f, 0.1843137f, 1f); }
    }


    /// <summary>
    /// Returns the color Tomato1
    /// </summary>
    public static Color Tomato1
    {
      get { return new Color(1f, 0.3882353f, 0.2784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Tomato2
    /// </summary>
    public static Color Tomato2
    {
      get { return new Color(0.9333333f, 0.3607843f, 0.2588235f, 1f); }
    }


    /// <summary>
    /// Returns the color Tomato3
    /// </summary>
    public static Color Tomato3
    {
      get { return new Color(0.8039216f, 0.3098039f, 0.2235294f, 1f); }
    }


    /// <summary>
    /// Returns the color Tomato4
    /// </summary>
    public static Color Tomato4
    {
      get { return new Color(0.5450981f, 0.2117647f, 0.1490196f, 1f); }
    }


    /// <summary>
    /// Returns the color OrangeRed1
    /// </summary>
    public static Color OrangeRed1
    {
      get { return new Color(1f, 0.2705882f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color OrangeRed2
    /// </summary>
    public static Color OrangeRed2
    {
      get { return new Color(0.9333333f, 0.2509804f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color OrangeRed3
    /// </summary>
    public static Color OrangeRed3
    {
      get { return new Color(0.8039216f, 0.2156863f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color OrangeRed4
    /// </summary>
    public static Color OrangeRed4
    {
      get { return new Color(0.5450981f, 0.145098f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Red1
    /// </summary>
    public static Color Red1
    {
      get { return new Color(1f, 0f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Red2
    /// </summary>
    public static Color Red2
    {
      get { return new Color(0.9333333f, 0f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Red3
    /// </summary>
    public static Color Red3
    {
      get { return new Color(0.8039216f, 0f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Red4
    /// </summary>
    public static Color Red4
    {
      get { return new Color(0.5450981f, 0f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color DeepPink1
    /// </summary>
    public static Color DeepPink1
    {
      get { return new Color(1f, 0.07843138f, 0.5764706f, 1f); }
    }


    /// <summary>
    /// Returns the color DeepPink2
    /// </summary>
    public static Color DeepPink2
    {
      get { return new Color(0.9333333f, 0.07058824f, 0.5372549f, 1f); }
    }


    /// <summary>
    /// Returns the color DeepPink3
    /// </summary>
    public static Color DeepPink3
    {
      get { return new Color(0.8039216f, 0.0627451f, 0.4627451f, 1f); }
    }


    /// <summary>
    /// Returns the color DeepPink4
    /// </summary>
    public static Color DeepPink4
    {
      get { return new Color(0.5450981f, 0.03921569f, 0.3137255f, 1f); }
    }


    /// <summary>
    /// Returns the color HotPink1
    /// </summary>
    public static Color HotPink1
    {
      get { return new Color(1f, 0.4313726f, 0.7058824f, 1f); }
    }


    /// <summary>
    /// Returns the color HotPink2
    /// </summary>
    public static Color HotPink2
    {
      get { return new Color(0.9333333f, 0.4156863f, 0.654902f, 1f); }
    }


    /// <summary>
    /// Returns the color HotPink3
    /// </summary>
    public static Color HotPink3
    {
      get { return new Color(0.8039216f, 0.3764706f, 0.5647059f, 1f); }
    }


    /// <summary>
    /// Returns the color HotPink4
    /// </summary>
    public static Color HotPink4
    {
      get { return new Color(0.5450981f, 0.227451f, 0.3843137f, 1f); }
    }


    /// <summary>
    /// Returns the color Pink1
    /// </summary>
    public static Color Pink1
    {
      get { return new Color(1f, 0.7098039f, 0.772549f, 1f); }
    }


    /// <summary>
    /// Returns the color Pink2
    /// </summary>
    public static Color Pink2
    {
      get { return new Color(0.9333333f, 0.6627451f, 0.7215686f, 1f); }
    }


    /// <summary>
    /// Returns the color Pink3
    /// </summary>
    public static Color Pink3
    {
      get { return new Color(0.8039216f, 0.5686275f, 0.6196079f, 1f); }
    }


    /// <summary>
    /// Returns the color Pink4
    /// </summary>
    public static Color Pink4
    {
      get { return new Color(0.5450981f, 0.3882353f, 0.4235294f, 1f); }
    }


    /// <summary>
    /// Returns the color LightPink1
    /// </summary>
    public static Color LightPink1
    {
      get { return new Color(1f, 0.682353f, 0.7254902f, 1f); }
    }


    /// <summary>
    /// Returns the color LightPink2
    /// </summary>
    public static Color LightPink2
    {
      get { return new Color(0.9333333f, 0.6352941f, 0.6784314f, 1f); }
    }


    /// <summary>
    /// Returns the color LightPink3
    /// </summary>
    public static Color LightPink3
    {
      get { return new Color(0.8039216f, 0.5490196f, 0.5843138f, 1f); }
    }


    /// <summary>
    /// Returns the color LightPink4
    /// </summary>
    public static Color LightPink4
    {
      get { return new Color(0.5450981f, 0.372549f, 0.3960784f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleVioletRed1
    /// </summary>
    public static Color PaleVioletRed1
    {
      get { return new Color(1f, 0.509804f, 0.6705883f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleVioletRed2
    /// </summary>
    public static Color PaleVioletRed2
    {
      get { return new Color(0.9333333f, 0.4745098f, 0.6235294f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleVioletRed3
    /// </summary>
    public static Color PaleVioletRed3
    {
      get { return new Color(0.8039216f, 0.4078431f, 0.5372549f, 1f); }
    }


    /// <summary>
    /// Returns the color PaleVioletRed4
    /// </summary>
    public static Color PaleVioletRed4
    {
      get { return new Color(0.5450981f, 0.2784314f, 0.3647059f, 1f); }
    }


    /// <summary>
    /// Returns the color Maroon1
    /// </summary>
    public static Color Maroon1
    {
      get { return new Color(1f, 0.2039216f, 0.7019608f, 1f); }
    }


    /// <summary>
    /// Returns the color Maroon2
    /// </summary>
    public static Color Maroon2
    {
      get { return new Color(0.9333333f, 0.1882353f, 0.654902f, 1f); }
    }


    /// <summary>
    /// Returns the color Maroon3
    /// </summary>
    public static Color Maroon3
    {
      get { return new Color(0.8039216f, 0.1607843f, 0.5647059f, 1f); }
    }


    /// <summary>
    /// Returns the color Maroon4
    /// </summary>
    public static Color Maroon4
    {
      get { return new Color(0.5450981f, 0.1098039f, 0.3843137f, 1f); }
    }


    /// <summary>
    /// Returns the color VioletRed1
    /// </summary>
    public static Color VioletRed1
    {
      get { return new Color(1f, 0.2431373f, 0.5882353f, 1f); }
    }


    /// <summary>
    /// Returns the color VioletRed2
    /// </summary>
    public static Color VioletRed2
    {
      get { return new Color(0.9333333f, 0.227451f, 0.5490196f, 1f); }
    }


    /// <summary>
    /// Returns the color VioletRed3
    /// </summary>
    public static Color VioletRed3
    {
      get { return new Color(0.8039216f, 0.1960784f, 0.4705882f, 1f); }
    }


    /// <summary>
    /// Returns the color VioletRed4
    /// </summary>
    public static Color VioletRed4
    {
      get { return new Color(0.5450981f, 0.1333333f, 0.3215686f, 1f); }
    }


    /// <summary>
    /// Returns the color Magenta1
    /// </summary>
    public static Color Magenta1
    {
      get { return new Color(1f, 0f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color Magenta2
    /// </summary>
    public static Color Magenta2
    {
      get { return new Color(0.9333333f, 0f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color Magenta3
    /// </summary>
    public static Color Magenta3
    {
      get { return new Color(0.8039216f, 0f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color Magenta4
    /// </summary>
    public static Color Magenta4
    {
      get { return new Color(0.5450981f, 0f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color Orchid1
    /// </summary>
    public static Color Orchid1
    {
      get { return new Color(1f, 0.5137255f, 0.9803922f, 1f); }
    }


    /// <summary>
    /// Returns the color Orchid2
    /// </summary>
    public static Color Orchid2
    {
      get { return new Color(0.9333333f, 0.4784314f, 0.9137255f, 1f); }
    }


    /// <summary>
    /// Returns the color Orchid3
    /// </summary>
    public static Color Orchid3
    {
      get { return new Color(0.8039216f, 0.4117647f, 0.7882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Orchid4
    /// </summary>
    public static Color Orchid4
    {
      get { return new Color(0.5450981f, 0.2784314f, 0.5372549f, 1f); }
    }


    /// <summary>
    /// Returns the color Plum1
    /// </summary>
    public static Color Plum1
    {
      get { return new Color(1f, 0.7333333f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color Plum2
    /// </summary>
    public static Color Plum2
    {
      get { return new Color(0.9333333f, 0.682353f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color Plum3
    /// </summary>
    public static Color Plum3
    {
      get { return new Color(0.8039216f, 0.5882353f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color Plum4
    /// </summary>
    public static Color Plum4
    {
      get { return new Color(0.5450981f, 0.4f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumOrchid1
    /// </summary>
    public static Color MediumOrchid1
    {
      get { return new Color(0.8784314f, 0.4f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumOrchid2
    /// </summary>
    public static Color MediumOrchid2
    {
      get { return new Color(0.8196079f, 0.372549f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumOrchid3
    /// </summary>
    public static Color MediumOrchid3
    {
      get { return new Color(0.7058824f, 0.3215686f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumOrchid4
    /// </summary>
    public static Color MediumOrchid4
    {
      get { return new Color(0.4784314f, 0.2156863f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkOrchid1
    /// </summary>
    public static Color DarkOrchid1
    {
      get { return new Color(0.7490196f, 0.2431373f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkOrchid2
    /// </summary>
    public static Color DarkOrchid2
    {
      get { return new Color(0.6980392f, 0.227451f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkOrchid3
    /// </summary>
    public static Color DarkOrchid3
    {
      get { return new Color(0.6039216f, 0.1960784f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkOrchid4
    /// </summary>
    public static Color DarkOrchid4
    {
      get { return new Color(0.4078431f, 0.1333333f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color Purple1
    /// </summary>
    public static Color Purple1
    {
      get { return new Color(0.6078432f, 0.1882353f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color Purple2
    /// </summary>
    public static Color Purple2
    {
      get { return new Color(0.5686275f, 0.172549f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color Purple3
    /// </summary>
    public static Color Purple3
    {
      get { return new Color(0.4901961f, 0.1490196f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color Purple4
    /// </summary>
    public static Color Purple4
    {
      get { return new Color(0.3333333f, 0.1019608f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumPurple1
    /// </summary>
    public static Color MediumPurple1
    {
      get { return new Color(0.6705883f, 0.509804f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumPurple2
    /// </summary>
    public static Color MediumPurple2
    {
      get { return new Color(0.6235294f, 0.4745098f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumPurple3
    /// </summary>
    public static Color MediumPurple3
    {
      get { return new Color(0.5372549f, 0.4078431f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color MediumPurple4
    /// </summary>
    public static Color MediumPurple4
    {
      get { return new Color(0.3647059f, 0.2784314f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color Thistle1
    /// </summary>
    public static Color Thistle1
    {
      get { return new Color(1f, 0.8823529f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color Thistle2
    /// </summary>
    public static Color Thistle2
    {
      get { return new Color(0.9333333f, 0.8235294f, 0.9333333f, 1f); }
    }


    /// <summary>
    /// Returns the color Thistle3
    /// </summary>
    public static Color Thistle3
    {
      get { return new Color(0.8039216f, 0.7098039f, 0.8039216f, 1f); }
    }


    /// <summary>
    /// Returns the color Thistle4
    /// </summary>
    public static Color Thistle4
    {
      get { return new Color(0.5450981f, 0.4823529f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray0
    /// </summary>
    public static Color Gray0
    {
      get { return new Color(0f, 0f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey0
    /// </summary>
    public static Color Grey0
    {
      get { return new Color(0f, 0f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray1
    /// </summary>
    public static Color Gray1
    {
      get { return new Color(0.01176471f, 0.01176471f, 0.01176471f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey1
    /// </summary>
    public static Color Grey1
    {
      get { return new Color(0.01176471f, 0.01176471f, 0.01176471f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray2
    /// </summary>
    public static Color Gray2
    {
      get { return new Color(0.01960784f, 0.01960784f, 0.01960784f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey2
    /// </summary>
    public static Color Grey2
    {
      get { return new Color(0.01960784f, 0.01960784f, 0.01960784f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray3
    /// </summary>
    public static Color Gray3
    {
      get { return new Color(0.03137255f, 0.03137255f, 0.03137255f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey3
    /// </summary>
    public static Color Grey3
    {
      get { return new Color(0.03137255f, 0.03137255f, 0.03137255f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray4
    /// </summary>
    public static Color Gray4
    {
      get { return new Color(0.03921569f, 0.03921569f, 0.03921569f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey4
    /// </summary>
    public static Color Grey4
    {
      get { return new Color(0.03921569f, 0.03921569f, 0.03921569f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray5
    /// </summary>
    public static Color Gray5
    {
      get { return new Color(0.05098039f, 0.05098039f, 0.05098039f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey5
    /// </summary>
    public static Color Grey5
    {
      get { return new Color(0.05098039f, 0.05098039f, 0.05098039f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray6
    /// </summary>
    public static Color Gray6
    {
      get { return new Color(0.05882353f, 0.05882353f, 0.05882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey6
    /// </summary>
    public static Color Grey6
    {
      get { return new Color(0.05882353f, 0.05882353f, 0.05882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray7
    /// </summary>
    public static Color Gray7
    {
      get { return new Color(0.07058824f, 0.07058824f, 0.07058824f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey7
    /// </summary>
    public static Color Grey7
    {
      get { return new Color(0.07058824f, 0.07058824f, 0.07058824f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray8
    /// </summary>
    public static Color Gray8
    {
      get { return new Color(0.07843138f, 0.07843138f, 0.07843138f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey8
    /// </summary>
    public static Color Grey8
    {
      get { return new Color(0.07843138f, 0.07843138f, 0.07843138f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray9
    /// </summary>
    public static Color Gray9
    {
      get { return new Color(0.09019608f, 0.09019608f, 0.09019608f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey9
    /// </summary>
    public static Color Grey9
    {
      get { return new Color(0.09019608f, 0.09019608f, 0.09019608f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray10
    /// </summary>
    public static Color Gray10
    {
      get { return new Color(0.1019608f, 0.1019608f, 0.1019608f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey10
    /// </summary>
    public static Color Grey10
    {
      get { return new Color(0.1019608f, 0.1019608f, 0.1019608f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray11
    /// </summary>
    public static Color Gray11
    {
      get { return new Color(0.1098039f, 0.1098039f, 0.1098039f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey11
    /// </summary>
    public static Color Grey11
    {
      get { return new Color(0.1098039f, 0.1098039f, 0.1098039f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray12
    /// </summary>
    public static Color Gray12
    {
      get { return new Color(0.1215686f, 0.1215686f, 0.1215686f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey12
    /// </summary>
    public static Color Grey12
    {
      get { return new Color(0.1215686f, 0.1215686f, 0.1215686f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray13
    /// </summary>
    public static Color Gray13
    {
      get { return new Color(0.1294118f, 0.1294118f, 0.1294118f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey13
    /// </summary>
    public static Color Grey13
    {
      get { return new Color(0.1294118f, 0.1294118f, 0.1294118f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray14
    /// </summary>
    public static Color Gray14
    {
      get { return new Color(0.1411765f, 0.1411765f, 0.1411765f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey14
    /// </summary>
    public static Color Grey14
    {
      get { return new Color(0.1411765f, 0.1411765f, 0.1411765f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray15
    /// </summary>
    public static Color Gray15
    {
      get { return new Color(0.1490196f, 0.1490196f, 0.1490196f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey15
    /// </summary>
    public static Color Grey15
    {
      get { return new Color(0.1490196f, 0.1490196f, 0.1490196f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray16
    /// </summary>
    public static Color Gray16
    {
      get { return new Color(0.1607843f, 0.1607843f, 0.1607843f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey16
    /// </summary>
    public static Color Grey16
    {
      get { return new Color(0.1607843f, 0.1607843f, 0.1607843f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray17
    /// </summary>
    public static Color Gray17
    {
      get { return new Color(0.1686275f, 0.1686275f, 0.1686275f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey17
    /// </summary>
    public static Color Grey17
    {
      get { return new Color(0.1686275f, 0.1686275f, 0.1686275f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray18
    /// </summary>
    public static Color Gray18
    {
      get { return new Color(0.1803922f, 0.1803922f, 0.1803922f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey18
    /// </summary>
    public static Color Grey18
    {
      get { return new Color(0.1803922f, 0.1803922f, 0.1803922f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray19
    /// </summary>
    public static Color Gray19
    {
      get { return new Color(0.1882353f, 0.1882353f, 0.1882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey19
    /// </summary>
    public static Color Grey19
    {
      get { return new Color(0.1882353f, 0.1882353f, 0.1882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray20
    /// </summary>
    public static Color Gray20
    {
      get { return new Color(0.2f, 0.2f, 0.2f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey20
    /// </summary>
    public static Color Grey20
    {
      get { return new Color(0.2f, 0.2f, 0.2f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray21
    /// </summary>
    public static Color Gray21
    {
      get { return new Color(0.2117647f, 0.2117647f, 0.2117647f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey21
    /// </summary>
    public static Color Grey21
    {
      get { return new Color(0.2117647f, 0.2117647f, 0.2117647f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray22
    /// </summary>
    public static Color Gray22
    {
      get { return new Color(0.2196078f, 0.2196078f, 0.2196078f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey22
    /// </summary>
    public static Color Grey22
    {
      get { return new Color(0.2196078f, 0.2196078f, 0.2196078f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray23
    /// </summary>
    public static Color Gray23
    {
      get { return new Color(0.2313726f, 0.2313726f, 0.2313726f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey23
    /// </summary>
    public static Color Grey23
    {
      get { return new Color(0.2313726f, 0.2313726f, 0.2313726f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray24
    /// </summary>
    public static Color Gray24
    {
      get { return new Color(0.2392157f, 0.2392157f, 0.2392157f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey24
    /// </summary>
    public static Color Grey24
    {
      get { return new Color(0.2392157f, 0.2392157f, 0.2392157f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray25
    /// </summary>
    public static Color Gray25
    {
      get { return new Color(0.2509804f, 0.2509804f, 0.2509804f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey25
    /// </summary>
    public static Color Grey25
    {
      get { return new Color(0.2509804f, 0.2509804f, 0.2509804f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray26
    /// </summary>
    public static Color Gray26
    {
      get { return new Color(0.2588235f, 0.2588235f, 0.2588235f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey26
    /// </summary>
    public static Color Grey26
    {
      get { return new Color(0.2588235f, 0.2588235f, 0.2588235f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray27
    /// </summary>
    public static Color Gray27
    {
      get { return new Color(0.2705882f, 0.2705882f, 0.2705882f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey27
    /// </summary>
    public static Color Grey27
    {
      get { return new Color(0.2705882f, 0.2705882f, 0.2705882f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray28
    /// </summary>
    public static Color Gray28
    {
      get { return new Color(0.2784314f, 0.2784314f, 0.2784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey28
    /// </summary>
    public static Color Grey28
    {
      get { return new Color(0.2784314f, 0.2784314f, 0.2784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray29
    /// </summary>
    public static Color Gray29
    {
      get { return new Color(0.2901961f, 0.2901961f, 0.2901961f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey29
    /// </summary>
    public static Color Grey29
    {
      get { return new Color(0.2901961f, 0.2901961f, 0.2901961f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray30
    /// </summary>
    public static Color Gray30
    {
      get { return new Color(0.3019608f, 0.3019608f, 0.3019608f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey30
    /// </summary>
    public static Color Grey30
    {
      get { return new Color(0.3019608f, 0.3019608f, 0.3019608f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray31
    /// </summary>
    public static Color Gray31
    {
      get { return new Color(0.3098039f, 0.3098039f, 0.3098039f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey31
    /// </summary>
    public static Color Grey31
    {
      get { return new Color(0.3098039f, 0.3098039f, 0.3098039f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray32
    /// </summary>
    public static Color Gray32
    {
      get { return new Color(0.3215686f, 0.3215686f, 0.3215686f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey32
    /// </summary>
    public static Color Grey32
    {
      get { return new Color(0.3215686f, 0.3215686f, 0.3215686f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray33
    /// </summary>
    public static Color Gray33
    {
      get { return new Color(0.3294118f, 0.3294118f, 0.3294118f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey33
    /// </summary>
    public static Color Grey33
    {
      get { return new Color(0.3294118f, 0.3294118f, 0.3294118f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray34
    /// </summary>
    public static Color Gray34
    {
      get { return new Color(0.3411765f, 0.3411765f, 0.3411765f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey34
    /// </summary>
    public static Color Grey34
    {
      get { return new Color(0.3411765f, 0.3411765f, 0.3411765f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray35
    /// </summary>
    public static Color Gray35
    {
      get { return new Color(0.3490196f, 0.3490196f, 0.3490196f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey35
    /// </summary>
    public static Color Grey35
    {
      get { return new Color(0.3490196f, 0.3490196f, 0.3490196f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray36
    /// </summary>
    public static Color Gray36
    {
      get { return new Color(0.3607843f, 0.3607843f, 0.3607843f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey36
    /// </summary>
    public static Color Grey36
    {
      get { return new Color(0.3607843f, 0.3607843f, 0.3607843f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray37
    /// </summary>
    public static Color Gray37
    {
      get { return new Color(0.3686275f, 0.3686275f, 0.3686275f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey37
    /// </summary>
    public static Color Grey37
    {
      get { return new Color(0.3686275f, 0.3686275f, 0.3686275f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray38
    /// </summary>
    public static Color Gray38
    {
      get { return new Color(0.3803922f, 0.3803922f, 0.3803922f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey38
    /// </summary>
    public static Color Grey38
    {
      get { return new Color(0.3803922f, 0.3803922f, 0.3803922f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray39
    /// </summary>
    public static Color Gray39
    {
      get { return new Color(0.3882353f, 0.3882353f, 0.3882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey39
    /// </summary>
    public static Color Grey39
    {
      get { return new Color(0.3882353f, 0.3882353f, 0.3882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray40
    /// </summary>
    public static Color Gray40
    {
      get { return new Color(0.4f, 0.4f, 0.4f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey40
    /// </summary>
    public static Color Grey40
    {
      get { return new Color(0.4f, 0.4f, 0.4f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray41
    /// </summary>
    public static Color Gray41
    {
      get { return new Color(0.4117647f, 0.4117647f, 0.4117647f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey41
    /// </summary>
    public static Color Grey41
    {
      get { return new Color(0.4117647f, 0.4117647f, 0.4117647f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray42
    /// </summary>
    public static Color Gray42
    {
      get { return new Color(0.4196078f, 0.4196078f, 0.4196078f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey42
    /// </summary>
    public static Color Grey42
    {
      get { return new Color(0.4196078f, 0.4196078f, 0.4196078f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray43
    /// </summary>
    public static Color Gray43
    {
      get { return new Color(0.4313726f, 0.4313726f, 0.4313726f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey43
    /// </summary>
    public static Color Grey43
    {
      get { return new Color(0.4313726f, 0.4313726f, 0.4313726f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray44
    /// </summary>
    public static Color Gray44
    {
      get { return new Color(0.4392157f, 0.4392157f, 0.4392157f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey44
    /// </summary>
    public static Color Grey44
    {
      get { return new Color(0.4392157f, 0.4392157f, 0.4392157f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray45
    /// </summary>
    public static Color Gray45
    {
      get { return new Color(0.4509804f, 0.4509804f, 0.4509804f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey45
    /// </summary>
    public static Color Grey45
    {
      get { return new Color(0.4509804f, 0.4509804f, 0.4509804f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray46
    /// </summary>
    public static Color Gray46
    {
      get { return new Color(0.4588235f, 0.4588235f, 0.4588235f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey46
    /// </summary>
    public static Color Grey46
    {
      get { return new Color(0.4588235f, 0.4588235f, 0.4588235f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray47
    /// </summary>
    public static Color Gray47
    {
      get { return new Color(0.4705882f, 0.4705882f, 0.4705882f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey47
    /// </summary>
    public static Color Grey47
    {
      get { return new Color(0.4705882f, 0.4705882f, 0.4705882f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray48
    /// </summary>
    public static Color Gray48
    {
      get { return new Color(0.4784314f, 0.4784314f, 0.4784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey48
    /// </summary>
    public static Color Grey48
    {
      get { return new Color(0.4784314f, 0.4784314f, 0.4784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray49
    /// </summary>
    public static Color Gray49
    {
      get { return new Color(0.4901961f, 0.4901961f, 0.4901961f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey49
    /// </summary>
    public static Color Grey49
    {
      get { return new Color(0.4901961f, 0.4901961f, 0.4901961f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray50
    /// </summary>
    public static Color Gray50
    {
      get { return new Color(0.4980392f, 0.4980392f, 0.4980392f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey50
    /// </summary>
    public static Color Grey50
    {
      get { return new Color(0.4980392f, 0.4980392f, 0.4980392f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray51
    /// </summary>
    public static Color Gray51
    {
      get { return new Color(0.509804f, 0.509804f, 0.509804f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey51
    /// </summary>
    public static Color Grey51
    {
      get { return new Color(0.509804f, 0.509804f, 0.509804f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray52
    /// </summary>
    public static Color Gray52
    {
      get { return new Color(0.5215687f, 0.5215687f, 0.5215687f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey52
    /// </summary>
    public static Color Grey52
    {
      get { return new Color(0.5215687f, 0.5215687f, 0.5215687f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray53
    /// </summary>
    public static Color Gray53
    {
      get { return new Color(0.5294118f, 0.5294118f, 0.5294118f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey53
    /// </summary>
    public static Color Grey53
    {
      get { return new Color(0.5294118f, 0.5294118f, 0.5294118f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray54
    /// </summary>
    public static Color Gray54
    {
      get { return new Color(0.5411765f, 0.5411765f, 0.5411765f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey54
    /// </summary>
    public static Color Grey54
    {
      get { return new Color(0.5411765f, 0.5411765f, 0.5411765f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray55
    /// </summary>
    public static Color Gray55
    {
      get { return new Color(0.5490196f, 0.5490196f, 0.5490196f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey55
    /// </summary>
    public static Color Grey55
    {
      get { return new Color(0.5490196f, 0.5490196f, 0.5490196f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray56
    /// </summary>
    public static Color Gray56
    {
      get { return new Color(0.5607843f, 0.5607843f, 0.5607843f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey56
    /// </summary>
    public static Color Grey56
    {
      get { return new Color(0.5607843f, 0.5607843f, 0.5607843f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray57
    /// </summary>
    public static Color Gray57
    {
      get { return new Color(0.5686275f, 0.5686275f, 0.5686275f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey57
    /// </summary>
    public static Color Grey57
    {
      get { return new Color(0.5686275f, 0.5686275f, 0.5686275f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray58
    /// </summary>
    public static Color Gray58
    {
      get { return new Color(0.5803922f, 0.5803922f, 0.5803922f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey58
    /// </summary>
    public static Color Grey58
    {
      get { return new Color(0.5803922f, 0.5803922f, 0.5803922f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray59
    /// </summary>
    public static Color Gray59
    {
      get { return new Color(0.5882353f, 0.5882353f, 0.5882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey59
    /// </summary>
    public static Color Grey59
    {
      get { return new Color(0.5882353f, 0.5882353f, 0.5882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray60
    /// </summary>
    public static Color Gray60
    {
      get { return new Color(0.6f, 0.6f, 0.6f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey60
    /// </summary>
    public static Color Grey60
    {
      get { return new Color(0.6f, 0.6f, 0.6f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray61
    /// </summary>
    public static Color Gray61
    {
      get { return new Color(0.6117647f, 0.6117647f, 0.6117647f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey61
    /// </summary>
    public static Color Grey61
    {
      get { return new Color(0.6117647f, 0.6117647f, 0.6117647f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray62
    /// </summary>
    public static Color Gray62
    {
      get { return new Color(0.6196079f, 0.6196079f, 0.6196079f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey62
    /// </summary>
    public static Color Grey62
    {
      get { return new Color(0.6196079f, 0.6196079f, 0.6196079f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray63
    /// </summary>
    public static Color Gray63
    {
      get { return new Color(0.6313726f, 0.6313726f, 0.6313726f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey63
    /// </summary>
    public static Color Grey63
    {
      get { return new Color(0.6313726f, 0.6313726f, 0.6313726f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray64
    /// </summary>
    public static Color Gray64
    {
      get { return new Color(0.6392157f, 0.6392157f, 0.6392157f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey64
    /// </summary>
    public static Color Grey64
    {
      get { return new Color(0.6392157f, 0.6392157f, 0.6392157f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray65
    /// </summary>
    public static Color Gray65
    {
      get { return new Color(0.6509804f, 0.6509804f, 0.6509804f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey65
    /// </summary>
    public static Color Grey65
    {
      get { return new Color(0.6509804f, 0.6509804f, 0.6509804f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray66
    /// </summary>
    public static Color Gray66
    {
      get { return new Color(0.6588235f, 0.6588235f, 0.6588235f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey66
    /// </summary>
    public static Color Grey66
    {
      get { return new Color(0.6588235f, 0.6588235f, 0.6588235f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray67
    /// </summary>
    public static Color Gray67
    {
      get { return new Color(0.6705883f, 0.6705883f, 0.6705883f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey67
    /// </summary>
    public static Color Grey67
    {
      get { return new Color(0.6705883f, 0.6705883f, 0.6705883f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray68
    /// </summary>
    public static Color Gray68
    {
      get { return new Color(0.6784314f, 0.6784314f, 0.6784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey68
    /// </summary>
    public static Color Grey68
    {
      get { return new Color(0.6784314f, 0.6784314f, 0.6784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray69
    /// </summary>
    public static Color Gray69
    {
      get { return new Color(0.6901961f, 0.6901961f, 0.6901961f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey69
    /// </summary>
    public static Color Grey69
    {
      get { return new Color(0.6901961f, 0.6901961f, 0.6901961f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray70
    /// </summary>
    public static Color Gray70
    {
      get { return new Color(0.7019608f, 0.7019608f, 0.7019608f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey70
    /// </summary>
    public static Color Grey70
    {
      get { return new Color(0.7019608f, 0.7019608f, 0.7019608f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray71
    /// </summary>
    public static Color Gray71
    {
      get { return new Color(0.7098039f, 0.7098039f, 0.7098039f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey71
    /// </summary>
    public static Color Grey71
    {
      get { return new Color(0.7098039f, 0.7098039f, 0.7098039f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray72
    /// </summary>
    public static Color Gray72
    {
      get { return new Color(0.7215686f, 0.7215686f, 0.7215686f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey72
    /// </summary>
    public static Color Grey72
    {
      get { return new Color(0.7215686f, 0.7215686f, 0.7215686f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray73
    /// </summary>
    public static Color Gray73
    {
      get { return new Color(0.7294118f, 0.7294118f, 0.7294118f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey73
    /// </summary>
    public static Color Grey73
    {
      get { return new Color(0.7294118f, 0.7294118f, 0.7294118f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray74
    /// </summary>
    public static Color Gray74
    {
      get { return new Color(0.7411765f, 0.7411765f, 0.7411765f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey74
    /// </summary>
    public static Color Grey74
    {
      get { return new Color(0.7411765f, 0.7411765f, 0.7411765f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray75
    /// </summary>
    public static Color Gray75
    {
      get { return new Color(0.7490196f, 0.7490196f, 0.7490196f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey75
    /// </summary>
    public static Color Grey75
    {
      get { return new Color(0.7490196f, 0.7490196f, 0.7490196f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray76
    /// </summary>
    public static Color Gray76
    {
      get { return new Color(0.7607843f, 0.7607843f, 0.7607843f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey76
    /// </summary>
    public static Color Grey76
    {
      get { return new Color(0.7607843f, 0.7607843f, 0.7607843f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray77
    /// </summary>
    public static Color Gray77
    {
      get { return new Color(0.7686275f, 0.7686275f, 0.7686275f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey77
    /// </summary>
    public static Color Grey77
    {
      get { return new Color(0.7686275f, 0.7686275f, 0.7686275f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray78
    /// </summary>
    public static Color Gray78
    {
      get { return new Color(0.7803922f, 0.7803922f, 0.7803922f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey78
    /// </summary>
    public static Color Grey78
    {
      get { return new Color(0.7803922f, 0.7803922f, 0.7803922f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray79
    /// </summary>
    public static Color Gray79
    {
      get { return new Color(0.7882353f, 0.7882353f, 0.7882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey79
    /// </summary>
    public static Color Grey79
    {
      get { return new Color(0.7882353f, 0.7882353f, 0.7882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray80
    /// </summary>
    public static Color Gray80
    {
      get { return new Color(0.8f, 0.8f, 0.8f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey80
    /// </summary>
    public static Color Grey80
    {
      get { return new Color(0.8f, 0.8f, 0.8f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray81
    /// </summary>
    public static Color Gray81
    {
      get { return new Color(0.8117647f, 0.8117647f, 0.8117647f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey81
    /// </summary>
    public static Color Grey81
    {
      get { return new Color(0.8117647f, 0.8117647f, 0.8117647f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray82
    /// </summary>
    public static Color Gray82
    {
      get { return new Color(0.8196079f, 0.8196079f, 0.8196079f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey82
    /// </summary>
    public static Color Grey82
    {
      get { return new Color(0.8196079f, 0.8196079f, 0.8196079f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray83
    /// </summary>
    public static Color Gray83
    {
      get { return new Color(0.8313726f, 0.8313726f, 0.8313726f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey83
    /// </summary>
    public static Color Grey83
    {
      get { return new Color(0.8313726f, 0.8313726f, 0.8313726f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray84
    /// </summary>
    public static Color Gray84
    {
      get { return new Color(0.8392157f, 0.8392157f, 0.8392157f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey84
    /// </summary>
    public static Color Grey84
    {
      get { return new Color(0.8392157f, 0.8392157f, 0.8392157f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray85
    /// </summary>
    public static Color Gray85
    {
      get { return new Color(0.8509804f, 0.8509804f, 0.8509804f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey85
    /// </summary>
    public static Color Grey85
    {
      get { return new Color(0.8509804f, 0.8509804f, 0.8509804f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray86
    /// </summary>
    public static Color Gray86
    {
      get { return new Color(0.8588235f, 0.8588235f, 0.8588235f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey86
    /// </summary>
    public static Color Grey86
    {
      get { return new Color(0.8588235f, 0.8588235f, 0.8588235f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray87
    /// </summary>
    public static Color Gray87
    {
      get { return new Color(0.8705882f, 0.8705882f, 0.8705882f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey87
    /// </summary>
    public static Color Grey87
    {
      get { return new Color(0.8705882f, 0.8705882f, 0.8705882f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray88
    /// </summary>
    public static Color Gray88
    {
      get { return new Color(0.8784314f, 0.8784314f, 0.8784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey88
    /// </summary>
    public static Color Grey88
    {
      get { return new Color(0.8784314f, 0.8784314f, 0.8784314f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray89
    /// </summary>
    public static Color Gray89
    {
      get { return new Color(0.8901961f, 0.8901961f, 0.8901961f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey89
    /// </summary>
    public static Color Grey89
    {
      get { return new Color(0.8901961f, 0.8901961f, 0.8901961f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray90
    /// </summary>
    public static Color Gray90
    {
      get { return new Color(0.8980392f, 0.8980392f, 0.8980392f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey90
    /// </summary>
    public static Color Grey90
    {
      get { return new Color(0.8980392f, 0.8980392f, 0.8980392f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray91
    /// </summary>
    public static Color Gray91
    {
      get { return new Color(0.9098039f, 0.9098039f, 0.9098039f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey91
    /// </summary>
    public static Color Grey91
    {
      get { return new Color(0.9098039f, 0.9098039f, 0.9098039f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray92
    /// </summary>
    public static Color Gray92
    {
      get { return new Color(0.9215686f, 0.9215686f, 0.9215686f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey92
    /// </summary>
    public static Color Grey92
    {
      get { return new Color(0.9215686f, 0.9215686f, 0.9215686f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray93
    /// </summary>
    public static Color Gray93
    {
      get { return new Color(0.9294118f, 0.9294118f, 0.9294118f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey93
    /// </summary>
    public static Color Grey93
    {
      get { return new Color(0.9294118f, 0.9294118f, 0.9294118f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray94
    /// </summary>
    public static Color Gray94
    {
      get { return new Color(0.9411765f, 0.9411765f, 0.9411765f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey94
    /// </summary>
    public static Color Grey94
    {
      get { return new Color(0.9411765f, 0.9411765f, 0.9411765f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray95
    /// </summary>
    public static Color Gray95
    {
      get { return new Color(0.9490196f, 0.9490196f, 0.9490196f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey95
    /// </summary>
    public static Color Grey95
    {
      get { return new Color(0.9490196f, 0.9490196f, 0.9490196f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray96
    /// </summary>
    public static Color Gray96
    {
      get { return new Color(0.9607843f, 0.9607843f, 0.9607843f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey96
    /// </summary>
    public static Color Grey96
    {
      get { return new Color(0.9607843f, 0.9607843f, 0.9607843f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray97
    /// </summary>
    public static Color Gray97
    {
      get { return new Color(0.9686275f, 0.9686275f, 0.9686275f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey97
    /// </summary>
    public static Color Grey97
    {
      get { return new Color(0.9686275f, 0.9686275f, 0.9686275f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray98
    /// </summary>
    public static Color Gray98
    {
      get { return new Color(0.9803922f, 0.9803922f, 0.9803922f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey98
    /// </summary>
    public static Color Grey98
    {
      get { return new Color(0.9803922f, 0.9803922f, 0.9803922f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray99
    /// </summary>
    public static Color Gray99
    {
      get { return new Color(0.9882353f, 0.9882353f, 0.9882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey99
    /// </summary>
    public static Color Grey99
    {
      get { return new Color(0.9882353f, 0.9882353f, 0.9882353f, 1f); }
    }


    /// <summary>
    /// Returns the color Gray100
    /// </summary>
    public static Color Gray100
    {
      get { return new Color(1f, 1f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color Grey100
    /// </summary>
    public static Color Grey100
    {
      get { return new Color(1f, 1f, 1f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkGrey
    /// </summary>
    public static Color DarkGrey
    {
      get { return new Color(0.6627451f, 0.6627451f, 0.6627451f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkGray
    /// </summary>
    public static Color DarkGray
    {
      get { return new Color(0.6627451f, 0.6627451f, 0.6627451f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkBlue
    /// </summary>
    public static Color DarkBlue
    {
      get { return new Color(0f, 0f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkCyan
    /// </summary>
    public static Color DarkCyan
    {
      get { return new Color(0f, 0.5450981f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkMagenta
    /// </summary>
    public static Color DarkMagenta
    {
      get { return new Color(0.5450981f, 0f, 0.5450981f, 1f); }
    }


    /// <summary>
    /// Returns the color DarkRed
    /// </summary>
    public static Color DarkRed
    {
      get { return new Color(0.5450981f, 0f, 0f, 1f); }
    }


    /// <summary>
    /// Returns the color LightGreen
    /// </summary>
    public static Color LightGreen
    {
      get { return new Color(0.5647059f, 0.9333333f, 0.5647059f, 1f); }
    }
		#endregion


	}
}
