using System;
using System.Collections.Generic;
using System.Text;

namespace Jade.Core
{
	/// <summary>
	/// Options for multi threading
	/// </summary>
	[Flags]
	public enum RenderLoopThreadOptions
	{
		/// <summary>
		/// Run single threaded (no flags set)
		/// </summary>
		SingleThread = 0,
		/// <summary>
		/// Run with threaded culling - one thread per scene
		/// </summary>
		ThreadedCull = 1 << 0,

		// Bits 1-15 reserved for potential future threaded cull options

		/// <summary>
		/// Run with threaded rendering - one thread per device/context
		/// </summary>
		ThreadedRender = 1 << 16

		// Bits 17-32 reserved for potential future threaded cull options
	}
}
