using System;
using System.Collections.Generic;
using System.Threading;
using System.ComponentModel;

using Jade.SceneGraph;
using Jade.Rendering;

namespace Jade.Core
{
	/// <summary>
	/// A render operation handle
	/// </summary>
	public interface IRenderOperationHandle
	{
		/// <summary>
		/// Gets the scene being rendered.
		/// </summary>
		/// <value>The scene.</value>
		Node Scene
		{
			get;
		}
		/// <summary>
		/// Gets the overlay scene being rendered.
		/// </summary>
		/// <value>The overlay.</value>
		Node Overlay
		{
			get;
		}
		/// <summary>
		/// Gets the camera.
		/// </summary>
		/// <value>The camera.</value>
		Camera Camera
		{
			get;
		}
		/// <summary>
		/// Gets the window.
		/// </summary>
		/// <value>The window.</value>
		Window Window
		{
			get;
		}
	}
}
