using System;

namespace Jade.Core
{
	/// <summary>
	/// The Update speed of the engine
	/// </summary>
	public enum UpdateSpeed
	{
		/// <summary>
		/// Run at full speed
		/// </summary>
		Aggressive = 0,
		/// <summary>
		/// Run at a normal speed.  This is fast, but must lower resource than Aggressive
		/// </summary>
		Normal = 1,
		/// <summary>
		/// Run at a slow speed
		/// </summary>
		Slow = 10,
		/// <summary>
		/// Run at a very slow speed
		/// </summary>
		VerySlow = 50,
		/// <summary>
		/// Run at approximately 30 FPS (This is not accurate - only an approximation)
		/// </summary>
		FPS30 = 32,
		/// <summary>
		/// Run at approximately 60 FPS (This is not accurate - only an approximation)
		/// </summary>
		FPS60 = 15,
		/// <summary>
		/// Run at approximately 100 FPS (This is not accurate - only an approximation)
		/// </summary>
		FPS100 = 8
	}
}
