using System;

namespace Jade.Entities
{
	/// <summary>
	/// The coordinate space for an object
	/// </summary>
	public enum CoordinateSystem
	{
		/// <summary>
		/// The object is defined in world space
		/// </summary>
		World,
		/// <summary>
		/// The object is defined in screen space (pixels)
		/// </summary>
		Screen,
		/// <summary>
		/// The object is defined in clip space (-1 - 1)
		/// </summary>
		Clip
	}

}
