#region LGPL License
/*
Jad Engine Library
Copyright (C) 2007 Jad Engine Project Team

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
#endregion

#region Using Directives

using System;
using System.Collections.Generic;
using System.Text;

using Pluto.Core;

using Jade.SceneGraph;

#endregion

namespace Jade.Entities
{
	/// <summary>
	/// The base class that holds an actual Entity at a <see cref="Node"/> 
	/// in the scene graph
	/// </summary>
	[CompletionStatus(DevelopmentState.Beta,Notes="Needs discussion to determine what should exist in base class")]
	public interface IEntity
	{
		/// <summary>
		/// Called during update.
		/// </summary>
		/// <param name="args">The <see cref="NodeWalkerArgs"/>.  This provides access to the current <see cref="Node"/> being updated</param>
		void OnUpdate(NodeWalkerArgs args);
	}
}
