using System;
using System.Collections.Generic;
using System.Text;

using Jade.Core;
using Jade.SceneGraph;
using Jade.Resources;

using Pluto.Math;

namespace Jade.Entities
{
	/// <summary>
	/// Class for creating a single omni light source
	/// </summary>
	public class OmniLight : Light
	{
		/// <summary>
		/// Initializes a new instance of the <see cref="Light"/> class.
		/// </summary>
		public OmniLight()
			: base(LightType.Omni, Colors.White)
		{
		}

		/// <summary>
		/// Initializes a new instance of the <see cref="Light"/> class.
		/// </summary>
		/// <param name="color">The color.</param>
		public OmniLight(Color color)
			: base(LightType.Omni,color)
		{
		}
	}
}
