using Pluto.Math;
using System.Collections.Generic;
using System;
namespace Jade.Import
{
  public class ObjGroup
  {
    public ObjGroup(string name)
    {
      this.Name = name;
    }

    private string _name;		    // name of this group
    private List<uint> _triangleIndices = new List<uint>();
    private List<uint> _lineIndices = new List<uint>();
    private BoundingBox _bbox = new BoundingBox();

    public string Name
    {
      get { return this._name; }
      set { this._name = value; }
    }

    public List<uint> Triangles
    {
      get { return this._triangleIndices; }
      set { this._triangleIndices = value; }
    }

    public List<uint> Lines
    {
      get { return this._lineIndices; }
      set { this._lineIndices = value; }
    }

    public BoundingBox BoundingBox
    {
      get { return this._bbox; }
      set { this._bbox = value; }
    }

    internal void UpdateBoundingBox(Vector3 position)
    {
      Vector3 min = new Vector3();
      Vector3 max = new Vector3();

      min.X = Math.Min(this._bbox.Min.X, position.X);
      min.Y = Math.Min(this._bbox.Min.Y, position.Y);
      min.Z = Math.Min(this._bbox.Min.Z, position.Z);

      max.X = Math.Max(this._bbox.Max.X, position.X);
      max.Y = Math.Max(this._bbox.Max.Y, position.Y);
      max.Z = Math.Max(this._bbox.Max.Z, position.Z);

      this._bbox.Min = min;
      this._bbox.Max = max;      
    }
  }
}