using Pluto.Math;
using Jade.Core;

namespace Jade.Import
{
  public class ObjMaterial
  {
    public ObjMaterial(string name)
    {
      this._name = name;
    }

    private string _name;
    private Color _diffuse = new Color(0.8f, 0.8f, 0.8f, 1.0f);
    private Color _ambient = new Color(0.2f, 0.2f, 0.2f, 1.0f);
    private Color _specular = new Color(0.0f, 0.0f, 0.0f, 1.0f);
    private float _shininess = 0.0f;
    private float _trans = 1.0f;

    private string _diffMap;
    private string _ambMap;
    private string _specMap;
    private string _transMap;

    public string Name
    {
      get { return this._name; }
      set { this._name = value; }
    }

    public Color Diffuse
    {
      get { return this._diffuse; }
      set { this._diffuse = value; }
    }

    public Color Ambient
    {
      get { return this._ambient; }
      set { this._ambient = value; }
    }

    public Color Specular
    {
      get { return this._specular; }
      set { this._specular = value; }
    }

    public float Shininess
    {
      get { return this._shininess; }
      set { this._shininess = value; }
    }

    public float Transparency
    {
      get { return this._trans; }
      set { this._trans = value; }
    }

    public string DiffuseMap
    {
      get { return this._diffMap; }
      set { this._diffMap = value; }
    }

    public string AmbientMap
    {
      get { return this._ambMap; }
      set { this._ambMap = value; }
    }

    public string SpecularMap
    {
      get { return this._specMap; }
      set { this._specMap = value; }
    }

    public string TransparencyMap
    {
      get { return this._transMap; }
      set { this._transMap = value; }
    }
  }
}
