using Pluto.Math;
using SD = System.Drawing;

namespace Jade.Import
{
  public class ObjVertex
  {
    private Vector3 _position = new Vector3();
    private Vector3 _normal = new Vector3();
    private Vector2 _texCoord = new Vector2();
    private SD.Color _color = new SD.Color();

    public ObjVertex()
    {
    }

    public Vector3 Position
    {
      get { return this._position; }
      set { this._position = value; }
    }

    public Vector3 Normal
    {
      get { return this._normal; }
      set { this._normal = value; }
    }

    public Vector2 TexCoord
    {
      get { return this._texCoord; }
      set { this._texCoord = value; }
    }

    public SD.Color Color
    {
      get { return this._color; }
      set { this._color = value; }
    }

    public override bool Equals(object obj)
    {
      if (!(obj is ObjVertex))
        return false;

      ObjVertex vertex = (ObjVertex)obj;

      return this._position.Equals(vertex.Position) &&
          this._normal.Equals(vertex.Normal) &&
          this._texCoord.Equals(vertex.TexCoord) &&
          this._color.Equals(vertex.Color);
    }
  }
}