#region LGPL License
/*
Jad Engine Library
Copyright (C) 2007 Jad Engine Project Team

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
#endregion

#region Using Directives

using System;
using System.Collections.Generic;
using System.Text;

using Pluto.Core;
using Pluto.Math;

using Jade.Rendering;
using Jade.Rendering.Enums;
using Jade.Core;
using System.Collections;

#endregion

namespace Jade.Rendering
{
    /// <summary>
    /// An effect is where the shader code is located. It's compiled by the device
    /// and then it generates a VertexShader and PixelShader that can be used by
    /// the renderer.
    /// </summary>
    public abstract class Effect
    {
        Adapter _adapter;

		/// <summary>
		/// Initializes a new instance of the <see cref="Effect"/> class.
		/// </summary>
		/// <param name="adapter">The adapter.</param>
		/// <param name="name">The name.</param>
        public Effect(Adapter adapter,string name)
        {
            _adapter = adapter;
        }

		/// <summary>
		/// Loads the specified shader code.
		/// </summary>
		/// <param name="shaderCode">The shader code.</param>
		/// <returns></returns>
        public abstract bool Load(string shaderCode);
    }
}
