using System;
using System.Collections.Generic;
using System.Text;

using Jade.Core;
using Jade.Entities;
using Jade.Rendering.Enums;
using Jade.Rendering.States;
using Jade.Resources;

namespace Jade.Rendering
{
	/// <summary>
	/// A class to hold a shader and the parameters associated with it
	/// </summary>
	public class Shader
	{
		string _source;
		/// <summary>
		/// Gets or sets the source for the shader.
		/// </summary>
		/// <value>The source.</value>
		public string Source
		{
			get { return _source; }
			set { _source = value; }
		}

		Dictionary<string, int> _registersByName;
		/// <summary>
		/// Gets the mapped registers assigned by name.
		/// </summary>
		public IDictionary<string, int> RegistersByName
		{
			get { return _registersByName; }
		}

		/// <summary>
		/// Initializes a new instance of the <see cref="Shader"/> class.
		/// </summary>
		internal Shader()
		{
			_registersByName = new Dictionary<string, int>();
		}
	}
}
