using System;
using System.Collections.Generic;
using System.Text;

namespace Jade.Rendering.Enums
{
    /// <summary>
    /// RGB or alpha blending operation.
    /// </summary>
    public enum BlendOperation
    {
        /// <summary>
        /// Add source 1 and source 2.
        /// </summary>
        Add,

        /// <summary>
        /// Subtract source 1 from source 2. 
        /// </summary>
        Subtract,
 
        /// <summary>
        /// Subtract source 2 from source 1. 
        /// </summary>
        RevSubtract,

        /// <summary>
        /// Find the minimum of source 1 and source 2. 
        /// </summary>
        Min,

        /// <summary>
        /// Find the maximum of source 1 and source 2. 
        /// </summary>
        Max
    }
}
