using System;
using System.Text;

namespace Jade.Rendering.Enums
{
	/// <summary>
	/// Clear Flags used when clearing the surface
	/// </summary>
	public enum ClearFlags
	{
		/// <summary>
		/// Clears the Color Buffer
		/// </summary>
		Target = 1,

		/// <summary>
		/// Clears The ZBuffer
		/// </summary>
		ZBuffer = 2,

		/// <summary>
		/// Clears the Stencil
		/// </summary>
		Stencil = 4,

		/// <summary>
		/// Clears All
		/// </summary>
		All=Target+ZBuffer+Stencil
	}
}
