using System;

namespace Jade.Rendering.Enums
{
	/// <summary>
	/// Indicates triangles facing a particular direction are not drawn
	/// </summary>
	public enum CullMode
	{
		/// <summary>
		/// Always draw all triangles
		/// </summary>
		None=1,

		/// <summary>
		/// Do not draw triangles that are front-facing
		/// </summary>
		Front=2,

		/// <summary>
		/// Do not draw triangles that are back-facing
		/// </summary>
		Back=3
	}
}
