using System;
using System.Collections.Generic;
using System.Text;

namespace Jade.Rendering.Enums
{
    /// <summary>
    /// The stencil operations that can be performed during depth-stencil testing.
    /// </summary>
    public enum StencilOperation
    {
        /// <summary>
        /// Keep the existing stencil data. 
        /// </summary>
        Keep=1,

        /// <summary>
        /// Set the stencil data to 0.
        /// </summary>
        Zero=2,

        /// <summary>
        /// Set the stencil data to the reference value. 
        /// </summary>
        Replace=3,

        /// <summary>
        /// Increment the stencil value by 1, and clamp the result.
        /// </summary>
        IncrSat=4,

        /// <summary>
        /// Decrement the stencil value by 1, and clamp the result.
        /// </summary>
        DecrSat=5,

        /// <summary>
        /// Invert the stencil data.
        /// </summary>
        Invert=6,

        /// <summary>
        /// Increment the stencil value by 1, and wrap the result if necessary.
        /// </summary>
        Incr=7,

        /// <summary>
        /// Decrement the stencil value by 1, and wrap the result if necessary.
        /// </summary>
        Decr=8

     }
}
