using System;

namespace Jade.Rendering.Enums
{
	/// <summary>
	///    Enumeration identifying the texture type.
	/// </summary>
	public enum TextureType
	{
		/// <summary>
		///    1D texture, used in combination with 1D texture coordinates.
		/// </summary>
		OneD = 1,
		/// <summary>
		///    2D texture, used in combination with 2D texture coordinates (default).
		/// </summary>
		TwoD = 2,
		/// <summary>
		///    3D volume texture, used in combination with 3D texture coordinates.
		/// </summary>
		ThreeD = 3,
		/// <summary>
		///    3D cube map, used in combination with 3D texture coordinates.
		/// </summary>
		CubeMap = 4
	}
}
