#region Using Directives

using System;
using System.Collections.Generic;
using System.Globalization;
using System.Text;

using System.IO;
using System.Xml.Serialization;

using Jade.Core;
using Jade.Entities;
using Jade.SceneGraph;
using Jade.SceneGraph.Transforms;
using Jade.Rendering;
using Jade.Rendering.Utility;
using Jade.Resources;
using Jade.Input;
using Jade.Rendering.States;
using Jade.Rendering.Enums;

using Pluto.Core;
using Pluto.Math;
using Pluto.VFS;
using Pluto.Configuration;

#endregion

namespace Jade.Rendering
{
    /// <summary>
    /// Contains a PostProduction Effect to process
    /// </summary>
    public class PostProductionEffect
    {
        #region Fields and Properties

        /// <summary>
        /// Indicates if this effect has to be processed
        /// </summary>
        private bool _enabled;

        /// <summary>
        /// Indicates if this effect has to be processed
        /// </summary>
        protected bool Enabled
        {
            get { return _enabled; }
            set { _enabled = value; }
        }

        /// <summary>
        /// The hlsl effect
        /// </summary>
        protected string _hLSL;

        /// <summary>
        /// Gets/Sets the HLSL effect
        /// </summary>
        public string HLSL
        {
            get { return _hLSL; }
            set { _hLSL = value; }

        }

        /// <summary>
        /// This is the destination Render
        /// </summary>
        public RenderTargetBase DestinationRenderTarget;

        #endregion

        #region Constructors

        public PostProductionEffect(RenderTargetBase destination, float sizeX, float sizeY)
        {
            DestinationRenderTarget = destination;
            _enabled = true;
        }

        #endregion

        #region Methods

        /// <summary>
        /// Process the effect
        /// </summary>
        public virtual void Process(PostProduction postProduction)
        {
            // We must render a Quad using an effect
            
        }

        #endregion
    }
}
