#region LGPL License
/*
Jad Engine Library
Copyright (C) 2007 Jad Engine Project Team

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
#endregion

#region Using Directives

using System;
using System.Collections.Generic;
using System.Text;

using Pluto.Core;
using Pluto.Math;

using Jade.Rendering;
using Jade.Rendering.States;
using Jade.Entities;
using Jade.SceneGraph;
using Jade.Resources;

#endregion

namespace Jade.Rendering
{
	/// <summary>
	/// Entity with positioning
	/// </summary>
	public class TransformedEntity
	{
		/// <summary>
		/// The entity to render
		/// </summary>
		public IEntity Entity;
		/// <summary>
		/// The entity's transform
		/// </summary>
		public Matrixd Transform;

		/// <summary>
		/// Initializes a new instance of the <see cref="TransformedEntity"/> class.
		/// </summary>
		/// <param name="entity">The entity.</param>
		/// <param name="transform">The transform.</param>
		public TransformedEntity(IEntity entity, Matrixd transform)
		{
			Entity = entity;
			Transform = transform;
		}
	}
}
