using System;
using System.Collections.Generic;
using System.Text;
using Jade.Core;
using Jade.Rendering.Enums;
using Jade.Rendering.States;
using Jade.Resources;

namespace Jade.Rendering
{
    /// <summary>
    /// A sampler is an struct that holds a texture and its sampler states setting.
    /// When on the shaders you are refering to a texture, you are really using a sampler: the texture and the setting for tris texture: filters....
    /// </summary>
    public struct Sampler
    {
        #region Fields

        /// <summary>The texture</summary>
        Texture _texture;

        /// <summary>The sampler states to be applied</summary>
        public SamplerState States;

        #endregion

        #region Properties

        /// <summary>Gets/Sets the texture</summary>
        public Texture Texture
        {
            get { return _texture; }
            set { _texture = value; }
        }

        #endregion

        #region Methods

        /// <summary>
        /// Initializes the states to the default values and sets the texture=null
        /// </summary>
        public void Initialize()
        {
            States.Initialize();
            Texture = null;
        }

        #endregion

    }
}
