#region LGPL License
/*
Jad Engine Library
Copyright (C) 2007 Jad Engine Project Team

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
#endregion

#region Using Directives

using System;
using System.Collections.Generic;
using System.Text;

using Pluto.Core;

#endregion

namespace Jade.Resources
{
    /// <summary>
    /// A buffer is a chunk of graphics card memory used to store 'something'
    /// You should use it to store the vertex information and the index buffer
    /// information, but you can store anything.
    /// 
    /// To create a VertexBuffer, you should do:
    /// 
    /// buffer=Adapter.CreateBuffer();
    /// 
    /// Add a Vector3 array element called Position
    /// buffer.AddElement(typeof(Vector3[]),"Position",BufferUsage.Position);
    /// 
    /// Vector3[] position=buffer.GetElement("Position");
    /// 
    /// fill the information
    /// 
    /// buffer.Update();
    /// 
    /// To create an IndexBuffer:
    /// 
    /// buffer.AddElement(typeof(ushort[]),"Indices",BufferUsage.Indices);
    /// 
    /// ushort[] indices=buffer["Indices"];
    /// 
    /// The engine has 2 helper classes: JVertexBuffer and JIndexBuffer
    /// to easy the development.
    /// </summary>
	[CompletionStatus(DevelopmentState.Alpha, Notes = "Initial implementation in place")]
	public class Buffer
    {
	}
}
