using System;
using System.Collections.Generic;
using System.Text;

namespace Jade.Resources
{
    /// <summary>
    /// The type of attenuation.
    /// </summary>
    public enum AttenuationType
    {
        /// <summary>
        /// Attenuation is not used for this light.
        /// </summary>
        None = 0,

        /// <summary>
        /// Linear between near and far.
        /// </summary>
        Inverse = 1,

        /// <summary>
        /// Linear squared between near and far.
        /// </summary>
        InverseSquare = 2,

        /// <summary>
        /// Smooth between near and far.
        /// </summary>
        DualRadius = 3,

        /// <summary>
        /// Standard style.
        /// </summary>
        Standard = 4
    }
}
