using System;


namespace Jade.Resources
{
	/// <summary>
	/// The various light types that Jad suports.
	/// </summary>
	public enum LightType
	{
		/// <summary>
		/// An ambient light
		/// </summary>
		Ambient = -1,

		/// <summary>
		/// A point light.
		/// </summary>
		Omni = 0,

		/// <summary>
		/// A spot light.
		/// </summary>
		Spot = 1,

		/// <summary>
		/// A directional light that only has direction, but no position.
		/// </summary>
		Directional = 2,

		/// <summary>
		/// Indicates that the light type is unknown.
		/// </summary>
		Unknown = 3
	}
}
