﻿using System;
using System.Collections.Generic;

namespace Jade.Resources
{
	/// <summary>
	/// Interface for the renderer to get out specific renderstates
	/// </summary>
	public interface IRenderStateCollection
	{
		/// <summary>
		/// Gets the number of render states.
		/// </summary>
		/// <value>The number of individual renderstates.</value>
		int Count
		{
			get;
		}
		/// <summary>
		/// Gets the individual, single material render states.
		/// </summary>
		/// <value>The render states.</value>
		RenderState GetRenderState(int index);
	}
}
