#region LGPL License
/*
Jad Engine Library
Copyright (C) 2007 Jad Engine Project Team

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
#endregion

#region Using Directives

using System;
using System.Collections.Generic;
using System.Text;

using Pluto.Core;
using Pluto.Math;

using Jade.Rendering;
using Jade.Rendering.Enums;
using Jade.Core;
using System.Collections;
using Jade.Rendering.States;
using Jade.Resources;

#endregion

namespace Jade.Resources
{
    /// <summary>
    /// This class has information about a rectangle of a Texture.  It maps a series of
	/// rectangles to a specific image/frame within a Texture
    /// </summary>
    public class ImageMap
    {
        #region Fields

		private List<Rectangle> _maps;
		/// <summary>
		/// Gets the maps for rectangles to textures.
		/// </summary>
		/// <value>The maps.</value>
		public IList<Rectangle> Maps
		{
			get { return _maps; }
		}

        #endregion

        #region Constructor

		/// <summary>
		/// Initializes a new instance of the <see cref="ImageMap"/> class.
		/// </summary>
        public ImageMap()
        {
			_maps = new List<Rectangle>();
        }

        #endregion

        #region Methods

		/// <summary>
		/// Adds the specified rectangle to the image maps.
		/// </summary>
		/// <param name="rectangle">The rectangle.</param>
        public void Add(Rectangle rectangle)
        {
			_maps.Add(rectangle);
        }

        #endregion
    }
}
