#region Using Directives

using System;
using System.Collections.Generic;
using System.Text;


using Pluto.Math;

#endregion


namespace Jade.SceneGraph
{
	/// <summary>
	/// Interface for an implementation of a scene Transform.
	/// Must provide the means to get or convert to a Matrix as well
	/// as a position.
	/// </summary>
	public interface ITransform
	{	
		/// <summary>
		/// Gets the position.
		/// </summary>
		/// <value>The position.</value>
		Vector3d Position
		{
			get;
		}
		/// <summary>
		/// Gets the transform.
		/// </summary>
		/// <value>The transform.</value>
		Matrixd Transform
		{
			get;
		}
	}
}
