

namespace Jade.SceneGraph.Transforms
{
	/// <summary>
	/// Directions which we are moving into
	/// </summary>		
	public enum Direction : int
	{
		/// <summary>
		/// Move forward
		/// </summary>
		Forward = 0,
		/// <summary>
		/// Move backwards
		/// </summary>
		Backwards = 1,
		/// <summary>
		/// Move Left
		/// </summary>
		Right = 2,
		/// <summary>
		/// Move Right
		/// </summary>
		Left = 3,
		/// <summary>
		/// Move Up
		/// </summary>
		Up = 4,
		/// <summary>
		/// Move Down
		/// </summary>
		Down = 5,
		/// <summary>
		/// Pitch Up
		/// </summary>
		PitchUp = 6,
		/// <summary>
		/// Pitch Down
		/// </summary>
		PitchDown = 7,
		/// <summary>
		/// Roll Left
		/// </summary>
		RollRight = 8,
		/// <summary>
		/// Roll Right
		/// </summary>
		RollLeft = 9,
		/// <summary>
		/// Yaw Right
		/// </summary>
		YawRight = 10,
		/// <summary>
		/// Yaw Left
		/// </summary>
		YawLeft = 11,		
		/// <summary>
		/// Zoom In
		/// </summary>
		ZoomIn = 12,
		/// <summary>
		/// Zoom Out
		/// </summary>
		ZoomOut = 13
	}
}