using System;
using System.Collections.Generic;
using System.Text;

using Pluto.Math;

namespace Jade.SceneGraph.Transforms
{
	/// <summary>
	/// Returns the identity matrix for a transform
	/// </summary>
	public class Identity : ITransform 
	{
		#region ITransform Members

		/// <summary>
		/// Gets the position.
		/// </summary>
		/// <value>The position.</value>
		public Vector3d Position
		{
			get { return Vector3d.Zero; }
		}

		/// <summary>
		/// Gets the transform.
		/// </summary>
		/// <value>The transform.</value>
		public Matrixd Transform
		{
			get { return Matrixd.Identity; }
		}

		#endregion
	}
}
