using System;
using System.IO;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

using Pluto.Core;
using Pluto.Configuration;
using Pluto.DoubleDispatcher;

using MbUnit.Framework;
using Jade.Core;

[assembly: MbUnit.Framework.AssemblyCleanup(typeof(Jade.UnitTests.MainSetup))]

namespace Jade.UnitTests
{
	/// <summary>
	/// Main class for assembly level setup/teardown.
	/// This dramatically speeds up testing, since we only load and setup plugins one time for
	/// the entire test suite
	/// </summary>
	public static class MainSetup
	{
		[SetUp]
		public static void Init()
		{
			// Make sure we initialize Jad.Engine
			Jad.Initialize("./configuration.xml");		
			IConfigurationService _configService = Jad.Engine.RootServiceProvider.GetService<IConfigurationService>();
		}		
	}
}
