using System;
using System.Collections.Generic;
using System.Text;
using MbUnit.Framework;
using Pluto.Core;
using Jade.SceneGraph;
using Jade.Core;

namespace Jade.UnitTests
{
    [TestFixture("Static main class Tests")]
    public class JadEngineTests
    {
        [Test]
        public void CheckRequiredServices()
        {
			// Check main provider
            IPlutoRootServiceProvider rootProvider = Jad.Engine.RootServiceProvider;
            Assert.IsNotNull(rootProvider, "Root provider is null!");
			
			// Check configuration
			Assert.IsNotNull(rootProvider.GetService<Pluto.Configuration.IConfigurationService>(), "Configuration service is null!");
			
			// Check double dispatch factory
			Assert.IsNotNull(rootProvider.GetService<Pluto.DoubleDispatcher.DoubleDispatchServiceFactory>(), "DoubleDispatchServiceFactory is null!");

        }

		[Test]
		public void CheckRenderer()
		{
			Assert.IsNotNull(Jad.Engine.DefaultRenderingSystem, "Renderer was not created");
			Console.WriteLine("Renderer created: " + Jad.Engine.DefaultRenderingSystem.Name);
		}
    }
}
